/* Generated by Pyrex 0.9.3 on Tue Jun 21 22:30:00 2005 */

#include "Python.h"
#include "structmember.h"
#ifndef PY_LONG_LONG
  #define PY_LONG_LONG LONG_LONG
#endif
#include "stdlib.h"
#include "string.h"
#include "setjmp.h"
#include "pari/pari.h"
#include "pari/anal.h"


typedef struct {PyObject **p; char *s;} __Pyx_InternTabEntry; /*proto*/
typedef struct {PyObject **p; char *s; long n;} __Pyx_StringTabEntry; /*proto*/
static PyObject *__Pyx_UnpackItem(PyObject *, int); /*proto*/
static int __Pyx_EndUnpack(PyObject *, int); /*proto*/
static int __Pyx_PrintItem(PyObject *); /*proto*/
static int __Pyx_PrintNewline(void); /*proto*/
static void __Pyx_Raise(PyObject *type, PyObject *value, PyObject *tb); /*proto*/
static void __Pyx_ReRaise(void); /*proto*/
static PyObject *__Pyx_Import(PyObject *name, PyObject *from_list); /*proto*/
static PyObject *__Pyx_GetExcValue(void); /*proto*/
static int __Pyx_ArgTypeTest(PyObject *obj, PyTypeObject *type, int none_allowed, char *name); /*proto*/
static int __Pyx_TypeTest(PyObject *obj, PyTypeObject *type); /*proto*/
static int __Pyx_GetStarArgs(PyObject **args, PyObject **kwds, char *kwd_list[], int nargs, PyObject **args2, PyObject **kwds2); /*proto*/
static void __Pyx_WriteUnraisable(char *name); /*proto*/
static void __Pyx_AddTraceback(char *funcname); /*proto*/
static PyTypeObject *__Pyx_ImportType(char *module_name, char *class_name, long size);  /*proto*/
static int __Pyx_SetVtable(PyObject *dict, void *vtable); /*proto*/
static int __Pyx_GetVtable(PyObject *dict, void *vtabptr); /*proto*/
static PyObject *__Pyx_CreateClass(PyObject *bases, PyObject *dict, PyObject *name, char *modname); /*proto*/
static int __Pyx_InternStrings(__Pyx_InternTabEntry *t); /*proto*/
static int __Pyx_InitStrings(__Pyx_StringTabEntry *t); /*proto*/
static PyObject *__Pyx_GetName(PyObject *dict, PyObject *name); /*proto*/

static PyObject *__pyx_m;
static PyObject *__pyx_b;
static int __pyx_lineno;
static char *__pyx_filename;
staticforward char **__pyx_f;

static char __pyx_mdoc[] = "\npy_pari -- Python interface to PARI C-library.\n\nThis module provides a new interface to the PARI C-library.  It is\nmodeled on the gp interpreter, but with all the advantages associated\nwith using a real programming language (Python) instead of a hacked\ninterpreter.\n\nHere are several advantages of Python/PARI over GP:\n\n      - Improved memory management and garbage collection:\n\n            * Automatic garbage collection!  Each Python/PARI object\n              has its own piece of memory allocated from the Python\n              heap.  When objects go out of scope the Python memory\n              manager deletes them.  (Implementation: I grafted\n              genuine memory management onto PARI by creatinging a\n              mini \"PARI stack\" in the Python heap for each GEN that\n              is wrapped by a Python object.  In some cases it is\n              necessary to copy this GEN back to the main PARI stack\n              for computations, but this is very fast.)\n\n\n            * If the \"PARI stack overflows\", then py_pari\n            *automatically* doubles the PARI stack and your\n            computation continues uninterrupted.  The main stack is\n            unlikely to overflow because it is only used for very\n            small atomic computations; as soon as an object is\n            computed it is moved of the stack into its own chunk of\n            memory in the Python heap.\n\n      - Exception handling.  try, except, raise\n      \n      - Genuine object oriented language with user defined classes,\n        multiple inheritence, polymorphism, etc.\n      \n      - Object serialization:  This makes loading and saving objects\n        to disk easy.\n            >>> a = pari(5)\n            >>> import pickle\n            >>> s = pickle.dumps(a); \n            >>> z = pickle.loads(s);\n            >>> print z\n            5\n            >>> type(z)\n            <type \'_py_pari.gen\'>\n            >>> a == z\n            True\n            >>> a is z\n            False\n\n      - Python: easy access to massive amount of software aleady written \n            in Python, e.g., for compression, networking, 2d and 3d\n            graphics, etc.\n\nPROBLEMS/WARNINGS\n\n      - PARI commands run at the C-level and cannot be interrupted from\n        the Python interpreter with ctrl-C until they return from C level.\n        This is in accord with how the Python interpreter works.\n        \n      - Some of the PARI error and log messages print to stdout.  This\n        can be very annoying, since it might interfere with output the\n        user is trying to send to a file.  Possible fixes: (1) Modify \n    \n";

/* Declarations from _py_pari */

staticforward PyTypeObject __pyx_type_8_py_pari_gen;

struct __pyx_obj_8_py_pari_gen {
  PyObject_HEAD
  struct __pyx_vtabstruct_8_py_pari_gen *__pyx_vtab;
  GEN g;
  PyObject *refers_to;
  pari_sp b;
};

struct __pyx_vtabstruct_8_py_pari_gen {
  PyObject *((*init)(struct __pyx_obj_8_py_pari_gen *,GEN ,pari_sp ));
  GEN ((*_gen)(struct __pyx_obj_8_py_pari_gen *));
};
static struct __pyx_vtabstruct_8_py_pari_gen *__pyx_vtabptr_8_py_pari_gen;

static PyTypeObject *__pyx_ptype_8_py_pari_gen = 0;
static gp_data __pyx_v_8_py_pari___GP_DATA;
static int __pyx_v_8_py_pari_REAL_PREC;
static pariout_t __pyx_v_8_py_pari_fmt;
static unsigned long __pyx_v_8_py_pari_num_primes;
static pari_sp __pyx_v_8_py_pari_stack_avma;
static struct __pyx_obj_8_py_pari_gen *__pyx_v_8_py_pari_ZERO;
static struct __pyx_obj_8_py_pari_gen *__pyx_v_8_py_pari_ONE;
static struct __pyx_obj_8_py_pari_gen *__pyx_v_8_py_pari_TWO;
static long __pyx_k3;
static unsigned long __pyx_k4;
static PyObject *__pyx_k5;
static PyObject *__pyx_k6;
static PyObject *__pyx_k7;
static PyObject *__pyx_k8;
static PyObject *__pyx_k9;
static PyObject *__pyx_k10;
static PyObject *__pyx_k11;
static long __pyx_k12;
static PyObject *__pyx_k13;
static PyObject *__pyx_k14;
static long __pyx_k15;
static PyObject *__pyx_k16;
static PyObject *__pyx_k17;
static int __pyx_k18;
static int __pyx_k19;
static int __pyx_k20;
static int __pyx_k21;
static PyObject *__pyx_k22;
static int __pyx_k23;
static PyObject *__pyx_k24;
static PyObject *__pyx_k25;
static long __pyx_k26;
static PyObject *__pyx_k27;
static PyObject *__pyx_k28;
static PyObject *__pyx_k29;
static PyObject *__pyx_k31;
static long __pyx_k32;
static long __pyx_k33;
static long __pyx_k34;
static long __pyx_k35;
static PyObject *__pyx_k36;
static long __pyx_k37;
static long __pyx_k38;
static PyObject *__pyx_k39;
static PyObject *__pyx_k40;
static PyObject *__pyx_k41;
static PyObject *__pyx_k42;
static PyObject *__pyx_k43;
static long __pyx_k44;
static long __pyx_k45;
static long __pyx_k46;
static PyObject *__pyx_k47;
static PyObject *__pyx_k48;
static PyObject *__pyx_k50;
static int __pyx_k51;
static int __pyx_k52;
static PyObject *__pyx_k53;
static PyObject *__pyx_k54;
static PyObject *__pyx_k55;
static PyObject *__pyx_k56;
static int (__pyx_f_8_py_pari_is_int_or_real_type(GEN )); /*proto*/
static size_t (__pyx_f_8_py_pari_fix_size(size_t )); /*proto*/
static int (__pyx_f_8_py_pari_init_stack(size_t )); /*proto*/
static GEN (__pyx_f_8_py_pari_str_to_GEN(char (*))); /*proto*/
static PyObject *(__pyx_f_8_py_pari_GEN_to_str(GEN )); /*proto*/
static PyObject *(__pyx_f_8_py_pari_save_avma(void)); /*proto*/
static struct __pyx_obj_8_py_pari_gen *(__pyx_f_8_py_pari_new_gen_noclear(GEN )); /*proto*/
static struct __pyx_obj_8_py_pari_gen *(__pyx_f_8_py_pari_new_gen(GEN )); /*proto*/
static struct __pyx_obj_8_py_pari_gen *(__pyx_f_8_py_pari___xxx_new_gen(GEN ,pari_sp )); /*proto*/
static struct __pyx_obj_8_py_pari_gen *(__pyx_f_8_py_pari__new_gen(GEN ,pari_sp )); /*proto*/
static struct __pyx_obj_8_py_pari_gen *(__pyx_f_8_py_pari_new_ref(GEN ,PyObject *)); /*proto*/
static int (__pyx_f_8_py_pari_get_var(PyObject *)); /*proto*/

/* Implementation of _py_pari */

static char (__pyx_k1[]) = "\n* Make it so when asking for, e.g., the n-th prime, if not enough primes have\n  been precomputed, py_pari automatically precomputes enough primes and answers\n  the question.  Make py_pari robust like MAGMA, and not lame like gp.\n\n";
static char (__pyx_k49[]) = "";

static PyObject *__pyx_n_gc;
static PyObject *__pyx_n_my_sigint;
static PyObject *__pyx_n_init_fmt;
static PyObject *__pyx_n__init;
static PyObject *__pyx_n_pari;
static PyObject *__pyx_n_stack_ptr;
static PyObject *__pyx_n_stack_top;
static PyObject *__pyx_n_stack_bottom;
static PyObject *__pyx_n_stack_size;
static PyObject *__pyx_n_stack_usage;
static PyObject *__pyx_n_stack_available;
static PyObject *__pyx_n_execute;
static PyObject *__pyx_n_eval;
static PyObject *__pyx_n__error;
static PyObject *__pyx_n_min;
static PyObject *__pyx_n_max;
static PyObject *__pyx_n_prime_list;
static PyObject *__pyx_n_nth_prime;
static PyObject *__pyx_n_euler;
static PyObject *__pyx_n_pi;
static PyObject *__pyx_n_factorial;
static PyObject *__pyx_n_vector;
static PyObject *__pyx_n_matrix;
static PyObject *__pyx_n_finitefield_init;
static PyObject *__pyx_n_set_real_precision;
static PyObject *__pyx_n_get_real_precision;
static PyObject *__pyx_n_set_series_precision;
static PyObject *__pyx_n_get_series_precision;
static PyObject *__pyx_n_series_precision;
static PyObject *__pyx_n_init_primes;
static PyObject *__pyx_n___read_script;
static PyObject *__pyx_n_read;
static PyObject *__pyx_n_False;
static PyObject *__pyx_n_z;

static PyObject *__pyx_k49p;

static int __pyx_f_8_py_pari_is_int_or_real_type(GEN __pyx_v_g) {
  int __pyx_v_t;
  int __pyx_r;
  int __pyx_1;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2034 */
  __pyx_v_t = typ(__pyx_v_g);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2035 */
  __pyx_1 = (__pyx_v_t == t_INT);
  if (!__pyx_1) {
    __pyx_1 = (__pyx_v_t == t_REAL);
  }
  __pyx_r = __pyx_1;
  goto __pyx_L0;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_WriteUnraisable("_py_pari.is_int_or_real_type");
  __pyx_L0:;
  return __pyx_r;
}

static size_t __pyx_f_8_py_pari_fix_size(size_t __pyx_v_a) {
  size_t __pyx_v_b;
  size_t __pyx_r;
  int __pyx_1;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2039 */
  __pyx_v_b = (__pyx_v_a - (__pyx_v_a & (BYTES_IN_LONG - 1)));

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2040 */
  __pyx_1 = (__pyx_v_b < 1024);
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2041 */
    __pyx_v_b = 1024;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2042 */
  __pyx_r = __pyx_v_b;
  goto __pyx_L0;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_WriteUnraisable("_py_pari.fix_size");
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_n_MemoryError;

static PyObject *__pyx_k57p;

static char (__pyx_k57[]) = "Unable to allocate %s bytes memory for PARI.";

static int __pyx_f_8_py_pari_init_stack(size_t __pyx_v_size) {
  size_t __pyx_v_s;
  int __pyx_r;
  pari_sp __pyx_1;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2050 */
  __pyx_1 = bot;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2052 */
    PyMem_Free(((void (*))bot));
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2054 */
  __pyx_2 = (__pyx_v_size == 0);
  if (__pyx_2) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2055 */
    __pyx_v_size = (2 * (top - bot));
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2058 */
  __pyx_v_s = __pyx_f_8_py_pari_fix_size(__pyx_v_size);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2063 */
  bot = ((pari_sp )PyMem_Malloc(__pyx_v_s));

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2064 */
  __pyx_2 = (!bot);
  if (__pyx_2) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2065 */
    __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_MemoryError); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2065; goto __pyx_L1;}
    __pyx_4 = PyInt_FromLong(((long )__pyx_v_size)); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2065; goto __pyx_L1;}
    __pyx_5 = PyNumber_Remainder(__pyx_k57p, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2065; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __Pyx_Raise(__pyx_3, __pyx_5, 0);
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2065; goto __pyx_L1;}
    goto __pyx_L4;
  }
  __pyx_L4:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2066 */
  top = (bot + __pyx_v_s);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2067 */
  avma = top;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2068 */
  __pyx_v_8_py_pari_stack_avma = avma;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("_py_pari.init_stack");
  __pyx_r = -1;
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_n_KeyboardInterrupt;

static PyObject *__pyx_f_8_py_pari_my_sigint(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_8_py_pari_my_sigint(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_signum = 0;
  PyObject *__pyx_v_frame = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"signum","frame",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_signum, &__pyx_v_frame)) return 0;
  Py_INCREF(__pyx_v_signum);
  Py_INCREF(__pyx_v_frame);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2072 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_KeyboardInterrupt); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2072; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2072; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("_py_pari.my_sigint");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_signum);
  Py_DECREF(__pyx_v_frame);
  return __pyx_r;
}

static char (__pyx_k58[]) = "g";

static PyObject *__pyx_f_8_py_pari_init_fmt(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_8_py_pari_init_fmt(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2079 */
  __pyx_v_8_py_pari_fmt.format = (__pyx_k58[0]);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2080 */
  __pyx_v_8_py_pari_fmt.fieldw = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2081 */
  __pyx_v_8_py_pari_fmt.sigd = (-1);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2082 */
  __pyx_v_8_py_pari_fmt.sp = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2083 */
  __pyx_v_8_py_pari_fmt.prettyp = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2084 */
  __pyx_v_8_py_pari_fmt.TeXstyle = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2086 */
  GP_DATA->fmt = (&__pyx_v_8_py_pari_fmt);

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("_py_pari.init_fmt");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_n_initialized;
static PyObject *__pyx_n_RuntimeError;
static PyObject *__pyx_n_signal;
static PyObject *__pyx_n_SIGINT;

static PyObject *__pyx_k59p;

static char (__pyx_k59[]) = "pari_init has already been called.";

static PyObject *__pyx_f_8_py_pari__init(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_8_py_pari__init[] = "\n    Initialize the PARI system.\n    \n    INPUT:\n        size -- long, the number of bytes for the initial PARI stack\n                (see note below)\n        maxprime -- unsigned long, upper limit on a precomputed prime\n                    number table  (default: 500000)\n\n    NOTES:\n    \n        * In py_pari, the PARI stack is different than in gp or the\n          PARI C library.  In Python, instead of the PARI stack\n          holding the results of all computations, it *only* holds the\n          results of an individual computation.  Each time a new\n          Python/PARI object is computed, it it copied to its own\n          space in the Python heap, and the memory it occupied on the\n          PARI stack is freed.  Thus it is not necessary to make the\n          stack very large.  Also, unlike in PARI, if the stack does\n          overflow, in most cases the PARI stack is automatically\n          increased and the relevant step of the computation rerun.\n\n          This design obviously involves some performance penalties\n          over the way PARI works, but it scales much better and is\n          far more robus for large projects.\n          \n        * If you do not want prime numbers, put maxprime=2, but be\n          careful because many PARI functions require this table.  If\n          you get the error message \"not enough precomputed primes\",\n          increase this parameter.\n          \n    ";
static PyObject *__pyx_f_8_py_pari__init(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_size;
  unsigned long __pyx_v_maxprime;
  PyObject *__pyx_v_signal;
  PyObject *__pyx_v_stack_avma;
  PyObject *__pyx_r;
  unsigned long __pyx_1;
  PyObject *__pyx_2 = 0;
  int __pyx_3;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  PyObject *__pyx_6 = 0;
  static char *__pyx_argnames[] = {"size","maxprime",0};
  __pyx_v_size = __pyx_k3;
  __pyx_v_maxprime = __pyx_k4;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|ll", __pyx_argnames, &__pyx_v_size, &__pyx_v_maxprime)) return 0;
  __pyx_v_signal = Py_None; Py_INCREF(__pyx_v_signal);
  __pyx_v_stack_avma = Py_None; Py_INCREF(__pyx_v_stack_avma);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2122 */
  __pyx_1 = precdl;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2123 */
    __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_RuntimeError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2123; goto __pyx_L1;}
    __Pyx_Raise(__pyx_2, __pyx_k59p, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2123; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2125 */
  pari_init(1024,__pyx_v_maxprime);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2126 */
  __pyx_3 = __pyx_f_8_py_pari_init_stack(__pyx_v_size); if (__pyx_3 == -1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2126; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2127 */
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_init_fmt); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2127; goto __pyx_L1;}
  __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2127; goto __pyx_L1;}
  __pyx_5 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2127; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  Py_DECREF(__pyx_5); __pyx_5 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2128 */
  __pyx_2 = __Pyx_Import(__pyx_n_signal, 0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2128; goto __pyx_L1;}
  Py_DECREF(__pyx_v_signal);
  __pyx_v_signal = __pyx_2;
  __pyx_2 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2129 */
  __pyx_4 = PyObject_GetAttr(__pyx_v_signal, __pyx_n_signal); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2129; goto __pyx_L1;}
  __pyx_5 = PyObject_GetAttr(__pyx_v_signal, __pyx_n_SIGINT); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2129; goto __pyx_L1;}
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_my_sigint); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2129; goto __pyx_L1;}
  __pyx_6 = PyTuple_New(2); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2129; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_6, 0, __pyx_5);
  PyTuple_SET_ITEM(__pyx_6, 1, __pyx_2);
  __pyx_5 = 0;
  __pyx_2 = 0;
  __pyx_5 = PyObject_CallObject(__pyx_4, __pyx_6); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2129; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  Py_DECREF(__pyx_6); __pyx_6 = 0;
  Py_DECREF(__pyx_5); __pyx_5 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2130 */
  __pyx_2 = PyInt_FromLong(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2130; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_initialized, __pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2130; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2131 */
  __pyx_4 = PyLong_FromUnsignedLong(avma); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2131; goto __pyx_L1;}
  Py_DECREF(__pyx_v_stack_avma);
  __pyx_v_stack_avma = __pyx_4;
  __pyx_4 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2132 */
  __pyx_v_8_py_pari_num_primes = __pyx_v_maxprime;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2133 */
  __pyx_6 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2133; goto __pyx_L1;}
  __pyx_5 = PyInt_FromLong(0); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2133; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2133; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_5);
  __pyx_5 = 0;
  __pyx_4 = PyObject_CallObject(__pyx_6, __pyx_2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2133; goto __pyx_L1;}
  Py_DECREF(__pyx_6); __pyx_6 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_4, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2133; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v_8_py_pari_ZERO));
  ((PyObject *)__pyx_v_8_py_pari_ZERO) = __pyx_4;
  __pyx_4 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2134 */
  __pyx_5 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2134; goto __pyx_L1;}
  __pyx_6 = PyInt_FromLong(1); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2134; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2134; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_6);
  __pyx_6 = 0;
  __pyx_4 = PyObject_CallObject(__pyx_5, __pyx_2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2134; goto __pyx_L1;}
  Py_DECREF(__pyx_5); __pyx_5 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_4, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2134; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v_8_py_pari_ONE));
  ((PyObject *)__pyx_v_8_py_pari_ONE) = __pyx_4;
  __pyx_4 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2135 */
  __pyx_6 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2135; goto __pyx_L1;}
  __pyx_5 = PyInt_FromLong(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2135; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2135; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_5);
  __pyx_5 = 0;
  __pyx_4 = PyObject_CallObject(__pyx_6, __pyx_2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2135; goto __pyx_L1;}
  Py_DECREF(__pyx_6); __pyx_6 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_4, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2135; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v_8_py_pari_TWO));
  ((PyObject *)__pyx_v_8_py_pari_TWO) = __pyx_4;
  __pyx_4 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2136 */
  __pyx_5 = PyInt_FromLong(0); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2136; goto __pyx_L1;}
  __pyx_r = __pyx_5;
  __pyx_5 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  Py_XDECREF(__pyx_6);
  __Pyx_AddTraceback("_py_pari._init");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_signal);
  Py_DECREF(__pyx_v_stack_avma);
  return __pyx_r;
}

static GEN __pyx_f_8_py_pari_str_to_GEN(char (*__pyx_v_s)) {
  int __pyx_v_n;
  GEN __pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2148 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2149 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2149; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2149; goto __pyx_L1;}
    __pyx_4 = PyString_FromString(__pyx_v_s); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2149; goto __pyx_L1;}
    __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2149; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_5, 0, __pyx_3);
    PyTuple_SET_ITEM(__pyx_5, 1, __pyx_4);
    __pyx_3 = 0;
    __pyx_4 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_5); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2149; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2150 */
  __pyx_r = flisseq(__pyx_v_s);
  goto __pyx_L0;

  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("_py_pari.str_to_GEN");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_n_str;

static PyObject *__pyx_k61p;

static char (__pyx_k61[]) = "converting a gen to a string";

static PyObject *__pyx_f_8_py_pari_GEN_to_str(GEN __pyx_v_g) {
  char (*__pyx_v_c);
  int __pyx_v_n;
  PyObject *__pyx_v_s;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  __pyx_v_s = Py_None; Py_INCREF(__pyx_v_s);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2155 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2156 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2157 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2157; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2157; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2157; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k61p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k61p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2157; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2159 */
  __pyx_v_c = GENtostr(__pyx_v_g);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2160 */
  __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2160; goto __pyx_L1;}
  __pyx_4 = PyString_FromString(__pyx_v_c); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2160; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2160; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_4);
  __pyx_4 = 0;
  __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2160; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_v_s);
  __pyx_v_s = __pyx_4;
  __pyx_4 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2161 */
  free(__pyx_v_c);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2162 */
  Py_INCREF(__pyx_v_s);
  __pyx_r = __pyx_v_s;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("_py_pari.GEN_to_str");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_s);
  return __pyx_r;
}

static char (__pyx_k62[]) = "\n            g -- PARI GEN\n            b -- pointer to memory chunk where PARI gen lives\n                 (if nonzero then this memory is freed when the object\n                  goes out of scope)\n        ";

static PyObject *__pyx_f_8_py_pari_3gen_init(struct __pyx_obj_8_py_pari_gen *__pyx_v_self,GEN __pyx_v_g,pari_sp __pyx_v_b) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2180 */
  __pyx_k62;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2186 */
  __pyx_v_self->g = __pyx_v_g;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2187 */
  __pyx_v_self->b = __pyx_v_b;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2188 */
  __pyx_1 = PyDict_New(); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2188; goto __pyx_L1;}
  Py_DECREF(__pyx_v_self->refers_to);
  __pyx_v_self->refers_to = __pyx_1;
  __pyx_1 = 0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("_py_pari.gen.init");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static void __pyx_f_8_py_pari_3gen___dealloc__(PyObject *__pyx_v_self); /*proto*/
static void __pyx_f_8_py_pari_3gen___dealloc__(PyObject *__pyx_v_self) {
  pari_sp __pyx_1;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2191 */
  __pyx_1 = ((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->b;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2193 */
    PyMem_Free(((void (*))((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->b));
    goto __pyx_L2;
  }
  __pyx_L2:;

  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("_py_pari.gen.__dealloc__");
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
}

static PyObject *__pyx_f_8_py_pari_3gen___repr__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_8_py_pari_3gen___repr__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2196 */
  __pyx_1 = __pyx_f_8_py_pari_GEN_to_str(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2196; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("_py_pari.gen.__repr__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static GEN __pyx_f_8_py_pari_3gen__gen(struct __pyx_obj_8_py_pari_gen *__pyx_v_self) {
  GEN __pyx_r;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2199 */
  __pyx_r = __pyx_v_self->g;
  goto __pyx_L0;

  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_WriteUnraisable("_py_pari.gen._gen");
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n_py_pari_py;

static PyObject *__pyx_k63p;

static char (__pyx_k63[]) = "sage.pari.py_pari_py";

static PyObject *__pyx_f_8_py_pari_3gen___reduce__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_8_py_pari_3gen___reduce__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_z;
  PyObject *__pyx_v_sage;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_z = Py_None; Py_INCREF(__pyx_v_z);
  __pyx_v_sage = Py_None; Py_INCREF(__pyx_v_sage);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2202 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2202; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2202; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_self);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2202; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_z);
  __pyx_v_z = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2203 */
  __pyx_1 = __Pyx_Import(__pyx_k63p, 0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2203; goto __pyx_L1;}
  Py_DECREF(__pyx_v_sage);
  __pyx_v_sage = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2204 */
  __pyx_2 = PyObject_GetAttr(__pyx_v_sage, __pyx_n_pari); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2204; goto __pyx_L1;}
  __pyx_3 = PyObject_GetAttr(__pyx_2, __pyx_n_py_pari_py); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2204; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_1 = PyObject_GetAttr(__pyx_3, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2204; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2204; goto __pyx_L1;}
  Py_INCREF(__pyx_v_z);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_z);
  __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2204; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_1);
  PyTuple_SET_ITEM(__pyx_3, 1, __pyx_2);
  __pyx_1 = 0;
  __pyx_2 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("_py_pari.gen.__reduce__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_z);
  Py_DECREF(__pyx_v_sage);
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_k64p;

static char (__pyx_k64[]) = "error adding PARI objects";

static PyObject *__pyx_f_8_py_pari_3gen__add(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_8_py_pari_3gen__add(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_8_py_pari_gen *__pyx_v_other = 0;
  PyObject *__pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"other",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_other)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);
  __pyx_v_n = Py_None; Py_INCREF(__pyx_v_n);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_other), __pyx_ptype_8_py_pari_gen, 1, "other")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2210; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2211 */
  __pyx_1 = PyInt_FromLong(setjmp(GP_DATA->env)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2211; goto __pyx_L1;}
  Py_DECREF(__pyx_v_n);
  __pyx_v_n = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2212 */
  __pyx_2 = PyObject_IsTrue(__pyx_v_n); if (__pyx_2 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2212; goto __pyx_L1;}
  if (__pyx_2) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2212; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2212; goto __pyx_L1;}
    Py_INCREF(__pyx_v_n);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_n);
    Py_INCREF(__pyx_k64p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k64p);
    __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2212; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2213 */
  __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gadd(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g),__pyx_v_other->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2213; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("_py_pari.gen._add");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_n);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_k65p;

static char (__pyx_k65[]) = "error subtracting PARI objects";

static PyObject *__pyx_f_8_py_pari_3gen__sub(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_8_py_pari_3gen__sub(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_8_py_pari_gen *__pyx_v_other = 0;
  PyObject *__pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"other",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_other)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);
  __pyx_v_n = Py_None; Py_INCREF(__pyx_v_n);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_other), __pyx_ptype_8_py_pari_gen, 1, "other")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2215; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2216 */
  __pyx_1 = PyInt_FromLong(setjmp(GP_DATA->env)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2216; goto __pyx_L1;}
  Py_DECREF(__pyx_v_n);
  __pyx_v_n = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2217 */
  __pyx_2 = PyObject_IsTrue(__pyx_v_n); if (__pyx_2 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2217; goto __pyx_L1;}
  if (__pyx_2) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2217; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2217; goto __pyx_L1;}
    Py_INCREF(__pyx_v_n);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_n);
    Py_INCREF(__pyx_k65p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k65p);
    __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2217; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2218 */
  __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gsub(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g),__pyx_v_other->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2218; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("_py_pari.gen._sub");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_n);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_k66p;

static char (__pyx_k66[]) = "error multiplying PARI objects";

static PyObject *__pyx_f_8_py_pari_3gen__mul(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_8_py_pari_3gen__mul(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_8_py_pari_gen *__pyx_v_other = 0;
  PyObject *__pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"other",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_other)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);
  __pyx_v_n = Py_None; Py_INCREF(__pyx_v_n);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_other), __pyx_ptype_8_py_pari_gen, 1, "other")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2220; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2221 */
  __pyx_1 = PyInt_FromLong(setjmp(GP_DATA->env)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2221; goto __pyx_L1;}
  Py_DECREF(__pyx_v_n);
  __pyx_v_n = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2222 */
  __pyx_2 = PyObject_IsTrue(__pyx_v_n); if (__pyx_2 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2222; goto __pyx_L1;}
  if (__pyx_2) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2222; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2222; goto __pyx_L1;}
    Py_INCREF(__pyx_v_n);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_n);
    Py_INCREF(__pyx_k66p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k66p);
    __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2222; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2223 */
  __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gmul(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g),__pyx_v_other->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2223; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("_py_pari.gen._mul");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_n);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_k67p;

static char (__pyx_k67[]) = "error dividing PARI objects";

static PyObject *__pyx_f_8_py_pari_3gen__div(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_8_py_pari_3gen__div(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_8_py_pari_gen *__pyx_v_other = 0;
  PyObject *__pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"other",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_other)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);
  __pyx_v_n = Py_None; Py_INCREF(__pyx_v_n);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_other), __pyx_ptype_8_py_pari_gen, 1, "other")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2225; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2226 */
  __pyx_1 = PyInt_FromLong(setjmp(GP_DATA->env)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2226; goto __pyx_L1;}
  Py_DECREF(__pyx_v_n);
  __pyx_v_n = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2227 */
  __pyx_2 = PyObject_IsTrue(__pyx_v_n); if (__pyx_2 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2227; goto __pyx_L1;}
  if (__pyx_2) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2227; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2227; goto __pyx_L1;}
    Py_INCREF(__pyx_v_n);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_n);
    Py_INCREF(__pyx_k67p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k67p);
    __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2227; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2228 */
  __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gdiv(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g),forcecopy(__pyx_v_other->g)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2228; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("_py_pari.gen._div");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_n);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_k68p;

static char (__pyx_k68[]) = "error quotienting PARI objects";

static PyObject *__pyx_f_8_py_pari_3gen__mod(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_8_py_pari_3gen__mod(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_8_py_pari_gen *__pyx_v_other = 0;
  PyObject *__pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"other",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_other)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);
  __pyx_v_n = Py_None; Py_INCREF(__pyx_v_n);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_other), __pyx_ptype_8_py_pari_gen, 1, "other")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2230; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2231 */
  __pyx_1 = PyInt_FromLong(setjmp(GP_DATA->env)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2231; goto __pyx_L1;}
  Py_DECREF(__pyx_v_n);
  __pyx_v_n = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2232 */
  __pyx_2 = PyObject_IsTrue(__pyx_v_n); if (__pyx_2 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2232; goto __pyx_L1;}
  if (__pyx_2) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2232; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2232; goto __pyx_L1;}
    Py_INCREF(__pyx_v_n);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_n);
    Py_INCREF(__pyx_k68p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k68p);
    __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2232; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2233 */
  __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gmod(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g),__pyx_v_other->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2233; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("_py_pari.gen._mod");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_n);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_n__add;

static PyObject *__pyx_f_8_py_pari_3gen___add__(PyObject *__pyx_v_self, PyObject *__pyx_v_other); /*proto*/
static PyObject *__pyx_f_8_py_pari_3gen___add__(PyObject *__pyx_v_self, PyObject *__pyx_v_other) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2236 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2236; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2236; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_self);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2236; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_self);
  __pyx_v_self = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2236 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2236; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2236; goto __pyx_L1;}
  Py_INCREF(__pyx_v_other);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_other);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2236; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_other);
  __pyx_v_other = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2237 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n__add); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2237; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2237; goto __pyx_L1;}
  Py_INCREF(__pyx_v_other);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_other);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2237; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("_py_pari.gen.__add__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_n__sub;

static PyObject *__pyx_f_8_py_pari_3gen___sub__(PyObject *__pyx_v_self, PyObject *__pyx_v_other); /*proto*/
static PyObject *__pyx_f_8_py_pari_3gen___sub__(PyObject *__pyx_v_self, PyObject *__pyx_v_other) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2240 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2240; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2240; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_self);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2240; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_self);
  __pyx_v_self = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2240 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2240; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2240; goto __pyx_L1;}
  Py_INCREF(__pyx_v_other);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_other);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2240; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_other);
  __pyx_v_other = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2241 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n__sub); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2241; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2241; goto __pyx_L1;}
  Py_INCREF(__pyx_v_other);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_other);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2241; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("_py_pari.gen.__sub__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_n__mul;

static PyObject *__pyx_f_8_py_pari_3gen___mul__(PyObject *__pyx_v_self, PyObject *__pyx_v_other); /*proto*/
static PyObject *__pyx_f_8_py_pari_3gen___mul__(PyObject *__pyx_v_self, PyObject *__pyx_v_other) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2244 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2244; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2244; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_self);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2244; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_self);
  __pyx_v_self = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2244 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2244; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2244; goto __pyx_L1;}
  Py_INCREF(__pyx_v_other);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_other);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2244; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_other);
  __pyx_v_other = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2245 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n__mul); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2245; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2245; goto __pyx_L1;}
  Py_INCREF(__pyx_v_other);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_other);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2245; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("_py_pari.gen.__mul__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_n__div;

static PyObject *__pyx_f_8_py_pari_3gen___div__(PyObject *__pyx_v_self, PyObject *__pyx_v_other); /*proto*/
static PyObject *__pyx_f_8_py_pari_3gen___div__(PyObject *__pyx_v_self, PyObject *__pyx_v_other) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2248 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2248; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2248; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_self);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2248; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_self);
  __pyx_v_self = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2248 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2248; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2248; goto __pyx_L1;}
  Py_INCREF(__pyx_v_other);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_other);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2248; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_other);
  __pyx_v_other = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2249 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n__div); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2249; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2249; goto __pyx_L1;}
  Py_INCREF(__pyx_v_other);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_other);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2249; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("_py_pari.gen.__div__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_n__mod;

static PyObject *__pyx_f_8_py_pari_3gen___mod__(PyObject *__pyx_v_self, PyObject *__pyx_v_other); /*proto*/
static PyObject *__pyx_f_8_py_pari_3gen___mod__(PyObject *__pyx_v_self, PyObject *__pyx_v_other) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2252 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2252; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2252; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_self);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2252; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_self);
  __pyx_v_self = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2252 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2252; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2252; goto __pyx_L1;}
  Py_INCREF(__pyx_v_other);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_other);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2252; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_other);
  __pyx_v_other = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2253 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n__mod); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2253; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2253; goto __pyx_L1;}
  Py_INCREF(__pyx_v_other);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_other);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2253; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("_py_pari.gen.__mod__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_f_8_py_pari_3gen___neg__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_8_py_pari_3gen___neg__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2256 */
  __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gneg(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2256; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("_py_pari.gen.__neg__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_k69p;

static char (__pyx_k69[]) = "error exponentiating PARI object";

static PyObject *__pyx_f_8_py_pari_3gen___pow__(PyObject *__pyx_v_self, PyObject *__pyx_v_n, PyObject *__pyx_v_m); /*proto*/
static PyObject *__pyx_f_8_py_pari_3gen___pow__(PyObject *__pyx_v_self, PyObject *__pyx_v_n, PyObject *__pyx_v_m) {
  struct __pyx_obj_8_py_pari_gen *__pyx_v__n;
  struct __pyx_obj_8_py_pari_gen *__pyx_v__self;
  int __pyx_v_j;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_n);
  Py_INCREF(__pyx_v_m);
  ((PyObject*)__pyx_v__n) = Py_None; Py_INCREF(((PyObject*)__pyx_v__n));
  ((PyObject*)__pyx_v__self) = Py_None; Py_INCREF(((PyObject*)__pyx_v__self));

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2260 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2260; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2260; goto __pyx_L1;}
  Py_INCREF(__pyx_v_n);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_n);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2260; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2260; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__n));
  ((PyObject *)__pyx_v__n) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2261 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2261; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2261; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_self);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2261; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2261; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__self));
  ((PyObject *)__pyx_v__self) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2264 */
  __pyx_v_j = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2265 */
  __pyx_4 = __pyx_v_j;
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2266 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2266; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_j); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2266; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2266; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_k69p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k69p);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2266; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2268 */
  __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gpow(forcecopy(__pyx_v__self->g),__pyx_v__n->g,__pyx_v_8_py_pari_REAL_PREC))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2268; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("_py_pari.gen.__pow__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__n);
  Py_DECREF(__pyx_v__self);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_n);
  Py_DECREF(__pyx_v_m);
  return __pyx_r;
}

static PyObject *__pyx_k70p;
static PyObject *__pyx_k71p;

static char (__pyx_k70[]) = "Use ** for exponentiation, not '^', which means xor\n";
static char (__pyx_k71[]) = "in Python, and has the wrong precedence.";

static PyObject *__pyx_f_8_py_pari_3gen___xor__(PyObject *__pyx_v_self, PyObject *__pyx_v_n); /*proto*/
static PyObject *__pyx_f_8_py_pari_3gen___xor__(PyObject *__pyx_v_self, PyObject *__pyx_v_n) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_n);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_self), __pyx_ptype_8_py_pari_gen, 1, "self")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2270; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2271 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_RuntimeError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2271; goto __pyx_L1;}
  __pyx_2 = PyNumber_Add(__pyx_k70p, __pyx_k71p); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2271; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, __pyx_2, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2271; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("_py_pari.gen.__xor__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_n);
  return __pyx_r;
}

static PyObject *__pyx_k72p;

static char (__pyx_k72[]) = "error right shifting PARI object";

static PyObject *__pyx_f_8_py_pari_3gen___rshift__(PyObject *__pyx_v_self, PyObject *__pyx_arg_n); /*proto*/
static PyObject *__pyx_f_8_py_pari_3gen___rshift__(PyObject *__pyx_v_self, PyObject *__pyx_arg_n) {
  long __pyx_v_n;
  PyObject *__pyx_r;
  long __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_n = PyInt_AsLong(__pyx_arg_n); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2274; goto __pyx_L1;}
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_self), __pyx_ptype_8_py_pari_gen, 1, "self")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2274; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2275 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2276 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2276; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2276; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2276; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k72p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k72p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2276; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2277 */
  __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gshift(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g),(-__pyx_v_n)))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2277; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("_py_pari.gen.__rshift__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_k73p;

static char (__pyx_k73[]) = "error left shifting PARI object";

static PyObject *__pyx_f_8_py_pari_3gen___lshift__(PyObject *__pyx_v_self, PyObject *__pyx_arg_n); /*proto*/
static PyObject *__pyx_f_8_py_pari_3gen___lshift__(PyObject *__pyx_v_self, PyObject *__pyx_arg_n) {
  long __pyx_v_n;
  PyObject *__pyx_r;
  long __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_n = PyInt_AsLong(__pyx_arg_n); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2279; goto __pyx_L1;}
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_self), __pyx_ptype_8_py_pari_gen, 1, "self")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2279; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2280 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2281 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2281; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2281; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2281; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k73p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k73p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2281; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2282 */
  __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gshift(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g),__pyx_v_n))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2282; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("_py_pari.gen.__lshift__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_k74p;

static char (__pyx_k74[]) = "error inverting PARI object";

static PyObject *__pyx_f_8_py_pari_3gen___invert__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_8_py_pari_3gen___invert__(PyObject *__pyx_v_self) {
  PyObject *__pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_n = Py_None; Py_INCREF(__pyx_v_n);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2285 */
  __pyx_1 = PyInt_FromLong(setjmp(GP_DATA->env)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2285; goto __pyx_L1;}
  Py_DECREF(__pyx_v_n);
  __pyx_v_n = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2286 */
  __pyx_2 = PyObject_IsTrue(__pyx_v_n); if (__pyx_2 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2286; goto __pyx_L1;}
  if (__pyx_2) {
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2286; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2286; goto __pyx_L1;}
    Py_INCREF(__pyx_v_n);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_n);
    Py_INCREF(__pyx_k74p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k74p);
    __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2286; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2287 */
  __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(ginv(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2287; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("_py_pari.gen.__invert__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_n);
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n_polcoeff;
static PyObject *__pyx_n_isinstance;
static PyObject *__pyx_n_tuple;
static PyObject *__pyx_n_nrows;
static PyObject *__pyx_n_IndexError;
static PyObject *__pyx_n_ncols;

static PyObject *__pyx_k75p;
static PyObject *__pyx_k76p;
static PyObject *__pyx_k77p;

static char (__pyx_k75[]) = "row i(=%s) must be between 0 and %s";
static char (__pyx_k76[]) = "column j(=%s) must be between 0 and %s";
static char (__pyx_k77[]) = "index (%s) must be between 0 and %s";

static PyObject *__pyx_f_8_py_pari_3gen___getitem__(PyObject *__pyx_v_self, PyObject *__pyx_v_n); /*proto*/
static char __pyx_doc_8_py_pari_3gen___getitem__[] = "\n        Return a *copy* of the nth entry.\n\n        The indexing is 0-based, like in Python.  However, *copying*\n        the nth entry instead of returning reference is different\n        than what one usually does in Python.  However, we do it\n        this way for consistency with the PARI/GP interpreter, which\n        does make copies.\n        ";
static PyObject *__pyx_f_8_py_pari_3gen___getitem__(PyObject *__pyx_v_self, PyObject *__pyx_v_n) {
  PyObject *__pyx_v_i;
  PyObject *__pyx_v_j;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  int __pyx_6;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_n);
  __pyx_v_i = Py_None; Py_INCREF(__pyx_v_i);
  __pyx_v_j = Py_None; Py_INCREF(__pyx_v_j);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2302 */
  __pyx_1 = (typ(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g) == t_POL);
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2303 */
    __pyx_2 = PyObject_GetAttr(__pyx_v_self, __pyx_n_polcoeff); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2303; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2303; goto __pyx_L1;}
    Py_INCREF(__pyx_v_n);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_n);
    __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2303; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_r = __pyx_4;
    __pyx_4 = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2305 */
  __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_isinstance); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2305; goto __pyx_L1;}
  __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_tuple); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2305; goto __pyx_L1;}
  __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2305; goto __pyx_L1;}
  Py_INCREF(__pyx_v_n);
  PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_n);
  PyTuple_SET_ITEM(__pyx_4, 1, __pyx_3);
  __pyx_3 = 0;
  __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2305; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  __pyx_1 = PyObject_IsTrue(__pyx_3); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2305; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2306 */
    __pyx_2 = PyInt_FromLong(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2306; goto __pyx_L1;}
    __pyx_4 = PyObject_GetItem(__pyx_v_n, __pyx_2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2306; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_3 = PyInt_FromLong(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2306; goto __pyx_L1;}
    __pyx_2 = PyObject_GetItem(__pyx_v_n, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2306; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_v_i);
    __pyx_v_i = __pyx_4;
    __pyx_4 = 0;
    Py_DECREF(__pyx_v_j);
    __pyx_v_j = __pyx_2;
    __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2307 */
    __pyx_3 = PyInt_FromLong(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2307; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_v_i, __pyx_3, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2307; goto __pyx_L1;}
    __pyx_1 = __pyx_1 < 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    if (!__pyx_1) {
      __pyx_4 = PyObject_GetAttr(__pyx_v_self, __pyx_n_nrows); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2307; goto __pyx_L1;}
      __pyx_2 = PyTuple_New(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2307; goto __pyx_L1;}
      __pyx_3 = PyObject_CallObject(__pyx_4, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2307; goto __pyx_L1;}
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      if (PyObject_Cmp(__pyx_v_i, __pyx_3, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2307; goto __pyx_L1;}
      __pyx_1 = __pyx_1 >= 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
    }
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2308 */
      __pyx_4 = __Pyx_GetName(__pyx_b, __pyx_n_IndexError); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2308; goto __pyx_L1;}
      __pyx_2 = PyObject_GetAttr(__pyx_v_self, __pyx_n_nrows); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2308; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2308; goto __pyx_L1;}
      __pyx_5 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2308; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __pyx_2 = PyTuple_New(2); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2308; goto __pyx_L1;}
      Py_INCREF(__pyx_v_i);
      PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_i);
      PyTuple_SET_ITEM(__pyx_2, 1, __pyx_5);
      __pyx_5 = 0;
      __pyx_3 = PyNumber_Remainder(__pyx_k75p, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2308; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      __Pyx_Raise(__pyx_4, __pyx_3, 0);
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2308; goto __pyx_L1;}
      goto __pyx_L4;
    }
    __pyx_L4:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2309 */
    __pyx_5 = PyInt_FromLong(0); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2309; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_v_j, __pyx_5, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2309; goto __pyx_L1;}
    __pyx_1 = __pyx_1 < 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    if (!__pyx_1) {
      __pyx_2 = PyObject_GetAttr(__pyx_v_self, __pyx_n_ncols); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2309; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2309; goto __pyx_L1;}
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2309; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      if (PyObject_Cmp(__pyx_v_j, __pyx_3, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2309; goto __pyx_L1;}
      __pyx_1 = __pyx_1 >= 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
    }
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2310 */
      __pyx_5 = __Pyx_GetName(__pyx_b, __pyx_n_IndexError); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2310; goto __pyx_L1;}
      __pyx_2 = PyObject_GetAttr(__pyx_v_self, __pyx_n_ncols); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2310; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2310; goto __pyx_L1;}
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2310; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      __pyx_2 = PyTuple_New(2); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2310; goto __pyx_L1;}
      Py_INCREF(__pyx_v_j);
      PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_j);
      PyTuple_SET_ITEM(__pyx_2, 1, __pyx_3);
      __pyx_3 = 0;
      __pyx_4 = PyNumber_Remainder(__pyx_k76p, __pyx_2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2310; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      __Pyx_Raise(__pyx_5, __pyx_4, 0);
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2310; goto __pyx_L1;}
      goto __pyx_L5;
    }
    __pyx_L5:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2311 */
    __pyx_3 = PyInt_FromLong(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2311; goto __pyx_L1;}
    __pyx_2 = PyNumber_Add(__pyx_v_j, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2311; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_1 = PyInt_AsLong(__pyx_2); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2311; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_5 = PyInt_FromLong(1); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2311; goto __pyx_L1;}
    __pyx_4 = PyNumber_Add(__pyx_v_i, __pyx_5); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2311; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    __pyx_6 = PyInt_AsLong(__pyx_4); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2311; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_3 = ((PyObject *)__pyx_f_8_py_pari_new_ref(((GEN )(((GEN )(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g[__pyx_1]))[__pyx_6])),__pyx_v_self)); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2311; goto __pyx_L1;}
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2313 */
  __pyx_2 = PyInt_FromLong(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2313; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_v_n, __pyx_2, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2313; goto __pyx_L1;}
  __pyx_1 = __pyx_1 < 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__pyx_1) {
    __pyx_5 = PyInt_FromLong(glength(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g)); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2313; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_v_n, __pyx_5, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2313; goto __pyx_L1;}
    __pyx_1 = __pyx_1 >= 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
  }
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2314 */
    __pyx_4 = __Pyx_GetName(__pyx_b, __pyx_n_IndexError); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2314; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong((glength(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g) - 1)); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2314; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(2); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2314; goto __pyx_L1;}
    Py_INCREF(__pyx_v_n);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_n);
    PyTuple_SET_ITEM(__pyx_2, 1, __pyx_3);
    __pyx_3 = 0;
    __pyx_5 = PyNumber_Remainder(__pyx_k77p, __pyx_2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2314; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __Pyx_Raise(__pyx_4, __pyx_5, 0);
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2314; goto __pyx_L1;}
    goto __pyx_L6;
  }
  __pyx_L6:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2315 */
  __pyx_3 = PyInt_FromLong(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2315; goto __pyx_L1;}
  __pyx_2 = PyNumber_Add(__pyx_v_n, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2315; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_6 = PyInt_AsLong(__pyx_2); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2315; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_4 = ((PyObject *)__pyx_f_8_py_pari_new_ref(((GEN )(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g[__pyx_6])),__pyx_v_self)); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2315; goto __pyx_L1;}
  __pyx_r = __pyx_4;
  __pyx_4 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("_py_pari.gen.__getitem__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_i);
  Py_DECREF(__pyx_v_j);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_n);
  return __pyx_r;
}

static PyObject *__pyx_f_8_py_pari_3gen___getslice__(PyObject *__pyx_v_self, int __pyx_arg_i, int __pyx_arg_j); /*proto*/
static char __pyx_doc_8_py_pari_3gen___getslice__[] = "\n        EXAMPLES:\n            >>> v = pari(xrange(20))\n            >>> v[2:5]\n            [2, 3, 4]\n            >>> v[:]\n            [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19]\n            >>> v[10:]\n            [10, 11, 12, 13, 14, 15, 16, 17, 18, 19]\n            >>> v[:5]\n            [0, 1, 2, 3, 4]\n            >>> v\n            [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19]\n            >>> v[-1]\n            Traceback (most recent call last):\n            ...\n            IndexError: index (-1) must be between 0 and 19\n            >>> v[:-3]\n            [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16]\n            >>> v[5:]\n            [5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19]\n        ";
static PyObject *__pyx_f_8_py_pari_3gen___getslice__(PyObject *__pyx_v_self, int __pyx_arg_i, int __pyx_arg_j) {
  long __pyx_v_i;
  long __pyx_v_j;
  long __pyx_v_l;
  long __pyx_v_k;
  PyObject *__pyx_v_v;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_i = __pyx_arg_i;
  __pyx_v_j = __pyx_arg_j;
  __pyx_v_v = Py_None; Py_INCREF(__pyx_v_v);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2342 */
  __pyx_v_l = glength(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2343 */
  __pyx_1 = (__pyx_v_j >= __pyx_v_l);
  if (__pyx_1) {
    __pyx_v_j = __pyx_v_l;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2344 */
  __pyx_1 = (__pyx_v_i < 0);
  if (__pyx_1) {
    __pyx_v_i = 0;
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2345 */
  __pyx_1 = (__pyx_v_j <= __pyx_v_i);
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_vector); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2345; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2345; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2345; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2345; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;
    goto __pyx_L4;
  }
  __pyx_L4:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2346 */
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_vector); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2346; goto __pyx_L1;}
  __pyx_4 = PyInt_FromLong((__pyx_v_j - __pyx_v_i)); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2346; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2346; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_4);
  __pyx_4 = 0;
  __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2346; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_v_v);
  __pyx_v_v = __pyx_4;
  __pyx_4 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2347 */
  for (__pyx_v_k = __pyx_v_i; __pyx_v_k < __pyx_v_j; ++__pyx_v_k) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2348 */
    __pyx_2 = PyInt_FromLong(__pyx_v_k); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2348; goto __pyx_L1;}
    __pyx_3 = PyObject_GetItem(__pyx_v_self, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2348; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_4 = PyInt_FromLong((__pyx_v_k - __pyx_v_i)); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2348; goto __pyx_L1;}
    if (PyObject_SetItem(__pyx_v_v, __pyx_4, __pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2348; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_L5:;
  }
  __pyx_L6:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2349 */
  Py_INCREF(__pyx_v_v);
  __pyx_r = __pyx_v_v;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("_py_pari.gen.__getslice__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_v);
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n___setitem__;

static PyObject *__pyx_k79p;
static PyObject *__pyx_k80p;
static PyObject *__pyx_k81p;

static char (__pyx_k79[]) = "row i(=%s) must be between 0 and %s";
static char (__pyx_k80[]) = "column j(=%s) must be between 0 and %s";
static char (__pyx_k81[]) = "index (%s) must be between 0 and %s";

static int __pyx_f_8_py_pari_3gen___setitem__(PyObject *__pyx_v_self, PyObject *__pyx_v_n, PyObject *__pyx_v_y); /*proto*/
static char __pyx_doc_8_py_pari_3gen___setitem__[] = "\n        Set the nth entry to a reference to y.  \n        \n        WARNINGS:\n\n            -- There is a known BUG: If v is a vector and entry i of v is a vector,\n                        v[i][j] = x\n               should set entry j of v[i] to x.  Instead it sets it to nonsense.\n               I do not understand why this occurs.  The following is a safe way\n               to do the same thing:\n                        tmp = v[i]; tmp[j] = x    \n        \n            -- The indexing is 0-based, like everywhere else in Python, but\n               *unlike* in GP/PARI.\n            \n            -- Assignment sets the nth entry to a reference to y,\n               assuming y is an object of type gen.  This is the same\n               as in Python, but *different* than what happens in the\n               gp interpreter, where assignment makes a copy of y.\n\n            -- Because setting creates references it is *possible* to\n               make circular references, unlike in GP.  Do *not* do\n               this (see the example below).  If you need circular\n               references, work at the Python level (where they work\n               well), not the PARI object level.\n\n        EXAMPLES:\n            >>> v = pari(range(10))\n            >>> v\n            [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]\n            >>> v[0] = 10\n            >>> w = pari([5,8,-20])\n            >>> v\n            [10, 1, 2, 3, 4, 5, 6, 7, 8, 9]\n            >>> v[1] = w\n            >>> v\n            [10, [5, 8, -20], 2, 3, 4, 5, 6, 7, 8, 9]\n            >>> w[0] = -30\n            >>> v\n            [10, [-30, 8, -20], 2, 3, 4, 5, 6, 7, 8, 9]\n            >>> t = v[1]; t[1] = 10   # don\'t do v[1][1] !!! (because of mysterious BUG...)\n            >>> v\n            [10, [-30, 10, -20], 2, 3, 4, 5, 6, 7, 8, 9]\n            >>> w\n            [-30, 10, -20]\n            \n        Finally, we create a circular reference:\n            >>> v = pari([0])\n            >>> w = pari([v])\n            >>> v\n            [0]\n            >>> w\n            [[0]]\n            >>> v[0] = w\n            >>> # Now there is a circular reference.  Trying to access v[0] will crash SAGE.\n\n        ";
static int __pyx_f_8_py_pari_3gen___setitem__(PyObject *__pyx_v_self, PyObject *__pyx_v_n, PyObject *__pyx_v_y) {
  int __pyx_v_e;
  struct __pyx_obj_8_py_pari_gen *__pyx_v_x;
  PyObject *__pyx_v_i;
  PyObject *__pyx_v_j;
  int __pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  int __pyx_6;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_n);
  Py_INCREF(__pyx_v_y);
  ((PyObject*)__pyx_v_x) = Py_None; Py_INCREF(((PyObject*)__pyx_v_x));
  __pyx_v_i = Py_None; Py_INCREF(__pyx_v_i);
  __pyx_v_j = Py_None; Py_INCREF(__pyx_v_j);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2410 */
  __pyx_v_e = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2411 */
  __pyx_1 = __pyx_v_e;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2411; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_e); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2411; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2411; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_n___setitem__);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_n___setitem__);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2411; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2414 */
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2414; goto __pyx_L1;}
  __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2414; goto __pyx_L1;}
  Py_INCREF(__pyx_v_y);
  PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_y);
  __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2414; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2414; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v_x));
  ((PyObject *)__pyx_v_x) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2415 */
  __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_isinstance); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2415; goto __pyx_L1;}
  __pyx_4 = __Pyx_GetName(__pyx_b, __pyx_n_tuple); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2415; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2415; goto __pyx_L1;}
  Py_INCREF(__pyx_v_n);
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_n);
  PyTuple_SET_ITEM(__pyx_3, 1, __pyx_4);
  __pyx_4 = 0;
  __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2415; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_1 = PyObject_IsTrue(__pyx_4); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2415; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2416 */
    if (PyObject_SetItem(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->refers_to, __pyx_v_n, ((PyObject *)__pyx_v_x)) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2416; goto __pyx_L1;}

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2417 */
    __pyx_2 = PyInt_FromLong(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2417; goto __pyx_L1;}
    __pyx_3 = PyObject_GetItem(__pyx_v_n, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2417; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_v_i);
    __pyx_v_i = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2418 */
    __pyx_4 = PyInt_FromLong(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2418; goto __pyx_L1;}
    __pyx_2 = PyObject_GetItem(__pyx_v_n, __pyx_4); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2418; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_v_j);
    __pyx_v_j = __pyx_2;
    __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2419 */
    __pyx_3 = PyInt_FromLong(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2419; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_v_i, __pyx_3, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2419; goto __pyx_L1;}
    __pyx_1 = __pyx_1 < 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    if (!__pyx_1) {
      __pyx_4 = PyObject_GetAttr(__pyx_v_self, __pyx_n_nrows); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2419; goto __pyx_L1;}
      __pyx_2 = PyTuple_New(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2419; goto __pyx_L1;}
      __pyx_3 = PyObject_CallObject(__pyx_4, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2419; goto __pyx_L1;}
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      if (PyObject_Cmp(__pyx_v_i, __pyx_3, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2419; goto __pyx_L1;}
      __pyx_1 = __pyx_1 >= 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
    }
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2420 */
      __pyx_4 = __Pyx_GetName(__pyx_b, __pyx_n_IndexError); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2420; goto __pyx_L1;}
      __pyx_2 = PyObject_GetAttr(__pyx_v_self, __pyx_n_nrows); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2420; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2420; goto __pyx_L1;}
      __pyx_5 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2420; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __pyx_2 = PyTuple_New(2); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2420; goto __pyx_L1;}
      Py_INCREF(__pyx_v_i);
      PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_i);
      PyTuple_SET_ITEM(__pyx_2, 1, __pyx_5);
      __pyx_5 = 0;
      __pyx_3 = PyNumber_Remainder(__pyx_k79p, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2420; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      __Pyx_Raise(__pyx_4, __pyx_3, 0);
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2420; goto __pyx_L1;}
      goto __pyx_L4;
    }
    __pyx_L4:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2421 */
    __pyx_5 = PyInt_FromLong(0); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2421; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_v_j, __pyx_5, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2421; goto __pyx_L1;}
    __pyx_1 = __pyx_1 < 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    if (!__pyx_1) {
      __pyx_2 = PyObject_GetAttr(__pyx_v_self, __pyx_n_ncols); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2421; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2421; goto __pyx_L1;}
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2421; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      if (PyObject_Cmp(__pyx_v_j, __pyx_3, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2421; goto __pyx_L1;}
      __pyx_1 = __pyx_1 >= 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
    }
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2422 */
      __pyx_5 = __Pyx_GetName(__pyx_b, __pyx_n_IndexError); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2422; goto __pyx_L1;}
      __pyx_2 = PyObject_GetAttr(__pyx_v_self, __pyx_n_ncols); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2422; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2422; goto __pyx_L1;}
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2422; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      __pyx_2 = PyTuple_New(2); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2422; goto __pyx_L1;}
      Py_INCREF(__pyx_v_j);
      PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_j);
      PyTuple_SET_ITEM(__pyx_2, 1, __pyx_3);
      __pyx_3 = 0;
      __pyx_4 = PyNumber_Remainder(__pyx_k80p, __pyx_2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2422; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      __Pyx_Raise(__pyx_5, __pyx_4, 0);
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2422; goto __pyx_L1;}
      goto __pyx_L5;
    }
    __pyx_L5:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2423 */
    __pyx_3 = PyInt_FromLong(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2423; goto __pyx_L1;}
    __pyx_2 = PyNumber_Add(__pyx_v_j, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2423; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_1 = PyInt_AsLong(__pyx_2); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2423; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_5 = PyInt_FromLong(1); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2423; goto __pyx_L1;}
    __pyx_4 = PyNumber_Add(__pyx_v_i, __pyx_5); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2423; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    __pyx_6 = PyInt_AsLong(__pyx_4); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2423; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    (((GEN )(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g[__pyx_1]))[__pyx_6]) = ((long )__pyx_v_x->g);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2424 */
    __pyx_r = 0;
    goto __pyx_L0;
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2426 */
  __pyx_3 = PyInt_FromLong(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2426; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_v_n, __pyx_3, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2426; goto __pyx_L1;}
  __pyx_1 = __pyx_1 < 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  if (!__pyx_1) {
    __pyx_2 = PyInt_FromLong(glength(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2426; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_v_n, __pyx_2, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2426; goto __pyx_L1;}
    __pyx_1 = __pyx_1 >= 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
  }
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2427 */
    __pyx_5 = __Pyx_GetName(__pyx_b, __pyx_n_IndexError); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2427; goto __pyx_L1;}
    __pyx_4 = PyInt_FromLong((glength(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g) - 1)); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2427; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2427; goto __pyx_L1;}
    Py_INCREF(__pyx_v_n);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_n);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_4);
    __pyx_4 = 0;
    __pyx_2 = PyNumber_Remainder(__pyx_k81p, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2427; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __Pyx_Raise(__pyx_5, __pyx_2, 0);
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2427; goto __pyx_L1;}
    goto __pyx_L6;
  }
  __pyx_L6:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2428 */
  if (PyObject_SetItem(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->refers_to, __pyx_v_n, ((PyObject *)__pyx_v_x)) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2428; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2431 */
  __pyx_v_e = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2432 */
  __pyx_6 = __pyx_v_e;
  if (__pyx_6) {
    __pyx_4 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2432; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_e); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2432; goto __pyx_L1;}
    __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2432; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_5, 0, __pyx_3);
    Py_INCREF(__pyx_n___setitem__);
    PyTuple_SET_ITEM(__pyx_5, 1, __pyx_n___setitem__);
    __pyx_3 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_4, __pyx_5); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2432; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    goto __pyx_L7;
  }
  __pyx_L7:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2433 */
  __pyx_3 = PyInt_FromLong(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2433; goto __pyx_L1;}
  __pyx_4 = PyNumber_Add(__pyx_v_n, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2433; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_1 = PyInt_AsLong(__pyx_4); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2433; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  (((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g[__pyx_1]) = ((long )__pyx_v_x->g);

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("_py_pari.gen.__setitem__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_i);
  Py_DECREF(__pyx_v_j);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_n);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}

static int __pyx_f_8_py_pari_3gen___len__(PyObject *__pyx_v_self); /*proto*/
static int __pyx_f_8_py_pari_3gen___len__(PyObject *__pyx_v_self) {
  int __pyx_r;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2436 */
  __pyx_r = glength(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g);
  goto __pyx_L0;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("_py_pari.gen.__len__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_8_py_pari_3gen_ncols(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_8_py_pari_3gen_ncols(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2439 */
  __pyx_1 = PyInt_FromLong(glength(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2439; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("_py_pari.gen.ncols");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}


static PyObject *__pyx_f_8_py_pari_3gen_nrows(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_8_py_pari_3gen_nrows(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2443 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2444 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2444; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2444; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2444; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_n_nrows);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_n_nrows);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2444; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2445 */
  __pyx_2 = PyInt_FromLong(glength(((GEN )(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g[1])))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2445; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("_py_pari.gen.nrows");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_8_py_pari_3gen_polcoeff(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_8_py_pari_3gen_polcoeff[] = "\n        EXAMPLES:\n            >>> f = pari(\"x^2 + y^3 + x*y\")\n            >>> f\n            x^2 + y*x + y^3\n            >>> f.polcoeff(1)\n            y\n            >>> f.polcoeff(3)\n            0\n            >>> f.polcoeff(3, \"y\")\n            1\n            >>> f.polcoeff(1, \"y\")\n            x\n        ";
static PyObject *__pyx_f_8_py_pari_3gen_polcoeff(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_n;
  PyObject *__pyx_v_var = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"n","var",0};
  __pyx_v_var = __pyx_k5;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l|O", __pyx_argnames, &__pyx_v_n, &__pyx_v_var)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_var);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2462 */
  __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(polcoeff0(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g),__pyx_v_n,__pyx_f_8_py_pari_get_var(__pyx_v_var)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2462; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("_py_pari.gen.polcoeff");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_var);
  return __pyx_r;
}

static int __pyx_f_8_py_pari_3gen___cmp__(PyObject *__pyx_v_self, PyObject *__pyx_v_other); /*proto*/
static char __pyx_doc_8_py_pari_3gen___cmp__[] = "\n        Comparisons.\n        ";
static int __pyx_f_8_py_pari_3gen___cmp__(PyObject *__pyx_v_self, PyObject *__pyx_v_other) {
  int __pyx_v_tg;
  int __pyx_v_to;
  PyObject *__pyx_v_sg;
  PyObject *__pyx_v_so;
  int __pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);
  __pyx_v_sg = Py_None; Py_INCREF(__pyx_v_sg);
  __pyx_v_so = Py_None; Py_INCREF(__pyx_v_so);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_other), __pyx_ptype_8_py_pari_gen, 1, "other")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2469; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2473 */
  __pyx_1 = gegal(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g,((struct __pyx_obj_8_py_pari_gen *)__pyx_v_other)->g);
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2474 */
    __pyx_r = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2476 */
  __pyx_v_tg = typ(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2477 */
  __pyx_v_to = typ(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_other)->g);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2479 */
  __pyx_1 = __pyx_f_8_py_pari_is_int_or_real_type(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g);
  if (__pyx_1) {
    __pyx_1 = __pyx_f_8_py_pari_is_int_or_real_type(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_other)->g);
  }
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2480 */
    __pyx_r = gcmp(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g,((struct __pyx_obj_8_py_pari_gen *)__pyx_v_other)->g);
    goto __pyx_L0;
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2482 */
  __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2482; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2482; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_self);
  __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2482; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_v_sg);
  __pyx_v_sg = __pyx_4;
  __pyx_4 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2483 */
  __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2483; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2483; goto __pyx_L1;}
  Py_INCREF(__pyx_v_other);
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_other);
  __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2483; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_v_so);
  __pyx_v_so = __pyx_4;
  __pyx_4 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2484 */
  if (PyObject_Cmp(__pyx_v_sg, __pyx_v_so, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2484; goto __pyx_L1;}
  __pyx_1 = __pyx_1 < 0;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2485 */
    __pyx_r = (-1);
    goto __pyx_L0;
    goto __pyx_L4;
  }
  /*else*/ {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2487 */
    __pyx_r = 1;
    goto __pyx_L0;
  }
  __pyx_L4:;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("_py_pari.gen.__cmp__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_sg);
  Py_DECREF(__pyx_v_so);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_n___cmp__;
static PyObject *__pyx_n_bool;

static PyObject *__pyx_f_8_py_pari_3gen___richcmp__(PyObject *__pyx_v_self, PyObject *__pyx_v_other, int __pyx_v_op); /*proto*/
static char __pyx_doc_8_py_pari_3gen___richcmp__[] = "\n        EXAMPLES:\n            >>> a = pari(5)\n            >>> b = 10\n            >>> a < b\n            True\n            >>> a <= b\n            True\n            >>> a <= 5\n            True\n            >>> a > b\n            False\n            >>> a >= b\n            False\n            >>> a >= pari(10)\n            False\n            >>> a == 5\n            True\n            >>> a is 5\n            False\n        ";
static PyObject *__pyx_f_8_py_pari_3gen___richcmp__(PyObject *__pyx_v_self, PyObject *__pyx_v_other, int __pyx_v_op) {
  int __pyx_v_n;
  struct __pyx_obj_8_py_pari_gen *__pyx_v_x;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);
  ((PyObject*)__pyx_v_x) = Py_None; Py_INCREF(((PyObject*)__pyx_v_x));
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_self), __pyx_ptype_8_py_pari_gen, 1, "self")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2490; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2514 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2514; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2514; goto __pyx_L1;}
  Py_INCREF(__pyx_v_other);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_other);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2514; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2514; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v_x));
  ((PyObject *)__pyx_v_x) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2515 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n___cmp__); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2515; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2515; goto __pyx_L1;}
  Py_INCREF(((PyObject *)__pyx_v_x));
  PyTuple_SET_ITEM(__pyx_2, 0, ((PyObject *)__pyx_v_x));
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2515; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_4 = PyInt_AsLong(__pyx_3); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2515; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_v_n = __pyx_4;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2516 */
  __pyx_4 = (__pyx_v_op == 0);
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2517 */
    __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_bool); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2517; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong((__pyx_v_n < 0)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2517; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2517; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2517; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_4 = (__pyx_v_op == 1);
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2519 */
    __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_bool); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2519; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong((__pyx_v_n <= 0)); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2519; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2519; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_3);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2519; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_4 = (__pyx_v_op == 2);
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2521 */
    __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_bool); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2521; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong((__pyx_v_n == 0)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2521; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2521; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2521; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_4 = (__pyx_v_op == 3);
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2523 */
    __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_bool); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2523; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong((__pyx_v_n != 0)); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2523; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2523; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_3);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2523; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_4 = (__pyx_v_op == 4);
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2525 */
    __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_bool); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2525; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong((__pyx_v_n > 0)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2525; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2525; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2525; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_4 = (__pyx_v_op == 5);
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2527 */
    __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_bool); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2527; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong((__pyx_v_n >= 0)); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2527; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2527; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_3);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2527; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("_py_pari.gen.__richcmp__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_f_8_py_pari_3gen_copy(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_8_py_pari_3gen_copy(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2530 */
  __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2530; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("_py_pari.gen.copy");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n_replace;
static PyObject *__pyx_n_find;

static PyObject *__pyx_k84p;
static PyObject *__pyx_k85p;
static PyObject *__pyx_k86p;
static PyObject *__pyx_k87p;
static PyObject *__pyx_k88p;
static PyObject *__pyx_k89p;
static PyObject *__pyx_k90p;
static PyObject *__pyx_k91p;
static PyObject *__pyx_k92p;
static PyObject *__pyx_k93p;

static char (__pyx_k84[]) = "Mat(";
static char (__pyx_k85[]) = "[";
static char (__pyx_k86[]) = "]";
static char (__pyx_k87[]) = "~";
static char (__pyx_k88[]) = "";
static char (__pyx_k89[]) = ";";
static char (__pyx_k90[]) = ";";
static char (__pyx_k91[]) = "], [";
static char (__pyx_k92[]) = "[";
static char (__pyx_k93[]) = "]";

static PyObject *__pyx_f_8_py_pari_3gen_list_str(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_8_py_pari_3gen_list_str[] = "\n        Return str that might correctly evaluate to a Python-list.\n        ";
static PyObject *__pyx_f_8_py_pari_3gen_list_str(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_s;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_s = Py_None; Py_INCREF(__pyx_v_s);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2543 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2543; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2543; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_self);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2543; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_s);
  __pyx_v_s = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2544 */
  __pyx_1 = PySequence_GetSlice(__pyx_v_s, 0, 4); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2544; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_1, __pyx_k84p, &__pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2544; goto __pyx_L1;}
  __pyx_4 = __pyx_4 == 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2545 */
    __pyx_2 = PySequence_GetSlice(__pyx_v_s, 4, (-1)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2545; goto __pyx_L1;}
    __pyx_3 = PyNumber_Add(__pyx_k85p, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2545; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_1 = PyNumber_Add(__pyx_3, __pyx_k86p); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2545; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_v_s);
    __pyx_v_s = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2546 */
  __pyx_2 = PyObject_GetAttr(__pyx_v_s, __pyx_n_replace); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2546; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2546; goto __pyx_L1;}
  Py_INCREF(__pyx_k87p);
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_k87p);
  Py_INCREF(__pyx_k88p);
  PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k88p);
  __pyx_1 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2546; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_v_s);
  __pyx_v_s = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2547 */
  __pyx_2 = PyObject_GetAttr(__pyx_v_s, __pyx_n_find); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2547; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2547; goto __pyx_L1;}
  Py_INCREF(__pyx_k89p);
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_k89p);
  __pyx_1 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2547; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_2 = PyInt_FromLong((-1)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2547; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_1, __pyx_2, &__pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2547; goto __pyx_L1;}
  __pyx_4 = __pyx_4 != 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2548 */
    __pyx_3 = PyObject_GetAttr(__pyx_v_s, __pyx_n_replace); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2548; goto __pyx_L1;}
    __pyx_1 = PyTuple_New(2); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2548; goto __pyx_L1;}
    Py_INCREF(__pyx_k90p);
    PyTuple_SET_ITEM(__pyx_1, 0, __pyx_k90p);
    Py_INCREF(__pyx_k91p);
    PyTuple_SET_ITEM(__pyx_1, 1, __pyx_k91p);
    __pyx_2 = PyObject_CallObject(__pyx_3, __pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2548; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_v_s);
    __pyx_v_s = __pyx_2;
    __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2549 */
    __pyx_3 = PyNumber_Add(__pyx_k92p, __pyx_v_s); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2549; goto __pyx_L1;}
    __pyx_1 = PyNumber_Add(__pyx_3, __pyx_k93p); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2549; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_v_s);
    __pyx_v_s = __pyx_1;
    __pyx_1 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2550 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_eval); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2550; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2550; goto __pyx_L1;}
    Py_INCREF(__pyx_v_s);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_s);
    __pyx_1 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2550; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;
    goto __pyx_L3;
  }
  /*else*/ {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2552 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_eval); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2552; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2552; goto __pyx_L1;}
    Py_INCREF(__pyx_v_s);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_s);
    __pyx_1 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2552; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;
  }
  __pyx_L3:;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("_py_pari.gen.list_str");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_s);
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n_int;

static PyObject *__pyx_k94p;

static char (__pyx_k94[]) = "error in __int__";

static PyObject *__pyx_f_8_py_pari_3gen___int__(PyObject *__pyx_v_self); /*proto*/
static char __pyx_doc_8_py_pari_3gen___int__[] = "\n        Return Python int.\n        ";
static PyObject *__pyx_f_8_py_pari_3gen___int__(PyObject *__pyx_v_self) {
  int __pyx_v_err;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2564 */
  __pyx_v_err = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2565 */
  __pyx_1 = __pyx_v_err;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2566 */
    __pyx_1 = (__pyx_v_err == 28);
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_int); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2566; goto __pyx_L1;}
      __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2566; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2566; goto __pyx_L1;}
      Py_INCREF(__pyx_v_self);
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_self);
      __pyx_5 = PyObject_CallObject(__pyx_3, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2566; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2566; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_5);
      __pyx_5 = 0;
      __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2566; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __pyx_r = __pyx_4;
      __pyx_4 = 0;
      goto __pyx_L0;
      goto __pyx_L3;
    }
    __pyx_L3:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2567 */
    __pyx_5 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2567; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_err); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2567; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2567; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_k94p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k94p);
    __pyx_2 = 0;
    __pyx_4 = PyObject_CallObject(__pyx_5, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2567; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2568 */
  __pyx_2 = PyInt_FromLong(gtolong(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2568; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("_py_pari.gen.__int__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n_TypeError;
static PyObject *__pyx_n_append;

static PyObject *__pyx_k95p;

static char (__pyx_k95[]) = "Object (=%s) must be of type t_VEC.";

static PyObject *__pyx_f_8_py_pari_3gen_python_list(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_8_py_pari_3gen_python_list[] = "\n        Return a Python list of the PARI gens.  This object must be of\n        type t_VEC\n\n        INPUT: None\n        OUTPUT:\n           list -- Python list whose elements are the\n                   elements of the input gen.\n        EXAMPLES:\n            >>> v=pari([1,2,3,10,102,10])\n            >>> w = v.python_list()\n            >>> w\n            [1, 2, 3, 10, 102, 10]\n            >>> type(w[0])\n            <type \'_py_pari.gen\'>\n        ";
static PyObject *__pyx_f_8_py_pari_3gen_python_list(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_n;
  long __pyx_v_m;
  struct __pyx_obj_8_py_pari_gen *__pyx_v_t;
  PyObject *__pyx_v_V;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);
  ((PyObject*)__pyx_v_t) = Py_None; Py_INCREF(((PyObject*)__pyx_v_t));
  __pyx_v_V = Py_None; Py_INCREF(__pyx_v_V);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2587 */
  __pyx_1 = (typ(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g) != t_VEC);
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2588 */
    __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2588; goto __pyx_L1;}
    __pyx_3 = PyNumber_Remainder(__pyx_k95p, __pyx_v_self); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2588; goto __pyx_L1;}
    __Pyx_Raise(__pyx_2, __pyx_3, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2588; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2591 */
  __pyx_v_m = glength(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2592 */
  __pyx_2 = PyList_New(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2592; goto __pyx_L1;}
  Py_DECREF(__pyx_v_V);
  __pyx_v_V = __pyx_2;
  __pyx_2 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2593 */
  for (__pyx_v_n = 0; __pyx_v_n < __pyx_v_m; ++__pyx_v_n) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2594 */
    __pyx_3 = ((PyObject *)__pyx_f_8_py_pari_new_ref(((GEN )(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g[(__pyx_v_n + 1)])),__pyx_v_V)); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2594; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v_t));
    ((PyObject *)__pyx_v_t) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2595 */
    __pyx_2 = PyObject_GetAttr(__pyx_v_V, __pyx_n_append); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2595; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2595; goto __pyx_L1;}
    Py_INCREF(((PyObject *)__pyx_v_t));
    PyTuple_SET_ITEM(__pyx_3, 0, ((PyObject *)__pyx_v_t));
    __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2595; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_L3:;
  }
  __pyx_L4:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2596 */
  Py_INCREF(__pyx_v_V);
  __pyx_r = __pyx_v_V;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("_py_pari.gen.python_list");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_t);
  Py_DECREF(__pyx_v_V);
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n_python;

static PyObject *__pyx_k96p;

static char (__pyx_k96[]) = "sage.pari.py_pari_py";

static PyObject *__pyx_f_8_py_pari_3gen_python(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_8_py_pari_3gen_python[] = "\n        Return Python eval of self.\n        ";
static PyObject *__pyx_f_8_py_pari_3gen_python(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_sage;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_sage = Py_None; Py_INCREF(__pyx_v_sage);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2602 */
  __pyx_1 = __Pyx_Import(__pyx_k96p, 0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2602; goto __pyx_L1;}
  Py_DECREF(__pyx_v_sage);
  __pyx_v_sage = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2603 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_sage, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2603; goto __pyx_L1;}
  __pyx_2 = PyObject_GetAttr(__pyx_1, __pyx_n_py_pari_py); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2603; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  __pyx_1 = PyObject_GetAttr(__pyx_2, __pyx_n_python); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2603; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2603; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_self);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2603; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("_py_pari.gen.python");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_sage);
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n_long;

static PyObject *__pyx_f_8_py_pari_3gen___long__(PyObject *__pyx_v_self); /*proto*/
static char __pyx_doc_8_py_pari_3gen___long__[] = "\n        Return Python long.\n        ";
static PyObject *__pyx_f_8_py_pari_3gen___long__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2609 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_long); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2609; goto __pyx_L1;}
  __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2609; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2609; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_self);
  __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2609; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2609; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_4);
  __pyx_4 = 0;
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2609; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("_py_pari.gen.__long__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n_float;

static PyObject *__pyx_k97p;

static char (__pyx_k97[]) = "error in __float__";

static PyObject *__pyx_f_8_py_pari_3gen___float__(PyObject *__pyx_v_self); /*proto*/
static char __pyx_doc_8_py_pari_3gen___float__[] = "\n        Return Python float.\n        ";
static PyObject *__pyx_f_8_py_pari_3gen___float__(PyObject *__pyx_v_self) {
  int __pyx_v_err;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2623 */
  __pyx_v_err = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2624 */
  __pyx_1 = __pyx_v_err;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2625 */
    __pyx_1 = (__pyx_v_err == 28);
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_float); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2625; goto __pyx_L1;}
      __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2625; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2625; goto __pyx_L1;}
      Py_INCREF(__pyx_v_self);
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_self);
      __pyx_5 = PyObject_CallObject(__pyx_3, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2625; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2625; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_5);
      __pyx_5 = 0;
      __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2625; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __pyx_r = __pyx_4;
      __pyx_4 = 0;
      goto __pyx_L0;
      goto __pyx_L3;
    }
    __pyx_L3:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2626 */
    __pyx_5 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2626; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(__pyx_v_err); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2626; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2626; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    Py_INCREF(__pyx_k97p);
    PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k97p);
    __pyx_2 = 0;
    __pyx_4 = PyObject_CallObject(__pyx_5, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2626; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2627 */
  __pyx_2 = PyFloat_FromDouble(gtodouble(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2627; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("_py_pari.gen.__float__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_k98p;

static char (__pyx_k98[]) = "error in __bool__";

static PyObject *__pyx_f_8_py_pari_3gen___bool__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_8_py_pari_3gen___bool__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_err;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2631 */
  __pyx_v_err = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2632 */
  __pyx_1 = __pyx_v_err;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2633 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2633; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_err); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2633; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2633; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k98p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k98p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2633; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2634 */
  __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_bool); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2634; goto __pyx_L1;}
  __pyx_4 = PyInt_FromLong((((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g != stoi(0))); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2634; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2634; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_4);
  __pyx_4 = 0;
  __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2634; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_r = __pyx_4;
  __pyx_4 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("_py_pari.gen.__bool__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_8_py_pari_3gen_isprime(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_8_py_pari_3gen_isprime[] = "\n        isprime(x, flag=0): Returns True if x is a PROVEN prime\n        number, and False otherwise. \n\n        INPUT:\n            flag -- int \n                    0 (default): use a combination of algorithms.\n                    1: certify primality using the Pocklington-Lehmer Test.\n                    2: certify primality using the APRCL test.\n        OUTPUT:\n            bool -- True or False\n        EXAMPLES:\n            >>> pari(9).isprime()\n            False\n            >>> pari(17).isprime()\n            True\n            >>> n = pari(561)    # smallest Carmichael number\n            >>> n.isprime()      # not just a pseudo-primality test!\n            False\n            >>> n.isprime(1)\n            False\n            >>> n.isprime(2)\n            False\n        ";
static PyObject *__pyx_f_8_py_pari_3gen_isprime(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_flag = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  long __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"flag",0};
  __pyx_v_flag = __pyx_k6;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_flag)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_flag);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2665 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_bool); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2665; goto __pyx_L1;}
  __pyx_2 = PyInt_AsLong(__pyx_v_flag); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2665; goto __pyx_L1;}
  __pyx_3 = PyInt_FromLong((gisprime(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g,__pyx_2) != stoi(0))); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2665; goto __pyx_L1;}
  __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2665; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
  __pyx_3 = 0;
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2665; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("_py_pari.gen.isprime");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_flag);
  return __pyx_r;
}

static PyObject *__pyx_f_8_py_pari_3gen_divrem(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_8_py_pari_3gen_divrem[] = "\n\n        divrem(x, y, {v}): Euclidean division of x by y giving as a\n            2-dimensional column vector the quotient and the\n            remainder, with respect to v (to main variable if v is\n            omitted).\n\n        >>> \n        ";
static PyObject *__pyx_f_8_py_pari_3gen_divrem(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_y = 0;
  PyObject *__pyx_v_var = 0;
  struct __pyx_obj_8_py_pari_gen *__pyx_v__y;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"y","var",0};
  __pyx_v_var = __pyx_k7;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|O", __pyx_argnames, &__pyx_v_y, &__pyx_v_var)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_y);
  Py_INCREF(__pyx_v_var);
  ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2682 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2682; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2682; goto __pyx_L1;}
  Py_INCREF(__pyx_v_y);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2682; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2682; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__y));
  ((PyObject *)__pyx_v__y) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2683 */
  __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(divrem(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g),__pyx_v__y->g,__pyx_f_8_py_pari_get_var(__pyx_v_var)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2683; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("_py_pari.gen.divrem");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__y);
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  Py_DECREF(__pyx_v_var);
  return __pyx_r;
}

static PyObject *__pyx_f_8_py_pari_3gen_lex(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_8_py_pari_3gen_lex[] = "\n\n        lex(x,y): Compare x and y lexicographically (1 if x>y, 0 if\n            x==y, -1 if x<y)\n        \n        ";
static PyObject *__pyx_f_8_py_pari_3gen_lex(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_y = 0;
  struct __pyx_obj_8_py_pari_gen *__pyx_v__y;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"y",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_y);
  ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2693 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2693; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2693; goto __pyx_L1;}
  Py_INCREF(__pyx_v_y);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2693; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2693; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__y));
  ((PyObject *)__pyx_v__y) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2694 */
  __pyx_1 = PyInt_FromLong(lexcmp(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g,__pyx_v__y->g)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2694; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("_py_pari.gen.lex");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__y);
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}

static PyObject *__pyx_f_8_py_pari_3gen_max(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_8_py_pari_3gen_max[] = "\n        max(x,y): Return the maximum of x and y.\n        ";
static PyObject *__pyx_f_8_py_pari_3gen_max(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_y = 0;
  struct __pyx_obj_8_py_pari_gen *__pyx_v__y;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"y",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_y);
  ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2701 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2701; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2701; goto __pyx_L1;}
  Py_INCREF(__pyx_v_y);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2701; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2701; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__y));
  ((PyObject *)__pyx_v__y) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2702 */
  __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gmax(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g),__pyx_v__y->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2702; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("_py_pari.gen.max");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__y);
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}

static PyObject *__pyx_f_8_py_pari_3gen_min(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_8_py_pari_3gen_min[] = "\n        min(x,y): Return the minumum of x and y.\n        ";
static PyObject *__pyx_f_8_py_pari_3gen_min(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_y = 0;
  struct __pyx_obj_8_py_pari_gen *__pyx_v__y;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"y",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_y);
  ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2709 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2709; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2709; goto __pyx_L1;}
  Py_INCREF(__pyx_v_y);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2709; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2709; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__y));
  ((PyObject *)__pyx_v__y) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2710 */
  __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gmin(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g),__pyx_v__y->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2710; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("_py_pari.gen.min");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__y);
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}

static PyObject *__pyx_f_8_py_pari_3gen_shift(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_8_py_pari_3gen_shift[] = "\n        shift(x,n): shift x left n bits if n>=0, right -n bits if n<0.\n        ";
static PyObject *__pyx_f_8_py_pari_3gen_shift(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"n",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l", __pyx_argnames, &__pyx_v_n)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2716 */
  __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gshift(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g),__pyx_v_n))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2716; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("_py_pari.gen.shift");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_8_py_pari_3gen_shiftmul(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_8_py_pari_3gen_shiftmul[] = "\n        shiftmul(x,n): Return the product of x by 2^n (n>=0 or n<0).\n        ";
static PyObject *__pyx_f_8_py_pari_3gen_shiftmul(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"n",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l", __pyx_argnames, &__pyx_v_n)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2722 */
  __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gmul2n(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g),__pyx_v_n))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2722; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("_py_pari.gen.shiftmul");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_8_py_pari_3gen_sign(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_8_py_pari_3gen_sign[] = "\n        sign(x): Return the sign of x, where x is of type integer, real\n            or fraction.\n        ";
static PyObject *__pyx_f_8_py_pari_3gen_sign(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2729 */
  __pyx_1 = PyInt_FromLong(gsigne(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2729; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("_py_pari.gen.sign");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_8_py_pari_3gen_vecmax(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_8_py_pari_3gen_vecmax[] = "\n        vecmax(x): Return the maximum of the elements of the vector/matrix x,\n        ";
static PyObject *__pyx_f_8_py_pari_3gen_vecmax(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2735 */
  __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(vecmax(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2735; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("_py_pari.gen.vecmax");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_8_py_pari_3gen_vecmin(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_8_py_pari_3gen_vecmin[] = "\n        vecmin(x): Return the maximum of the elements of the vector/matrix x,\n        ";
static PyObject *__pyx_f_8_py_pari_3gen_vecmin(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2742 */
  __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(vecmin(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2742; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("_py_pari.gen.vecmin");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_8_py_pari_3gen_Col(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_8_py_pari_3gen_Col[] = "\n        Col(x): Transforms the object x into a column vector.\n        \n        The vector will have only one component, except in the\n        following cases:\n\n           * When x is a vector or a quadratic form, the resulting\n             vector is the initial object considered as a column\n             vector.\n\n           * When x is a matrix, the resulting vector is the column of\n             row vectors comprising the matrix.\n\n           * When x is a character string, the result is a column of\n             individual characters.\n\n           * When x is a polynomial, the coefficients of the vector\n             start with the leading coefficient of the polynomial.\n\n           * When x is a power series, only the significant\n             coefficients are taken into account, but this time by\n             increasing order of degree.\n\n        INPUT:\n            x -- gen\n        OUTPUT:\n            gen\n        EXAMPLES:\n            >>> pari(1.5).Col()\n            [1.5000000000000000000000000000]~\n            >>> pari([1,2,3,4]).Col()\n            [1, 2, 3, 4]~\n            >>> pari(\'[1,2; 3,4]\').Col()\n            [[1, 2], [3, 4]]~\n            >>> pari(\'\"SAGE\"\').Col()\n            [\"S\", \"A\", \"G\", \"E\"]~\n            >>> pari(\'3*x^3 + x\').Col()\n            [3, 0, 1, 0]~\n            >>> pari(\'x + 3*x^3 + O(x^5)\').Col()\n            [1, 0, 3, 0]~\n        ";
static PyObject *__pyx_f_8_py_pari_3gen_Col(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2793 */
  __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gtocol(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2793; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("_py_pari.gen.Col");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_8_py_pari_3gen_List(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_8_py_pari_3gen_List[] = "\n        List(x): transforms the PARI vector or list x into a list.\n\n        EXAMPLES:\n            >>> v = pari([1,2,3])\n            >>> v\n            [1, 2, 3]\n            >>> v.type()\n            \'t_VEC\'\n            >>> w = v.List()\n            >>> w\n            List([1, 2, 3])\n            >>> w.type()\n            \'t_LIST\'\n        ";
static PyObject *__pyx_f_8_py_pari_3gen_List(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2811 */
  __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gtolist(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2811; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("_py_pari.gen.List");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_8_py_pari_3gen_Mat(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_8_py_pari_3gen_Mat[] = "\n        Mat(x): Returns the matrix defined by x.\n        \n           * If x is already a matrix, a copy of x is created and\n             returned.\n           \n           * If x is not a vector or a matrix, this function returns a\n             1x1 matrix.\n        \n           * If x is a row (resp. column) vector, this functions\n             returns a 1-row (resp. 1-column) matrix, *unless* all\n             elements are column (resp. row) vectors of the same\n             length, in which case the vectors are concatenated\n             sideways and the associated big matrix is returned.\n\n        INPUT:\n            x -- gen\n        OUTPUT:\n            gen -- a PARI matrix\n\n        EXAMPLES:\n            >>> x = pari(5)\n            >>> x.type()\n            \'t_INT\'\n            >>> y = x.Mat()\n            >>> y\n            Mat(5)\n            >>> y.type()\n            \'t_MAT\'\n            >>> x = pari(\'[1,2;3,4]\')\n            >>> x.type()\n            \'t_MAT\'\n            >>> x = pari(\'[1,2,3,4]\')\n            >>> x.type()\n            \'t_VEC\'\n            >>> y = x.Mat()\n            >>> y\n            Mat([1, 2, 3, 4])\n            >>> y.type()\n            \'t_MAT\'\n\n            >>> v = pari(\'[1,2;3,4]\').Vec(); v\n            [[1, 3]~, [2, 4]~]\n            >>> v.Mat()\n            [1, 2; 3, 4]\n            >>> v = pari(\'[1,2;3,4]\').Col(); v\n            [[1, 2], [3, 4]]~\n            >>> v.Mat()\n            [1, 2; 3, 4]\n        ";
static PyObject *__pyx_f_8_py_pari_3gen_Mat(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2864 */
  __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gtomat(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2864; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("_py_pari.gen.Mat");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_8_py_pari_3gen_Mod(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_8_py_pari_3gen_Mod[] = "\n        Mod(x, y): Returns the object x modulo y, denoted Mod(x, y).\n\n        The input y must be a an integer or a polynomial:\n\n           * If y is an INTEGER, x must also be an integer, a rational\n             number, or a p-adic number compatible with the modulus y.\n\n           * If y is a POLYNOMIAL, x must be a scalar (which is not a polmod),\n             a polynomial, a rational function, or a power series.\n\n        WARNING: This function is not the same as x % y, the result of\n        which is an integer or a polynomial.\n\n        INPUT:\n            x -- gen\n            y -- integer or polynomial\n\n        OUTPUT:\n            gen -- intmod or polmod\n            \n        EXAMPLES:\n            >>> z = pari(3)\n            >>> x = z.Mod(pari(7))\n            >>> x\n            Mod(3, 7)\n            >>> x**2\n            Mod(2, 7)\n            >>> x**100\n            Mod(4, 7)\n            >>> x.type()\n            \'t_INTMOD\'\n\n            >>> f = pari(\"x^2 + x + 1\")\n            >>> g = pari(\"x\")\n            >>> a = g.Mod(f)\n            >>> a\n            Mod(x, x^2 + x + 1)\n            >>> a*a\n            Mod(-x - 1, x^2 + x + 1)\n            >>> a.type()\n            \'t_POLMOD\'\n        ";
static PyObject *__pyx_f_8_py_pari_3gen_Mod(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_y = 0;
  struct __pyx_obj_8_py_pari_gen *__pyx_v__y;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"y",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_y);
  ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2911 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2911; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2911; goto __pyx_L1;}
  Py_INCREF(__pyx_v_y);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2911; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2911; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__y));
  ((PyObject *)__pyx_v__y) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2912 */
  __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gmodulcp(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g),__pyx_v__y->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2912; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("_py_pari.gen.Mod");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__y);
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}

static PyObject *__pyx_k99p;

static char (__pyx_k99[]) = "error in Pol";

static PyObject *__pyx_f_8_py_pari_3gen_Pol(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_8_py_pari_3gen_Pol[] = "\n        Pol(x, {v}): convert x into a polynomial with main variable v\n        and return the result.\n\n           * If x is a scalar, returns a constant polynomial.\n           \n           * If x is a power series, the effect is identical\n              to kbd{truncate}, i.e.~it chops off the O(X^k).\n              \n           * If x is a vector, this function creates the polynomial\n             whose coefficients are given in x, with x[0]\n             being the leading coefficient (which can be zero).\n\n        WARNING: This is *not* a substitution function. It will not\n        transform an object containing variables of higher priority\n        than v:\n            >> pari(\'x+y\').Pol(\'y\')\n            Traceback (most recent call last):\n            ...\n            RuntimeError: PARI error 8: error in Pol\n\n        INPUT:\n            x -- gen\n            v -- (optional) which variable, defaults to \'x\'\n        OUTPUT:\n            gen -- a polynomial\n        EXAMPLES:\n            >>> v = pari(\"[1,2,3,4]\")\n            >>> f = v.Pol()\n            >>> f\n            x^3 + 2*x^2 + 3*x + 4\n            >>> f*f\n            x^6 + 4*x^5 + 10*x^4 + 20*x^3 + 25*x^2 + 24*x + 16\n            \n            >>> v = pari(\"[1,2;3,4]\")\n            >>> v.Pol()\n            [1, 3]~*x + [2, 4]~\n        ";
static PyObject *__pyx_f_8_py_pari_3gen_Pol(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_v = 0;
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"v",0};
  __pyx_v_v = __pyx_k8;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_v)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_v);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2954 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2955 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2956 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2956; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2956; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2956; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k99p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k99p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2956; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2957 */
  __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gtopoly(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g),__pyx_f_8_py_pari_get_var(__pyx_v_v)))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2957; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("_py_pari.gen.Pol");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_v);
  return __pyx_r;
}

static PyObject *__pyx_k100p;

static char (__pyx_k100[]) = "error in Polrev";

static PyObject *__pyx_f_8_py_pari_3gen_Polrev(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_8_py_pari_3gen_Polrev[] = "\n        Polrev(x, {v}): Convert x into a polynomial with main variable\n        v and return the result.  This is the reverse of Pol if x is a\n        vector, otherwise it is identical to Pol.   By \"reverse\" we mean\n        that the coefficients are reveresed.\n\n        INPUT:\n            x -- gen\n        OUTPUT:\n            gen -- a polynomial\n        EXAMPLES:\n            >>> v = pari(\"[1,2,3,4]\")\n            >>> f = v.Polrev()\n            >>> f\n            4*x^3 + 3*x^2 + 2*x + 1\n            >>> v.Pol()\n            x^3 + 2*x^2 + 3*x + 4            \n            >>> v.Polrev(\'y\')\n            4*y^3 + 3*y^2 + 2*y + 1\n            \n        Note that Polrev does *not* reverse the coefficients of a polynomial!\n            >>> f\n            4*x^3 + 3*x^2 + 2*x + 1\n            >>> f.Polrev()\n            4*x^3 + 3*x^2 + 2*x + 1\n            >>> v = pari(\"[1,2;3,4]\")\n            >>> v.Polrev()\n            [2, 4]~*x + [1, 3]~\n        ";
static PyObject *__pyx_f_8_py_pari_3gen_Polrev(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_v = 0;
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"v",0};
  __pyx_v_v = __pyx_k9;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_v)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_v);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2990 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2991 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2992 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2992; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2992; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2992; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k100p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k100p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2992; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2993 */
  __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gtopolyrev(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g),__pyx_f_8_py_pari_get_var(__pyx_v_v)))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2993; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("_py_pari.gen.Polrev");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_v);
  return __pyx_r;
}

static PyObject *__pyx_f_8_py_pari_3gen_Qfb(PyObject *__pyx_v_a, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_8_py_pari_3gen_Qfb[] = "\n        Qfb(a,b,c,{D=0.}): Returns the binary quadratic form\n                   a*x^2+b*x*y+c*y^2.\n        The optional D is 0 by default and initializes Shanks\'s\n        distance if b^2-4*a*c > 0.\n\n        NOTE: Negative definit forms are not implemented, so use their\n        positive definitine counterparts instead.  (I.e., if f is a\n        negative definite quadratic form, then -f is positive\n        definite.)\n\n        INPUT:\n            a -- gen\n            b -- gen\n            c -- gen\n            D -- gen (optional, defaults to 0)\n        OUTPUT:\n            gen -- binary quadratic form\n        EXAMPLES:\n            >>> pari(3).Qfb(7, 2)\n            Qfb(3, 7, 2, 0.E-28)\n        ";
static PyObject *__pyx_f_8_py_pari_3gen_Qfb(PyObject *__pyx_v_a, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_b = 0;
  PyObject *__pyx_v_c = 0;
  PyObject *__pyx_v_D = 0;
  struct __pyx_obj_8_py_pari_gen *__pyx_v__b;
  struct __pyx_obj_8_py_pari_gen *__pyx_v__c;
  struct __pyx_obj_8_py_pari_gen *__pyx_v__D;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"b","c","D",0};
  __pyx_v_D = __pyx_k10;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO|O", __pyx_argnames, &__pyx_v_b, &__pyx_v_c, &__pyx_v_D)) return 0;
  Py_INCREF(__pyx_v_a);
  Py_INCREF(__pyx_v_b);
  Py_INCREF(__pyx_v_c);
  Py_INCREF(__pyx_v_D);
  ((PyObject*)__pyx_v__b) = Py_None; Py_INCREF(((PyObject*)__pyx_v__b));
  ((PyObject*)__pyx_v__c) = Py_None; Py_INCREF(((PyObject*)__pyx_v__c));
  ((PyObject*)__pyx_v__D) = Py_None; Py_INCREF(((PyObject*)__pyx_v__D));

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3020 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3020; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3020; goto __pyx_L1;}
  Py_INCREF(__pyx_v_b);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_b);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3020; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3020; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__b));
  ((PyObject *)__pyx_v__b) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3021 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3021; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3021; goto __pyx_L1;}
  Py_INCREF(__pyx_v_c);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_c);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3021; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3021; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__c));
  ((PyObject *)__pyx_v__c) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3022 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3022; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3022; goto __pyx_L1;}
  Py_INCREF(__pyx_v_D);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_D);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3022; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3022; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v__D));
  ((PyObject *)__pyx_v__D) = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3023 */
  __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(Qfb0(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_a)->g),__pyx_v__b->g,__pyx_v__c->g,__pyx_v__D->g,__pyx_v_8_py_pari_REAL_PREC))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3023; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("_py_pari.gen.Qfb");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v__b);
  Py_DECREF(__pyx_v__c);
  Py_DECREF(__pyx_v__D);
  Py_DECREF(__pyx_v_a);
  Py_DECREF(__pyx_v_b);
  Py_DECREF(__pyx_v_c);
  Py_DECREF(__pyx_v_D);
  return __pyx_r;
}

static PyObject *__pyx_f_8_py_pari_3gen_Ser(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_8_py_pari_3gen_Ser[] = "\n        Ser(x,{v=x}): Create a power series from x with main variable v\n        and return the result.\n\n           * If x is a scalar, this gives a constant power series with\n             precision given by the default series precision, as returned\n             by get_series_precision().\n             \n           * If x is a polynomial, the precision is the greatest of\n             get_series_precision() and the degree of the polynomial.\n\n           * If x is a vector, the precision is similarly given, and\n             the coefficients of the vector are understood to be the\n             coefficients of the power series starting from the\n             constant term (i.e.~the reverse of the function Pol).\n\n        WARNING: This is *not* a substitution function. It will not\n        transform an object containing variables of higher priority than v.\n\n        INPUT:\n            x -- gen\n            v -- PARI variable (default: x)\n        OUTPUT:\n            gen -- PARI object of PARI type t_SER\n        EXAMPLES:\n            >>> x = pari([1,2,3,4,5])\n            >>> x.Ser()\n            1 + 2*x + 3*x^2 + 4*x^3 + 5*x^4 + O(x^5)\n            >>> f = x.Ser(\'v\'); print f\n            1 + 2*v + 3*v^2 + 4*v^3 + 5*v^4 + O(v^5)\n            >>> pari(1)/f\n            1 - 2*v + v^2 + O(v^5)\n            >>> pari(1).Ser()\n            1 + O(x^16)\n        ";
static PyObject *__pyx_f_8_py_pari_3gen_Ser(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_v = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"v",0};
  __pyx_v_v = __pyx_k11;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_v)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_v);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3062 */
  __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gtoser(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g,__pyx_f_8_py_pari_get_var(__pyx_v_v)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3062; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("_py_pari.gen.Ser");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_v);
  return __pyx_r;
}

static PyObject *__pyx_f_8_py_pari_3gen_Set(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_8_py_pari_3gen_Set[] = "\n        Set(x): convert x into a set, i.e. a row vector of strings in\n        increasing lexicographic order.\n\n        INPUT:\n            x -- gen\n        OUTPUT:\n            gen -- a vector of strings in increasing lexicographic order.\n        EXAMPLES:\n            >>> pari([1,5,2]).Set()\n            [\"1\", \"2\", \"5\"]\n            >>> pari([]).Set()     # the empty set\n            []\n            >>> pari([1,1,-1,-1,3,3]).Set()\n            [\"-1\", \"1\", \"3\"]\n            >>> pari(1).Set()\n            [\"1\"]\n            >>> pari(\'1/(x*y)\').Set()\n            [\"1/(y*x)\"]\n            >>> pari(\'[\"bc\",\"ab\",\"bc\"]\').Set()\n            [\"ab\", \"bc\"]\n        ";
static PyObject *__pyx_f_8_py_pari_3gen_Set(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3088 */
  __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gtoset(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3088; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("_py_pari.gen.Set");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_n_type;
static PyObject *__pyx_n_t_VEC;

static PyObject *__pyx_k102p;

static char (__pyx_k102[]) = "converting a gen to a string";

static PyObject *__pyx_f_8_py_pari_3gen_Str(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_8_py_pari_3gen_Str[] = "\n        Str(x): Concatenate the entries of the vector x into a single\n        string.  If x is not a t_VEC its print representation is\n        returned.\n\n        INPUT:\n            x -- gen\n        OUTPUT:\n            gen -- a PARI gen of type t_STR, i.e., a PARI string\n        EXAMPLES:\n            >>> pari([1,2,[\'abc\',1]]).Str()\n            12[abc, 1]\n            >>> pari([1,1,1.54]).Str()\n            111.5400000000000000000000000000\n            >>> pari([1,1.54,1]).Str()\n            11.54000000000000000000000000001\n            >>> pari(1).Str()       # 1 is automatically converted to string rep\n            1\n            >>> x = pari(\'x\')       # PARI variable \"x\"\n            >>> x.Str()             # is converted to string rep.\n            x\n            >>> x.Str().type()\n            \'t_STR\'\n        ";
static PyObject *__pyx_f_8_py_pari_3gen_Str(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  char (*__pyx_v_c);
  int __pyx_v_n;
  PyObject *__pyx_v_v;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);
  __pyx_v_v = Py_None; Py_INCREF(__pyx_v_v);

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3118 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_x, __pyx_n_type); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3118; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3118; goto __pyx_L1;}
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3118; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (PyObject_Cmp(__pyx_3, __pyx_n_t_VEC, &__pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3118; goto __pyx_L1;}
  __pyx_4 = __pyx_4 != 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3119 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3120 */
    __pyx_4 = __pyx_v_n;
    if (__pyx_4) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3121 */
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3121; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3121; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3121; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
      Py_INCREF(__pyx_k102p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k102p);
      __pyx_2 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3121; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L3;
    }
    __pyx_L3:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3122 */
    __pyx_v_c = GENtostr(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3123 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(strtoGENstr(__pyx_v_c))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3123; goto __pyx_L1;}
    Py_DECREF(__pyx_v_v);
    __pyx_v_v = __pyx_1;
    __pyx_1 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3124 */
    free(__pyx_v_c);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3125 */
    Py_INCREF(__pyx_v_v);
    __pyx_r = __pyx_v_v;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3126 */
  __pyx_3 = ((PyObject *)__pyx_f_8_py_pari_new_gen(Str(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g))); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3126; goto __pyx_L1;}
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("_py_pari.gen.Str");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_v);
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_n_ValueError;

static PyObject *__pyx_k103p;

static char (__pyx_k103[]) = "Cannot convert %s, interpreted as ASCII values, to a string.";

static PyObject *__pyx_f_8_py_pari_3gen_Strchr(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_8_py_pari_3gen_Strchr[] = "\n        Strchr(x): converts x to a string, translating each integer\n        into a character (in ASCII).\n\n        NOTE: Vecsmall is (essentially) the inverse to Strchr().\n\n        INPUT:\n            x -- PARI vector of integers\n        OUTPUT:\n            gen -- a PARI string\n        EXAMPLES:\n            >>> pari([65,66,123]).Strchr()\n            AB{\n            >>> pari(\'\"SAGE\"\').Vecsmall()   # pari(\'\"SAGE\"\') --> PARI t_STR\n            Vecsmall([83, 65, 71, 69])\n            >>> _.Strchr()\n            SAGE\n            >>> pari([83, 65, 71, 69]).Strchr()\n            SAGE\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_Strchr(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    int __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_x);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3150 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3151 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3152 */
      __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_ValueError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3152; goto __pyx_L1;}
      __pyx_3 = PyNumber_Remainder(__pyx_k103p, __pyx_v_x); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3152; goto __pyx_L1;}
      __Pyx_Raise(__pyx_2, __pyx_3, 0);
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3152; goto __pyx_L1;}
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3153 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(Strchr(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3153; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.Strchr");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_k105p;

  static char (__pyx_k105[]) = "x must be of type t_VEC.";

  static PyObject *__pyx_f_8_py_pari_3gen_Strexpand(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_Strexpand[] = "\n        Strexpand(x): Concatenate the entries of the vector x into a\n        single string, performing tilde expansion.\n\n        NOTE: I have no clue what the point of this function is. -- William\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_Strexpand(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_x);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3162 */
    __pyx_1 = PyObject_GetAttr(__pyx_v_x, __pyx_n_type); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3162; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3162; goto __pyx_L1;}
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3162; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (PyObject_Cmp(__pyx_3, __pyx_n_t_VEC, &__pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3162; goto __pyx_L1;}
    __pyx_4 = __pyx_4 != 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    if (__pyx_4) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3163 */
      __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3163; goto __pyx_L1;}
      __Pyx_Raise(__pyx_1, __pyx_k105p, 0);
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3163; goto __pyx_L1;}
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3164 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(Strexpand(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3164; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.Strexpand");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }


  static PyObject *__pyx_f_8_py_pari_3gen_Strtex(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_Strtex[] = "\n        Strtex(x): Translates the vector x of PARI gens to TeX format\n        and returns the resulting concatenated strings as a PARI t_STR.\n\n        INPUT:\n            x -- gen\n        OUTPUT:\n            gen -- PARI t_STR (string)\n        EXAMPLES:\n            >>> v=pari(\'x^2\')\n            >>> v.Strtex()\n            {x^{2}}\n            >>> v=pari([\'1/x^2\',\'x\'])\n            >>> v.Strtex()\n            {{1}over{x^{2}}}{x}\n            >>> v=pari([\'1 + 1/x + 1/(y+1)\',\'x-1\'])\n            >>> v.Strtex()             # the \"\\r\" is really \"\r\" (changed for doctests)\n            {{ left({y + {2}}over{y + 1}\\right) x + 1}over{x}}{x - 1}\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_Strtex(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    PyObject *__pyx_5 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_x);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3187 */
    __pyx_1 = PyObject_GetAttr(__pyx_v_x, __pyx_n_type); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3187; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3187; goto __pyx_L1;}
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3187; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (PyObject_Cmp(__pyx_3, __pyx_n_t_VEC, &__pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3187; goto __pyx_L1;}
    __pyx_4 = __pyx_4 != 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    if (__pyx_4) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3188 */
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_vector); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3188; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3188; goto __pyx_L1;}
      __pyx_3 = PyList_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3188; goto __pyx_L1;}
      Py_INCREF(__pyx_v_x);
      PyList_SET_ITEM(__pyx_3, 0, __pyx_v_x);
      __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3188; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_5, 0, __pyx_2);
      PyTuple_SET_ITEM(__pyx_5, 1, __pyx_3);
      __pyx_2 = 0;
      __pyx_3 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_5); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3188; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      if (!__Pyx_TypeTest(__pyx_2, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3188; goto __pyx_L1;}
      Py_DECREF(__pyx_v_x);
      __pyx_v_x = __pyx_2;
      __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3189 */
    __pyx_3 = ((PyObject *)__pyx_f_8_py_pari_new_gen(Strtex(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g))); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3189; goto __pyx_L1;}
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_5);
    __Pyx_AddTraceback("_py_pari.gen.Strtex");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_3gen_Vec(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_Vec[] = "\n        Vec(x): Transforms the object x into a vector.\n\n        INPUT:\n            x -- gen\n        OUTPUT:\n            gen -- of PARI type t_VEC\n        EXAMPLES:\n            >>> pari(1).Vec()\n            [1]\n            >>> pari(\'x^3\').Vec()\n            [1, 0, 0, 0]\n            >>> pari(\'x^3 + 3*x - 2\').Vec()\n            [1, 0, 3, -2]\n            >>> pari([1,2,3]).Vec()\n            [1, 2, 3]\n            >>> pari(\'ab\').Vec()\n            [1, 0]\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_Vec(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_x);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3213 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gtovec(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3213; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    __Pyx_AddTraceback("_py_pari.gen.Vec");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_k107p;

  static char (__pyx_k107[]) = "Cannot convert %s to Vecsmall.";

  static PyObject *__pyx_f_8_py_pari_3gen_Vecsmall(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_Vecsmall[] = "\n        Vecsmall(x): transforms the object x into a t_VECSMALL.\n\n        INPUT:\n            x -- gen\n        OUTPUT:\n            gen -- PARI t_VECSMALL\n        EXAMPLES:\n            >>> pari([1,2,3]).Vecsmall()\n            Vecsmall([1, 2, 3])\n            >>> pari(\'\"SAGE\"\').Vecsmall()\n            Vecsmall([83, 65, 71, 69])\n            >>> pari(1234).Vecsmall()\n            Vecsmall([1234])\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_Vecsmall(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    int __pyx_2;
    PyObject *__pyx_3 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_x);
    __pyx_v_n = Py_None; Py_INCREF(__pyx_v_n);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3231 */
    __pyx_1 = PyInt_FromLong(setjmp(GP_DATA->env)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3231; goto __pyx_L1;}
    Py_DECREF(__pyx_v_n);
    __pyx_v_n = __pyx_1;
    __pyx_1 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3232 */
    __pyx_2 = PyObject_IsTrue(__pyx_v_n); if (__pyx_2 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3232; goto __pyx_L1;}
    if (__pyx_2) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3233 */
      __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3233; goto __pyx_L1;}
      __pyx_3 = PyNumber_Remainder(__pyx_k107p, __pyx_v_x); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3233; goto __pyx_L1;}
      __Pyx_Raise(__pyx_1, __pyx_3, 0);
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3233; goto __pyx_L1;}
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3234 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gtovecsmall(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3234; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.Vecsmall");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_n);
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_k108p;

  static char (__pyx_k108[]) = "x (=%s) must be of type t_INT, but is of type %s.";

  static PyObject *__pyx_f_8_py_pari_3gen_binary(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_binary[] = "\n        binary(x): gives the vector formed by the binary digits of\n        abs(x), where x is of type t_INT.\n\n        INPUT:\n            x -- gen of type t_INT\n        OUTPUT:\n            gen -- of type t_VEC\n        EXAMPLES:\n            >>> pari(0).binary()\n            [0]\n            >>> pari(-5).binary()\n            [1, 0, 1]\n            >>> pari(5).binary()\n            [1, 0, 1]\n            >>> pari(2005).binary()\n            [1, 1, 1, 1, 1, 0, 1, 0, 1, 0, 1]\n\n            >> pari(\'\"2\"\').binary()\n            Traceback (most recent call last):\n            ...\n            TypeError: x (=2) must be of type t_INT, but is of type t_STR.\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_binary(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    PyObject *__pyx_5 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_x);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3260 */
    __pyx_1 = (typ(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g) != t_INT);
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3261 */
      __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3261; goto __pyx_L1;}
      __pyx_3 = PyObject_GetAttr(__pyx_v_x, __pyx_n_type); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3261; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3261; goto __pyx_L1;}
      __pyx_5 = PyObject_CallObject(__pyx_3, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3261; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3261; goto __pyx_L1;}
      Py_INCREF(__pyx_v_x);
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_x);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_5);
      __pyx_5 = 0;
      __pyx_4 = PyNumber_Remainder(__pyx_k108p, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3261; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __Pyx_Raise(__pyx_2, __pyx_4, 0);
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3261; goto __pyx_L1;}
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3262 */
    __pyx_5 = ((PyObject *)__pyx_f_8_py_pari_new_gen(binaire(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g))); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3262; goto __pyx_L1;}
    __pyx_r = __pyx_5;
    __pyx_5 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    Py_XDECREF(__pyx_5);
    __Pyx_AddTraceback("_py_pari.gen.binary");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_k109p;
  static PyObject *__pyx_k110p;

  static char (__pyx_k109[]) = "x (=%s) must be of type t_INT, but is of type %s.";
  static char (__pyx_k110[]) = "y (=%s) must be of type t_INT, but is of type %s.";

  static PyObject *__pyx_f_8_py_pari_3gen_bitand(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_bitand[] = "\n        bitand(x,y): Bitwise and of two integers x and y. Negative\n        numbers behave as if modulo some large power of 2.\n\n        INPUT:\n            x -- gen  (of type t_INT)\n            y -- coercible to gen  (of type t_INT)\n        OUTPUT:\n            gen -- of type type t_INT\n        EXAMPLES:\n            >>> pari(8).bitand(4)\n            0\n            >>> pari(8).bitand(8)\n            8\n            >>> pari(6).binary()\n            [1, 1, 0]\n            >>> pari(7).binary()\n            [1, 1, 1]\n            >>> pari(6).bitand(7)\n            6\n            >>> pari(19).bitand(-1)\n            19\n            >>> pari(-1).bitand(-1)\n            -1\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_bitand(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_y = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__y;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    PyObject *__pyx_5 = 0;
    static char *__pyx_argnames[] = {"y",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
    Py_INCREF(__pyx_v_x);
    Py_INCREF(__pyx_v_y);
    ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3291 */
    __pyx_1 = (typ(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g) != t_INT);
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3292 */
      __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3292; goto __pyx_L1;}
      __pyx_3 = PyObject_GetAttr(__pyx_v_x, __pyx_n_type); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3292; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3292; goto __pyx_L1;}
      __pyx_5 = PyObject_CallObject(__pyx_3, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3292; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3292; goto __pyx_L1;}
      Py_INCREF(__pyx_v_x);
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_x);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_5);
      __pyx_5 = 0;
      __pyx_4 = PyNumber_Remainder(__pyx_k109p, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3292; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __Pyx_Raise(__pyx_2, __pyx_4, 0);
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3292; goto __pyx_L1;}
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3293 */
    __pyx_5 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3293; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3293; goto __pyx_L1;}
    Py_INCREF(__pyx_v_y);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_y);
    __pyx_2 = PyObject_CallObject(__pyx_5, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3293; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    if (!__Pyx_TypeTest(__pyx_2, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3293; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__y));
    ((PyObject *)__pyx_v__y) = __pyx_2;
    __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3294 */
    __pyx_1 = (typ(__pyx_v__y->g) != t_INT);
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3295 */
      __pyx_4 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3295; goto __pyx_L1;}
      __pyx_5 = PyObject_GetAttr(((PyObject *)__pyx_v__y), __pyx_n_type); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3295; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3295; goto __pyx_L1;}
      __pyx_2 = PyObject_CallObject(__pyx_5, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3295; goto __pyx_L1;}
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3295; goto __pyx_L1;}
      Py_INCREF(((PyObject *)__pyx_v__y));
      PyTuple_SET_ITEM(__pyx_5, 0, ((PyObject *)__pyx_v__y));
      PyTuple_SET_ITEM(__pyx_5, 1, __pyx_2);
      __pyx_2 = 0;
      __pyx_3 = PyNumber_Remainder(__pyx_k110p, __pyx_5); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3295; goto __pyx_L1;}
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      __Pyx_Raise(__pyx_4, __pyx_3, 0);
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3295; goto __pyx_L1;}
      goto __pyx_L3;
    }
    __pyx_L3:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3296 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gbitand(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g,__pyx_v__y->g))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3296; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    Py_XDECREF(__pyx_5);
    __Pyx_AddTraceback("_py_pari.gen.bitand");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__y);
    Py_DECREF(__pyx_v_x);
    Py_DECREF(__pyx_v_y);
    return __pyx_r;
  }

  static PyObject *__pyx_k111p;

  static char (__pyx_k111[]) = "x (=%s) must be of type t_INT, but is of type %s.";

  static PyObject *__pyx_f_8_py_pari_3gen_bitneg(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_bitneg[] = "\n        bitneg(x,{n=-1}): Bitwise negation of the integer x truncated\n        to n bits.  n=-1 (the default) represents an infinite sequence\n        of the bit 1.  Negative numbers behave as if modulo some large\n        power of 2.\n\n        With n=-1, this function returns -n-1.  With n >= 0, it returns\n        a number a such that  a = -n-1 (mod 2^n).\n\n        INPUT:\n            x -- gen (t_INT)\n            n -- long, default = -1\n        OUTPUT:\n            gen -- t_INT\n        EXAMPLES:\n            >>> pari(10).bitneg()\n            -11\n            >>> pari(1).bitneg()\n            -2\n            >>> pari(-2).bitneg()\n            1\n            >>> pari(-1).bitneg()\n            0\n            >>> pari(569).bitneg()\n            -570\n            >>> pari(569).bitneg(10)\n            454\n            >>> 454 % 2**10\n            454\n            >>> -570 % 2**10\n            454\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_bitneg(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    long __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    PyObject *__pyx_5 = 0;
    static char *__pyx_argnames[] = {"n",0};
    __pyx_v_n = __pyx_k12;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|l", __pyx_argnames, &__pyx_v_n)) return 0;
    Py_INCREF(__pyx_v_x);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3332 */
    __pyx_1 = (typ(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g) != t_INT);
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3333 */
      __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3333; goto __pyx_L1;}
      __pyx_3 = PyObject_GetAttr(__pyx_v_x, __pyx_n_type); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3333; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3333; goto __pyx_L1;}
      __pyx_5 = PyObject_CallObject(__pyx_3, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3333; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3333; goto __pyx_L1;}
      Py_INCREF(__pyx_v_x);
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_x);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_5);
      __pyx_5 = 0;
      __pyx_4 = PyNumber_Remainder(__pyx_k111p, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3333; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __Pyx_Raise(__pyx_2, __pyx_4, 0);
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3333; goto __pyx_L1;}
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3334 */
    __pyx_5 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gbitneg(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g,__pyx_v_n))); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3334; goto __pyx_L1;}
    __pyx_r = __pyx_5;
    __pyx_5 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    Py_XDECREF(__pyx_5);
    __Pyx_AddTraceback("_py_pari.gen.bitneg");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_k112p;
  static PyObject *__pyx_k113p;

  static char (__pyx_k112[]) = "x (=%s) must be of type t_INT, but is of type %s.";
  static char (__pyx_k113[]) = "y (=%s) must be of type t_INT, but is of type %s.";

  static PyObject *__pyx_f_8_py_pari_3gen_bitnegimply(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_bitnegimply[] = "\n        bitnegimply(x,y): Bitwise negated imply of two integers x and\n        y, in other words, x BITAND BITNEG(y). Negative numbers behave\n        as if modulo big power of 2.\n\n        INPUT:\n            x -- gen  (of type t_INT)\n            y -- coercible to gen  (of type t_INT)\n        OUTPUT:\n            gen -- of type type t_INT\n        EXAMPLES:\n            >>> pari(14).bitnegimply(0)    \n            14\n            >>> pari(8).bitnegimply(8)\n            0\n            >>> pari(8+4).bitnegimply(8)\n            4\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_bitnegimply(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_y = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__y;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    PyObject *__pyx_5 = 0;
    static char *__pyx_argnames[] = {"y",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
    Py_INCREF(__pyx_v_x);
    Py_INCREF(__pyx_v_y);
    ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3357 */
    __pyx_1 = (typ(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g) != t_INT);
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3358 */
      __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3358; goto __pyx_L1;}
      __pyx_3 = PyObject_GetAttr(__pyx_v_x, __pyx_n_type); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3358; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3358; goto __pyx_L1;}
      __pyx_5 = PyObject_CallObject(__pyx_3, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3358; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3358; goto __pyx_L1;}
      Py_INCREF(__pyx_v_x);
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_x);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_5);
      __pyx_5 = 0;
      __pyx_4 = PyNumber_Remainder(__pyx_k112p, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3358; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __Pyx_Raise(__pyx_2, __pyx_4, 0);
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3358; goto __pyx_L1;}
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3359 */
    __pyx_5 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3359; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3359; goto __pyx_L1;}
    Py_INCREF(__pyx_v_y);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_y);
    __pyx_2 = PyObject_CallObject(__pyx_5, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3359; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    if (!__Pyx_TypeTest(__pyx_2, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3359; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__y));
    ((PyObject *)__pyx_v__y) = __pyx_2;
    __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3360 */
    __pyx_1 = (typ(__pyx_v__y->g) != t_INT);
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3361 */
      __pyx_4 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3361; goto __pyx_L1;}
      __pyx_5 = PyObject_GetAttr(((PyObject *)__pyx_v__y), __pyx_n_type); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3361; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3361; goto __pyx_L1;}
      __pyx_2 = PyObject_CallObject(__pyx_5, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3361; goto __pyx_L1;}
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3361; goto __pyx_L1;}
      Py_INCREF(((PyObject *)__pyx_v__y));
      PyTuple_SET_ITEM(__pyx_5, 0, ((PyObject *)__pyx_v__y));
      PyTuple_SET_ITEM(__pyx_5, 1, __pyx_2);
      __pyx_2 = 0;
      __pyx_3 = PyNumber_Remainder(__pyx_k113p, __pyx_5); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3361; goto __pyx_L1;}
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      __Pyx_Raise(__pyx_4, __pyx_3, 0);
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3361; goto __pyx_L1;}
      goto __pyx_L3;
    }
    __pyx_L3:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3362 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gbitnegimply(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g,__pyx_v__y->g))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3362; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    Py_XDECREF(__pyx_5);
    __Pyx_AddTraceback("_py_pari.gen.bitnegimply");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__y);
    Py_DECREF(__pyx_v_x);
    Py_DECREF(__pyx_v_y);
    return __pyx_r;
  }

  static PyObject *__pyx_k114p;
  static PyObject *__pyx_k115p;

  static char (__pyx_k114[]) = "x (=%s) must be of type t_INT, but is of type %s.";
  static char (__pyx_k115[]) = "y (=%s) must be of type t_INT, but is of type %s.";

  static PyObject *__pyx_f_8_py_pari_3gen_bitor(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_bitor[] = "\n        bitor(x,y): Bitwise or of two integers x and y. Negative\n        numbers behave as if modulo big power of 2.\n\n        INPUT:\n            x -- gen  (of type t_INT)\n            y -- coercible to gen  (of type t_INT)\n        OUTPUT:\n            gen -- of type type t_INT\n        EXAMPLES:\n            >>> pari(14).bitor(0)\n            14\n            >>> pari(8).bitor(4)\n            12\n            >>> pari(12).bitor(1)\n            13\n            >>> pari(13).bitor(1)\n            13\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_bitor(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_y = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__y;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    PyObject *__pyx_5 = 0;
    static char *__pyx_argnames[] = {"y",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
    Py_INCREF(__pyx_v_x);
    Py_INCREF(__pyx_v_y);
    ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3386 */
    __pyx_1 = (typ(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g) != t_INT);
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3387 */
      __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3387; goto __pyx_L1;}
      __pyx_3 = PyObject_GetAttr(__pyx_v_x, __pyx_n_type); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3387; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3387; goto __pyx_L1;}
      __pyx_5 = PyObject_CallObject(__pyx_3, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3387; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3387; goto __pyx_L1;}
      Py_INCREF(__pyx_v_x);
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_x);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_5);
      __pyx_5 = 0;
      __pyx_4 = PyNumber_Remainder(__pyx_k114p, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3387; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __Pyx_Raise(__pyx_2, __pyx_4, 0);
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3387; goto __pyx_L1;}
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3388 */
    __pyx_5 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3388; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3388; goto __pyx_L1;}
    Py_INCREF(__pyx_v_y);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_y);
    __pyx_2 = PyObject_CallObject(__pyx_5, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3388; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    if (!__Pyx_TypeTest(__pyx_2, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3388; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__y));
    ((PyObject *)__pyx_v__y) = __pyx_2;
    __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3389 */
    __pyx_1 = (typ(__pyx_v__y->g) != t_INT);
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3390 */
      __pyx_4 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3390; goto __pyx_L1;}
      __pyx_5 = PyObject_GetAttr(((PyObject *)__pyx_v__y), __pyx_n_type); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3390; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3390; goto __pyx_L1;}
      __pyx_2 = PyObject_CallObject(__pyx_5, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3390; goto __pyx_L1;}
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3390; goto __pyx_L1;}
      Py_INCREF(((PyObject *)__pyx_v__y));
      PyTuple_SET_ITEM(__pyx_5, 0, ((PyObject *)__pyx_v__y));
      PyTuple_SET_ITEM(__pyx_5, 1, __pyx_2);
      __pyx_2 = 0;
      __pyx_3 = PyNumber_Remainder(__pyx_k115p, __pyx_5); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3390; goto __pyx_L1;}
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      __Pyx_Raise(__pyx_4, __pyx_3, 0);
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3390; goto __pyx_L1;}
      goto __pyx_L3;
    }
    __pyx_L3:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3391 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gbitor(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g,__pyx_v__y->g))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3391; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    Py_XDECREF(__pyx_5);
    __Pyx_AddTraceback("_py_pari.gen.bitor");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__y);
    Py_DECREF(__pyx_v_x);
    Py_DECREF(__pyx_v_y);
    return __pyx_r;
  }

  static PyObject *__pyx_k116p;

  static char (__pyx_k116[]) = "x (=%s) must be of type t_INT, but is of type %s.";

  static PyObject *__pyx_f_8_py_pari_3gen_bittest(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_bittest[] = "\n        bittest(x, long n): Returns bit number n (coefficient of 2^n in binary)\n        of the integer x. Negative numbers behave as if modulo a big power of 2.\n\n        INPUT:\n           x -- gen (pari integer)\n        OUTPUT:\n           bool -- a Python bool\n        EXAMPLES:\n            >>> x = pari(6)\n            >>> x.bittest(0)\n            False\n            >>> x.bittest(1)\n            True\n            >>> x.bittest(2)\n            True\n            >>> x.bittest(3)\n            False\n            >>> pari(-3).bittest(0)\n            True\n            >>> pari(-3).bittest(1)\n            False\n            >>> [pari(-3).bittest(n) for n in range(10)]\n            [True, False, True, True, True, True, True, True, True, True]\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_bittest(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    long __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    PyObject *__pyx_5 = 0;
    static char *__pyx_argnames[] = {"n",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l", __pyx_argnames, &__pyx_v_n)) return 0;
    Py_INCREF(__pyx_v_x);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3420 */
    __pyx_1 = (typ(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g) != t_INT);
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3421 */
      __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3421; goto __pyx_L1;}
      __pyx_3 = PyObject_GetAttr(__pyx_v_x, __pyx_n_type); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3421; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3421; goto __pyx_L1;}
      __pyx_5 = PyObject_CallObject(__pyx_3, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3421; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3421; goto __pyx_L1;}
      Py_INCREF(__pyx_v_x);
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_x);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_5);
      __pyx_5 = 0;
      __pyx_4 = PyNumber_Remainder(__pyx_k116p, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3421; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __Pyx_Raise(__pyx_2, __pyx_4, 0);
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3421; goto __pyx_L1;}
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3422 */
    __pyx_5 = __Pyx_GetName(__pyx_b, __pyx_n_bool); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3422; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(bittest(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g,__pyx_v_n)); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3422; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3422; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_3);
    __pyx_3 = 0;
    __pyx_4 = PyObject_CallObject(__pyx_5, __pyx_2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3422; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_r = __pyx_4;
    __pyx_4 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    Py_XDECREF(__pyx_5);
    __Pyx_AddTraceback("_py_pari.gen.bittest");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_k117p;
  static PyObject *__pyx_k118p;

  static char (__pyx_k117[]) = "x (=%s) must be of type t_INT, but is of type %s.";
  static char (__pyx_k118[]) = "y (=%s) must be of type t_INT, but is of type %s.";

  static PyObject *__pyx_f_8_py_pari_3gen_bitxor(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_bitxor[] = "\n        bitxor(x,y): Bitwise exclusive or of two integers x and y.\n        Negative numbers behave as if modulo big power of 2.\n        \n        INPUT:\n            x -- gen  (of type t_INT)\n            y -- coercible to gen  (of type t_INT)\n        OUTPUT:\n            gen -- of type type t_INT\n        EXAMPLES:\n            >>> pari(6).bitxor(4)\n            2\n            >>> pari(0).bitxor(4)\n            4\n            >>> pari(6).bitxor(0)\n            6\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_bitxor(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_y = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__y;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    PyObject *__pyx_5 = 0;
    static char *__pyx_argnames[] = {"y",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
    Py_INCREF(__pyx_v_x);
    Py_INCREF(__pyx_v_y);
    ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3443 */
    __pyx_1 = (typ(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g) != t_INT);
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3444 */
      __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3444; goto __pyx_L1;}
      __pyx_3 = PyObject_GetAttr(__pyx_v_x, __pyx_n_type); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3444; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3444; goto __pyx_L1;}
      __pyx_5 = PyObject_CallObject(__pyx_3, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3444; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3444; goto __pyx_L1;}
      Py_INCREF(__pyx_v_x);
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_x);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_5);
      __pyx_5 = 0;
      __pyx_4 = PyNumber_Remainder(__pyx_k117p, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3444; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __Pyx_Raise(__pyx_2, __pyx_4, 0);
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3444; goto __pyx_L1;}
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3445 */
    __pyx_5 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3445; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3445; goto __pyx_L1;}
    Py_INCREF(__pyx_v_y);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_y);
    __pyx_2 = PyObject_CallObject(__pyx_5, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3445; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    if (!__Pyx_TypeTest(__pyx_2, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3445; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__y));
    ((PyObject *)__pyx_v__y) = __pyx_2;
    __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3446 */
    __pyx_1 = (typ(__pyx_v__y->g) != t_INT);
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3447 */
      __pyx_4 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3447; goto __pyx_L1;}
      __pyx_5 = PyObject_GetAttr(((PyObject *)__pyx_v__y), __pyx_n_type); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3447; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3447; goto __pyx_L1;}
      __pyx_2 = PyObject_CallObject(__pyx_5, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3447; goto __pyx_L1;}
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3447; goto __pyx_L1;}
      Py_INCREF(((PyObject *)__pyx_v__y));
      PyTuple_SET_ITEM(__pyx_5, 0, ((PyObject *)__pyx_v__y));
      PyTuple_SET_ITEM(__pyx_5, 1, __pyx_2);
      __pyx_2 = 0;
      __pyx_3 = PyNumber_Remainder(__pyx_k118p, __pyx_5); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3447; goto __pyx_L1;}
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      __Pyx_Raise(__pyx_4, __pyx_3, 0);
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3447; goto __pyx_L1;}
      goto __pyx_L3;
    }
    __pyx_L3:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3448 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gbitxor(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g,__pyx_v__y->g))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3448; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    Py_XDECREF(__pyx_5);
    __Pyx_AddTraceback("_py_pari.gen.bitxor");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__y);
    Py_DECREF(__pyx_v_x);
    Py_DECREF(__pyx_v_y);
    return __pyx_r;
  }

  static PyObject *__pyx_k119p;

  static char (__pyx_k119[]) = "Ceiling of %s not defined.";

  static PyObject *__pyx_f_8_py_pari_3gen_ceil(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_ceil[] = "\n        Return the smallest integer >= x.\n\n        INPUT:\n           x -- gen\n        OUTPUT:\n           gen -- integer\n        EXAMPLES:\n            >>> pari(1.4).ceil()\n            2\n            >>> pari(-1.4).ceil()\n            -1\n            >>> pari(\'x\').ceil()\n            x\n            >>> pari(\'x^2+5*x+2.2\').ceil()\n            x^2 + 5*x + 2.2000000000000000000000000000\n            >>> pari(\'3/4\').ceil()\n            1\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_ceil(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    int __pyx_2;
    PyObject *__pyx_3 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_x);
    __pyx_v_n = Py_None; Py_INCREF(__pyx_v_n);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3471 */
    __pyx_1 = PyInt_FromLong(setjmp(GP_DATA->env)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3471; goto __pyx_L1;}
    Py_DECREF(__pyx_v_n);
    __pyx_v_n = __pyx_1;
    __pyx_1 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3472 */
    __pyx_1 = PyInt_FromLong(20); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3472; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_v_n, __pyx_1, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3472; goto __pyx_L1;}
    __pyx_2 = __pyx_2 == 0;
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    if (__pyx_2) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3473 */
      __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3473; goto __pyx_L1;}
      __pyx_3 = PyNumber_Remainder(__pyx_k119p, __pyx_v_x); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3473; goto __pyx_L1;}
      __Pyx_Raise(__pyx_1, __pyx_3, 0);
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3473; goto __pyx_L1;}
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3474 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gceil(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3474; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.ceil");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_n);
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_3gen_centerlift(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_centerlift[] = "\n        centerlift(x,{v}): Centered lift of x.  This function returns\n        exactly the same thing as lift, except if x is an integer mod.\n\n        INPUT:\n            x -- gen\n            v -- var (default: x)\n        OUTPUT:\n            gen\n        EXAMPLES:\n            >>> x = pari(-2).Mod(5)\n            >>> x.centerlift()\n            -2\n            >>> x.lift()\n            3\n            >>> f = pari(\'x-1\').Mod(\'x^2 + 1\')\n            >>> f.centerlift()\n            x - 1\n            >>> f.lift()\n            x - 1\n            >>> f = pari(\'x-y\').Mod(\'x^2+1\')\n            >>> f\n            Mod(x - y, x^2 + 1)\n            >>> f.centerlift(\'x\')\n            x - y\n            >>> f.centerlift(\'y\')\n            Mod(x - y, x^2 + 1)\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_centerlift(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_v = 0;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    static char *__pyx_argnames[] = {"v",0};
    __pyx_v_v = __pyx_k13;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_v)) return 0;
    Py_INCREF(__pyx_v_x);
    Py_INCREF(__pyx_v_v);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3505 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(centerlift0(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g,__pyx_f_8_py_pari_get_var(__pyx_v_v)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3505; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    __Pyx_AddTraceback("_py_pari.gen.centerlift");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_x);
    Py_DECREF(__pyx_v_v);
    return __pyx_r;
  }

  static PyObject *__pyx_k120p;

  static char (__pyx_k120[]) = "y (=%s) must be of type t_VEC, but is of type %s.";

  static PyObject *__pyx_f_8_py_pari_3gen_changevar(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_changevar[] = "\n        changevar(gen x, y): change variables of x according to the vector y.\n\n        INPUT:\n            x -- gen\n            y -- gen (or coercible to gen)\n        OUTPUT:\n            gen\n        EXAMPLES:\n            >>> pari(\'x^3+1\').changevar([\'y\'])\n            y^3 + 1\n            >>> pari(\'x^3+y^2\').changevar([\'y\',\'z\'])\n            y^3 + z^2\n            >>> pari(\'x^3+y^2\').changevar([\'y\',\'z+1\'])\n            y^3 + (z^2 + 2*z + 1)\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_changevar(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_y = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__y;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    PyObject *__pyx_5 = 0;
    static char *__pyx_argnames[] = {"y",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
    Py_INCREF(__pyx_v_x);
    Py_INCREF(__pyx_v_y);
    ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3526 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3526; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3526; goto __pyx_L1;}
    Py_INCREF(__pyx_v_y);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3526; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3526; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__y));
    ((PyObject *)__pyx_v__y) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3527 */
    __pyx_4 = (typ(__pyx_v__y->g) != t_VEC);
    if (__pyx_4) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3528 */
      __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3528; goto __pyx_L1;}
      __pyx_2 = PyObject_GetAttr(((PyObject *)__pyx_v__y), __pyx_n_type); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3528; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3528; goto __pyx_L1;}
      __pyx_5 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3528; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __pyx_2 = PyTuple_New(2); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3528; goto __pyx_L1;}
      Py_INCREF(((PyObject *)__pyx_v__y));
      PyTuple_SET_ITEM(__pyx_2, 0, ((PyObject *)__pyx_v__y));
      PyTuple_SET_ITEM(__pyx_2, 1, __pyx_5);
      __pyx_5 = 0;
      __pyx_3 = PyNumber_Remainder(__pyx_k120p, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3528; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      __Pyx_Raise(__pyx_1, __pyx_3, 0);
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3528; goto __pyx_L1;}
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3529 */
    __pyx_5 = ((PyObject *)__pyx_f_8_py_pari_new_gen(changevar(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g,__pyx_v__y->g))); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3529; goto __pyx_L1;}
    __pyx_r = __pyx_5;
    __pyx_5 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_5);
    __Pyx_AddTraceback("_py_pari.gen.changevar");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__y);
    Py_DECREF(__pyx_v_x);
    Py_DECREF(__pyx_v_y);
    return __pyx_r;
  }

  static PyObject *__pyx_k121p;

  static char (__pyx_k121[]) = "component (=%s) must be between 1 and %s, inclusive";

  static PyObject *__pyx_f_8_py_pari_3gen_component(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_component[] = "\n        component(x, long n): Return n\'th component of the internal\n        representation of x.  This this function is 1-based\n        instead of 0-based.\n\n        NOTE: For vectors or matrices, it is simpler to use x[n-1]. For\n        list objects such as is output by nfinit, it is easier to use\n        member functions.\n\n        INPUT:\n            x -- gen\n            n -- C long (coercible to)\n        OUTPUT:\n            gen\n        EXAMPLES:\n            >>> pari([0,1,2,3,4]).component(1)\n            0\n            >>> pari([0,1,2,3,4]).component(2)\n            1\n            >>> pari([0,1,2,3,4]).component(4)\n            3\n            >>> pari(\'x^3 + 2\').component(1)\n            2\n            >>> pari(\'x^3 + 2\').component(2)\n            0\n            >>> pari(\'x^3 + 2\').component(4)\n            1\n            >>> pari(\'x\').component(0)\n            Traceback (most recent call last):\n            ...\n            IndexError: component (=0) must be between 1 and 2, inclusive\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_component(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    long __pyx_v_n;
    long __pyx_v_m;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    PyObject *__pyx_5 = 0;
    static char *__pyx_argnames[] = {"n",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l", __pyx_argnames, &__pyx_v_n)) return 0;
    Py_INCREF(__pyx_v_x);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3565 */
    __pyx_v_m = glength(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3566 */
    __pyx_1 = (__pyx_v_n <= 0);
    if (!__pyx_1) {
      __pyx_1 = (__pyx_v_n > __pyx_v_m);
    }
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3567 */
      __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_IndexError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3567; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3567; goto __pyx_L1;}
      __pyx_4 = PyInt_FromLong(__pyx_v_m); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3567; goto __pyx_L1;}
      __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3567; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_5, 0, __pyx_3);
      PyTuple_SET_ITEM(__pyx_5, 1, __pyx_4);
      __pyx_3 = 0;
      __pyx_4 = 0;
      __pyx_3 = PyNumber_Remainder(__pyx_k121p, __pyx_5); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3567; goto __pyx_L1;}
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      __Pyx_Raise(__pyx_2, __pyx_3, 0);
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3567; goto __pyx_L1;}
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3568 */
    __pyx_4 = ((PyObject *)__pyx_f_8_py_pari_new_gen(compo(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g,__pyx_v_n))); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3568; goto __pyx_L1;}
    __pyx_r = __pyx_4;
    __pyx_4 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    Py_XDECREF(__pyx_5);
    __Pyx_AddTraceback("_py_pari.gen.component");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_k122p;
  static PyObject *__pyx_k123p;

  static char (__pyx_k122[]) = "x (=%s) has no conjugate.";
  static char (__pyx_k123[]) = "error in conj";

  static PyObject *__pyx_f_8_py_pari_3gen_conj(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_conj[] = "\n        conj(x): Return the algebraic conjugate of x.\n\n        INPUT:\n            x -- gen\n        OUTPUT:\n            gen\n        EXAMPLES:\n            >>> pari(\'x+1\').conj()\n            x + 1\n            >>> pari(\'x+I\').conj()\n            x - I\n            >>> pari(\'1/(2*x+3*I)\').conj()\n            1/(2*x - 3*I)\n            >>> pari([1,2,\'2-I\',\'Mod(x,x^2+1)\', \'Mod(x,x^2-2)\']).conj()\n            [1, 2, 2 + I, Mod(-x, x^2 + 1), Mod(-x, x^2 - 2)]\n            >>> pari(\'Mod(x,x^2-2)\').conj()\n            Mod(-x, x^2 - 2)\n            \n            >> pari(\'Mod(x,x^3-3)\').conj()\n            Traceback (most recent call last):\n            ...\n            TypeError: x (=Mod(x, x^3 - 3)) has no conjugate.\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_conj(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    int __pyx_2;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_x);
    __pyx_v_n = Py_None; Py_INCREF(__pyx_v_n);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3595 */
    __pyx_1 = PyInt_FromLong(setjmp(GP_DATA->env)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3595; goto __pyx_L1;}
    Py_DECREF(__pyx_v_n);
    __pyx_v_n = __pyx_1;
    __pyx_1 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3596 */
    __pyx_2 = PyObject_IsTrue(__pyx_v_n); if (__pyx_2 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3596; goto __pyx_L1;}
    if (__pyx_2) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3597 */
      __pyx_1 = PyInt_FromLong(20); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3597; goto __pyx_L1;}
      if (PyObject_Cmp(__pyx_v_n, __pyx_1, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3597; goto __pyx_L1;}
      __pyx_2 = __pyx_2 == 0;
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      if (__pyx_2) {

        /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3598 */
        __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3598; goto __pyx_L1;}
        __pyx_3 = PyNumber_Remainder(__pyx_k122p, __pyx_v_x); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3598; goto __pyx_L1;}
        __Pyx_Raise(__pyx_1, __pyx_3, 0);
        Py_DECREF(__pyx_1); __pyx_1 = 0;
        Py_DECREF(__pyx_3); __pyx_3 = 0;
        {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3598; goto __pyx_L1;}
        goto __pyx_L3;
      }
      /*else*/ {

        /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3600 */
        __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3600; goto __pyx_L1;}
        __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3600; goto __pyx_L1;}
        Py_INCREF(__pyx_v_n);
        PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_n);
        Py_INCREF(__pyx_k123p);
        PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k123p);
        __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3600; goto __pyx_L1;}
        Py_DECREF(__pyx_1); __pyx_1 = 0;
        Py_DECREF(__pyx_3); __pyx_3 = 0;
        Py_DECREF(__pyx_4); __pyx_4 = 0;
      }
      __pyx_L3:;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3601 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gconj(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3601; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.conj");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_n);
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_k124p;
  static PyObject *__pyx_k125p;

  static char (__pyx_k124[]) = "x (=%s) has no conjugate.";
  static char (__pyx_k125[]) = "error in conj";

  static PyObject *__pyx_f_8_py_pari_3gen_conjvec(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_conjvec[] = "\n        conjvec(x): Returns the vector of all conjugates of the\n        algebraic number x.  An algebraic number is a polynomial over\n        Q modulo an irreducible polynomial.\n\n        INPUT:\n            x -- gen\n        OUTPUT:\n            gen\n        EXAMPLES:\n            >>> pari(\'Mod(1+x,x^2-2)\').conjvec()\n            [-0.41421356237309504880168872420, 2.4142135623730950488016887242]~\n            >>> pari(\'Mod(x,x^3-3)\').conjvec()\n            [1.4422495703074083823216383108, -0.72112478515370419116081915539 + 1.2490247664834064794131795438*I, -0.72112478515370419116081915539 - 1.2490247664834064794131795438*I]~\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_conjvec(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    int __pyx_2;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_x);
    __pyx_v_n = Py_None; Py_INCREF(__pyx_v_n);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3619 */
    __pyx_1 = PyInt_FromLong(setjmp(GP_DATA->env)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3619; goto __pyx_L1;}
    Py_DECREF(__pyx_v_n);
    __pyx_v_n = __pyx_1;
    __pyx_1 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3620 */
    __pyx_2 = PyObject_IsTrue(__pyx_v_n); if (__pyx_2 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3620; goto __pyx_L1;}
    if (__pyx_2) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3621 */
      __pyx_1 = PyInt_FromLong(20); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3621; goto __pyx_L1;}
      if (PyObject_Cmp(__pyx_v_n, __pyx_1, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3621; goto __pyx_L1;}
      __pyx_2 = __pyx_2 == 0;
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      if (__pyx_2) {

        /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3622 */
        __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3622; goto __pyx_L1;}
        __pyx_3 = PyNumber_Remainder(__pyx_k124p, __pyx_v_x); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3622; goto __pyx_L1;}
        __Pyx_Raise(__pyx_1, __pyx_3, 0);
        Py_DECREF(__pyx_1); __pyx_1 = 0;
        Py_DECREF(__pyx_3); __pyx_3 = 0;
        {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3622; goto __pyx_L1;}
        goto __pyx_L3;
      }
      /*else*/ {

        /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3624 */
        __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3624; goto __pyx_L1;}
        __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3624; goto __pyx_L1;}
        Py_INCREF(__pyx_v_n);
        PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_n);
        Py_INCREF(__pyx_k125p);
        PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k125p);
        __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3624; goto __pyx_L1;}
        Py_DECREF(__pyx_1); __pyx_1 = 0;
        Py_DECREF(__pyx_3); __pyx_3 = 0;
        Py_DECREF(__pyx_4); __pyx_4 = 0;
      }
      __pyx_L3:;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3625 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(conjvec(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g,__pyx_v_8_py_pari_REAL_PREC))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3625; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.conjvec");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_n);
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_3gen_denominator(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_denominator[] = "\n        denominator(x): Return the denominator of x.  When x is a\n        vector, this is the least common multiple of the denominators\n        of the components of x.\n\n        what about poly?\n        INPUT:\n            x -- gen\n        OUTPUT:\n            gen \n        EXAMPLES:\n            >>> pari(\'5/9\').denominator()\n            9\n            >>> pari(\'(x+1)/(x-2)\').denominator()\n            x - 2\n            >>> pari(\'2/3 + 5/8*x + 7/3*x^2 + 1/5*y\').denominator()\n            1\n            >>> pari(\'2/3*x\').denominator()\n            1\n            >>> pari(\'[2/3, 5/8, 7/3, 1/5]\').denominator()\n            120\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_denominator(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_x);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3650 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(denom(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3650; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    __Pyx_AddTraceback("_py_pari.gen.denominator");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_k126p;
  static PyObject *__pyx_k127p;

  static char (__pyx_k126[]) = "x (=%s) has no floor.";
  static char (__pyx_k127[]) = "error in floor";

  static PyObject *__pyx_f_8_py_pari_3gen_floor(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_floor[] = "\n        floor(x): Return the floor of x, which is the largest integer <= x.\n        This function also works component-wise on polynomials, vectors, etc.\n\n        INPUT:\n            x -- gen\n        OUTPUT:\n            gen\n        EXAMPLES:\n            >>> pari(\'5/9\').floor()\n            0\n            >>> pari(\'11/9\').floor()\n            1\n            >>> pari(\'1.17\').floor()\n            1\n            >>> pari(\'x\').floor()\n            x\n            >>> pari(\'x+1.5\').floor()\n            x + 1.5000000000000000000000000000\n            >>> pari(\'[1.5,2.3,4.99]\').floor()\n            [1, 2, 4]\n            >>> pari(\'[[1.1,2.2],[3.3,4.4]]\').floor()\n            [[1, 2], [3, 4]]\n\n            >> pari(\'\"hello world\"\').floor()\n            Traceback (most recent call last):\n            ...\n            TypeError: x (=hello world) has no floor.\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_floor(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    int __pyx_2;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_x);
    __pyx_v_n = Py_None; Py_INCREF(__pyx_v_n);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3682 */
    __pyx_1 = PyInt_FromLong(setjmp(GP_DATA->env)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3682; goto __pyx_L1;}
    Py_DECREF(__pyx_v_n);
    __pyx_v_n = __pyx_1;
    __pyx_1 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3683 */
    __pyx_2 = PyObject_IsTrue(__pyx_v_n); if (__pyx_2 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3683; goto __pyx_L1;}
    if (__pyx_2) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3684 */
      __pyx_1 = PyInt_FromLong(20); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3684; goto __pyx_L1;}
      if (PyObject_Cmp(__pyx_v_n, __pyx_1, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3684; goto __pyx_L1;}
      __pyx_2 = __pyx_2 == 0;
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      if (__pyx_2) {

        /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3685 */
        __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3685; goto __pyx_L1;}
        __pyx_3 = PyNumber_Remainder(__pyx_k126p, __pyx_v_x); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3685; goto __pyx_L1;}
        __Pyx_Raise(__pyx_1, __pyx_3, 0);
        Py_DECREF(__pyx_1); __pyx_1 = 0;
        Py_DECREF(__pyx_3); __pyx_3 = 0;
        {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3685; goto __pyx_L1;}
        goto __pyx_L3;
      }
      /*else*/ {

        /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3687 */
        __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3687; goto __pyx_L1;}
        __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3687; goto __pyx_L1;}
        Py_INCREF(__pyx_v_n);
        PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_n);
        Py_INCREF(__pyx_k127p);
        PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k127p);
        __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3687; goto __pyx_L1;}
        Py_DECREF(__pyx_1); __pyx_1 = 0;
        Py_DECREF(__pyx_3); __pyx_3 = 0;
        Py_DECREF(__pyx_4); __pyx_4 = 0;
      }
      __pyx_L3:;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3688 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gfloor(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3688; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.floor");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_n);
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_k128p;
  static PyObject *__pyx_k129p;

  static char (__pyx_k128[]) = "Fractional part of %s not defined.";
  static char (__pyx_k129[]) = "error in frac";

  static PyObject *__pyx_f_8_py_pari_3gen_frac(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_frac[] = "\n        frac(x): Return the fractional part of x, which is x - floor(x).\n\n        INPUT:\n            x -- gen\n        OUTPUT:\n            gen\n        EXAMPLES:\n            >>> pari(\'1.7\').frac()\n            0.70000000000000000000000000001\n            >>> pari(\'sqrt(2)\').frac()\n            0.41421356237309504880168872420\n\n            >> pari(\'sqrt(-2)\').frac()\n            Traceback (most recent call last):\n            ...\n            TypeError: Fractional part of 1.4142135623730950488016887242*I not defined.\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_frac(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    int __pyx_2;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_x);
    __pyx_v_n = Py_None; Py_INCREF(__pyx_v_n);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3709 */
    __pyx_1 = PyInt_FromLong(setjmp(GP_DATA->env)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3709; goto __pyx_L1;}
    Py_DECREF(__pyx_v_n);
    __pyx_v_n = __pyx_1;
    __pyx_1 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3710 */
    __pyx_2 = PyObject_IsTrue(__pyx_v_n); if (__pyx_2 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3710; goto __pyx_L1;}
    if (__pyx_2) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3711 */
      __pyx_1 = PyInt_FromLong(20); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3711; goto __pyx_L1;}
      if (PyObject_Cmp(__pyx_v_n, __pyx_1, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3711; goto __pyx_L1;}
      __pyx_2 = __pyx_2 == 0;
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      if (__pyx_2) {

        /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3712 */
        __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3712; goto __pyx_L1;}
        __pyx_3 = PyNumber_Remainder(__pyx_k128p, __pyx_v_x); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3712; goto __pyx_L1;}
        __Pyx_Raise(__pyx_1, __pyx_3, 0);
        Py_DECREF(__pyx_1); __pyx_1 = 0;
        Py_DECREF(__pyx_3); __pyx_3 = 0;
        {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3712; goto __pyx_L1;}
        goto __pyx_L3;
      }
      /*else*/ {

        /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3714 */
        __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3714; goto __pyx_L1;}
        __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3714; goto __pyx_L1;}
        Py_INCREF(__pyx_v_n);
        PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_n);
        Py_INCREF(__pyx_k129p);
        PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k129p);
        __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3714; goto __pyx_L1;}
        Py_DECREF(__pyx_1); __pyx_1 = 0;
        Py_DECREF(__pyx_3); __pyx_3 = 0;
        Py_DECREF(__pyx_4); __pyx_4 = 0;
      }
      __pyx_L3:;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3715 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gfrac(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3715; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.frac");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_n);
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_k130p;
  static PyObject *__pyx_k131p;

  static char (__pyx_k130[]) = "Imaginary part of %s not defined.";
  static char (__pyx_k131[]) = "error in imag";

  static PyObject *__pyx_f_8_py_pari_3gen_imag(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_imag[] = "\n        imag(x): Return the imaginary part of x.  This function also\n        works component-wise.\n\n        INPUT:\n            x -- gen\n        OUTPUT:\n            gen\n        EXAMPLES:\n            >>> pari(\'1+2*I\').imag()\n            2\n            >>> pari(\'sqrt(-2)\').imag()\n            1.4142135623730950488016887242\n            >>> pari(\'x+I\').imag()\n            1\n            >>> pari(\'x+2*I\').imag()\n            2\n            >>> pari(\'(1+I)*x^2+2*I\').imag()\n            x^2 + 2\n            >>> pari(\'[1,2,3] + [4*I,5,6]\').imag()\n            [4, 0, 0]\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_imag(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    int __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_x);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3741 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3742 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3743 */
      __pyx_1 = (__pyx_v_n == 20);
      if (__pyx_1) {

        /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3744 */
        __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3744; goto __pyx_L1;}
        __pyx_3 = PyNumber_Remainder(__pyx_k130p, __pyx_v_x); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3744; goto __pyx_L1;}
        __Pyx_Raise(__pyx_2, __pyx_3, 0);
        Py_DECREF(__pyx_2); __pyx_2 = 0;
        Py_DECREF(__pyx_3); __pyx_3 = 0;
        {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3744; goto __pyx_L1;}
        goto __pyx_L3;
      }
      /*else*/ {

        /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3746 */
        __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3746; goto __pyx_L1;}
        __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3746; goto __pyx_L1;}
        __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3746; goto __pyx_L1;}
        PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
        Py_INCREF(__pyx_k131p);
        PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k131p);
        __pyx_3 = 0;
        __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3746; goto __pyx_L1;}
        Py_DECREF(__pyx_2); __pyx_2 = 0;
        Py_DECREF(__pyx_4); __pyx_4 = 0;
        Py_DECREF(__pyx_3); __pyx_3 = 0;
      }
      __pyx_L3:;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3747 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gimag(forcecopy(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g))))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3747; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.imag");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_3gen_length(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_length[] = "\n        length(x): Return the number of non-code words in x.  If x\n        is a string, this is the number of characters of x.\n\n        ?? terminator ?? carriage return ??\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_length(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_x);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3756 */
    __pyx_1 = PyInt_FromLong(glength(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3756; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    __Pyx_AddTraceback("_py_pari.gen.length");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_k132p;

  static char (__pyx_k132[]) = "error in lift";

  static PyObject *__pyx_f_8_py_pari_3gen_lift(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_lift[] = "\n        lift(x,{v}): Returns the lift of an element of Z/nZ to Z or\n        R[x]/(P) to R[x] for a type R if v is omitted.  If v is given,\n        lift only polymods with main variable v.  If v does not occur\n        in x, lift only intmods.\n\n        INPUT:\n            x -- gen\n            v -- (optional) variable\n        OUTPUT:\n            gen \n        EXAMPLES:\n            >>> x = pari(\"x\")\n            >>> a = x.Mod(x**3 + 17*x + 3)\n            >>> a\n            Mod(x, x^3 + 17*x + 3)\n            >>> b = a**4; b\n            Mod(-17*x^2 - 3*x, x^3 + 17*x + 3)\n            >>> b.lift()\n            -17*x^2 - 3*x\n\n        ??? more examples\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_lift(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_v = 0;
    PyObject *__pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    int __pyx_2;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {"v",0};
    __pyx_v_v = __pyx_k14;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_v)) return 0;
    Py_INCREF(__pyx_v_x);
    Py_INCREF(__pyx_v_v);
    __pyx_v_n = Py_None; Py_INCREF(__pyx_v_n);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3782 */
    __pyx_1 = PyInt_FromLong(setjmp(GP_DATA->env)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3782; goto __pyx_L1;}
    Py_DECREF(__pyx_v_n);
    __pyx_v_n = __pyx_1;
    __pyx_1 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3783 */
    __pyx_2 = PyObject_IsTrue(__pyx_v_n); if (__pyx_2 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3783; goto __pyx_L1;}
    if (__pyx_2) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3784 */
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3784; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3784; goto __pyx_L1;}
      Py_INCREF(__pyx_v_n);
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_n);
      Py_INCREF(__pyx_k132p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k132p);
      __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3784; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3785 */
    __pyx_1 = PyInt_FromLong((-1)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3785; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_v_v, __pyx_1, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3785; goto __pyx_L1;}
    __pyx_2 = __pyx_2 == 0;
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    if (__pyx_2) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3786 */
      __pyx_3 = ((PyObject *)__pyx_f_8_py_pari_new_gen(lift(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g)))); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3786; goto __pyx_L1;}
      __pyx_r = __pyx_3;
      __pyx_3 = 0;
      goto __pyx_L0;
      goto __pyx_L3;
    }
    __pyx_L3:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3787 */
    __pyx_4 = ((PyObject *)__pyx_f_8_py_pari_new_gen(lift0(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g),__pyx_f_8_py_pari_get_var(__pyx_v_v)))); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3787; goto __pyx_L1;}
    __pyx_r = __pyx_4;
    __pyx_4 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.lift");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_n);
    Py_DECREF(__pyx_v_x);
    Py_DECREF(__pyx_v_v);
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_3gen_numerator(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_numerator[] = "\n        numerator(x): Returns the numerator of x.\n\n        INPUT:\n            x -- gen\n        OUTPUT:\n            gen\n        EXAMPLES:\n\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_numerator(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_x);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3800 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(numer(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3800; goto __pyx_L1;}
    __Pyx_Raise(__pyx_1, 0, 0);
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3800; goto __pyx_L1;}

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    __Pyx_AddTraceback("_py_pari.gen.numerator");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_3gen_numtoperm(PyObject *__pyx_v_k, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_numtoperm[] = "\n        numtoperm(k, n): Return the permutation number k (mod n!) of n\n        letters, where n is an integer.\n        \n        INPUT:\n            k -- gen, integer\n            n -- int\n        OUTPUT:\n            gen -- vector (permutation of {1,...,n})\n        EXAMPLES:\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_numtoperm(PyObject *__pyx_v_k, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    long __pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    static char *__pyx_argnames[] = {"n",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l", __pyx_argnames, &__pyx_v_n)) return 0;
    Py_INCREF(__pyx_v_k);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3815 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(numtoperm(__pyx_v_n,((struct __pyx_obj_8_py_pari_gen *)__pyx_v_k)->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3815; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    __Pyx_AddTraceback("_py_pari.gen.numtoperm");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_k);
    return __pyx_r;
  }

  static PyObject *__pyx_k133p;

  static char (__pyx_k133[]) = "p (=%s) must be of type t_INT, but is of type %s.";

  static PyObject *__pyx_f_8_py_pari_3gen_padicprec(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_padicprec[] = "\n        padicprec(x,p): Return the absolute p-adic precision of the object x.\n\n        INPUT:\n            x -- gen\n        OUTPUT:\n            int\n        EXAMPLES:\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_padicprec(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_p = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__p;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    PyObject *__pyx_5 = 0;
    static char *__pyx_argnames[] = {"p",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_p)) return 0;
    Py_INCREF(__pyx_v_x);
    Py_INCREF(__pyx_v_p);
    ((PyObject*)__pyx_v__p) = Py_None; Py_INCREF(((PyObject*)__pyx_v__p));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3829 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3829; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3829; goto __pyx_L1;}
    Py_INCREF(__pyx_v_p);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_p);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3829; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3829; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__p));
    ((PyObject *)__pyx_v__p) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3830 */
    __pyx_4 = (typ(__pyx_v__p->g) != t_INT);
    if (__pyx_4) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3831 */
      __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3831; goto __pyx_L1;}
      __pyx_2 = PyObject_GetAttr(((PyObject *)__pyx_v__p), __pyx_n_type); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3832; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3832; goto __pyx_L1;}
      __pyx_5 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3832; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __pyx_2 = PyTuple_New(2); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3832; goto __pyx_L1;}
      Py_INCREF(((PyObject *)__pyx_v__p));
      PyTuple_SET_ITEM(__pyx_2, 0, ((PyObject *)__pyx_v__p));
      PyTuple_SET_ITEM(__pyx_2, 1, __pyx_5);
      __pyx_5 = 0;
      __pyx_3 = PyNumber_Remainder(__pyx_k133p, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3831; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      __Pyx_Raise(__pyx_1, __pyx_3, 0);
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3831; goto __pyx_L1;}
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3833 */
    __pyx_5 = PyInt_FromLong(padicprec(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g,__pyx_v__p->g)); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3833; goto __pyx_L1;}
    __pyx_r = __pyx_5;
    __pyx_5 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_5);
    __Pyx_AddTraceback("_py_pari.gen.padicprec");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__p);
    Py_DECREF(__pyx_v_x);
    Py_DECREF(__pyx_v_p);
    return __pyx_r;
  }

  static PyObject *__pyx_k134p;

  static char (__pyx_k134[]) = "x (=%s) must be of type t_VEC, but is of type %s.";

  static PyObject *__pyx_f_8_py_pari_3gen_permtonum(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_permtonum[] = "\n        permtonum(x): Return the ordinal (between 1 and n!) of permutation vector x.\n        ??? Huh ???  say more.  what is a perm vector.  0 to n-1 or 1-n.\n\n        INPUT:\n            x -- gen (vector of integers)\n        OUTPUT:\n            gen -- integer\n        EXAMPLES:\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_permtonum(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    PyObject *__pyx_5 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_x);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3846 */
    __pyx_1 = (typ(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g) != t_VEC);
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3847 */
      __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3847; goto __pyx_L1;}
      __pyx_3 = PyObject_GetAttr(__pyx_v_x, __pyx_n_type); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3847; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3847; goto __pyx_L1;}
      __pyx_5 = PyObject_CallObject(__pyx_3, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3847; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3847; goto __pyx_L1;}
      Py_INCREF(__pyx_v_x);
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_x);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_5);
      __pyx_5 = 0;
      __pyx_4 = PyNumber_Remainder(__pyx_k134p, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3847; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __Pyx_Raise(__pyx_2, __pyx_4, 0);
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3847; goto __pyx_L1;}
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3848 */
    __pyx_5 = ((PyObject *)__pyx_f_8_py_pari_new_gen(permtonum(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g))); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3848; goto __pyx_L1;}
    __Pyx_Raise(__pyx_5, 0, 0);
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3848; goto __pyx_L1;}

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    Py_XDECREF(__pyx_5);
    __Pyx_AddTraceback("_py_pari.gen.permtonum");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_3gen_precision(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_precision[] = "\n        precision(x,{n}): Change the precision of x to be n, where n\n        is a C-integer). If n is omitted, output the real precision of x.\n\n        INPUT:\n            x -- gen\n            n -- (optional) int\n        OUTPUT:\n            nothing\n          or\n            gen if n is omitted\n        EXAMPLES:\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_precision(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    long __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    static char *__pyx_argnames[] = {"n",0};
    __pyx_v_n = __pyx_k15;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|l", __pyx_argnames, &__pyx_v_n)) return 0;
    Py_INCREF(__pyx_v_x);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3864 */
    __pyx_1 = (__pyx_v_n <= (-1));
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3865 */
      __pyx_2 = PyInt_FromLong(precision(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3865; goto __pyx_L1;}
      __pyx_r = __pyx_2;
      __pyx_2 = 0;
      goto __pyx_L0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3866 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(precision0(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g,__pyx_v_n))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3866; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    __Pyx_AddTraceback("_py_pari.gen.precision");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_k135p;

  static char (__pyx_k135[]) = "x (=%s) must be of type t_INT, but is of type %s.";

  static PyObject *__pyx_f_8_py_pari_3gen_random(PyObject *__pyx_v_N, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_random[] = "\n        random({N=2^31}): Return a pseudo-random integer between 0 and N-1.\n\n        INPUT:\n            N -- gen, integer\n        OUTPUT:\n            gen -- integer\n        EXAMPLES:\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_random(PyObject *__pyx_v_N, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    PyObject *__pyx_5 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_N);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3878 */
    __pyx_1 = (typ(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_N)->g) != t_INT);
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3879 */
      __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3879; goto __pyx_L1;}
      __pyx_3 = PyObject_GetAttr(__pyx_v_N, __pyx_n_type); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3879; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3879; goto __pyx_L1;}
      __pyx_5 = PyObject_CallObject(__pyx_3, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3879; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3879; goto __pyx_L1;}
      Py_INCREF(__pyx_v_N);
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_N);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_5);
      __pyx_5 = 0;
      __pyx_4 = PyNumber_Remainder(__pyx_k135p, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3879; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __Pyx_Raise(__pyx_2, __pyx_4, 0);
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3879; goto __pyx_L1;}
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3880 */
    __pyx_5 = ((PyObject *)__pyx_f_8_py_pari_new_gen(genrand(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_N)->g))); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3880; goto __pyx_L1;}
    __pyx_r = __pyx_5;
    __pyx_5 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    Py_XDECREF(__pyx_5);
    __Pyx_AddTraceback("_py_pari.gen.random");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_N);
    return __pyx_r;
  }

  static PyObject *__pyx_k136p;

  static char (__pyx_k136[]) = "error in real";

  static PyObject *__pyx_f_8_py_pari_3gen_real(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_real[] = "\n        real(x): Return the real part of x.\n\n        INPUT:\n            x -- gen\n        OUTPUT:\n            gen \n        EXAMPLES:\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_real(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    int __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_x);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3893 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3894 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3895 */
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3895; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3895; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3895; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k136p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k136p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3895; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3896 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(greal(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g)))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3896; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.real");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_k137p;

  static char (__pyx_k137[]) = "error in round";

  static PyObject *__pyx_f_8_py_pari_3gen_round(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_round[] = "\n        round(x,estimat=False):  If x is a real number, returns x rounded\n        to the nearest integer (rounding up).  If the optional argument\n        estimate is True, also returns the binary exponent e of the difference\n        between the original and the rounded value (the \"fractional part\")\n        (this is the integer ceiling of log_2(error)).\n\n        When x is a general PARI object, this function returns the result\n        of rounding every coefficient at every level of PARI object.\n        Note that this is different than what the truncate function\n        does (see the example below).\n\n        One use of round is to get exact results after a long\n        approximate computation, when theory tells you that the\n        coefficients must be integers.\n        \n        INPUT:\n            x -- gen\n            estimate -- (optional) bool, False by default\n        OUTPUT:\n            * if estimate == False, return a single gen.\n            * if estimate == True, return rounded verison of x and\n              error estimate in bits, both as gens.\n        EXAMPLES:\n            >>> pari(\'1.5\').round()\n            2\n            >>> pari(\'1.5\').round(True)\n            (2, -1)\n            >>> pari(\'1.5 + 2.1*I\').round()\n            2 + 2*I\n            >>> pari(\'1.0001\').round(True)\n            (1, -14)\n            >>> pari(\'(2.4*x^2 - 1.7)/x\').round()\n            (2*x^2 - 2)/x\n            >>> pari(\'(2.4*x^2 - 1.7)/x\').truncate()\n            2.4000000000000000000000000000*x\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_round(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_estimate = 0;
    int __pyx_v_n;
    long __pyx_v_e;
    struct __pyx_obj_8_py_pari_gen *__pyx_v_y;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    int __pyx_5;
    static char *__pyx_argnames[] = {"estimate",0};
    __pyx_v_estimate = __pyx_k16;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_estimate)) return 0;
    Py_INCREF(__pyx_v_x);
    Py_INCREF(__pyx_v_estimate);
    ((PyObject*)__pyx_v_y) = Py_None; Py_INCREF(((PyObject*)__pyx_v_y));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3937 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3938 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3939 */
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3939; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3939; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3939; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k137p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k137p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3939; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3940 */
    __pyx_1 = PyObject_IsTrue(__pyx_v_estimate); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3940; goto __pyx_L1;}
    __pyx_5 = (!__pyx_1);
    if (__pyx_5) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3941 */
      __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(ground(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3941; goto __pyx_L1;}
      __pyx_r = __pyx_2;
      __pyx_2 = 0;
      goto __pyx_L0;
      goto __pyx_L3;
    }
    __pyx_L3:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3944 */
    __pyx_4 = ((PyObject *)__pyx_f_8_py_pari_new_gen(grndtoi(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g,(&__pyx_v_e)))); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3944; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v_y));
    ((PyObject *)__pyx_v_y) = __pyx_4;
    __pyx_4 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3945 */
    __pyx_3 = PyInt_FromLong(__pyx_v_e); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3945; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(2); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3945; goto __pyx_L1;}
    Py_INCREF(((PyObject *)__pyx_v_y));
    PyTuple_SET_ITEM(__pyx_2, 0, ((PyObject *)__pyx_v_y));
    PyTuple_SET_ITEM(__pyx_2, 1, __pyx_3);
    __pyx_3 = 0;
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.round");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_y);
    Py_DECREF(__pyx_v_x);
    Py_DECREF(__pyx_v_estimate);
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_3gen_simplify(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_simplify[] = "\n        simplify(x): Simplify the object x as much as possible, and return\n        the result.\n\n        A complex or quadratic number whose imaginary part is an exact 0\n        (i.e., not an approximate one such as O(3) or 0.E-28) is converted\n        to its real part, and a a polynomial of degree 0 is converted to\n        its constant term.  Simplification occurs recursively.\n\n        This function is useful before using arithmetic functions, which\n        expect integer arguments:\n            >>> y = pari(\'y\')\n            >>> x = pari(\'9\') + y - y\n            >>> x\n            9\n            >>> x.type()\n            \'t_POL\'\n            >>> x.factor()\n            matrix(0,2)\n            >>> pari(\'9\').factor()\n            Mat([3, 2])\n            >>> x.simplify()\n            9\n            >>> x.simplify().factor()\n            Mat([3, 2])\n        \n        INPUT:\n            x -- gen\n        OUTPUT:\n            gen \n        EXAMPLES:\n            >>> x = pari(\'1.5 + 0*I\')\n            >>> x.type()\n            \'t_COMPLEX\'\n            >>> x.simplify()\n            1.5000000000000000000000000000\n            >>> y = x.simplify()\n            >>> y.type()\n            \'t_REAL\'\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_simplify(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_x);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3988 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(simplify(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3988; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    __Pyx_AddTraceback("_py_pari.gen.simplify");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_3gen_sizebyte(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_sizebyte[] = "\n        sizebyte(x): Return the total number of bytes occupied by the\n        complete tree of the object x.\n        \n        INPUT:\n            x -- gen\n        OUTPUT:\n            int (a Python int)\n        EXAMPLES:\n            >>> pari(\'1\').sizebyte()\n            12\n            >>> pari(\'10\').sizebyte()\n            12\n            >>> pari(\'10000000000000\').sizebyte()\n            16\n            >>> pari(\'10^100\').sizebyte()\n            52\n            >>> pari(\'x\').sizebyte()\n            36\n            >>> pari(\'x^20\').sizebyte()\n            264\n            >>> pari(\'[x, 10^100]\').sizebyte()\n            100\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_sizebyte(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_x);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4015 */
    __pyx_1 = PyInt_FromLong(taille2(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4015; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    __Pyx_AddTraceback("_py_pari.gen.sizebyte");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_3gen_sizedigit(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_sizedigit[] = "\n\n        sizedigit(x): Return a quick estimate for the maximal number of\n        decimal digits before the decimal point of any component of x.\n\n        INPUT:\n            x -- gen\n        OUTPUT:\n            int -- Python integer\n        EXAMPLES:\n            >>> x = pari(\'10^100\')\n            >>> x.Str().length()\n            101\n            >>> x.sizedigit()\n            101\n\n        Note that digits after the decimal point are ignored.\n            >>> x = pari(\'1.234\')\n            >>> x\n            1.2340000000000000000000000000\n            >>> x.sizedigit()\n            1\n\n        The estimate can be one too big:\n            >>> pari(\'7234.1\').sizedigit()\n            4\n            >>> pari(\'9234.1\').sizedigit()\n            5\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_sizedigit(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_x);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4047 */
    __pyx_1 = PyInt_FromLong(sizedigit(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4047; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    __Pyx_AddTraceback("_py_pari.gen.sizedigit");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_k138p;

  static char (__pyx_k138[]) = "error in truncate";

  static PyObject *__pyx_f_8_py_pari_3gen_truncate(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_truncate[] = "\n        truncate(x,estimate=False):  Return the truncation of x.\n        If estimate is True, also return the number of error bits.\n        \n        When x is in the real numbers, this means that the part\n        after the decimal point is chopped away, e is the binary\n        exponent of the difference between the original and truncated\n        value (the \"fractional part\").    If x is a rational\n        function, the result is the integer part (Euclidean\n        quotient of numerator by denominator) and if requested\n        the error estimate is 0.\n\n        When truncate is applied to a power series (in X), it\n        transforms it into a polynomial or a rational function with\n        denominator a power of X, by chopping away the O(X^k).\n        Similarly, when applied to a p-adic number, it transforms it\n        into an integer or a rational number by chopping away the\n        O(p^k).\n\n        INPUT:\n            x -- gen\n            estimate -- (optional) bool, which is False by default\n        OUTPUT:\n            * if estimate == False, return a single gen.\n            * if estimate == True, return rounded verison of x and\n              error estimate in bits, both as gens.\n        OUTPUT:\n        EXAMPLES:\n            >>> pari(\'(x^2+1)/x\').round()\n            (x^2 + 1)/x\n            >>> pari(\'(x^2+1)/x\').truncate()\n            x\n            >>> pari(\'1.043\').truncate()\n            1\n            >>> pari(\'1.043\').truncate(True)\n            (1, -5)\n            >>> pari(\'1.6\').truncate()\n            1\n            >>> pari(\'1.6\').round()\n            2\n            >>> pari(\'1/3 + 2 + 3^2 + O(3^3)\').truncate()\n            34/3\n            >>> pari(\'sin(x+O(x^10))\').truncate()\n            1/362880*x^9 - 1/5040*x^7 + 1/120*x^5 - 1/6*x^3 + x\n            >>> pari(\'sin(x+O(x^10))\').round()   # each coefficient has abs < 1\n            x + O(x^10)\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_truncate(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_estimate = 0;
    int __pyx_v_n;
    long __pyx_v_e;
    struct __pyx_obj_8_py_pari_gen *__pyx_v_y;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    int __pyx_5;
    static char *__pyx_argnames[] = {"estimate",0};
    __pyx_v_estimate = __pyx_k17;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_estimate)) return 0;
    Py_INCREF(__pyx_v_x);
    Py_INCREF(__pyx_v_estimate);
    ((PyObject*)__pyx_v_y) = Py_None; Py_INCREF(((PyObject*)__pyx_v_y));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4098 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4099 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4100 */
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4100; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4100; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4100; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k138p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k138p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4100; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4101 */
    __pyx_1 = PyObject_IsTrue(__pyx_v_estimate); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4101; goto __pyx_L1;}
    __pyx_5 = (!__pyx_1);
    if (__pyx_5) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4102 */
      __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gtrunc(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4102; goto __pyx_L1;}
      __pyx_r = __pyx_2;
      __pyx_2 = 0;
      goto __pyx_L0;
      goto __pyx_L3;
    }
    __pyx_L3:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4105 */
    __pyx_4 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gcvtoi(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g,(&__pyx_v_e)))); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4105; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v_y));
    ((PyObject *)__pyx_v_y) = __pyx_4;
    __pyx_4 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4106 */
    __pyx_3 = PyInt_FromLong(__pyx_v_e); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4106; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(2); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4106; goto __pyx_L1;}
    Py_INCREF(((PyObject *)__pyx_v_y));
    PyTuple_SET_ITEM(__pyx_2, 0, ((PyObject *)__pyx_v_y));
    PyTuple_SET_ITEM(__pyx_2, 1, __pyx_3);
    __pyx_3 = 0;
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.truncate");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_y);
    Py_DECREF(__pyx_v_x);
    Py_DECREF(__pyx_v_estimate);
    return __pyx_r;
  }

  static PyObject *__pyx_k139p;

  static char (__pyx_k139[]) = "error in valuation";

  static PyObject *__pyx_f_8_py_pari_3gen_valuation(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_valuation[] = "\n        valuation(x,p): Return the valuation of x with respect to p.\n\n        The valuation is the highest exponent of p dividing x.\n\n           * If p is an integer, x must be an integer, an intmod whose\n             modulus is divisible by p, a rational number, a p-adic\n             number, or a polynomial or power series in which case the\n             valuation is the minimal of the valuations of the\n             coefficients.\n\n           * If p is a polynomial, x must be a polynomial or a\n             rational fucntion.  If p is a monomial then x may also be\n             a power series.\n\n           * If x is a vector, complex or quadratic number, then the\n             valuation is the minimum of the component valuations.\n\n           * If x = 0, the result is 2^31-1 on 32-bit machines or\n             2^63-1 on 64-bit machines if x is an exact object.\n             If x is a p-adic number or power series, the result\n             is the exponent of the zero.\n\n        INPUT:\n            x -- gen\n            p -- coercible to gen\n        OUTPUT:\n            gen -- integer\n        EXAMPLES:\n            >>> pari(9).valuation(3)\n            2\n            >>> pari(9).valuation(9)\n            1\n            >>> x = pari(9).Mod(27); x.valuation(3)\n            2\n            >>> pari(\'5/3\').valuation(3)\n            -1\n            >>> pari(\'9 + 3*x + 15*x^2\').valuation(3)\n            1\n            >>> pari([9,3,15]).valuation(3)\n            1\n            >>> pari(\'9 + 3*x + 15*x^2 + O(x^5)\').valuation(3)\n            1\n\n            >>> pari(\'x^2*(x+1)^3\').valuation(pari(\'x+1\'))\n            3\n            >>> pari(\'x + O(x^5)\').valuation(\'x\')\n            1\n            >>> pari(\'2*x^2 + O(x^5)\').valuation(\'x\')\n            2\n\n            >> pari(0).valuation(3)   # on 32-bit machine\n            2147483647\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_valuation(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_p = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__p;
    int __pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    static char *__pyx_argnames[] = {"p",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_p)) return 0;
    Py_INCREF(__pyx_v_x);
    Py_INCREF(__pyx_v_p);
    ((PyObject*)__pyx_v__p) = Py_None; Py_INCREF(((PyObject*)__pyx_v__p));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4164 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4164; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4164; goto __pyx_L1;}
    Py_INCREF(__pyx_v_p);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_p);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4164; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4164; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__p));
    ((PyObject *)__pyx_v__p) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4166 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4167 */
    __pyx_4 = __pyx_v_n;
    if (__pyx_4) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4168 */
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4168; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4168; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4168; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
      Py_INCREF(__pyx_k139p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k139p);
      __pyx_2 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4168; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4169 */
    __pyx_1 = PyInt_FromLong(ggval(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g,__pyx_v__p->g)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4169; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.valuation");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__p);
    Py_DECREF(__pyx_v_x);
    Py_DECREF(__pyx_v_p);
    return __pyx_r;
  }

  static PyObject *__pyx_k140p;

  static char (__pyx_k140[]) = "error in valuation";

  static PyObject *__pyx_f_8_py_pari_3gen_variable(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_variable[] = "\n        variable(x): Return the main variable of the object x, or p\n        if x is a p-adic number.\n\n        This function raises a TypeError exception on scalars, i.e.,\n        on objects with no variable associated to them.\n\n        INPUT:\n            x -- gen \n        OUTPUT:\n            gen \n        EXAMPLES:\n            >>> pari(\'x^2 + x -2 \').variable()\n            x\n            >>> pari(\'1+2^3 + O(2^5)\').variable()\n            2\n            >>> pari(\'x+y\').variable()\n            x\n            >>> pari(\'y+z\').variable()\n            y\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_variable(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    int __pyx_2;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_x);
    __pyx_v_n = Py_None; Py_INCREF(__pyx_v_n);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4193 */
    __pyx_1 = PyInt_FromLong(setjmp(GP_DATA->env)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4193; goto __pyx_L1;}
    Py_DECREF(__pyx_v_n);
    __pyx_v_n = __pyx_1;
    __pyx_1 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4194 */
    __pyx_2 = PyObject_IsTrue(__pyx_v_n); if (__pyx_2 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4194; goto __pyx_L1;}
    if (__pyx_2) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4195 */
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4195; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4195; goto __pyx_L1;}
      Py_INCREF(__pyx_v_n);
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_n);
      Py_INCREF(__pyx_k140p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k140p);
      __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4195; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4196 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gpolvar(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4196; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.variable");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_n);
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_k141p;

  static char (__pyx_k141[]) = "error in sqrt";

  static PyObject *__pyx_f_8_py_pari_3gen_sqrt(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_sqrt(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    int __pyx_v_prec;
    int __pyx_v_err;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {"prec",0};
    __pyx_v_prec = __pyx_k18;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|i", __pyx_argnames, &__pyx_v_prec)) return 0;
    Py_INCREF(__pyx_v_x);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4204 */
    __pyx_v_err = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4205 */
    __pyx_1 = __pyx_v_err;
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4205; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_err); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4205; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4205; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k141p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k141p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4205; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4206 */
    __pyx_1 = (__pyx_v_prec < 3);
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4207 */
      __pyx_v_prec = __pyx_v_8_py_pari_REAL_PREC;
      goto __pyx_L3;
    }
    __pyx_L3:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4208 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gsqrt(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g),__pyx_v_prec))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4208; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.sqrt");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_k142p;

  static char (__pyx_k142[]) = "error evaluating gamma(%s)";

  static PyObject *__pyx_f_8_py_pari_3gen_gamma(PyObject *__pyx_v_s, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_gamma[] = "\n        gamma(x): Gamma function at s.\n        INPUT:\n            s -- gen (real or complex number\n        OUTPUT:\n            gen -- value of zeta at s.\n        EXAMPLES:\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_gamma(PyObject *__pyx_v_s, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    int __pyx_v_prec;
    int __pyx_v_err;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    PyObject *__pyx_5 = 0;
    static char *__pyx_argnames[] = {"prec",0};
    __pyx_v_prec = __pyx_k19;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|i", __pyx_argnames, &__pyx_v_prec)) return 0;
    Py_INCREF(__pyx_v_s);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4220 */
    __pyx_v_err = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4221 */
    __pyx_1 = __pyx_v_err;
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4221; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_err); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4221; goto __pyx_L1;}
      __pyx_4 = PyNumber_Remainder(__pyx_k142p, __pyx_v_s); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4221; goto __pyx_L1;}
      __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4221; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_5, 0, __pyx_3);
      PyTuple_SET_ITEM(__pyx_5, 1, __pyx_4);
      __pyx_3 = 0;
      __pyx_4 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_5); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4221; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4222 */
    __pyx_1 = (__pyx_v_prec < 3);
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4223 */
      __pyx_v_prec = __pyx_v_8_py_pari_REAL_PREC;
      goto __pyx_L3;
    }
    __pyx_L3:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4224 */
    __pyx_4 = ((PyObject *)__pyx_f_8_py_pari_new_gen(ggamma(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_s)->g),__pyx_v_prec))); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4224; goto __pyx_L1;}
    __pyx_r = __pyx_4;
    __pyx_4 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    Py_XDECREF(__pyx_5);
    __Pyx_AddTraceback("_py_pari.gen.gamma");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_s);
    return __pyx_r;
  }

  static PyObject *__pyx_k143p;

  static char (__pyx_k143[]) = "error evaluating zeta(%s)";

  static PyObject *__pyx_f_8_py_pari_3gen_zeta(PyObject *__pyx_v_s, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_zeta[] = "\n        zeta(s): Riemann zeta function at s with s a complex\n                 or a p-adic number.\n        INPUT:\n            s -- gen (real or complex number\n        OUTPUT:\n            gen -- value of zeta at s.\n        EXAMPLES:\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_zeta(PyObject *__pyx_v_s, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    int __pyx_v_prec;
    int __pyx_v_err;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    PyObject *__pyx_5 = 0;
    static char *__pyx_argnames[] = {"prec",0};
    __pyx_v_prec = __pyx_k20;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|i", __pyx_argnames, &__pyx_v_prec)) return 0;
    Py_INCREF(__pyx_v_s);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4238 */
    __pyx_v_err = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4239 */
    __pyx_1 = __pyx_v_err;
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4239; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_err); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4239; goto __pyx_L1;}
      __pyx_4 = PyNumber_Remainder(__pyx_k143p, __pyx_v_s); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4239; goto __pyx_L1;}
      __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4239; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_5, 0, __pyx_3);
      PyTuple_SET_ITEM(__pyx_5, 1, __pyx_4);
      __pyx_3 = 0;
      __pyx_4 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_5); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4239; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4240 */
    __pyx_1 = (__pyx_v_prec < 3);
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4241 */
      __pyx_v_prec = __pyx_v_8_py_pari_REAL_PREC;
      goto __pyx_L3;
    }
    __pyx_L3:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4242 */
    __pyx_4 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gzeta(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_s)->g),__pyx_v_prec))); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4242; goto __pyx_L1;}
    __pyx_r = __pyx_4;
    __pyx_4 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    Py_XDECREF(__pyx_5);
    __Pyx_AddTraceback("_py_pari.gen.zeta");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_s);
    return __pyx_r;
  }

  static PyObject *__pyx_k144p;

  static char (__pyx_k144[]) = "error in issquare";

  static PyObject *__pyx_f_8_py_pari_3gen_issquare(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_issquare(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    int __pyx_v_err;
    GEN __pyx_v_G;
    GEN __pyx_v_t;
    struct __pyx_obj_8_py_pari_gen *__pyx_v_g;
    PyObject *__pyx_v_v;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_x);
    ((PyObject*)__pyx_v_g) = Py_None; Py_INCREF(((PyObject*)__pyx_v_g));
    __pyx_v_v = Py_None; Py_INCREF(__pyx_v_v);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4253 */
    __pyx_v_err = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4254 */
    __pyx_1 = __pyx_v_err;
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4254; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_err); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4254; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4254; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k144p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k144p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4254; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4255 */
    __pyx_v_t = gcarrecomplet(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g),(&__pyx_v_G));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4256 */
    __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_bool); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4256; goto __pyx_L1;}
    __pyx_4 = ((PyObject *)__pyx_f_8_py_pari_new_gen_noclear(__pyx_v_t)); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4256; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4256; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_4);
    __pyx_4 = 0;
    __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4256; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_v_v);
    __pyx_v_v = __pyx_4;
    __pyx_4 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4257 */
    __pyx_1 = PyObject_IsTrue(__pyx_v_v); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4257; goto __pyx_L1;}
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4258 */
      __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(__pyx_v_G)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4258; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4258; goto __pyx_L1;}
      Py_INCREF(__pyx_v_v);
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_v);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_2);
      __pyx_2 = 0;
      __pyx_r = __pyx_3;
      __pyx_3 = 0;
      goto __pyx_L0;
      goto __pyx_L3;
    }
    /*else*/ {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4260 */
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4260; goto __pyx_L1;}
      Py_INCREF(__pyx_v_v);
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_v);
      Py_INCREF(Py_None);
      PyTuple_SET_ITEM(__pyx_4, 1, Py_None);
      __pyx_r = __pyx_4;
      __pyx_4 = 0;
      goto __pyx_L0;
    }
    __pyx_L3:;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.issquare");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_g);
    Py_DECREF(__pyx_v_v);
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_3gen_issquarefree(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_issquarefree(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_self);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4263 */
    __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_bool); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4263; goto __pyx_L1;}
    __pyx_2 = PyInt_FromLong(issquarefree(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4263; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4263; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4263; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.issquarefree");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_self);
    return __pyx_r;
  }

  static PyObject *__pyx_k145p;

  static char (__pyx_k145[]) = "error in lcm";

  static PyObject *__pyx_f_8_py_pari_3gen_lcm(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_lcm(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_y = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__y;
    int __pyx_v_err;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    static char *__pyx_argnames[] = {"y",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
    Py_INCREF(__pyx_v_x);
    Py_INCREF(__pyx_v_y);
    ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4267 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4267; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4267; goto __pyx_L1;}
    Py_INCREF(__pyx_v_y);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4267; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4267; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__y));
    ((PyObject *)__pyx_v__y) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4269 */
    __pyx_v_err = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4270 */
    __pyx_4 = __pyx_v_err;
    if (__pyx_4) {
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4270; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_err); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4270; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4270; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
      Py_INCREF(__pyx_k145p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k145p);
      __pyx_2 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4270; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4271 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(glcm(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g),forcecopy(__pyx_v__y->g)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4271; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.lcm");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__y);
    Py_DECREF(__pyx_v_x);
    Py_DECREF(__pyx_v_y);
    return __pyx_r;
  }

  static PyObject *__pyx_k146p;

  static char (__pyx_k146[]) = "error in gcd";

  static PyObject *__pyx_f_8_py_pari_3gen_gcd(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_gcd(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_y = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__y;
    int __pyx_v_err;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    static char *__pyx_argnames[] = {"y",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
    Py_INCREF(__pyx_v_x);
    Py_INCREF(__pyx_v_y);
    ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4275 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4275; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4275; goto __pyx_L1;}
    Py_INCREF(__pyx_v_y);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4275; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4275; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__y));
    ((PyObject *)__pyx_v__y) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4277 */
    __pyx_v_err = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4278 */
    __pyx_4 = __pyx_v_err;
    if (__pyx_4) {
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4278; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_err); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4278; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4278; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
      Py_INCREF(__pyx_k146p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k146p);
      __pyx_2 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4278; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4279 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(ggcd(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g),forcecopy(__pyx_v__y->g)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4279; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.gcd");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__y);
    Py_DECREF(__pyx_v_x);
    Py_DECREF(__pyx_v_y);
    return __pyx_r;
  }

  static PyObject *__pyx_k147p;

  static char (__pyx_k147[]) = "error in bezout";

  static PyObject *__pyx_f_8_py_pari_3gen_bezout(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_bezout(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_y = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__y;
    struct __pyx_obj_8_py_pari_gen *__pyx_v_u;
    struct __pyx_obj_8_py_pari_gen *__pyx_v_v;
    struct __pyx_obj_8_py_pari_gen *__pyx_v_g;
    GEN __pyx_v_U;
    GEN __pyx_v_V;
    GEN __pyx_v_G;
    int __pyx_v_err;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    static char *__pyx_argnames[] = {"y",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
    Py_INCREF(__pyx_v_x);
    Py_INCREF(__pyx_v_y);
    ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));
    ((PyObject*)__pyx_v_u) = Py_None; Py_INCREF(((PyObject*)__pyx_v_u));
    ((PyObject*)__pyx_v_v) = Py_None; Py_INCREF(((PyObject*)__pyx_v_v));
    ((PyObject*)__pyx_v_g) = Py_None; Py_INCREF(((PyObject*)__pyx_v_g));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4284 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4284; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4284; goto __pyx_L1;}
    Py_INCREF(__pyx_v_y);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4284; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4284; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__y));
    ((PyObject *)__pyx_v__y) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4286 */
    __pyx_v_err = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4287 */
    __pyx_4 = __pyx_v_err;
    if (__pyx_4) {
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4287; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_err); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4287; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4287; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
      Py_INCREF(__pyx_k147p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k147p);
      __pyx_2 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4287; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4288 */
    __pyx_v_G = gbezout(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g),forcecopy(__pyx_v__y->g),(&__pyx_v_U),(&__pyx_v_V));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4289 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen_noclear(__pyx_v_G)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4289; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v_g));
    ((PyObject *)__pyx_v_g) = __pyx_1;
    __pyx_1 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4290 */
    __pyx_3 = ((PyObject *)__pyx_f_8_py_pari_new_gen_noclear(__pyx_v_U)); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4290; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v_u));
    ((PyObject *)__pyx_v_u) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4291 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(__pyx_v_V)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4291; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v_v));
    ((PyObject *)__pyx_v_v) = __pyx_2;
    __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4292 */
    __pyx_1 = PyTuple_New(3); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4292; goto __pyx_L1;}
    Py_INCREF(((PyObject *)__pyx_v_g));
    PyTuple_SET_ITEM(__pyx_1, 0, ((PyObject *)__pyx_v_g));
    Py_INCREF(((PyObject *)__pyx_v_u));
    PyTuple_SET_ITEM(__pyx_1, 1, ((PyObject *)__pyx_v_u));
    Py_INCREF(((PyObject *)__pyx_v_v));
    PyTuple_SET_ITEM(__pyx_1, 2, ((PyObject *)__pyx_v_v));
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.bezout");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__y);
    Py_DECREF(__pyx_v_u);
    Py_DECREF(__pyx_v_v);
    Py_DECREF(__pyx_v_g);
    Py_DECREF(__pyx_v_x);
    Py_DECREF(__pyx_v_y);
    return __pyx_r;
  }

  static PyObject *__pyx_n_bezout;

  static PyObject *__pyx_f_8_py_pari_3gen_xgcd(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_xgcd(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_y = 0;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    static char *__pyx_argnames[] = {"y",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
    Py_INCREF(__pyx_v_x);
    Py_INCREF(__pyx_v_y);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4295 */
    __pyx_1 = PyObject_GetAttr(__pyx_v_x, __pyx_n_bezout); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4295; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4295; goto __pyx_L1;}
    Py_INCREF(__pyx_v_y);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4295; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.xgcd");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_x);
    Py_DECREF(__pyx_v_y);
    return __pyx_r;
  }

  static PyObject *__pyx_k148p;

  static char (__pyx_k148[]) = "error in elladd";

  static PyObject *__pyx_f_8_py_pari_3gen_elladd(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_elladd[] = "\n        e.elladd(z1, z2)\n\n        Sum of the points z1 and z2 on the elliptic curve e.\n\n        INPUT:\n            e -- elliptic curve E\n            z1 -- point on E\n            z2 -- point on E\n            \n        OUTPUT:\n            point on E\n\n        EXAMPLES:\n        First we create an elliptic curve:\n        \n            >>> e = pari([0, 1, 1, -2, 0]).ellinit()\n            >>> str(e)[:65]   # first part of output\n            \'[0, 1, 1, -2, 0, 4, -4, 1, -3, 112, -856, 389, 1404928/389, [0.90\'\n            \n        Next we add two points on the elliptic curve.  Notice that\n        the Python lists are automatically converted to PARI objects so\n        you don\'t have to do that explicitly in your code.\n        \n            >>> e.elladd([1,0,1], [-1,1,1])\n            [-3/4, -15/8]\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_elladd(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_z1 = 0;
    PyObject *__pyx_v_z2 = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__z1;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__z2;
    int __pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    static char *__pyx_argnames[] = {"z1","z2",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_z1, &__pyx_v_z2)) return 0;
    Py_INCREF(__pyx_v_self);
    Py_INCREF(__pyx_v_z1);
    Py_INCREF(__pyx_v_z2);
    ((PyObject*)__pyx_v__z1) = Py_None; Py_INCREF(((PyObject*)__pyx_v__z1));
    ((PyObject*)__pyx_v__z2) = Py_None; Py_INCREF(((PyObject*)__pyx_v__z2));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4330 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4330; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4330; goto __pyx_L1;}
    Py_INCREF(__pyx_v_z1);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_z1);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4330; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4330; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__z1));
    ((PyObject *)__pyx_v__z1) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4330 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4330; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4330; goto __pyx_L1;}
    Py_INCREF(__pyx_v_z2);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_z2);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4330; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4330; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__z2));
    ((PyObject *)__pyx_v__z2) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4332 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4333 */
    __pyx_4 = __pyx_v_n;
    if (__pyx_4) {
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4333; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4333; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4333; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
      Py_INCREF(__pyx_k148p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k148p);
      __pyx_2 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4333; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4334 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(addell(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g),__pyx_v__z1->g,__pyx_v__z2->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4334; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.elladd");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__z1);
    Py_DECREF(__pyx_v__z2);
    Py_DECREF(__pyx_v_self);
    Py_DECREF(__pyx_v_z1);
    Py_DECREF(__pyx_v_z2);
    return __pyx_r;
  }

  static PyObject *__pyx_k149p;

  static char (__pyx_k149[]) = "error in ellak";

  static PyObject *__pyx_f_8_py_pari_3gen_ellak(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_ellak[] = "\n        e.ellak(n): Returns the coefficient a_n of the L-function of\n        the elliptic curve e, i.e. the coefficient of a newform of\n        weight 2 newform.\n\n        The curve e must be a medium or long vector of the type given\n        by ellinit. For this function to work for every n and not just\n        those prime to the conductor, e must be a minimal Weierstrass\n        equation. If this is not the case, use the function\n        ellminimalmodel first before using ellak (or you will get\n        INCORRECT RESULTS!)\n\n        INPUT:\n            e -- a PARI elliptic curve.\n            n -- integer ..\n\n        EXAMPLES:\n            >>> e = pari([0, -1, 1, -10, -20]).ellinit()\n            >>> e.ellak(6)\n            2\n            >>> e.ellak(2005)        \n            2\n            >>> e.ellak(-1)\n            0\n            >>> e.ellak(0)\n            0\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_ellak(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_n = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__n;
    int __pyx_v_r;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    static char *__pyx_argnames[] = {"n",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_n)) return 0;
    Py_INCREF(__pyx_v_self);
    Py_INCREF(__pyx_v_n);
    ((PyObject*)__pyx_v__n) = Py_None; Py_INCREF(((PyObject*)__pyx_v__n));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4365 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4365; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4365; goto __pyx_L1;}
    Py_INCREF(__pyx_v_n);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_n);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4365; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4365; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__n));
    ((PyObject *)__pyx_v__n) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4367 */
    __pyx_v_r = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4368 */
    __pyx_4 = __pyx_v_r;
    if (__pyx_4) {
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4368; goto __pyx_L1;}
      __pyx_2 = PyTuple_New(2); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4368; goto __pyx_L1;}
      Py_INCREF(__pyx_v_n);
      PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_n);
      Py_INCREF(__pyx_k149p);
      PyTuple_SET_ITEM(__pyx_2, 1, __pyx_k149p);
      __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4368; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4369 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(akell(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g),__pyx_v__n->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4369; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.ellak");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__n);
    Py_DECREF(__pyx_v_self);
    Py_DECREF(__pyx_v_n);
    return __pyx_r;
  }

  static PyObject *__pyx_n_ellan;

  static PyObject *__pyx_k150p;

  static char (__pyx_k150[]) = "error in ellan";

  static PyObject *__pyx_f_8_py_pari_3gen_ellan(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_ellan[] = "\n        EXAMPLES:\n            >>> e = pari([0, -1, 1, -10, -20]).ellinit()\n            >>> e.ellan(3)\n            [1, -2, -1]\n            >>> e.ellan(20)\n            [1, -2, -1, 2, 1, 2, -2, 0, -2, -2, 1, -2, 4, 4, -1, -4, -2, 4, 0, 2]\n            >>> e.ellan(-1)\n            []\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_ellan(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    long __pyx_v_n;
    int __pyx_v_r;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {"n",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l", __pyx_argnames, &__pyx_v_n)) return 0;
    Py_INCREF(__pyx_v_self);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4383 */
    __pyx_v_r = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4384 */
    __pyx_1 = (__pyx_v_r == 64);
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4385 */
      __pyx_1 = __pyx_f_8_py_pari_init_stack(0); if (__pyx_1 == -1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4385; goto __pyx_L1;}

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4386 */
      __pyx_2 = PyObject_GetAttr(__pyx_v_self, __pyx_n_ellan); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4386; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4386; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4386; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4386; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      __pyx_r = __pyx_3;
      __pyx_3 = 0;
      goto __pyx_L0;
      goto __pyx_L2;
    }
    __pyx_1 = __pyx_v_r;
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4388 */
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4388; goto __pyx_L1;}
      __pyx_4 = PyInt_FromLong(__pyx_v_n); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4388; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4388; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_4);
      Py_INCREF(__pyx_k150p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k150p);
      __pyx_4 = 0;
      __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4388; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4389 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(anell(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g),__pyx_v_n))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4389; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.ellan");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_self);
    return __pyx_r;
  }

  static PyObject *__pyx_k151p;

  static char (__pyx_k151[]) = "in apell, p='%s' not a prime";

  static PyObject *__pyx_f_8_py_pari_3gen_ellap(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_ellap[] = "\n        e.ellak(p): Returns the prime-indexed coefficient a_p of the\n        L-function of the elliptic curve e, i.e. the coefficient of a\n        newform of weight 2 newform.\n\n        If p is not prime, this function will return an INCORRECT\n        answer.\n\n        The curve e must be a medium or long vector of the type given\n        by ellinit. For this function to work for every n and not just\n        those prime to the conductor, e must be a minimal Weierstrass\n        equation. If this is not the case, use the function\n        ellminimalmodel first before using ellak (or you will get\n        INCORRECT RESULTS!)\n\n        INPUT:\n            e -- a PARI elliptic curve.\n            p -- prime integer ..\n\n        EXAMPLES:\n            >>> e = pari([0, -1, 1, -10, -20]).ellinit()\n            >>> e.ellap(2)\n            -2\n            >>> e.ellap(2003)\n            4\n            >>> e.ellak(-1)\n            0\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_ellap(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_p = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__p;
    int __pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    PyObject *__pyx_5 = 0;
    static char *__pyx_argnames[] = {"p",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_p)) return 0;
    Py_INCREF(__pyx_v_self);
    Py_INCREF(__pyx_v_p);
    ((PyObject*)__pyx_v__p) = Py_None; Py_INCREF(((PyObject*)__pyx_v__p));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4421 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4421; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4421; goto __pyx_L1;}
    Py_INCREF(__pyx_v_p);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_p);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4421; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4421; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__p));
    ((PyObject *)__pyx_v__p) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4423 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4424 */
    __pyx_4 = __pyx_v_n;
    if (__pyx_4) {
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4424; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4424; goto __pyx_L1;}
      __pyx_3 = PyNumber_Remainder(__pyx_k151p, __pyx_v_p); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4424; goto __pyx_L1;}
      __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4424; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_5, 0, __pyx_2);
      PyTuple_SET_ITEM(__pyx_5, 1, __pyx_3);
      __pyx_2 = 0;
      __pyx_3 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_5); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4424; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4425 */
    __pyx_3 = ((PyObject *)__pyx_f_8_py_pari_new_gen(apell(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g),__pyx_v__p->g))); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4425; goto __pyx_L1;}
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_5);
    __Pyx_AddTraceback("_py_pari.gen.ellap");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__p);
    Py_DECREF(__pyx_v_self);
    Py_DECREF(__pyx_v_p);
    return __pyx_r;
  }

  static PyObject *__pyx_k152p;

  static char (__pyx_k152[]) = "error in ellbil";

  static PyObject *__pyx_f_8_py_pari_3gen_ellbil(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_ellbil[] = "\n        EXAMPLES:\n            >>> e = pari([0,1,1,-2,0]).ellinit()\n            >>> e.ellbil([1, 0, 1], [-1, 1, 1])\n            0.41818898449886058562988945853\n            >>> get_real_precision()\n            5\n\n        Increasing the precision does not increase the result, since quantities\n        related to the elliptic curve were computed to low precision.\n            >>> set_real_precision(10)\n            >>> e.ellbil([1, 0, 1], [-1, 1, 1])\n            0.41818898449886058562988945853\n            \n        However, if we recompute the elliptic curve after increasing the precision,\n        then the bilinear pairing will be computed to higher precision as well.\n            >>> e = pari([0,1,1,-2,0]).ellinit()\n            >>> e.ellbil([1, 0, 1], [-1, 1, 1])\n            0.41818898449886058562988945821587638237833645961491348466736402242784203834353\n            >>> set_real_precision(5)\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_ellbil(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_z1 = 0;
    PyObject *__pyx_v_z2 = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__z1;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__z2;
    int __pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    static char *__pyx_argnames[] = {"z1","z2",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_z1, &__pyx_v_z2)) return 0;
    Py_INCREF(__pyx_v_self);
    Py_INCREF(__pyx_v_z1);
    Py_INCREF(__pyx_v_z2);
    ((PyObject*)__pyx_v__z1) = Py_None; Py_INCREF(((PyObject*)__pyx_v__z1));
    ((PyObject*)__pyx_v__z2) = Py_None; Py_INCREF(((PyObject*)__pyx_v__z2));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4451 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4451; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4451; goto __pyx_L1;}
    Py_INCREF(__pyx_v_z1);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_z1);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4451; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4451; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__z1));
    ((PyObject *)__pyx_v__z1) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4452 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4452; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4452; goto __pyx_L1;}
    Py_INCREF(__pyx_v_z2);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_z2);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4452; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4452; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__z2));
    ((PyObject *)__pyx_v__z2) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4454 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4455 */
    __pyx_4 = __pyx_v_n;
    if (__pyx_4) {
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4455; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4455; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4455; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
      Py_INCREF(__pyx_k152p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k152p);
      __pyx_2 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4455; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4456 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(bilhell(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g),__pyx_v__z1->g,__pyx_v__z2->g,__pyx_v_8_py_pari_REAL_PREC))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4456; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.ellbil");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__z1);
    Py_DECREF(__pyx_v__z2);
    Py_DECREF(__pyx_v_self);
    Py_DECREF(__pyx_v_z1);
    Py_DECREF(__pyx_v_z2);
    return __pyx_r;
  }

  static PyObject *__pyx_k153p;

  static char (__pyx_k153[]) = "error in ellchangecurve";

  static PyObject *__pyx_f_8_py_pari_3gen_ellchangecurve(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_ellchangecurve[] = "\n        EXAMPLES:\n            >>> e = pari([1,2,3,4,5]).ellinit()\n            >>> e.ellglobalred()\n            [10351, [1, -1, 0, -1], 1]\n            >>> f = e.ellchangecurve([1,-1,0,-1])\n            >>> f[:5]\n            [1, -1, 0, 4, 3]\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_ellchangecurve(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_ch = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__ch;
    int __pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    static char *__pyx_argnames[] = {"ch",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_ch)) return 0;
    Py_INCREF(__pyx_v_e);
    Py_INCREF(__pyx_v_ch);
    ((PyObject*)__pyx_v__ch) = Py_None; Py_INCREF(((PyObject*)__pyx_v__ch));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4469 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4469; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4469; goto __pyx_L1;}
    Py_INCREF(__pyx_v_ch);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_ch);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4469; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4469; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__ch));
    ((PyObject *)__pyx_v__ch) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4471 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4472 */
    __pyx_4 = __pyx_v_n;
    if (__pyx_4) {
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4472; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4472; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4472; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
      Py_INCREF(__pyx_k153p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k153p);
      __pyx_2 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4472; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4473 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(coordch(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_e)->g),__pyx_v__ch->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4473; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.ellchangecurve");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__ch);
    Py_DECREF(__pyx_v_e);
    Py_DECREF(__pyx_v_ch);
    return __pyx_r;
  }

  static PyObject *__pyx_k154p;

  static char (__pyx_k154[]) = "error in ellchangepoint";

  static PyObject *__pyx_f_8_py_pari_3gen_ellchangepoint(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_ellchangepoint[] = "\n        x.ellchangepoint(y): change data on point or vector of points x\n                             on an elliptic curve according to y=[u,r,s,t]\n\n        EXAMPLES:\n            >>> e = pari([0,1,1,-2,0]).ellinit()\n            >>> x = pari([1,0,1])\n            >>> e.ellisoncurve([1,4,4])\n            False\n            >>> e.ellisoncurve(x)\n            True\n            >>> f = e.ellchangecurve([1,2,3,-1])\n            >>> f[:5]   # show only first five entries\n            [6, -2, -1, 17, 8]\n            >>> x.ellchangepoint([1,2,3,-1])\n            [-1, 4]\n            >>> f.ellisoncurve([-1,4])\n            True\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_ellchangepoint(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_y = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__y;
    int __pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    static char *__pyx_argnames[] = {"y",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
    Py_INCREF(__pyx_v_x);
    Py_INCREF(__pyx_v_y);
    ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4496 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4496; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4496; goto __pyx_L1;}
    Py_INCREF(__pyx_v_y);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4496; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4496; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__y));
    ((PyObject *)__pyx_v__y) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4498 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4499 */
    __pyx_4 = __pyx_v_n;
    if (__pyx_4) {
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4499; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4499; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4499; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
      Py_INCREF(__pyx_k154p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k154p);
      __pyx_2 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4499; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4500 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(pointch(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g),__pyx_v__y->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4500; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.ellchangepoint");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__y);
    Py_DECREF(__pyx_v_x);
    Py_DECREF(__pyx_v_y);
    return __pyx_r;
  }

  static PyObject *__pyx_n_ArithmeticError;

  static PyObject *__pyx_k155p;
  static PyObject *__pyx_k156p;
  static PyObject *__pyx_k157p;

  static char (__pyx_k155[]) = "k(=%s) must be positive";
  static char (__pyx_k156[]) = "k(=%s) must be even";
  static char (__pyx_k157[]) = "in elleisnum: invalid input";

  static PyObject *__pyx_f_8_py_pari_3gen_elleisnum(PyObject *__pyx_v_om, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_elleisnum[] = "\n        om.elleisnum(k, {flag=0}, {prec}): om=[om1,om2] being a\n            2-component vector giving a basis of a lattice L and k an\n            even positive integer, computes the numerical value of the\n            Eisenstein series of weight k. When flag is non-zero and\n            k=4 or 6, this gives g2 or g3 with the correct\n            normalization.\n\n        INPUT:\n            om -- gen, 2-component vector giving a basis of a lattice L\n            k  -- int (even positive)\n            flag -- int (default 0)\n            pref -- precision\n\n        OUTPUT:\n            gen -- numerical value of E_k\n\n        EXAMPLES:\n            >>> e = pari([0,1,1,-2,0]).ellinit()\n            >>> om = e.omega()\n            >>> om\n            [2.4902125608550550753213577920, 1.9717377015516482044224076983*I]\n            >>> om.elleisnum(2)\n            -5.2886493396542576217915346955\n            >>> om.elleisnum(4)\n            111.999999999999999999999999968\n            >>> om.elleisnum(100)\n            2.1531424857607763611270703324 E50\n            >>> om.elleisnum(5)\n            Traceback (most recent call last):\n            ...\n            ArithmeticError: k(=5) must be even\n            >>> om.elleisnum(0)\n            Traceback (most recent call last):\n            ...\n            ArithmeticError: k(=0) must be positive\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_elleisnum(PyObject *__pyx_v_om, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    long __pyx_v_k;
    int __pyx_v_flag;
    int __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    long __pyx_5;
    static char *__pyx_argnames[] = {"k","flag",0};
    __pyx_v_flag = __pyx_k21;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l|i", __pyx_argnames, &__pyx_v_k, &__pyx_v_flag)) return 0;
    Py_INCREF(__pyx_v_om);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4540 */
    __pyx_1 = (__pyx_v_k <= 0);
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4541 */
      __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_ArithmeticError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4541; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_k); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4541; goto __pyx_L1;}
      __pyx_4 = PyNumber_Remainder(__pyx_k155p, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4541; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __Pyx_Raise(__pyx_2, __pyx_4, 0);
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4541; goto __pyx_L1;}
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4542 */
    __pyx_5 = (__pyx_v_k % 2);
    if (__pyx_5) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4543 */
      __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_ArithmeticError); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4543; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_k); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4543; goto __pyx_L1;}
      __pyx_4 = PyNumber_Remainder(__pyx_k156p, __pyx_2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4543; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      __Pyx_Raise(__pyx_3, __pyx_4, 0);
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4543; goto __pyx_L1;}
      goto __pyx_L3;
    }
    __pyx_L3:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4545 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4546 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4546; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4546; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4546; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k157p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k157p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4546; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L4;
    }
    __pyx_L4:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4547 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(elleisnum(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_om)->g),__pyx_v_k,__pyx_v_flag,__pyx_v_8_py_pari_REAL_PREC))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4547; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.elleisnum");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_om);
    return __pyx_r;
  }

  static PyObject *__pyx_k158p;

  static char (__pyx_k158[]) = "error in elleta";

  static PyObject *__pyx_f_8_py_pari_3gen_elleta(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_elleta(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    int __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_self);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4551 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4552 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4552; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4552; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4552; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k158p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k158p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4552; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4553 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(elleta(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g),__pyx_v_8_py_pari_REAL_PREC))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4553; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.elleta");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_self);
    return __pyx_r;
  }

  static PyObject *__pyx_k159p;

  static char (__pyx_k159[]) = "error in ellglobalred";

  static PyObject *__pyx_f_8_py_pari_3gen_ellglobalred(PyObject *__pyx_v_e1, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_ellglobalred(PyObject *__pyx_v_e1, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    int __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_e1);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4557 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4558 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4558; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4558; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4558; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k159p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k159p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4558; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4559 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(globalreduction(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_e1)->g)))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4559; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.ellglobalred");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_e1);
    return __pyx_r;
  }

  static PyObject *__pyx_k160p;

  static char (__pyx_k160[]) = "error in ellheight";

  static PyObject *__pyx_f_8_py_pari_3gen_ellheight(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_ellheight(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_a = 0;
    PyObject *__pyx_v_flag = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__a;
    int __pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    long __pyx_5;
    static char *__pyx_argnames[] = {"a","flag",0};
    __pyx_v_flag = __pyx_k22;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|O", __pyx_argnames, &__pyx_v_a, &__pyx_v_flag)) return 0;
    Py_INCREF(__pyx_v_e);
    Py_INCREF(__pyx_v_a);
    Py_INCREF(__pyx_v_flag);
    ((PyObject*)__pyx_v__a) = Py_None; Py_INCREF(((PyObject*)__pyx_v__a));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4563 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4563; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4563; goto __pyx_L1;}
    Py_INCREF(__pyx_v_a);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_a);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4563; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4563; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__a));
    ((PyObject *)__pyx_v__a) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4565 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4566 */
    __pyx_4 = __pyx_v_n;
    if (__pyx_4) {
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4566; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4566; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4566; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
      Py_INCREF(__pyx_k160p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k160p);
      __pyx_2 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4566; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4567 */
    __pyx_5 = PyInt_AsLong(__pyx_v_flag); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4567; goto __pyx_L1;}
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(ellheight0(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_e)->g),__pyx_v__a->g,__pyx_5,__pyx_v_8_py_pari_REAL_PREC))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4567; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.ellheight");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__a);
    Py_DECREF(__pyx_v_e);
    Py_DECREF(__pyx_v_a);
    Py_DECREF(__pyx_v_flag);
    return __pyx_r;
  }

  static PyObject *__pyx_k161p;

  static char (__pyx_k161[]) = "error in ellheightmatrix";

  static PyObject *__pyx_f_8_py_pari_3gen_ellheightmatrix(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_ellheightmatrix[] = "\n        ellheightmatrix(e,x)\n\n        Returns the height matrix for vector of points x on elliptic curve e using\n        theta functions.\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_ellheightmatrix(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_x = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__x;
    int __pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    static char *__pyx_argnames[] = {"x",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_x)) return 0;
    Py_INCREF(__pyx_v_e);
    Py_INCREF(__pyx_v_x);
    ((PyObject*)__pyx_v__x) = Py_None; Py_INCREF(((PyObject*)__pyx_v__x));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4577 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4577; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4577; goto __pyx_L1;}
    Py_INCREF(__pyx_v_x);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_x);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4577; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4577; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__x));
    ((PyObject *)__pyx_v__x) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4579 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4580 */
    __pyx_4 = __pyx_v_n;
    if (__pyx_4) {
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4580; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4580; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4580; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
      Py_INCREF(__pyx_k161p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k161p);
      __pyx_2 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4580; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4581 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(mathell(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_e)->g),__pyx_v__x->g,__pyx_v_8_py_pari_REAL_PREC))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4581; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.ellheightmatrix");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__x);
    Py_DECREF(__pyx_v_e);
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_k162p;
  static PyObject *__pyx_k163p;

  static char (__pyx_k162[]) = "in ellinit: invalid input '%s' (flag=%s) to the elliptic curve creation function";
  static char (__pyx_k163[]) = "flag must be 0 or 1";

  static PyObject *__pyx_f_8_py_pari_3gen_ellinit(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_ellinit[] = "\n        ellinit(x,{flag=0}): x being the vector [a1,a2,a3,a4,a6], gives\n        the vector: [a1,a2,a3,a4,a6,\n                    b2,b4,b6,b8,\n                    c4,c6,\n                    delta,j,\n                    [e1,e2,e3],\n                    w1,w2,eta1,eta2,area].\n        If the curve is defined over a p-adic field, the last six components\n        are replaced by root,u^2,u,q,w,0. If optional flag is 1, omit them\n        altogether.\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_ellinit(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    int __pyx_v_flag;
    PyObject *__pyx_v_prec = 0;
    int __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    PyObject *__pyx_5 = 0;
    long __pyx_6;
    static char *__pyx_argnames[] = {"flag","prec",0};
    __pyx_v_flag = __pyx_k23;
    __pyx_v_prec = __pyx_k24;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|iO", __pyx_argnames, &__pyx_v_flag, &__pyx_v_prec)) return 0;
    Py_INCREF(__pyx_v_self);
    Py_INCREF(__pyx_v_prec);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4597 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4598 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4598; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4598; goto __pyx_L1;}
      __pyx_4 = PyInt_FromLong(__pyx_v_flag); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4598; goto __pyx_L1;}
      __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4598; goto __pyx_L1;}
      Py_INCREF(__pyx_v_self);
      PyTuple_SET_ITEM(__pyx_5, 0, __pyx_v_self);
      PyTuple_SET_ITEM(__pyx_5, 1, __pyx_4);
      __pyx_4 = 0;
      __pyx_4 = PyNumber_Remainder(__pyx_k162p, __pyx_5); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4598; goto __pyx_L1;}
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4598; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_5, 0, __pyx_3);
      PyTuple_SET_ITEM(__pyx_5, 1, __pyx_4);
      __pyx_3 = 0;
      __pyx_4 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_5); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4598; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4599 */
    __pyx_4 = PyInt_FromLong(3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4599; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_v_prec, __pyx_4, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4599; goto __pyx_L1;}
    __pyx_1 = __pyx_1 < 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4600 */
      __pyx_2 = PyInt_FromLong(__pyx_v_8_py_pari_REAL_PREC); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4600; goto __pyx_L1;}
      Py_DECREF(__pyx_v_prec);
      __pyx_v_prec = __pyx_2;
      __pyx_2 = 0;
      goto __pyx_L3;
    }
    __pyx_L3:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4601 */
    __pyx_1 = (__pyx_v_flag < 0);
    if (!__pyx_1) {
      __pyx_1 = (__pyx_v_flag >= 1);
    }
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4602 */
      __pyx_5 = __Pyx_GetName(__pyx_b, __pyx_n_ValueError); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4602; goto __pyx_L1;}
      __Pyx_Raise(__pyx_5, __pyx_k163p, 0);
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4602; goto __pyx_L1;}
      goto __pyx_L4;
    }
    __pyx_L4:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4603 */
    __pyx_6 = PyInt_AsLong(__pyx_v_prec); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4603; goto __pyx_L1;}
    __pyx_3 = ((PyObject *)__pyx_f_8_py_pari_new_gen(ellinit0(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g),__pyx_v_flag,__pyx_6))); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4603; goto __pyx_L1;}
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    Py_XDECREF(__pyx_5);
    __Pyx_AddTraceback("_py_pari.gen.ellinit");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_self);
    Py_DECREF(__pyx_v_prec);
    return __pyx_r;
  }

  static PyObject *__pyx_k164p;

  static char (__pyx_k164[]) = "in elleisoncurve: invalid input e=%s, x=%s";

  static PyObject *__pyx_f_8_py_pari_3gen_ellisoncurve(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_ellisoncurve(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_x = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__x;
    int __pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    PyObject *__pyx_5 = 0;
    static char *__pyx_argnames[] = {"x",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_x)) return 0;
    Py_INCREF(__pyx_v_e);
    Py_INCREF(__pyx_v_x);
    ((PyObject*)__pyx_v__x) = Py_None; Py_INCREF(((PyObject*)__pyx_v__x));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4607 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4607; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4607; goto __pyx_L1;}
    Py_INCREF(__pyx_v_x);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_x);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4607; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4607; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__x));
    ((PyObject *)__pyx_v__x) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4610 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4611 */
    __pyx_4 = __pyx_v_n;
    if (__pyx_4) {
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4611; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4611; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4611; goto __pyx_L1;}
      Py_INCREF(__pyx_v_e);
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_e);
      Py_INCREF(__pyx_v_x);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_v_x);
      __pyx_5 = PyNumber_Remainder(__pyx_k164p, __pyx_3); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4611; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4611; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_5);
      __pyx_2 = 0;
      __pyx_5 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4611; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4613 */
    __pyx_5 = __Pyx_GetName(__pyx_b, __pyx_n_bool); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4613; goto __pyx_L1;}
    __pyx_1 = PyInt_FromLong((oncurve(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_e)->g,__pyx_v__x->g) == 1)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4613; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4613; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_1);
    __pyx_1 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_5, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4613; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_5);
    __Pyx_AddTraceback("_py_pari.gen.ellisoncurve");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__x);
    Py_DECREF(__pyx_v_e);
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_k165p;

  static char (__pyx_k165[]) = "in ellj: invalid input '%s', argument must be element of the upper half plane";

  static PyObject *__pyx_f_8_py_pari_3gen_ellj(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_ellj(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    int __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    PyObject *__pyx_5 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_e);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4617 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4618 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4618; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4618; goto __pyx_L1;}
      __pyx_4 = PyNumber_Remainder(__pyx_k165p, __pyx_v_e); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4618; goto __pyx_L1;}
      __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4618; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_5, 0, __pyx_3);
      PyTuple_SET_ITEM(__pyx_5, 1, __pyx_4);
      __pyx_3 = 0;
      __pyx_4 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_5); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4618; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4619 */
    __pyx_4 = ((PyObject *)__pyx_f_8_py_pari_new_gen(jell(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_e)->g),__pyx_v_8_py_pari_REAL_PREC))); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4619; goto __pyx_L1;}
    __pyx_r = __pyx_4;
    __pyx_4 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    Py_XDECREF(__pyx_5);
    __Pyx_AddTraceback("_py_pari.gen.ellj");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_e);
    return __pyx_r;
  }

  static PyObject *__pyx_k166p;

  static char (__pyx_k166[]) = "in ellj: invalid input '%s', argument must be element of the upper half plane";

  static PyObject *__pyx_f_8_py_pari_3gen_elllocalred(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_elllocalred(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_p = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__p;
    int __pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    PyObject *__pyx_5 = 0;
    static char *__pyx_argnames[] = {"p",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_p)) return 0;
    Py_INCREF(__pyx_v_e);
    Py_INCREF(__pyx_v_p);
    ((PyObject*)__pyx_v__p) = Py_None; Py_INCREF(((PyObject*)__pyx_v__p));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4623 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4623; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4623; goto __pyx_L1;}
    Py_INCREF(__pyx_v_p);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_p);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4623; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4623; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__p));
    ((PyObject *)__pyx_v__p) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4625 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4626 */
    __pyx_4 = __pyx_v_n;
    if (__pyx_4) {
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4626; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4626; goto __pyx_L1;}
      __pyx_3 = PyNumber_Remainder(__pyx_k166p, __pyx_v_e); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4626; goto __pyx_L1;}
      __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4626; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_5, 0, __pyx_2);
      PyTuple_SET_ITEM(__pyx_5, 1, __pyx_3);
      __pyx_2 = 0;
      __pyx_3 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_5); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4626; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4627 */
    __pyx_3 = ((PyObject *)__pyx_f_8_py_pari_new_gen(localreduction(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_e)->g),__pyx_v__p->g))); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4627; goto __pyx_L1;}
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_5);
    __Pyx_AddTraceback("_py_pari.gen.elllocalred");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__p);
    Py_DECREF(__pyx_v_e);
    Py_DECREF(__pyx_v_p);
    return __pyx_r;
  }

  static PyObject *__pyx_k167p;

  static char (__pyx_k167[]) = "in elllseries: Error evaluating L(E,%s)";

  static PyObject *__pyx_f_8_py_pari_3gen_elllseries(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_elllseries(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_s = 0;
    PyObject *__pyx_v_A = 0;
    long __pyx_v_prec;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__s;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__A;
    PyObject *__pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    PyObject *__pyx_5 = 0;
    static char *__pyx_argnames[] = {"s","A","prec",0};
    __pyx_v_A = __pyx_k25;
    __pyx_v_prec = __pyx_k26;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|Ol", __pyx_argnames, &__pyx_v_s, &__pyx_v_A, &__pyx_v_prec)) return 0;
    Py_INCREF(__pyx_v_e);
    Py_INCREF(__pyx_v_s);
    Py_INCREF(__pyx_v_A);
    ((PyObject*)__pyx_v__s) = Py_None; Py_INCREF(((PyObject*)__pyx_v__s));
    ((PyObject*)__pyx_v__A) = Py_None; Py_INCREF(((PyObject*)__pyx_v__A));
    __pyx_v_n = Py_None; Py_INCREF(__pyx_v_n);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4631 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4631; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4631; goto __pyx_L1;}
    Py_INCREF(__pyx_v_s);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_s);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4631; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4631; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__s));
    ((PyObject *)__pyx_v__s) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4632 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4632; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4632; goto __pyx_L1;}
    Py_INCREF(__pyx_v_A);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_A);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4632; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4632; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__A));
    ((PyObject *)__pyx_v__A) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4633 */
    __pyx_4 = (__pyx_v_prec < 3);
    if (__pyx_4) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4634 */
      __pyx_v_prec = __pyx_v_8_py_pari_REAL_PREC;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4638 */
    if (PyObject_Cmp(__pyx_v_s, ((PyObject *)__pyx_v_8_py_pari_ZERO), &__pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4638; goto __pyx_L1;}
    __pyx_4 = __pyx_4 <= 0;
    if (__pyx_4) {
      __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_int); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4638; goto __pyx_L1;}
      __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4638; goto __pyx_L1;}
      Py_INCREF(__pyx_v_s);
      PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_s);
      __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4638; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_float); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4638; goto __pyx_L1;}
      __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4638; goto __pyx_L1;}
      Py_INCREF(__pyx_v_s);
      PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_s);
      __pyx_5 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4638; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      if (PyObject_Cmp(__pyx_3, __pyx_5, &__pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4638; goto __pyx_L1;}
      __pyx_4 = __pyx_4 == 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_5); __pyx_5 = 0;
    }
    if (__pyx_4) {
      Py_INCREF(((PyObject *)__pyx_v_8_py_pari_ZERO));
      __pyx_r = ((PyObject *)__pyx_v_8_py_pari_ZERO);
      goto __pyx_L0;
      goto __pyx_L3;
    }
    __pyx_L3:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4640 */
    __pyx_1 = PyInt_FromLong(setjmp(GP_DATA->env)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4640; goto __pyx_L1;}
    Py_DECREF(__pyx_v_n);
    __pyx_v_n = __pyx_1;
    __pyx_1 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4641 */
    __pyx_4 = PyObject_IsTrue(__pyx_v_n); if (__pyx_4 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4641; goto __pyx_L1;}
    if (__pyx_4) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4645 */
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4645; goto __pyx_L1;}
      __pyx_3 = PyNumber_Remainder(__pyx_k167p, __pyx_v_s); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4645; goto __pyx_L1;}
      __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4645; goto __pyx_L1;}
      Py_INCREF(__pyx_v_n);
      PyTuple_SET_ITEM(__pyx_5, 0, __pyx_v_n);
      PyTuple_SET_ITEM(__pyx_5, 1, __pyx_3);
      __pyx_3 = 0;
      __pyx_1 = PyObject_CallObject(__pyx_2, __pyx_5); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4645; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      goto __pyx_L4;
    }
    __pyx_L4:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4647 */
    __pyx_3 = ((PyObject *)__pyx_f_8_py_pari_new_gen(lseriesell(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_e)->g),__pyx_v__s->g,__pyx_v__A->g,__pyx_v_prec))); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4647; goto __pyx_L1;}
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_5);
    __Pyx_AddTraceback("_py_pari.gen.elllseries");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__s);
    Py_DECREF(__pyx_v__A);
    Py_DECREF(__pyx_v_n);
    Py_DECREF(__pyx_v_e);
    Py_DECREF(__pyx_v_s);
    Py_DECREF(__pyx_v_A);
    return __pyx_r;
  }

  static PyObject *__pyx_k168p;

  static char (__pyx_k168[]) = "error in ellminimalmodel";

  static PyObject *__pyx_f_8_py_pari_3gen_ellminimalmodel(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_ellminimalmodel[] = "\n        \n        ellminimalmodel(e): return the standard minimal integral model\n        of the rational elliptic curve e and the corresponding change\n        of variables.\n        INPUT:\n            e -- gen (that defines an elliptic curve)\n        OUTPUT:\n            gen -- minimal model\n            gen -- change of coordinates\n        EXAMPLES:\n            >>> e = pari([1,2,3,4,5]).ellinit()\n            >>> F, ch = e.ellminimalmodel()\n            >>> F[:5]\n            [1, -1, 0, 4, 3]\n            >>> ch\n            [1, -1, 0, -1]\n            >>> e.ellchangecurve(ch)[:5]\n            [1, -1, 0, 4, 3]\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_ellminimalmodel(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    GEN __pyx_v_x;
    GEN __pyx_v_y;
    struct __pyx_obj_8_py_pari_gen *__pyx_v_model;
    struct __pyx_obj_8_py_pari_gen *__pyx_v_change;
    pari_sp __pyx_v_t;
    int __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_e);
    ((PyObject*)__pyx_v_model) = Py_None; Py_INCREF(((PyObject*)__pyx_v_model));
    ((PyObject*)__pyx_v_change) = Py_None; Py_INCREF(((PyObject*)__pyx_v_change));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4674 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4675 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4675; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4675; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4675; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k168p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k168p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4675; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4676 */
    __pyx_v_x = ellminimalmodel(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_e)->g),(&__pyx_v_y));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4677 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen_noclear(__pyx_v_x)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4677; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v_model));
    ((PyObject *)__pyx_v_model) = __pyx_2;
    __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4678 */
    __pyx_4 = ((PyObject *)__pyx_f_8_py_pari_new_gen(__pyx_v_y)); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4678; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v_change));
    ((PyObject *)__pyx_v_change) = __pyx_4;
    __pyx_4 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4679 */
    __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4679; goto __pyx_L1;}
    Py_INCREF(((PyObject *)__pyx_v_model));
    PyTuple_SET_ITEM(__pyx_3, 0, ((PyObject *)__pyx_v_model));
    Py_INCREF(((PyObject *)__pyx_v_change));
    PyTuple_SET_ITEM(__pyx_3, 1, ((PyObject *)__pyx_v_change));
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.ellminimalmodel");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_model);
    Py_DECREF(__pyx_v_change);
    Py_DECREF(__pyx_v_e);
    return __pyx_r;
  }

  static PyObject *__pyx_k169p;

  static char (__pyx_k169[]) = "error in ellorder";

  static PyObject *__pyx_f_8_py_pari_3gen_ellorder(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_ellorder(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_x = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__x;
    int __pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    static char *__pyx_argnames[] = {"x",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_x)) return 0;
    Py_INCREF(__pyx_v_e);
    Py_INCREF(__pyx_v_x);
    ((PyObject*)__pyx_v__x) = Py_None; Py_INCREF(((PyObject*)__pyx_v__x));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4683 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4683; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4683; goto __pyx_L1;}
    Py_INCREF(__pyx_v_x);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_x);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4683; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4683; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__x));
    ((PyObject *)__pyx_v__x) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4685 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4686 */
    __pyx_4 = __pyx_v_n;
    if (__pyx_4) {
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4686; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4686; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4686; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
      Py_INCREF(__pyx_k169p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k169p);
      __pyx_2 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4686; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4687 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(orderell(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_e)->g),__pyx_v__x->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4687; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.ellorder");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__x);
    Py_DECREF(__pyx_v_e);
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_k170p;

  static char (__pyx_k170[]) = "error in ellordinate";

  static PyObject *__pyx_f_8_py_pari_3gen_ellordinate(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_ellordinate(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_x = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__x;
    int __pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    static char *__pyx_argnames[] = {"x",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_x)) return 0;
    Py_INCREF(__pyx_v_e);
    Py_INCREF(__pyx_v_x);
    ((PyObject*)__pyx_v__x) = Py_None; Py_INCREF(((PyObject*)__pyx_v__x));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4691 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4691; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4691; goto __pyx_L1;}
    Py_INCREF(__pyx_v_x);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_x);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4691; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4691; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__x));
    ((PyObject *)__pyx_v__x) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4693 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4694 */
    __pyx_4 = __pyx_v_n;
    if (__pyx_4) {
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4694; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4694; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4694; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
      Py_INCREF(__pyx_k170p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k170p);
      __pyx_2 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4694; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4695 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(ordell(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_e)->g),__pyx_v__x->g,__pyx_v_8_py_pari_REAL_PREC))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4695; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.ellordinate");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__x);
    Py_DECREF(__pyx_v_e);
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_k171p;

  static char (__pyx_k171[]) = "error in ellpointtoz";

  static PyObject *__pyx_f_8_py_pari_3gen_ellpointtoz(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_ellpointtoz(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_z = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__x;
    int __pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    static char *__pyx_argnames[] = {"z",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_z)) return 0;
    Py_INCREF(__pyx_v_e);
    Py_INCREF(__pyx_v_z);
    ((PyObject*)__pyx_v__x) = Py_None; Py_INCREF(((PyObject*)__pyx_v__x));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4699 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4699; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4699; goto __pyx_L1;}
    Py_INCREF(__pyx_v_z);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_z);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4699; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4699; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__x));
    ((PyObject *)__pyx_v__x) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4701 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4702 */
    __pyx_4 = __pyx_v_n;
    if (__pyx_4) {
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4702; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4702; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4702; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
      Py_INCREF(__pyx_k171p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k171p);
      __pyx_2 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4702; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4703 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(zell(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_e)->g),__pyx_v__x->g,__pyx_v_8_py_pari_REAL_PREC))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4703; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.ellpointtoz");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__x);
    Py_DECREF(__pyx_v_e);
    Py_DECREF(__pyx_v_z);
    return __pyx_r;
  }

  static PyObject *__pyx_k172p;

  static char (__pyx_k172[]) = "in ellpow";

  static PyObject *__pyx_f_8_py_pari_3gen_ellpow(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_ellpow(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_z = 0;
    PyObject *__pyx_v_n = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__z;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__n;
    int __pyx_v_r;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    static char *__pyx_argnames[] = {"z","n",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_z, &__pyx_v_n)) return 0;
    Py_INCREF(__pyx_v_e);
    Py_INCREF(__pyx_v_z);
    Py_INCREF(__pyx_v_n);
    ((PyObject*)__pyx_v__z) = Py_None; Py_INCREF(((PyObject*)__pyx_v__z));
    ((PyObject*)__pyx_v__n) = Py_None; Py_INCREF(((PyObject*)__pyx_v__n));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4707 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4707; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4707; goto __pyx_L1;}
    Py_INCREF(__pyx_v_z);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_z);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4707; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4707; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__z));
    ((PyObject *)__pyx_v__z) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4707 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4707; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4707; goto __pyx_L1;}
    Py_INCREF(__pyx_v_n);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_n);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4707; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4707; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__n));
    ((PyObject *)__pyx_v__n) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4709 */
    __pyx_v_r = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4710 */
    __pyx_4 = __pyx_v_r;
    if (__pyx_4) {
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4710; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_r); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4710; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4710; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
      Py_INCREF(__pyx_k172p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k172p);
      __pyx_2 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4710; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4711 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(powell(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_e)->g),__pyx_v__z->g,__pyx_v__n->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4711; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.ellpow");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__z);
    Py_DECREF(__pyx_v__n);
    Py_DECREF(__pyx_v_e);
    Py_DECREF(__pyx_v_z);
    Py_DECREF(__pyx_v_n);
    return __pyx_r;
  }

  static PyObject *__pyx_k173p;

  static char (__pyx_k173[]) = "in ellrootno";

  static PyObject *__pyx_f_8_py_pari_3gen_ellrootno(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_ellrootno(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_p = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__p;
    int __pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    static char *__pyx_argnames[] = {"p",0};
    __pyx_v_p = __pyx_k27;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_p)) return 0;
    Py_INCREF(__pyx_v_e);
    Py_INCREF(__pyx_v_p);
    ((PyObject*)__pyx_v__p) = Py_None; Py_INCREF(((PyObject*)__pyx_v__p));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4715 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4715; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4715; goto __pyx_L1;}
    Py_INCREF(__pyx_v_p);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_p);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4715; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4715; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__p));
    ((PyObject *)__pyx_v__p) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4717 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4718 */
    __pyx_4 = __pyx_v_n;
    if (__pyx_4) {
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4718; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4718; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4718; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
      Py_INCREF(__pyx_k173p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k173p);
      __pyx_2 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4718; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4719 */
    __pyx_1 = PyInt_FromLong(ellrootno(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_e)->g),__pyx_v__p->g)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4719; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.ellrootno");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__p);
    Py_DECREF(__pyx_v_e);
    Py_DECREF(__pyx_v_p);
    return __pyx_r;
  }

  static PyObject *__pyx_k174p;

  static char (__pyx_k174[]) = "in ellsigma";

  static PyObject *__pyx_f_8_py_pari_3gen_ellsigma(PyObject *__pyx_v_om, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_ellsigma(PyObject *__pyx_v_om, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_z = 0;
    PyObject *__pyx_v_flag = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__x;
    int __pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    long __pyx_5;
    static char *__pyx_argnames[] = {"z","flag",0};
    __pyx_v_flag = __pyx_k28;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|O", __pyx_argnames, &__pyx_v_z, &__pyx_v_flag)) return 0;
    Py_INCREF(__pyx_v_om);
    Py_INCREF(__pyx_v_z);
    Py_INCREF(__pyx_v_flag);
    ((PyObject*)__pyx_v__x) = Py_None; Py_INCREF(((PyObject*)__pyx_v__x));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4723 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4723; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4723; goto __pyx_L1;}
    Py_INCREF(__pyx_v_z);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_z);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4723; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4723; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__x));
    ((PyObject *)__pyx_v__x) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4725 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4726 */
    __pyx_4 = __pyx_v_n;
    if (__pyx_4) {
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4726; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4726; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4726; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
      Py_INCREF(__pyx_k174p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k174p);
      __pyx_2 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4726; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4727 */
    __pyx_5 = PyInt_AsLong(__pyx_v_flag); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4727; goto __pyx_L1;}
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(ellsigma(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_om)->g),__pyx_v__x->g,__pyx_5,__pyx_v_8_py_pari_REAL_PREC))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4727; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.ellsigma");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__x);
    Py_DECREF(__pyx_v_om);
    Py_DECREF(__pyx_v_z);
    Py_DECREF(__pyx_v_flag);
    return __pyx_r;
  }

  static PyObject *__pyx_k175p;

  static char (__pyx_k175[]) = "in ellsub";

  static PyObject *__pyx_f_8_py_pari_3gen_ellsub(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_ellsub(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_z1 = 0;
    PyObject *__pyx_v_z2 = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__z1;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__z2;
    int __pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    static char *__pyx_argnames[] = {"z1","z2",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_z1, &__pyx_v_z2)) return 0;
    Py_INCREF(__pyx_v_e);
    Py_INCREF(__pyx_v_z1);
    Py_INCREF(__pyx_v_z2);
    ((PyObject*)__pyx_v__z1) = Py_None; Py_INCREF(((PyObject*)__pyx_v__z1));
    ((PyObject*)__pyx_v__z2) = Py_None; Py_INCREF(((PyObject*)__pyx_v__z2));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4731 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4731; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4731; goto __pyx_L1;}
    Py_INCREF(__pyx_v_z1);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_z1);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4731; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4731; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__z1));
    ((PyObject *)__pyx_v__z1) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4731 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4731; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4731; goto __pyx_L1;}
    Py_INCREF(__pyx_v_z2);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_z2);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4731; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4731; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__z2));
    ((PyObject *)__pyx_v__z2) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4733 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4734 */
    __pyx_4 = __pyx_v_n;
    if (__pyx_4) {
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4734; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4734; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4734; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
      Py_INCREF(__pyx_k175p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k175p);
      __pyx_2 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4734; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4735 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(subell(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_e)->g),__pyx_v__z1->g,__pyx_v__z2->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4735; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.ellsub");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__z1);
    Py_DECREF(__pyx_v__z2);
    Py_DECREF(__pyx_v_e);
    Py_DECREF(__pyx_v_z1);
    Py_DECREF(__pyx_v_z2);
    return __pyx_r;
  }

  static PyObject *__pyx_k176p;

  static char (__pyx_k176[]) = "in elltaniyama";

  static PyObject *__pyx_f_8_py_pari_3gen_elltaniyama(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_elltaniyama(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    int __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_e);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4739 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4740 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4740; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4740; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4740; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k176p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k176p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4740; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4741 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(taniyama(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_e)->g)))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4741; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.elltaniyama");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_e);
    return __pyx_r;
  }

  static PyObject *__pyx_k177p;
  static PyObject *__pyx_k178p;

  static char (__pyx_k177[]) = "Elliptic curve was created to too low of precision.  Call ellinit with the real_precision higher.";
  static char (__pyx_k178[]) = "in elltors";

  static PyObject *__pyx_f_8_py_pari_3gen_elltors(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_elltors(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_flag = 0;
    int __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    long __pyx_5;
    static char *__pyx_argnames[] = {"flag",0};
    __pyx_v_flag = __pyx_k29;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_flag)) return 0;
    Py_INCREF(__pyx_v_e);
    Py_INCREF(__pyx_v_flag);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4745 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4746 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4747 */
      __pyx_1 = (__pyx_v_n == 22);
      if (__pyx_1) {

        /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4749 */
        __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_RuntimeError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4749; goto __pyx_L1;}
        __Pyx_Raise(__pyx_2, __pyx_k177p, 0);
        Py_DECREF(__pyx_2); __pyx_2 = 0;
        {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4749; goto __pyx_L1;}
        goto __pyx_L3;
      }
      __pyx_L3:;

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4750 */
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4750; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4750; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4750; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k178p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k178p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4750; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4751 */
    __pyx_5 = PyInt_AsLong(__pyx_v_flag); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4751; goto __pyx_L1;}
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(elltors0(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_e)->g),__pyx_5))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4751; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.elltors");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_e);
    Py_DECREF(__pyx_v_flag);
    return __pyx_r;
  }

  static PyObject *__pyx_k179p;

  static char (__pyx_k179[]) = "in ellwp";

  static PyObject *__pyx_f_8_py_pari_3gen_ellwp(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_ellwp[] = "\n        ellwp(E, z,{flag=0}): Return the complex value of the Weierstrass\n        P-function at z on the lattice defined by e.\n\n        INPUT:\n            E -- list OR elliptic curve\n                  list -- [om1, om2], which are Z-generators for a lattice\n                  elliptic curve -- created using ellinit\n                   \n            z -- (optional) complex number  OR string (default = \"z\")\n                   complex number -- any number in the complex plane\n                   string (or PARI variable) -- name of a variable.\n                 \n            n -- int (optional: default 20) if z is a variable, compute up to at least o(z^n).\n            \n            flag -- int: 0 (default): compute only P(z)\n                         1 compute [P(z),P\'(z)]\n                         2 consider om or E as an elliptic curve and use P-function to\n                           compute the point on E (with the Weierstrass equation for E)\n                           P(z)\n                           for that curve (identical to ellztopoint in this case).\n                    \n        OUTPUT:\n            gen -- complex number or list of two complex numbers\n\n        EXAMPLES:\n\n        We first define the elliptic curve X_0(11):\n            >>> E = pari([0,-1,1,-10,-20]).ellinit()\n\n        Compute P(1).\n            >>> E.ellwp(1)\n            13.965869525748497794694977693 + 2.660659330 E-28*I\n\n        Compute P(1+I), where I = sqrt(-1).\n            >>> E.ellwp(pari(\"1+I\"))\n            -1.1151068256555508792090664874 + 2.3341905230746988361847987997*I\n            >>> E.ellwp(\"1+I\")\n            -1.1151068256555508792090664874 + 2.3341905230746988361847987997*I\n\n        The series expansion, to the default 20 precision:\n            >>> E.ellwp()\n            z^-2 + 31/15*z^2 + 2501/756*z^4 + 961/675*z^6 + 77531/41580*z^8 + 1202285717/928746000*z^10 + 2403461/2806650*z^12 + 30211462703/43418875500*z^14 + 3539374016033/7723451736000*z^16 + 413306031683977/1289540602350000*z^18 + O(z^20)\n\n        Compute the series for wp to lower precision:\n            >>> E.ellwp(n=4)\n            z^-2 + 31/15*z^2 + O(z^4)\n\n        Next we use the version where the input is generators for a lattice:\n            >>> pari([1.2692, \'0.63 + 1.45*I\']).ellwp(1)\n            13.965614693668943648020037361 + 0.00064482927281053614745416359791*I\n\n        With flag 1 compute the pair P(z) and P\'(z):\n            >>> E.ellwp(1, flag=1)\n            [13.965869525748497794694977693 + 2.660659330 E-28*I, 50.561930088007275255584656888 + 1.615587134 E-27*I]\n\n        With flag=2, the computed pair is (x,y) on the curve instead of [P(z),P\'(z)]:\n            >>> E.ellwp(1, flag=2)\n            [14.299202859081831128028311026 + 2.660659330 E-28*I, 50.061930088007275255584656888 + 1.615587134 E-27*I]\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_ellwp(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_z = 0;
    long __pyx_v_n;
    long __pyx_v_flag;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__z;
    int __pyx_v_err;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    static char *__pyx_argnames[] = {"z","n","flag",0};
    __pyx_v_z = __pyx_k31;
    __pyx_v_n = __pyx_k32;
    __pyx_v_flag = __pyx_k33;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|Oll", __pyx_argnames, &__pyx_v_z, &__pyx_v_n, &__pyx_v_flag)) return 0;
    Py_INCREF(__pyx_v_e);
    Py_INCREF(__pyx_v_z);
    ((PyObject*)__pyx_v__z) = Py_None; Py_INCREF(((PyObject*)__pyx_v__z));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4815 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4815; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4815; goto __pyx_L1;}
    Py_INCREF(__pyx_v_z);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_z);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4815; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4815; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__z));
    ((PyObject *)__pyx_v__z) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4817 */
    __pyx_v_err = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4818 */
    __pyx_4 = __pyx_v_err;
    if (__pyx_4) {
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4818; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_err); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4818; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4818; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
      Py_INCREF(__pyx_k179p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k179p);
      __pyx_2 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4818; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4819 */
    __pyx_4 = (__pyx_v_n < 0);
    if (__pyx_4) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4820 */
      __pyx_v_n = 0;
      goto __pyx_L3;
    }
    __pyx_L3:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4821 */
    __pyx_4 = ((__pyx_v_n % 2) == 1);
    if (__pyx_4) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4822 */
      __pyx_v_n = (__pyx_v_n + 1);
      goto __pyx_L4;
    }
    __pyx_L4:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4823 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(ellwp0(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_e)->g),__pyx_v__z->g,__pyx_v_flag,__pyx_v_8_py_pari_REAL_PREC,((__pyx_v_n + 2) / 2)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4823; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.ellwp");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__z);
    Py_DECREF(__pyx_v_e);
    Py_DECREF(__pyx_v_z);
    return __pyx_r;
  }

  static PyObject *__pyx_k180p;

  static char (__pyx_k180[]) = "in ellzeta";

  static PyObject *__pyx_f_8_py_pari_3gen_ellzeta(PyObject *__pyx_v_om, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_ellzeta(PyObject *__pyx_v_om, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_z = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__z;
    int __pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    static char *__pyx_argnames[] = {"z",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_z)) return 0;
    Py_INCREF(__pyx_v_om);
    Py_INCREF(__pyx_v_z);
    ((PyObject*)__pyx_v__z) = Py_None; Py_INCREF(((PyObject*)__pyx_v__z));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4827 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4827; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4827; goto __pyx_L1;}
    Py_INCREF(__pyx_v_z);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_z);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4827; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4827; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__z));
    ((PyObject *)__pyx_v__z) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4829 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4830 */
    __pyx_4 = __pyx_v_n;
    if (__pyx_4) {
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4830; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4830; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4830; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
      Py_INCREF(__pyx_k180p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k180p);
      __pyx_2 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4830; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4831 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(ellzeta(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_om)->g),__pyx_v__z->g,__pyx_v_8_py_pari_REAL_PREC))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4831; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.ellzeta");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__z);
    Py_DECREF(__pyx_v_om);
    Py_DECREF(__pyx_v_z);
    return __pyx_r;
  }

  static PyObject *__pyx_k181p;

  static char (__pyx_k181[]) = "in ellztopoint";

  static PyObject *__pyx_f_8_py_pari_3gen_ellztopoint(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_ellztopoint(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    struct __pyx_obj_8_py_pari_gen *__pyx_v_z = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__z;
    int __pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    static char *__pyx_argnames[] = {"z",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_z)) return 0;
    Py_INCREF(__pyx_v_e);
    Py_INCREF(__pyx_v_z);
    ((PyObject*)__pyx_v__z) = Py_None; Py_INCREF(((PyObject*)__pyx_v__z));
    if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_z), __pyx_ptype_8_py_pari_gen, 1, "z")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4833; goto __pyx_L1;}

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4835 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4835; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4835; goto __pyx_L1;}
    Py_INCREF(((PyObject *)__pyx_v_z));
    PyTuple_SET_ITEM(__pyx_2, 0, ((PyObject *)__pyx_v_z));
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4835; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4835; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__z));
    ((PyObject *)__pyx_v__z) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4837 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4838 */
    __pyx_4 = __pyx_v_n;
    if (__pyx_4) {
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4838; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4838; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4838; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
      Py_INCREF(__pyx_k181p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k181p);
      __pyx_2 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4838; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4839 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(pointell(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_e)->g),__pyx_v__z->g,__pyx_v_8_py_pari_REAL_PREC))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4839; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.ellztopoint");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__z);
    Py_DECREF(__pyx_v_e);
    Py_DECREF(__pyx_v_z);
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_3gen_omega(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_omega[] = "\n        e.omega(): return basis for the period lattice of the elliptic curve e.\n        \n        EXAMPLES:\n            >>> e = pari([0, -1, 1, -10, -20]).ellinit()\n            >>> e.omega()\n            [1.2692093042795534216887946168, 0.63460465213977671084439730838 + 1.4588166169384952293308896122*I]\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_omega(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_e);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4850 */
    __pyx_1 = PySequence_GetSlice(__pyx_v_e, 14, 16); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4850; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    __Pyx_AddTraceback("_py_pari.gen.omega");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_e);
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_3gen_disc(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_disc[] = "\n        e.disc(): return the discriminant of the elliptic curve e.\n        \n        EXAMPLES:\n            >>> e = pari([0, -1, 1, -10, -20]).ellinit()\n            >>> e.disc()\n            -161051\n            >>> _.factor()\n            [-1, 1; 11, 5]\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_disc(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_e);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4863 */
    __pyx_1 = PyInt_FromLong(11); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4863; goto __pyx_L1;}
    __pyx_2 = PyObject_GetItem(__pyx_v_e, __pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4863; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    __Pyx_AddTraceback("_py_pari.gen.disc");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_e);
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_3gen_j(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_j[] = "\n        e.j(): return the j-invariant of the elliptic curve e.\n        \n        EXAMPLES:\n            >>> e = pari([0, -1, 1, -10, -20]).ellinit()\n            >>> e.j()\n            -122023936/161051\n            >>> _.factor()\n            [-1, 1; 2, 12; 11, -5; 31, 3]\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_j(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_e);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4876 */
    __pyx_1 = PyInt_FromLong(12); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4876; goto __pyx_L1;}
    __pyx_2 = PyObject_GetItem(__pyx_v_e, __pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4876; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    __Pyx_AddTraceback("_py_pari.gen.j");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_e);
    return __pyx_r;
  }

  static PyObject *__pyx_k182p;

  static char (__pyx_k182[]) = "error in bnfunit";

  static PyObject *__pyx_f_8_py_pari_3gen_bnfunit(PyObject *__pyx_v_k, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_bnfunit(PyObject *__pyx_v_k, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    int __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_k);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4883 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4884 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4885 */
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4885; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4885; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4885; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k182p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k182p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4885; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4886 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(buchfu(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_k)->g)))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4886; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.bnfunit");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_k);
    return __pyx_r;
  }

  static PyObject *__pyx_k183p;

  static char (__pyx_k183[]) = "error in nfinit";

  static PyObject *__pyx_f_8_py_pari_3gen_bnfinit(PyObject *__pyx_v_f, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_bnfinit(PyObject *__pyx_v_f, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    long __pyx_v_flag;
    int __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {"flag",0};
    __pyx_v_flag = __pyx_k34;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|l", __pyx_argnames, &__pyx_v_flag)) return 0;
    Py_INCREF(__pyx_v_f);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4890 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4891 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4892 */
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4892; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4892; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4892; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k183p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k183p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4892; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4894 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(bnfinit0(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_f)->g),__pyx_v_flag,((GEN )0),__pyx_v_8_py_pari_REAL_PREC))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4894; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.bnfinit");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_f);
    return __pyx_r;
  }

  static PyObject *__pyx_k184p;

  static char (__pyx_k184[]) = "error in idealfactor";

  static PyObject *__pyx_f_8_py_pari_3gen_idealfactor(PyObject *__pyx_v_nf, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_idealfactor(PyObject *__pyx_v_nf, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_x = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__x;
    PyObject *__pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    static char *__pyx_argnames[] = {"x",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_x)) return 0;
    Py_INCREF(__pyx_v_nf);
    Py_INCREF(__pyx_v_x);
    ((PyObject*)__pyx_v__x) = Py_None; Py_INCREF(((PyObject*)__pyx_v__x));
    __pyx_v_n = Py_None; Py_INCREF(__pyx_v_n);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4898 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4898; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4898; goto __pyx_L1;}
    Py_INCREF(__pyx_v_x);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_x);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4898; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4898; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__x));
    ((PyObject *)__pyx_v__x) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4899 */
    __pyx_1 = PyInt_FromLong(setjmp(GP_DATA->env)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4899; goto __pyx_L1;}
    Py_DECREF(__pyx_v_n);
    __pyx_v_n = __pyx_1;
    __pyx_1 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4900 */
    __pyx_4 = PyObject_IsTrue(__pyx_v_n); if (__pyx_4 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4900; goto __pyx_L1;}
    if (__pyx_4) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4901 */
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4901; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4901; goto __pyx_L1;}
      Py_INCREF(__pyx_v_n);
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_n);
      Py_INCREF(__pyx_k184p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k184p);
      __pyx_1 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4901; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4902 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(idealfactor(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_nf)->g),__pyx_v__x->g))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4902; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.idealfactor");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__x);
    Py_DECREF(__pyx_v_n);
    Py_DECREF(__pyx_v_nf);
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_k185p;

  static char (__pyx_k185[]) = "error in nfbasis";

  static PyObject *__pyx_f_8_py_pari_3gen_nfbasis(PyObject *__pyx_v_f, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_nfbasis(PyObject *__pyx_v_f, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    long __pyx_v_flag;
    PyObject *__pyx_v_p = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__p;
    GEN __pyx_v_g;
    int __pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    int __pyx_2;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {"flag","p",0};
    __pyx_v_flag = __pyx_k35;
    __pyx_v_p = __pyx_k36;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|lO", __pyx_argnames, &__pyx_v_flag, &__pyx_v_p)) return 0;
    Py_INCREF(__pyx_v_f);
    Py_INCREF(__pyx_v_p);
    ((PyObject*)__pyx_v__p) = Py_None; Py_INCREF(((PyObject*)__pyx_v__p));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4907 */
    __pyx_1 = PyInt_FromLong(0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4907; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_v_p, __pyx_1, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4907; goto __pyx_L1;}
    __pyx_2 = __pyx_2 != 0;
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    if (__pyx_2) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4908 */
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4908; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4908; goto __pyx_L1;}
      Py_INCREF(__pyx_v_p);
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_p);
      __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4908; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      if (!__Pyx_TypeTest(__pyx_4, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4908; goto __pyx_L1;}
      Py_DECREF(((PyObject *)__pyx_v__p));
      ((PyObject *)__pyx_v__p) = __pyx_4;
      __pyx_4 = 0;

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4909 */
      __pyx_v_g = __pyx_v__p->g;
      goto __pyx_L2;
    }
    /*else*/ {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4911 */
      __pyx_v_g = ((GEN )0);
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4914 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4915 */
    __pyx_2 = __pyx_v_n;
    if (__pyx_2) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4916 */
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4916; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4916; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4916; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k185p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k185p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4916; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L3;
    }
    __pyx_L3:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4918 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(nfbasis0(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_f)->g),__pyx_v_flag,__pyx_v_g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4918; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.nfbasis");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__p);
    Py_DECREF(__pyx_v_f);
    Py_DECREF(__pyx_v_p);
    return __pyx_r;
  }

  static PyObject *__pyx_k186p;

  static char (__pyx_k186[]) = "error in nfinit";

  static PyObject *__pyx_f_8_py_pari_3gen_nfinit(PyObject *__pyx_v_f, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_nfinit(PyObject *__pyx_v_f, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    long __pyx_v_flag;
    int __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {"flag",0};
    __pyx_v_flag = __pyx_k37;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|l", __pyx_argnames, &__pyx_v_flag)) return 0;
    Py_INCREF(__pyx_v_f);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4922 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4923 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4924 */
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4924; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4924; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4924; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k186p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k186p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4924; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4925 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(nfinit0(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_f)->g),__pyx_v_flag,__pyx_v_8_py_pari_REAL_PREC))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4925; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.nfinit");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_f);
    return __pyx_r;
  }

  static PyObject *__pyx_k187p;

  static char (__pyx_k187[]) = "error in nfbasis";

  static PyObject *__pyx_f_8_py_pari_3gen_polcompositum(PyObject *__pyx_v_pol1, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_polcompositum(PyObject *__pyx_v_pol1, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_pol2 = 0;
    long __pyx_v_flag;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__pol2;
    int __pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    static char *__pyx_argnames[] = {"pol2","flag",0};
    __pyx_v_flag = __pyx_k38;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|l", __pyx_argnames, &__pyx_v_pol2, &__pyx_v_flag)) return 0;
    Py_INCREF(__pyx_v_pol1);
    Py_INCREF(__pyx_v_pol2);
    ((PyObject*)__pyx_v__pol2) = Py_None; Py_INCREF(((PyObject*)__pyx_v__pol2));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4929 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4929; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4929; goto __pyx_L1;}
    Py_INCREF(__pyx_v_pol2);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_pol2);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4929; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4929; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__pol2));
    ((PyObject *)__pyx_v__pol2) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4932 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4933 */
    __pyx_4 = __pyx_v_n;
    if (__pyx_4) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4934 */
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4934; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4934; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4934; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
      Py_INCREF(__pyx_k187p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k187p);
      __pyx_2 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4934; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4935 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(polcompositum0(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_pol1)->g),__pyx_v__pol2->g,__pyx_v_flag))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4935; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.polcompositum");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__pol2);
    Py_DECREF(__pyx_v_pol1);
    Py_DECREF(__pyx_v_pol2);
    return __pyx_r;
  }

  static PyObject *__pyx_k188p;

  static char (__pyx_k188[]) = "error in poldisc";

  static PyObject *__pyx_f_8_py_pari_3gen_poldisc(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_poldisc(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_var = 0;
    int __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {"var",0};
    __pyx_v_var = __pyx_k39;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_var)) return 0;
    Py_INCREF(__pyx_v_x);
    Py_INCREF(__pyx_v_var);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4943 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4944 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4945 */
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4945; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4945; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4945; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k188p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k188p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4945; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4946 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(poldisc0(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g),__pyx_f_8_py_pari_get_var(__pyx_v_var)))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4946; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.poldisc");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_x);
    Py_DECREF(__pyx_v_var);
    return __pyx_r;
  }

  static PyObject *__pyx_k189p;

  static char (__pyx_k189[]) = "error in polgalois";

  static PyObject *__pyx_f_8_py_pari_3gen_polgalois(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_polgalois[] = "\n        polgalois(x): Galois group of the polynomial x\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_polgalois(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    int __pyx_v_err;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_x);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4953 */
    __pyx_v_err = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4954 */
    __pyx_1 = __pyx_v_err;
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4955 */
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4955; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_err); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4955; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4955; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k189p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k189p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4955; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4956 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(galois(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g),__pyx_v_8_py_pari_REAL_PREC))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4956; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.polgalois");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_k190p;
  static PyObject *__pyx_k191p;

  static char (__pyx_k190[]) = "x (=%s) must be a polynomial.";
  static char (__pyx_k191[]) = "error in polisirreducible";

  static PyObject *__pyx_f_8_py_pari_3gen_polisirreducible(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_polisirreducible[] = "\n        polisirreducible(x): Returns True if x is an irreducible\n        non-constant polynomial, or False if x is reducible or\n        constant.\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_polisirreducible(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    int __pyx_v_err;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_x);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4965 */
    __pyx_1 = (typ(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g) != t_POL);
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4966 */
      __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4966; goto __pyx_L1;}
      __pyx_3 = PyNumber_Remainder(__pyx_k190p, __pyx_v_x); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4966; goto __pyx_L1;}
      __Pyx_Raise(__pyx_2, __pyx_3, 0);
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4966; goto __pyx_L1;}
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4967 */
    __pyx_v_err = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4968 */
    __pyx_1 = __pyx_v_err;
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4969 */
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4969; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_err); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4969; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4969; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k191p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k191p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4969; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L3;
    }
    __pyx_L3:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4970 */
    __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_bool); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4970; goto __pyx_L1;}
    __pyx_4 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gisirreducible(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g)))); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4970; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4970; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_4);
    __pyx_4 = 0;
    __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4970; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_r = __pyx_4;
    __pyx_4 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.polisirreducible");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_x);
    return __pyx_r;
  }

  static PyObject *__pyx_k192p;

  static char (__pyx_k192[]) = "error in polresultant";

  static PyObject *__pyx_f_8_py_pari_3gen_polresultant(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_polresultant(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_y = 0;
    PyObject *__pyx_v_var = 0;
    PyObject *__pyx_v_flag = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__y;
    int __pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    long __pyx_5;
    static char *__pyx_argnames[] = {"y","var","flag",0};
    __pyx_v_var = __pyx_k40;
    __pyx_v_flag = __pyx_k41;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|OO", __pyx_argnames, &__pyx_v_y, &__pyx_v_var, &__pyx_v_flag)) return 0;
    Py_INCREF(__pyx_v_x);
    Py_INCREF(__pyx_v_y);
    Py_INCREF(__pyx_v_var);
    Py_INCREF(__pyx_v_flag);
    ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4975 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4975; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4975; goto __pyx_L1;}
    Py_INCREF(__pyx_v_y);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4975; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4975; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__y));
    ((PyObject *)__pyx_v__y) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4977 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4978 */
    __pyx_4 = __pyx_v_n;
    if (__pyx_4) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4979 */
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4979; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4979; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4979; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
      Py_INCREF(__pyx_k192p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k192p);
      __pyx_2 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4979; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4981 */
    __pyx_5 = PyInt_AsLong(__pyx_v_flag); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4981; goto __pyx_L1;}
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(polresultant0(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g),__pyx_v__y->g,__pyx_f_8_py_pari_get_var(__pyx_v_var),__pyx_5))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4981; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.polresultant");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__y);
    Py_DECREF(__pyx_v_x);
    Py_DECREF(__pyx_v_y);
    Py_DECREF(__pyx_v_var);
    Py_DECREF(__pyx_v_flag);
    return __pyx_r;
  }

  static PyObject *__pyx_k193p;

  static char (__pyx_k193[]) = "error in nfbasis";

  static PyObject *__pyx_f_8_py_pari_3gen_polroots(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_polroots[] = "\n        polroots(x,{flag=0}): complex roots of the polynomial x. flag\n        is optional, and can be 0: default, uses Schonhage\'s method modified\n        by Gourdon, or 1: uses a modified Newton method.\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_polroots(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_flag = 0;
    int __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    long __pyx_5;
    static char *__pyx_argnames[] = {"flag",0};
    __pyx_v_flag = __pyx_k42;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_flag)) return 0;
    Py_INCREF(__pyx_v_x);
    Py_INCREF(__pyx_v_flag);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4990 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4991 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4991; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4991; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4991; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k193p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k193p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4991; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4993 */
    __pyx_5 = PyInt_AsLong(__pyx_v_flag); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4993; goto __pyx_L1;}
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(roots0(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_x)->g),__pyx_5,__pyx_v_8_py_pari_REAL_PREC))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4993; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.polroots");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_x);
    Py_DECREF(__pyx_v_flag);
    return __pyx_r;
  }

  static PyObject *__pyx_k194p;

  static char (__pyx_k194[]) = "error in nfbasis";

  static PyObject *__pyx_f_8_py_pari_3gen_factor(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_factor[] = "\n        factor(x,{lim}): factorization of x. lim is optional and can\n        be set whenever x is of (possibly recursive) rational\n        type. If lim is set return partial factorization, using\n        primes up to lim (up to primelimit if lim=0)\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_factor(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_limit = 0;
    int __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    long __pyx_5;
    static char *__pyx_argnames[] = {"limit",0};
    __pyx_v_limit = __pyx_k43;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_limit)) return 0;
    Py_INCREF(__pyx_v_self);
    Py_INCREF(__pyx_v_limit);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5019 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5020 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5020; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5020; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5020; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k194p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k194p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5020; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5021 */
    __pyx_5 = PyInt_AsLong(__pyx_v_limit); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5021; goto __pyx_L1;}
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(factor0(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g),__pyx_5))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5021; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.factor");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_self);
    Py_DECREF(__pyx_v_limit);
    return __pyx_r;
  }

  static PyObject *__pyx_k195p;
  static PyObject *__pyx_k196p;
  static PyObject *__pyx_k197p;

  static char (__pyx_k195[]) = "error in eint1";
  static char (__pyx_k196[]) = "Input (x=%s) must be a real number.";
  static char (__pyx_k197[]) = "Input (x=%s) must be a positive real number.";

  static PyObject *__pyx_f_8_py_pari_3gen_eint1(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_eint1[] = "\n        eint1(x,{n})\n\n        Returns the exponential integral E1(x). If the optional\n        argument n is given, computes the vector of the first n\n        values of the exponential integral E1(x*n), for x > 0.\n        \n        REFERENCE: See page 262, Prop 5.6.12, of Cohen\'s book\n        \"A Course in Computational Algebraic Number Theory\".\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_eint1(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    long __pyx_v_n;
    int __pyx_v_err;
    int __pyx_v_t;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {"n",0};
    __pyx_v_n = __pyx_k44;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|l", __pyx_argnames, &__pyx_v_n)) return 0;
    Py_INCREF(__pyx_v_self);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5042 */
    __pyx_v_err = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5043 */
    __pyx_1 = __pyx_v_err;
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5043; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_err); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5043; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5043; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k195p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k195p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5043; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5046 */
    __pyx_v_t = typ(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5047 */
    __pyx_1 = (__pyx_v_t != t_INT);
    if (__pyx_1) {
      __pyx_1 = (__pyx_v_t != t_REAL);
    }
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5048 */
      __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5048; goto __pyx_L1;}
      __pyx_4 = PyNumber_Remainder(__pyx_k196p, __pyx_v_self); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5048; goto __pyx_L1;}
      __Pyx_Raise(__pyx_2, __pyx_4, 0);
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5048; goto __pyx_L1;}
      goto __pyx_L3;
    }
    __pyx_L3:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5050 */
    __pyx_1 = (__pyx_v_n <= 0);
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5051 */
      __pyx_3 = ((PyObject *)__pyx_f_8_py_pari_new_gen(eint1(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g),__pyx_v_8_py_pari_REAL_PREC))); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5051; goto __pyx_L1;}
      __pyx_r = __pyx_3;
      __pyx_3 = 0;
      goto __pyx_L0;
      goto __pyx_L4;
    }
    /*else*/ {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5053 */
      __pyx_1 = (gsigne(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g) <= 0);
      if (__pyx_1) {

        /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5054 */
        __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_ArithmeticError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5054; goto __pyx_L1;}
        __pyx_4 = PyNumber_Remainder(__pyx_k197p, __pyx_v_self); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5054; goto __pyx_L1;}
        __Pyx_Raise(__pyx_2, __pyx_4, 0);
        Py_DECREF(__pyx_2); __pyx_2 = 0;
        Py_DECREF(__pyx_4); __pyx_4 = 0;
        {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5054; goto __pyx_L1;}
        goto __pyx_L5;
      }
      __pyx_L5:;

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5055 */
      __pyx_3 = ((PyObject *)__pyx_f_8_py_pari_new_gen(veceint1(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g),stoi(__pyx_v_n),__pyx_v_8_py_pari_REAL_PREC))); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5055; goto __pyx_L1;}
      __pyx_r = __pyx_3;
      __pyx_3 = 0;
      goto __pyx_L0;
    }
    __pyx_L4:;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.eint1");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_self);
    return __pyx_r;
  }

  static PyObject *__pyx_k198p;

  static char (__pyx_k198[]) = "error in order";

  static PyObject *__pyx_f_8_py_pari_3gen_order(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_order(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    int __pyx_v_err;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_self);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5060 */
    __pyx_v_err = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5061 */
    __pyx_1 = __pyx_v_err;
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5061; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_err); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5061; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5061; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k198p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k198p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5061; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5062 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(order(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g)))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5062; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.order");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_self);
    return __pyx_r;
  }

  static PyObject *__pyx_k199p;

  static char (__pyx_k199[]) = "error in znprimroot";

  static PyObject *__pyx_f_8_py_pari_3gen_znprimroot(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_znprimroot(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    int __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_self);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5066 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5067 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5067; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5067; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5067; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k199p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k199p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5067; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5068 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(ggener(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g)))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5068; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.znprimroot");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_self);
    return __pyx_r;
  }

  static PyObject *__pyx_n_abs;

  static PyObject *__pyx_f_8_py_pari_3gen___abs__(PyObject *__pyx_v_self); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen___abs__(PyObject *__pyx_v_self) {
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    Py_INCREF(__pyx_v_self);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5071 */
    __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n_abs); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5071; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5071; goto __pyx_L1;}
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5071; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.__abs__");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_self);
    return __pyx_r;
  }

  static PyObject *__pyx_k200p;

  static char (__pyx_k200[]) = "error in abs";

  static PyObject *__pyx_f_8_py_pari_3gen_abs(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_abs(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    int __pyx_v_err;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_self);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5075 */
    __pyx_v_err = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5076 */
    __pyx_1 = __pyx_v_err;
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5076; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_err); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5076; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5076; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k200p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k200p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5076; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5077 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gabs(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g),__pyx_v_8_py_pari_REAL_PREC))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5077; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.abs");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_self);
    return __pyx_r;
  }

  static PyObject *__pyx_k201p;

  static char (__pyx_k201[]) = "error in mattranspose";

  static PyObject *__pyx_f_8_py_pari_3gen_mattranspose(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_mattranspose[] = "\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_mattranspose(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    int __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_self);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5083 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5084 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5084; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5084; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5084; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k201p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k201p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5084; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5085 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gtrans(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g)))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5085; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.mattranspose");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_self);
    return __pyx_r;
  }

  static PyObject *__pyx_k202p;

  static char (__pyx_k202[]) = "error in matker";

  static PyObject *__pyx_f_8_py_pari_3gen_matker(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_matker[] = "\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_matker(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    long __pyx_v_flag;
    int __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {"flag",0};
    __pyx_v_flag = __pyx_k45;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|l", __pyx_argnames, &__pyx_v_flag)) return 0;
    Py_INCREF(__pyx_v_self);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5091 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5092 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5092; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5092; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5092; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k202p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k202p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5092; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5093 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(matker0(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g),__pyx_v_flag))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5093; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.matker");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_self);
    return __pyx_r;
  }

  static PyObject *__pyx_k203p;

  static char (__pyx_k203[]) = "error in matkerint";

  static PyObject *__pyx_f_8_py_pari_3gen_matkerint(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_matkerint[] = "\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_matkerint(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    long __pyx_v_flag;
    int __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {"flag",0};
    __pyx_v_flag = __pyx_k46;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|l", __pyx_argnames, &__pyx_v_flag)) return 0;
    Py_INCREF(__pyx_v_self);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5099 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5100 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5100; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5100; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5100; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k203p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k203p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5100; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5101 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(matkerint0(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g),__pyx_v_flag))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5101; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.matkerint");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_self);
    return __pyx_r;
  }

  static PyObject *__pyx_k204p;

  static char (__pyx_k204[]) = "error in trace";

  static PyObject *__pyx_f_8_py_pari_3gen_trace(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_trace(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    int __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_self);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5105 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5106 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5106; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5106; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5106; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k204p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k204p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5106; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5107 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gtrace(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g)))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5107; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.trace");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_self);
    return __pyx_r;
  }

  static PyObject *__pyx_k205p;

  static char (__pyx_k205[]) = "error in norm";

  static PyObject *__pyx_f_8_py_pari_3gen_norm(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_norm(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    int __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_self);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5111 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5112 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5112; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5112; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5112; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k205p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k205p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5112; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5113 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gnorm(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g)))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5113; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.norm");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_self);
    return __pyx_r;
  }

  static PyObject *__pyx_k206p;

  static char (__pyx_k206[]) = "error in charpoly";

  static PyObject *__pyx_f_8_py_pari_3gen_charpoly(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_charpoly[] = "\n        charpoly(A,{v=x},{flag=0}): det(v*Id-A) = characteristic polynomial of the\n        matrix A using the comatrix. flag is optional and may be set to 1 (use\n        Lagrange interpolation) or 2 (use Hessenberg form), 0 being the default.\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_charpoly(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_var = 0;
    PyObject *__pyx_v_flag = 0;
    int __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    long __pyx_5;
    static char *__pyx_argnames[] = {"var","flag",0};
    __pyx_v_var = __pyx_k47;
    __pyx_v_flag = __pyx_k48;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|OO", __pyx_argnames, &__pyx_v_var, &__pyx_v_flag)) return 0;
    Py_INCREF(__pyx_v_self);
    Py_INCREF(__pyx_v_var);
    Py_INCREF(__pyx_v_flag);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5122 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5123 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5123; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5123; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5123; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k206p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k206p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5123; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5124 */
    __pyx_5 = PyInt_AsLong(__pyx_v_flag); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5124; goto __pyx_L1;}
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(charpoly0(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g),__pyx_f_8_py_pari_get_var(__pyx_v_var),__pyx_5))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5124; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.charpoly");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_self);
    Py_DECREF(__pyx_v_var);
    Py_DECREF(__pyx_v_flag);
    return __pyx_r;
  }

  static PyObject *__pyx_k207p;

  static char (__pyx_k207[]) = "error in nextprime";

  static PyObject *__pyx_f_8_py_pari_3gen_nextprime(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_nextprime[] = "\n        nextprime(x): smallest pseudoprime >= x\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_nextprime(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    int __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_self);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5132 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5133 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5133; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5133; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5133; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k207p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k207p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5133; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5134 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gnextprime(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g)))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5134; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.nextprime");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_self);
    return __pyx_r;
  }

  static PyObject *__pyx_k208p;

  static char (__pyx_k208[]) = "error in subst";

  static PyObject *__pyx_f_8_py_pari_3gen_subst(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_3gen_subst[] = "\n        EXAMPLES:\n           >>> x = pari(\"x\"); y = pari(\"y\")\n           >>> f = x**3 + 17*x + 3\n           >>> f.subst(x, y)\n           y^3 + 17*y + 3\n           >>> f.subst(x, \"z\")\n           z^3 + 17*z + 3\n           >>> f.subst(x, \"z\")**2\n           z^6 + 34*z^4 + 6*z^3 + 289*z^2 + 102*z + 9\n           >>> f.subst(x, \"x+1\")\n           x^3 + 3*x^2 + 20*x + 21\n           >>> f.subst(x, \"xyz\")\n           xyz^3 + 17*xyz + 3\n           >>> f.subst(x, \"xyz\")**2\n           xyz^6 + 34*xyz^4 + 6*xyz^3 + 289*xyz^2 + 102*xyz + 9\n        ";
  static PyObject *__pyx_f_8_py_pari_3gen_subst(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_var = 0;
    PyObject *__pyx_v_y = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__y;
    int __pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    static char *__pyx_argnames[] = {"var","y",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_var, &__pyx_v_y)) return 0;
    Py_INCREF(__pyx_v_self);
    Py_INCREF(__pyx_v_var);
    Py_INCREF(__pyx_v_y);
    ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5155 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5155; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5155; goto __pyx_L1;}
    Py_INCREF(__pyx_v_y);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5155; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5155; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__y));
    ((PyObject *)__pyx_v__y) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5157 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5158 */
    __pyx_4 = __pyx_v_n;
    if (__pyx_4) {
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5158; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5158; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5158; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
      Py_INCREF(__pyx_k208p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k208p);
      __pyx_2 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5158; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5159 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gsubst(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g),__pyx_f_8_py_pari_get_var(__pyx_v_var),__pyx_v__y->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5159; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.subst");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__y);
    Py_DECREF(__pyx_v_self);
    Py_DECREF(__pyx_v_var);
    Py_DECREF(__pyx_v_y);
    return __pyx_r;
  }

  static PyObject *__pyx_k209p;

  static char (__pyx_k209[]) = "error in __call__";

  static PyObject *__pyx_f_8_py_pari_3gen___call__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen___call__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_y = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__y;
    int __pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    static char *__pyx_argnames[] = {"y",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
    Py_INCREF(__pyx_v_self);
    Py_INCREF(__pyx_v_y);
    ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5164 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5164; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5164; goto __pyx_L1;}
    Py_INCREF(__pyx_v_y);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5164; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5164; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__y));
    ((PyObject *)__pyx_v__y) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5166 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5167 */
    __pyx_4 = __pyx_v_n;
    if (__pyx_4) {
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5167; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5167; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5167; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
      Py_INCREF(__pyx_k209p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k209p);
      __pyx_2 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5167; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5168 */
    __pyx_1 = PyInt_FromLong(0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5168; goto __pyx_L1;}
    __pyx_3 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gsubst(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g),__pyx_f_8_py_pari_get_var(__pyx_1),__pyx_v__y->g))); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5168; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.__call__");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__y);
    Py_DECREF(__pyx_v_self);
    Py_DECREF(__pyx_v_y);
    return __pyx_r;
  }

  static PyObject *__pyx_k210p;

  static char (__pyx_k210[]) = "error in imag";

  static PyObject *__pyx_f_8_py_pari_3gen_kronecker(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_kronecker(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_y = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__y;
    int __pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    static char *__pyx_argnames[] = {"y",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
    Py_INCREF(__pyx_v_self);
    Py_INCREF(__pyx_v_y);
    ((PyObject*)__pyx_v__y) = Py_None; Py_INCREF(((PyObject*)__pyx_v__y));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5172 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5172; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5172; goto __pyx_L1;}
    Py_INCREF(__pyx_v_y);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5172; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5172; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__y));
    ((PyObject *)__pyx_v__y) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5175 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5176 */
    __pyx_4 = __pyx_v_n;
    if (__pyx_4) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5177 */
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5177; goto __pyx_L1;}
      __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5177; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5177; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
      Py_INCREF(__pyx_k210p);
      PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k210p);
      __pyx_2 = 0;
      __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5177; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5179 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gkronecker(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g),__pyx_v__y->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5179; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.kronecker");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__y);
    Py_DECREF(__pyx_v_self);
    Py_DECREF(__pyx_v_y);
    return __pyx_r;
  }

  static PyObject *__pyx_k211p;

  static char (__pyx_k211[]) = "error in imag";

  static PyObject *__pyx_f_8_py_pari_3gen_exp(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_exp(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    int __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_self);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5183 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5184 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5185 */
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5185; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5185; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5185; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k211p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k211p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5185; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5186 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(gexp(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g),__pyx_v_8_py_pari_REAL_PREC))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5186; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.exp");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_self);
    return __pyx_r;
  }

  static PyObject *__pyx_k212p;

  static char (__pyx_k212[]) = "error in imag";

  static PyObject *__pyx_f_8_py_pari_3gen_log(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_log(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    int __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_self);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5190 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5191 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5192 */
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5192; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5192; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5192; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k212p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k212p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5192; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5193 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(glog(forcecopy(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g),__pyx_v_8_py_pari_REAL_PREC))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5193; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.gen.log");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_self);
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_3gen_type(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_3gen_type(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
    Py_INCREF(__pyx_v_self);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5197 */
    __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5197; goto __pyx_L1;}
    __pyx_2 = PyString_FromString(type_name(typ(((struct __pyx_obj_8_py_pari_gen *)__pyx_v_self)->g))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5197; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5197; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5197; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.gen.type");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_self);
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_save_avma(void) {
    PyObject *__pyx_r;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5208 */
    __pyx_v_8_py_pari_stack_avma = avma;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    __Pyx_AddTraceback("_py_pari.save_avma");
    __pyx_r = 0;
    __pyx_L0:;
    return __pyx_r;
  }

  static char (__pyx_k213[]) = "\n    Create a new gen, but don\'t free any memory on the stack.\n    ";

  static struct __pyx_obj_8_py_pari_gen *__pyx_f_8_py_pari_new_gen_noclear(GEN __pyx_v_x) {
    struct __pyx_obj_8_py_pari_gen *__pyx_r;
    PyObject *__pyx_1 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5211 */
    __pyx_k213;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5216 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari__new_gen(__pyx_v_x,top)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5216; goto __pyx_L1;}
    __pyx_r = (struct __pyx_obj_8_py_pari_gen *)__pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    (PyObject *)__pyx_r = Py_None; Py_INCREF((PyObject *)__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    __Pyx_AddTraceback("_py_pari.new_gen_noclear");
    __pyx_r = 0;
    __pyx_L0:;
    return ((struct __pyx_obj_8_py_pari_gen *)__pyx_r) ;
  }

  static char (__pyx_k214[]) = "\n    Create a new gen, then free the *entire* stack.\n    ";

  static struct __pyx_obj_8_py_pari_gen *__pyx_f_8_py_pari_new_gen(GEN __pyx_v_x) {
    struct __pyx_obj_8_py_pari_gen *__pyx_v_g;
    struct __pyx_obj_8_py_pari_gen *__pyx_r;
    PyObject *__pyx_1 = 0;
    ((PyObject*)__pyx_v_g) = Py_None; Py_INCREF(((PyObject*)__pyx_v_g));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5230 */
    __pyx_k214;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5235 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari__new_gen(__pyx_v_x,top)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5235; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v_g));
    ((PyObject *)__pyx_v_g) = __pyx_1;
    __pyx_1 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5236 */
    avma = top;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5237 */
    Py_INCREF(((PyObject *)__pyx_v_g));
    __pyx_r = (struct __pyx_obj_8_py_pari_gen *)((PyObject *)__pyx_v_g);
    goto __pyx_L0;

    (PyObject *)__pyx_r = Py_None; Py_INCREF((PyObject *)__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    __Pyx_AddTraceback("_py_pari.new_gen");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_g);
    return ((struct __pyx_obj_8_py_pari_gen *)__pyx_r) ;
  }

  static struct __pyx_obj_8_py_pari_gen *__pyx_f_8_py_pari___xxx_new_gen(GEN __pyx_v_x,pari_sp __pyx_v_start) {
    size_t __pyx_v_s;
    pari_sp __pyx_v_tmp_bot;
    pari_sp __pyx_v_tmp_top;
    pari_sp __pyx_v_tmp_avma;
    GEN __pyx_v_h;
    struct __pyx_obj_8_py_pari_gen *__pyx_v_p;
    struct __pyx_obj_8_py_pari_gen *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    ((PyObject*)__pyx_v_p) = Py_None; Py_INCREF(((PyObject*)__pyx_v_p));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5247 */
    __pyx_1 = (((pari_sp )__pyx_v_x) < bot);
    if (!__pyx_1) {
      __pyx_1 = (((pari_sp )__pyx_v_x) > top);
    }
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5248 */
      __pyx_2 = PyTuple_New(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5248; goto __pyx_L1;}
      __pyx_3 = PyObject_CallObject(((PyObject*)__pyx_ptype_8_py_pari_gen), __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5248; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5248; goto __pyx_L1;}
      Py_DECREF(((PyObject *)__pyx_v_p));
      ((PyObject *)__pyx_v_p) = __pyx_3;
      __pyx_3 = 0;

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5249 */
      __pyx_2 = ((struct __pyx_vtabstruct_8_py_pari_gen *)__pyx_v_p->__pyx_vtab)->init(__pyx_v_p,__pyx_v_x,0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5249; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5250 */
      Py_INCREF(((PyObject *)__pyx_v_p));
      __pyx_r = (struct __pyx_obj_8_py_pari_gen *)((PyObject *)__pyx_v_p);
      goto __pyx_L0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5252 */
    __pyx_v_tmp_top = top;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5253 */
    __pyx_v_tmp_bot = bot;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5254 */
    __pyx_v_tmp_avma = avma;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5255 */
    __pyx_v_s = ((size_t )(__pyx_v_start - avma));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5257 */
    bot = ((pari_sp )PyMem_Malloc(__pyx_v_s));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5258 */
    top = (bot + __pyx_v_s);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5259 */
    avma = top;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5260 */
    __pyx_v_h = forcecopy(__pyx_v_x);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5261 */
    __pyx_3 = PyTuple_New(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5261; goto __pyx_L1;}
    __pyx_2 = PyObject_CallObject(((PyObject*)__pyx_ptype_8_py_pari_gen), __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5261; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    if (!__Pyx_TypeTest(__pyx_2, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5261; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v_p));
    ((PyObject *)__pyx_v_p) = __pyx_2;
    __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5261 */
    __pyx_3 = ((struct __pyx_vtabstruct_8_py_pari_gen *)__pyx_v_p->__pyx_vtab)->init(__pyx_v_p,__pyx_v_h,bot); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5261; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5264 */
    top = __pyx_v_tmp_top;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5265 */
    bot = __pyx_v_tmp_bot;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5266 */
    avma = __pyx_v_tmp_avma;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5267 */
    Py_INCREF(((PyObject *)__pyx_v_p));
    __pyx_r = (struct __pyx_obj_8_py_pari_gen *)((PyObject *)__pyx_v_p);
    goto __pyx_L0;

    (PyObject *)__pyx_r = Py_None; Py_INCREF((PyObject *)__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.__xxx_new_gen");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_p);
    return ((struct __pyx_obj_8_py_pari_gen *)__pyx_r) ;
  }

  static struct __pyx_obj_8_py_pari_gen *__pyx_f_8_py_pari__new_gen(GEN __pyx_v_x,pari_sp __pyx_v_start) {
    size_t __pyx_v_s;
    pari_sp __pyx_v_tmp_bot;
    pari_sp __pyx_v_tmp_top;
    pari_sp __pyx_v_tmp_avma;
    GEN __pyx_v_h;
    struct __pyx_obj_8_py_pari_gen *__pyx_v_p;
    struct __pyx_obj_8_py_pari_gen *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    ((PyObject*)__pyx_v_p) = Py_None; Py_INCREF(((PyObject*)__pyx_v_p));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5277 */
    __pyx_1 = (((pari_sp )__pyx_v_x) < bot);
    if (!__pyx_1) {
      __pyx_1 = (((pari_sp )__pyx_v_x) > top);
    }
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5278 */
      __pyx_2 = PyTuple_New(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5278; goto __pyx_L1;}
      __pyx_3 = PyObject_CallObject(((PyObject*)__pyx_ptype_8_py_pari_gen), __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5278; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5278; goto __pyx_L1;}
      Py_DECREF(((PyObject *)__pyx_v_p));
      ((PyObject *)__pyx_v_p) = __pyx_3;
      __pyx_3 = 0;

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5279 */
      __pyx_2 = ((struct __pyx_vtabstruct_8_py_pari_gen *)__pyx_v_p->__pyx_vtab)->init(__pyx_v_p,__pyx_v_x,0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5279; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5280 */
      Py_INCREF(((PyObject *)__pyx_v_p));
      __pyx_r = (struct __pyx_obj_8_py_pari_gen *)((PyObject *)__pyx_v_p);
      goto __pyx_L0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5282 */
    __pyx_v_tmp_top = top;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5283 */
    __pyx_v_tmp_bot = bot;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5284 */
    __pyx_v_tmp_avma = avma;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5285 */
    __pyx_v_h = forcecopy(__pyx_v_x);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5286 */
    __pyx_v_s = ((size_t )(__pyx_v_tmp_avma - avma));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5288 */
    bot = ((pari_sp )PyMem_Malloc(__pyx_v_s));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5289 */
    top = (bot + __pyx_v_s);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5290 */
    avma = top;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5291 */
    __pyx_v_h = forcecopy(__pyx_v_x);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5292 */
    __pyx_3 = PyTuple_New(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5292; goto __pyx_L1;}
    __pyx_2 = PyObject_CallObject(((PyObject*)__pyx_ptype_8_py_pari_gen), __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5292; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    if (!__Pyx_TypeTest(__pyx_2, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5292; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v_p));
    ((PyObject *)__pyx_v_p) = __pyx_2;
    __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5292 */
    __pyx_3 = ((struct __pyx_vtabstruct_8_py_pari_gen *)__pyx_v_p->__pyx_vtab)->init(__pyx_v_p,__pyx_v_h,bot); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5292; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5295 */
    top = __pyx_v_tmp_top;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5296 */
    bot = __pyx_v_tmp_bot;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5297 */
    avma = __pyx_v_tmp_avma;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5298 */
    Py_INCREF(((PyObject *)__pyx_v_p));
    __pyx_r = (struct __pyx_obj_8_py_pari_gen *)((PyObject *)__pyx_v_p);
    goto __pyx_L0;

    (PyObject *)__pyx_r = Py_None; Py_INCREF((PyObject *)__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari._new_gen");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_p);
    return ((struct __pyx_obj_8_py_pari_gen *)__pyx_r) ;
  }

  static struct __pyx_obj_8_py_pari_gen *__pyx_f_8_py_pari_new_ref(GEN __pyx_v_x,PyObject *__pyx_v_g) {
    struct __pyx_obj_8_py_pari_gen *__pyx_v_p;
    struct __pyx_obj_8_py_pari_gen *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    Py_INCREF(__pyx_v_g);
    ((PyObject*)__pyx_v_p) = Py_None; Py_INCREF(((PyObject*)__pyx_v_p));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5302 */
    __pyx_1 = PyTuple_New(0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5302; goto __pyx_L1;}
    __pyx_2 = PyObject_CallObject(((PyObject*)__pyx_ptype_8_py_pari_gen), __pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5302; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    if (!__Pyx_TypeTest(__pyx_2, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5302; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v_p));
    ((PyObject *)__pyx_v_p) = __pyx_2;
    __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5302 */
    __pyx_1 = ((struct __pyx_vtabstruct_8_py_pari_gen *)__pyx_v_p->__pyx_vtab)->init(__pyx_v_p,__pyx_v_x,0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5302; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5303 */
    __pyx_2 = PyInt_FromLong((-1)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5303; goto __pyx_L1;}
    if (PyObject_SetItem(__pyx_v_p->refers_to, __pyx_2, __pyx_v_g) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5303; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5305 */
    Py_INCREF(((PyObject *)__pyx_v_p));
    __pyx_r = (struct __pyx_obj_8_py_pari_gen *)((PyObject *)__pyx_v_p);
    goto __pyx_L0;

    (PyObject *)__pyx_r = Py_None; Py_INCREF((PyObject *)__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    __Pyx_AddTraceback("_py_pari.new_ref");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_p);
    Py_DECREF(__pyx_v_g);
    return ((struct __pyx_obj_8_py_pari_gen *)__pyx_r) ;
  }

  static PyObject *__pyx_n_list;
  static PyObject *__pyx_n_xrange;
  static PyObject *__pyx_n_len;
  static PyObject *__pyx_n_enumerate;
  static PyObject *__pyx_n_AttributeError;
  static PyObject *__pyx_n_True;

  static PyObject *__pyx_f_8_py_pari_pari(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_pari[] = "\n    Create the PARI object got by evaluating s using PARI.\n    ";
  static PyObject *__pyx_f_8_py_pari_pari(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_s = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v_p;
    GEN __pyx_v_g;
    pari_sp __pyx_v_prev_avma;
    PyObject *__pyx_v_v;
    PyObject *__pyx_v_i;
    PyObject *__pyx_v_x;
    PyObject *__pyx_v_t;
    PyObject *__pyx_v_again;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    PyObject *__pyx_5 = 0;
    PyObject *__pyx_6 = 0;
    char (*__pyx_7);
    GEN __pyx_8;
    static char *__pyx_argnames[] = {"s",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_s)) return 0;
    Py_INCREF(__pyx_v_s);
    ((PyObject*)__pyx_v_p) = Py_None; Py_INCREF(((PyObject*)__pyx_v_p));
    __pyx_v_v = Py_None; Py_INCREF(__pyx_v_v);
    __pyx_v_i = Py_None; Py_INCREF(__pyx_v_i);
    __pyx_v_x = Py_None; Py_INCREF(__pyx_v_x);
    __pyx_v_t = Py_None; Py_INCREF(__pyx_v_t);
    __pyx_v_again = Py_None; Py_INCREF(__pyx_v_again);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5316 */
    __pyx_v_prev_avma = avma;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5318 */
    __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_isinstance); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5318; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(2); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5318; goto __pyx_L1;}
    Py_INCREF(__pyx_v_s);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_s);
    Py_INCREF(((PyObject*)__pyx_ptype_8_py_pari_gen));
    PyTuple_SET_ITEM(__pyx_2, 1, ((PyObject*)__pyx_ptype_8_py_pari_gen));
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5318; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_4 = PyObject_IsTrue(__pyx_3); if (__pyx_4 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5318; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    if (__pyx_4) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5319 */
      Py_INCREF(__pyx_v_s);
      __pyx_r = __pyx_v_s;
      goto __pyx_L0;
      goto __pyx_L2;
    }
    __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_isinstance); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5320; goto __pyx_L1;}
    __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_list); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5320; goto __pyx_L1;}
    __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_xrange); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5320; goto __pyx_L1;}
    __pyx_5 = __Pyx_GetName(__pyx_b, __pyx_n_tuple); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5320; goto __pyx_L1;}
    __pyx_6 = PyTuple_New(3); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5320; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_6, 0, __pyx_2);
    PyTuple_SET_ITEM(__pyx_6, 1, __pyx_3);
    PyTuple_SET_ITEM(__pyx_6, 2, __pyx_5);
    __pyx_2 = 0;
    __pyx_3 = 0;
    __pyx_5 = 0;
    __pyx_2 = PyTuple_New(2); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5320; goto __pyx_L1;}
    Py_INCREF(__pyx_v_s);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_s);
    PyTuple_SET_ITEM(__pyx_2, 1, __pyx_6);
    __pyx_6 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5320; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_4 = PyObject_IsTrue(__pyx_3); if (__pyx_4 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5320; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    if (__pyx_4) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5321 */
      __pyx_5 = __Pyx_GetName(__pyx_m, __pyx_n_vector); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5321; goto __pyx_L1;}
      __pyx_6 = __Pyx_GetName(__pyx_b, __pyx_n_len); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5321; goto __pyx_L1;}
      __pyx_1 = PyTuple_New(1); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5321; goto __pyx_L1;}
      Py_INCREF(__pyx_v_s);
      PyTuple_SET_ITEM(__pyx_1, 0, __pyx_v_s);
      __pyx_2 = PyObject_CallObject(__pyx_6, __pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5321; goto __pyx_L1;}
      Py_DECREF(__pyx_6); __pyx_6 = 0;
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5321; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
      __pyx_2 = 0;
      __pyx_6 = PyObject_CallObject(__pyx_5, __pyx_3); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5321; goto __pyx_L1;}
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_v_v);
      __pyx_v_v = __pyx_6;
      __pyx_6 = 0;

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5322 */
      __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_enumerate); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5322; goto __pyx_L1;}
      __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5322; goto __pyx_L1;}
      Py_INCREF(__pyx_v_s);
      PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_s);
      __pyx_5 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5322; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      __pyx_3 = PyObject_GetIter(__pyx_5); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5322; goto __pyx_L1;}
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      for (;;) {
        __pyx_L3:;
        __pyx_6 = PyIter_Next(__pyx_3);
        if (!__pyx_6) {
          if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5322; goto __pyx_L1;}
          break;
        }
        __pyx_1 = __Pyx_UnpackItem(__pyx_6, 0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5322; goto __pyx_L1;}
        Py_DECREF(__pyx_v_i);
        __pyx_v_i = __pyx_1;
        __pyx_1 = 0;
        __pyx_2 = __Pyx_UnpackItem(__pyx_6, 1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5322; goto __pyx_L1;}
        Py_DECREF(__pyx_v_x);
        __pyx_v_x = __pyx_2;
        __pyx_2 = 0;
        if (__Pyx_EndUnpack(__pyx_6, 2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5322; goto __pyx_L1;}
        Py_DECREF(__pyx_6); __pyx_6 = 0;

        /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5323 */
        __pyx_5 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5323; goto __pyx_L1;}
        __pyx_6 = PyTuple_New(1); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5323; goto __pyx_L1;}
        Py_INCREF(__pyx_v_x);
        PyTuple_SET_ITEM(__pyx_6, 0, __pyx_v_x);
        __pyx_1 = PyObject_CallObject(__pyx_5, __pyx_6); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5323; goto __pyx_L1;}
        Py_DECREF(__pyx_5); __pyx_5 = 0;
        Py_DECREF(__pyx_6); __pyx_6 = 0;
        if (PyObject_SetItem(__pyx_v_v, __pyx_v_i, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5323; goto __pyx_L1;}
        Py_DECREF(__pyx_1); __pyx_1 = 0;
      }
      __pyx_L4:;
      Py_DECREF(__pyx_3); __pyx_3 = 0;

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5324 */
      Py_INCREF(__pyx_v_v);
      __pyx_r = __pyx_v_v;
      goto __pyx_L0;
      goto __pyx_L2;
    }
    __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_isinstance); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5325; goto __pyx_L1;}
    __pyx_5 = __Pyx_GetName(__pyx_b, __pyx_n_bool); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5325; goto __pyx_L1;}
    __pyx_6 = PyTuple_New(2); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5325; goto __pyx_L1;}
    Py_INCREF(__pyx_v_s);
    PyTuple_SET_ITEM(__pyx_6, 0, __pyx_v_s);
    PyTuple_SET_ITEM(__pyx_6, 1, __pyx_5);
    __pyx_5 = 0;
    __pyx_1 = PyObject_CallObject(__pyx_2, __pyx_6); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5325; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_6); __pyx_6 = 0;
    __pyx_4 = PyObject_IsTrue(__pyx_1); if (__pyx_4 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5325; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    if (__pyx_4) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5326 */
      __pyx_4 = PyObject_IsTrue(__pyx_v_s); if (__pyx_4 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5326; goto __pyx_L1;}
      if (__pyx_4) {

        /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5327 */
        Py_INCREF(((PyObject *)__pyx_v_8_py_pari_ONE));
        __pyx_r = ((PyObject *)__pyx_v_8_py_pari_ONE);
        goto __pyx_L0;
        goto __pyx_L5;
      }
      __pyx_L5:;

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5328 */
      Py_INCREF(((PyObject *)__pyx_v_8_py_pari_ZERO));
      __pyx_r = ((PyObject *)__pyx_v_8_py_pari_ZERO);
      goto __pyx_L0;
      goto __pyx_L2;
    }
    /*else*/ {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5330 */
      /*try:*/ {

        /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5331 */
        __pyx_3 = PyObject_GetAttr(__pyx_v_s, __pyx_n_pari); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5331; goto __pyx_L6;}
        __pyx_5 = PyTuple_New(0); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5331; goto __pyx_L6;}
        __pyx_2 = PyObject_CallObject(__pyx_3, __pyx_5); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5331; goto __pyx_L6;}
        Py_DECREF(__pyx_3); __pyx_3 = 0;
        Py_DECREF(__pyx_5); __pyx_5 = 0;
        __pyx_r = __pyx_2;
        __pyx_2 = 0;
        goto __pyx_L0;
      }
      goto __pyx_L7;
      __pyx_L6:;
      Py_XDECREF(__pyx_6); __pyx_6 = 0;
      Py_XDECREF(__pyx_1); __pyx_1 = 0;
      Py_XDECREF(__pyx_3); __pyx_3 = 0;
      Py_XDECREF(__pyx_5); __pyx_5 = 0;
      Py_XDECREF(__pyx_2); __pyx_2 = 0;

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5332 */
      __pyx_6 = __Pyx_GetName(__pyx_b, __pyx_n_AttributeError); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5332; goto __pyx_L1;}
      __pyx_4 = PyErr_ExceptionMatches(__pyx_6);
      Py_DECREF(__pyx_6); __pyx_6 = 0;
      if (__pyx_4) {
        __Pyx_AddTraceback("_py_pari.pari");
        __pyx_1 = __Pyx_GetExcValue(); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5332; goto __pyx_L1;}
        Py_DECREF(__pyx_1); __pyx_1 = 0;

        /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5333 */
        goto __pyx_L7;
      }
      goto __pyx_L1;
      __pyx_L7:;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5335 */
    __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5335; goto __pyx_L1;}
    __pyx_5 = PyTuple_New(1); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5335; goto __pyx_L1;}
    Py_INCREF(__pyx_v_s);
    PyTuple_SET_ITEM(__pyx_5, 0, __pyx_v_s);
    __pyx_2 = PyObject_CallObject(__pyx_3, __pyx_5); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5335; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_v_t);
    __pyx_v_t = __pyx_2;
    __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5336 */
    __pyx_6 = __Pyx_GetName(__pyx_b, __pyx_n_True); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5336; goto __pyx_L1;}
    Py_DECREF(__pyx_v_again);
    __pyx_v_again = __pyx_6;
    __pyx_6 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5337 */
    while (1) {
      __pyx_L8:;
      __pyx_4 = PyObject_IsTrue(__pyx_v_again); if (__pyx_4 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5337; goto __pyx_L1;}
      if (!__pyx_4) break;

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5338 */
      /*try:*/ {

        /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5339 */
        __pyx_7 = PyString_AsString(__pyx_v_t); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5339; goto __pyx_L10;}
        __pyx_8 = __pyx_f_8_py_pari_str_to_GEN(__pyx_7); if (__pyx_8 == 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5339; goto __pyx_L10;}
        __pyx_v_g = __pyx_8;

        /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5340 */
        __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_False); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5340; goto __pyx_L10;}
        Py_DECREF(__pyx_v_again);
        __pyx_v_again = __pyx_1;
        __pyx_1 = 0;
      }
      goto __pyx_L11;
      __pyx_L10:;
      Py_XDECREF(__pyx_3); __pyx_3 = 0;
      Py_XDECREF(__pyx_5); __pyx_5 = 0;
      Py_XDECREF(__pyx_2); __pyx_2 = 0;
      Py_XDECREF(__pyx_6); __pyx_6 = 0;
      Py_XDECREF(__pyx_1); __pyx_1 = 0;

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5341 */
      __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_MemoryError); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5341; goto __pyx_L1;}
      __pyx_4 = PyErr_ExceptionMatches(__pyx_3);
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      if (__pyx_4) {
        __Pyx_AddTraceback("_py_pari.pari");
        __pyx_5 = __Pyx_GetExcValue(); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5341; goto __pyx_L1;}
        Py_DECREF(__pyx_5); __pyx_5 = 0;

        /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5342 */
        __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_True); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5342; goto __pyx_L1;}
        Py_DECREF(__pyx_v_again);
        __pyx_v_again = __pyx_2;
        __pyx_2 = 0;
        goto __pyx_L11;
      }
      goto __pyx_L1;
      __pyx_L11:;
    }
    __pyx_L9:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5345 */
    __pyx_6 = ((PyObject *)__pyx_f_8_py_pari_new_gen(__pyx_v_g)); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5345; goto __pyx_L1;}
    __pyx_r = __pyx_6;
    __pyx_6 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_5);
    Py_XDECREF(__pyx_6);
    __Pyx_AddTraceback("_py_pari.pari");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_p);
    Py_DECREF(__pyx_v_v);
    Py_DECREF(__pyx_v_i);
    Py_DECREF(__pyx_v_x);
    Py_DECREF(__pyx_v_t);
    Py_DECREF(__pyx_v_again);
    Py_DECREF(__pyx_v_s);
    return __pyx_r;
  }

  static char (__pyx_k215[]) = "\n    Converts a Python string into a PARI variable reference number.\n    Or if v = -1, returns -1.\n    ";

  static int __pyx_f_8_py_pari_get_var(PyObject *__pyx_v_v) {
    PyObject *__pyx_v_s;
    int __pyx_r;
    PyObject *__pyx_1 = 0;
    int __pyx_2;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    char (*__pyx_5);
    Py_INCREF(__pyx_v_v);
    __pyx_v_s = Py_None; Py_INCREF(__pyx_v_s);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5349 */
    __pyx_k215;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5353 */
    __pyx_1 = PyInt_FromLong((-1)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5353; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_v_v, __pyx_1, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5353; goto __pyx_L1;}
    __pyx_2 = __pyx_2 != 0;
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    if (__pyx_2) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5354 */
      __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5354; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5354; goto __pyx_L1;}
      Py_INCREF(__pyx_v_v);
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_v);
      __pyx_4 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5354; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_v_s);
      __pyx_v_s = __pyx_4;
      __pyx_4 = 0;

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5355 */
      __pyx_5 = PyString_AsString(__pyx_v_s); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5355; goto __pyx_L1;}
      __pyx_r = fetch_user_var(__pyx_5);
      goto __pyx_L0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5356 */
    __pyx_r = (-1);
    goto __pyx_L0;

    __pyx_r = 0;
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_WriteUnraisable("_py_pari.get_var");
    __pyx_L0:;
    Py_DECREF(__pyx_v_s);
    Py_DECREF(__pyx_v_v);
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_stack_ptr(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_stack_ptr(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5359 */
    __pyx_1 = PyLong_FromUnsignedLong(avma); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5359; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    __Pyx_AddTraceback("_py_pari.stack_ptr");
    __pyx_r = 0;
    __pyx_L0:;
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_stack_top(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_stack_top(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5362 */
    __pyx_1 = PyLong_FromUnsignedLong(top); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5362; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    __Pyx_AddTraceback("_py_pari.stack_top");
    __pyx_r = 0;
    __pyx_L0:;
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_stack_bottom(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_stack_bottom(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5365 */
    __pyx_1 = PyLong_FromUnsignedLong(bot); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5365; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    __Pyx_AddTraceback("_py_pari.stack_bottom");
    __pyx_r = 0;
    __pyx_L0:;
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_stack_size(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_stack_size[] = "\n    Stack size, in bytes\n    ";
  static PyObject *__pyx_f_8_py_pari_stack_size(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5372 */
    __pyx_1 = PyLong_FromUnsignedLong((top - bot)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5372; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    __Pyx_AddTraceback("_py_pari.stack_size");
    __pyx_r = 0;
    __pyx_L0:;
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_stack_usage(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_stack_usage[] = "\n    How much memory in megabytes is currently being used on the PARI stack.\n    ";
  static PyObject *__pyx_f_8_py_pari_stack_usage(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5379 */
    __pyx_1 = PyLong_FromUnsignedLong((top - avma)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5379; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    __Pyx_AddTraceback("_py_pari.stack_usage");
    __pyx_r = 0;
    __pyx_L0:;
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_stack_available(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_stack_available[] = "\n    How much memory in bytes is currently available on the PARI stack.\n    ";
  static PyObject *__pyx_f_8_py_pari_stack_available(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5386 */
    __pyx_1 = PyLong_FromUnsignedLong((avma - bot)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5386; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    __Pyx_AddTraceback("_py_pari.stack_available");
    __pyx_r = 0;
    __pyx_L0:;
    return __pyx_r;
  }

  static PyObject *__pyx_k216p;

  static char (__pyx_k216[]) = "\n";

  static PyObject *__pyx_f_8_py_pari_execute(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_execute(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_s = 0;
    int __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    char (*__pyx_5);
    static char *__pyx_argnames[] = {"s",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_s)) return 0;
    Py_INCREF(__pyx_v_s);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5395 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5396 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5397 */
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5397; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5397; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5397; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_v_s);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_v_s);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5397; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5398 */
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_execute); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5398; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5398; goto __pyx_L1;}
      Py_INCREF(__pyx_v_s);
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_s);
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5398; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5401 */
    __pyx_2 = PyNumber_Add(__pyx_v_s, __pyx_k216p); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5401; goto __pyx_L1;}
    Py_DECREF(__pyx_v_s);
    __pyx_v_s = __pyx_2;
    __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5402 */
    __pyx_5 = PyString_AsString(__pyx_v_s); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5402; goto __pyx_L1;}
    flisseq(__pyx_5);

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.execute");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_s);
    return __pyx_r;
  }

  static PyObject *__pyx_k217p;

  static char (__pyx_k217[]) = "\n";

  static PyObject *__pyx_f_8_py_pari_eval(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_eval(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_s = 0;
    int __pyx_v_n;
    GEN __pyx_v_x;
    char (*__pyx_v_c);
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    char (*__pyx_5);
    static char *__pyx_argnames[] = {"s",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_s)) return 0;
    Py_INCREF(__pyx_v_s);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5406 */
    __pyx_v_n = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5407 */
    __pyx_1 = __pyx_v_n;
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5408 */
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5408; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5408; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5408; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_v_s);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_v_s);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5408; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5409 */
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_eval); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5409; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5409; goto __pyx_L1;}
      Py_INCREF(__pyx_v_s);
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_s);
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5409; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      __pyx_r = __pyx_3;
      __pyx_3 = 0;
      goto __pyx_L0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5415 */
    __pyx_2 = PyNumber_Add(__pyx_v_s, __pyx_k217p); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5415; goto __pyx_L1;}
    Py_DECREF(__pyx_v_s);
    __pyx_v_s = __pyx_2;
    __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5416 */
    __pyx_5 = PyString_AsString(__pyx_v_s); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5416; goto __pyx_L1;}
    __pyx_v_x = flisseq(__pyx_5);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5418 */
    __pyx_v_c = GENtostr(__pyx_v_x);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5420 */
    cgiv(__pyx_v_x);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5422 */
    __pyx_4 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5422; goto __pyx_L1;}
    __pyx_3 = PyString_FromString(__pyx_v_c); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5422; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5422; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_3);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_4, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5422; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_v_s);
    __pyx_v_s = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5424 */
    free(__pyx_v_c);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5425 */
    Py_INCREF(__pyx_v_s);
    __pyx_r = __pyx_v_s;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.eval");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_s);
    return __pyx_r;
  }

  static PyObject *__pyx_n_sys;
  static PyObject *__pyx_n_OverflowError;
  static PyObject *__pyx_n_InputError;

  static PyObject *__pyx_k219p;
  static PyObject *__pyx_k220p;
  static PyObject *__pyx_k221p;
  static PyObject *__pyx_k222p;
  static PyObject *__pyx_k223p;
  static PyObject *__pyx_k224p;
  static PyObject *__pyx_k225p;
  static PyObject *__pyx_k226p;

  static char (__pyx_k219[]) = "Incorrect type (%s)";
  static char (__pyx_k220[]) = "Unable to assign I-->S.  (%s)";
  static char (__pyx_k221[]) = "Unable to convert to integer: %s";
  static char (__pyx_k222[]) = "PARI ran out of memory, so we automatically increase the memory available to PARI.";
  static char (__pyx_k223[]) = "Object too big to fit in a codeword: %s";
  static char (__pyx_k224[]) = "Doubling number of precomputed primes.";
  static char (__pyx_k225[]) = "Bad arguments to an elliptic curve function: %s";
  static char (__pyx_k226[]) = "PARI error %s: %s";

  static PyObject *__pyx_f_8_py_pari__error(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari__error(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_n = 0;
    PyObject *__pyx_v_s = 0;
    PyObject *__pyx_v_sys;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    int __pyx_2;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {"n","s",0};
    __pyx_v_s = __pyx_k50;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|O", __pyx_argnames, &__pyx_v_n, &__pyx_v_s)) return 0;
    Py_INCREF(__pyx_v_n);
    Py_INCREF(__pyx_v_s);
    __pyx_v_sys = Py_None; Py_INCREF(__pyx_v_sys);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5428 */
    __pyx_1 = __Pyx_Import(__pyx_n_sys, 0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5428; goto __pyx_L1;}
    Py_DECREF(__pyx_v_sys);
    __pyx_v_sys = __pyx_1;
    __pyx_1 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5429 */
    __pyx_1 = PyInt_FromLong(20); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5429; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_v_n, __pyx_1, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5429; goto __pyx_L1;}
    __pyx_2 = __pyx_2 == 0;
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    if (__pyx_2) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5430 */
      __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5430; goto __pyx_L1;}
      __pyx_3 = PyNumber_Remainder(__pyx_k219p, __pyx_v_s); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5430; goto __pyx_L1;}
      __Pyx_Raise(__pyx_1, __pyx_3, 0);
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5430; goto __pyx_L1;}
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5431 */
    __pyx_1 = PyInt_FromLong(23); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5431; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_v_n, __pyx_1, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5431; goto __pyx_L1;}
    __pyx_2 = __pyx_2 == 0;
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    if (__pyx_2) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5432 */
      __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5432; goto __pyx_L1;}
      __pyx_1 = PyNumber_Remainder(__pyx_k220p, __pyx_v_s); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5432; goto __pyx_L1;}
      __Pyx_Raise(__pyx_3, __pyx_1, 0);
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5432; goto __pyx_L1;}
      goto __pyx_L3;
    }
    __pyx_L3:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5433 */
    __pyx_3 = PyInt_FromLong(24); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5433; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_v_n, __pyx_3, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5433; goto __pyx_L1;}
    __pyx_2 = __pyx_2 == 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    if (__pyx_2) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5434 */
      __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5434; goto __pyx_L1;}
      __pyx_3 = PyNumber_Remainder(__pyx_k221p, __pyx_v_s); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5434; goto __pyx_L1;}
      __Pyx_Raise(__pyx_1, __pyx_3, 0);
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5434; goto __pyx_L1;}
      goto __pyx_L4;
    }
    __pyx_L4:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5435 */
    __pyx_1 = PyInt_FromLong(64); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5435; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_v_n, __pyx_1, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5435; goto __pyx_L1;}
    __pyx_2 = __pyx_2 == 0;
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    if (__pyx_2) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5436 */
      if (__Pyx_PrintItem(__pyx_k222p) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5436; goto __pyx_L1;}
      if (__Pyx_PrintNewline() < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5436; goto __pyx_L1;}

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5437 */
      __pyx_2 = __pyx_f_8_py_pari_init_stack(0); if (__pyx_2 == -1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5437; goto __pyx_L1;}

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5438 */
      __pyx_r = Py_None; Py_INCREF(__pyx_r);
      goto __pyx_L0;
      goto __pyx_L5;
    }
    __pyx_L5:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5439 */
    __pyx_3 = PyInt_FromLong(65); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5439; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_v_n, __pyx_3, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5439; goto __pyx_L1;}
    __pyx_2 = __pyx_2 == 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    if (__pyx_2) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5440 */
      __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_OverflowError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5440; goto __pyx_L1;}
      __pyx_3 = PyNumber_Remainder(__pyx_k223p, __pyx_v_s); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5440; goto __pyx_L1;}
      __Pyx_Raise(__pyx_1, __pyx_3, 0);
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5440; goto __pyx_L1;}
      goto __pyx_L6;
    }
    __pyx_L6:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5441 */
    __pyx_1 = PyInt_FromLong(83); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5441; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_v_n, __pyx_1, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5441; goto __pyx_L1;}
    __pyx_2 = __pyx_2 == 0;
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    if (__pyx_2) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5443 */
      if (__Pyx_PrintItem(__pyx_k224p) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5443; goto __pyx_L1;}
      if (__Pyx_PrintNewline() < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5443; goto __pyx_L1;}

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5444 */
      __pyx_3 = __Pyx_GetName(__pyx_m, __pyx_n_init_primes); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5444; goto __pyx_L1;}
      __pyx_1 = PyInt_FromLong((2 * __pyx_v_8_py_pari_num_primes)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5444; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5444; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_1);
      __pyx_1 = 0;
      __pyx_1 = PyObject_CallObject(__pyx_3, __pyx_4); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5444; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_1); __pyx_1 = 0;

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5445 */
      __pyx_r = Py_None; Py_INCREF(__pyx_r);
      goto __pyx_L0;
      goto __pyx_L7;
    }
    __pyx_L7:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5446 */
    __pyx_3 = PyInt_FromLong(97); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5446; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_v_n, __pyx_3, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5446; goto __pyx_L1;}
    __pyx_2 = __pyx_2 == 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    if (__pyx_2) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5447 */
      __pyx_4 = __Pyx_GetName(__pyx_b, __pyx_n_InputError); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5447; goto __pyx_L1;}
      __pyx_1 = PyNumber_Remainder(__pyx_k225p, __pyx_v_s); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5447; goto __pyx_L1;}
      __Pyx_Raise(__pyx_4, __pyx_1, 0);
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5447; goto __pyx_L1;}
      goto __pyx_L8;
    }
    __pyx_L8:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5448 */
    __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_RuntimeError); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5448; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5448; goto __pyx_L1;}
    Py_INCREF(__pyx_v_n);
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_n);
    Py_INCREF(__pyx_v_s);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_v_s);
    __pyx_1 = PyNumber_Remainder(__pyx_k226p, __pyx_4); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5448; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __Pyx_Raise(__pyx_3, __pyx_1, 0);
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5448; goto __pyx_L1;}

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari._error");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_sys);
    Py_DECREF(__pyx_v_n);
    Py_DECREF(__pyx_v_s);
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_min(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_min(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_x = 0;
    PyObject *__pyx_v_y = 0;
    PyObject *__pyx_r;
    int __pyx_1;
    static char *__pyx_argnames[] = {"x","y",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_x, &__pyx_v_y)) return 0;
    Py_INCREF(__pyx_v_x);
    Py_INCREF(__pyx_v_y);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5453 */
    if (PyObject_Cmp(__pyx_v_x, __pyx_v_y, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5453; goto __pyx_L1;}
    __pyx_1 = __pyx_1 <= 0;
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5454 */
      Py_INCREF(__pyx_v_x);
      __pyx_r = __pyx_v_x;
      goto __pyx_L0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5455 */
    Py_INCREF(__pyx_v_y);
    __pyx_r = __pyx_v_y;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    __Pyx_AddTraceback("_py_pari.min");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_x);
    Py_DECREF(__pyx_v_y);
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_max(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_max(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_x = 0;
    PyObject *__pyx_v_y = 0;
    PyObject *__pyx_r;
    int __pyx_1;
    static char *__pyx_argnames[] = {"x","y",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_x, &__pyx_v_y)) return 0;
    Py_INCREF(__pyx_v_x);
    Py_INCREF(__pyx_v_y);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5458 */
    if (PyObject_Cmp(__pyx_v_x, __pyx_v_y, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5458; goto __pyx_L1;}
    __pyx_1 = __pyx_1 >= 0;
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5459 */
      Py_INCREF(__pyx_v_x);
      __pyx_r = __pyx_v_x;
      goto __pyx_L0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5460 */
    Py_INCREF(__pyx_v_y);
    __pyx_r = __pyx_v_y;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    __Pyx_AddTraceback("_py_pari.max");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_x);
    Py_DECREF(__pyx_v_y);
    return __pyx_r;
  }


  static PyObject *__pyx_f_8_py_pari_prime_list(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_prime_list[] = "\n    prime_list(n): returns list of the first n primes\n\n    INPUT:\n        n -- C long\n    OUTPUT:\n        gen -- PARI list of first n primes\n    EXAMPLES:\n        >>> prime_list(0)\n        []\n        >>> prime_list(-1)\n        []\n        >>> prime_list(3)\n        [2, 3, 5]\n        >>> prime_list(10)\n        [2, 3, 5, 7, 11, 13, 17, 19, 23, 29]\n        >>> prime_list(20)\n        [2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71]\n        >>> len(prime_list(1000))\n        1000\n    ";
  static PyObject *__pyx_f_8_py_pari_prime_list(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    long __pyx_v_n;
    int __pyx_v_e;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {"n",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l", __pyx_argnames, &__pyx_v_n)) return 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5486 */
    __pyx_v_e = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5487 */
    __pyx_1 = __pyx_v_e;
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5487; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_e); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5487; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5487; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_n_prime_list);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_n_prime_list);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5487; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5488 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(primes(__pyx_v_n))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5488; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.prime_list");
    __pyx_r = 0;
    __pyx_L0:;
    return __pyx_r;
  }

  static PyObject *__pyx_k228p;

  static char (__pyx_k228[]) = "nth prime meaningless for negative n (=%s)";

  static PyObject *__pyx_f_8_py_pari_nth_prime(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_nth_prime[] = "\n    nth_prime(n): returns the n-th prime, where n is a C-int\n    ";
  static PyObject *__pyx_f_8_py_pari_nth_prime(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    long __pyx_v_n;
    GEN __pyx_v_g;
    PyObject *__pyx_v_z;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    PyObject *__pyx_5 = 0;
    PyObject *__pyx_6 = 0;
    static char *__pyx_argnames[] = {"n",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l", __pyx_argnames, &__pyx_v_n)) return 0;
    __pyx_v_z = Py_None; Py_INCREF(__pyx_v_z);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5496 */
    __pyx_1 = (__pyx_v_n <= 0);
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5497 */
      __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_ArithmeticError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5497; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5497; goto __pyx_L1;}
      __pyx_4 = PyNumber_Remainder(__pyx_k228p, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5497; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __Pyx_Raise(__pyx_2, __pyx_4, 0);
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5497; goto __pyx_L1;}
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5499 */
    __pyx_3 = PyInt_FromLong(setjmp(GP_DATA->env)); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5499; goto __pyx_L1;}
    Py_DECREF(__pyx_v_z);
    __pyx_v_z = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5500 */
    __pyx_1 = PyObject_IsTrue(__pyx_v_z); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5500; goto __pyx_L1;}
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5501 */
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_init_primes); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5501; goto __pyx_L1;}
      __pyx_4 = __Pyx_GetName(__pyx_m, __pyx_n_max); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5501; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong((2 * __pyx_v_8_py_pari_num_primes)); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5501; goto __pyx_L1;}
      __pyx_5 = PyInt_FromLong((20 * __pyx_v_n)); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5501; goto __pyx_L1;}
      __pyx_6 = PyTuple_New(2); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5501; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_6, 0, __pyx_3);
      PyTuple_SET_ITEM(__pyx_6, 1, __pyx_5);
      __pyx_3 = 0;
      __pyx_5 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_4, __pyx_6); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5501; goto __pyx_L1;}
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_6); __pyx_6 = 0;
      __pyx_5 = PyTuple_New(1); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5501; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_5, 0, __pyx_3);
      __pyx_3 = 0;
      __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_5); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5501; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5502 */
      __pyx_6 = __Pyx_GetName(__pyx_m, __pyx_n_nth_prime); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5502; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5502; goto __pyx_L1;}
      __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5502; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_2, 0, __pyx_3);
      __pyx_3 = 0;
      __pyx_5 = PyObject_CallObject(__pyx_6, __pyx_2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5502; goto __pyx_L1;}
      Py_DECREF(__pyx_6); __pyx_6 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      __pyx_r = __pyx_5;
      __pyx_5 = 0;
      goto __pyx_L0;
      goto __pyx_L3;
    }
    __pyx_L3:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5504 */
    __pyx_v_g = prime(__pyx_v_n);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5505 */
    __pyx_4 = ((PyObject *)__pyx_f_8_py_pari_new_gen(__pyx_v_g)); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5505; goto __pyx_L1;}
    __pyx_r = __pyx_4;
    __pyx_4 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    Py_XDECREF(__pyx_5);
    Py_XDECREF(__pyx_6);
    __Pyx_AddTraceback("_py_pari.nth_prime");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_z);
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_euler(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_euler[] = "\n    EXAMPLES:\n        >> euler()\n        0.57721566490153286060651209008\n        >> get_real_precision()\n        5\n        >> euler(6)\n        0.57721566490153286060651209008240243104\n        >> set_real_precision(10)\n        >> euler()\n        0.57721566490153286060651209008240243104215933593992359880576723488486772677767\n        \n    We restore precision to the default.\n        >>> set_real_precision(5)\n        \n    Note that euler is still saved to the largest precision to which it has been\n    computed so far:\n        >> euler()\n        0.57721566490153286060651209008240243104215933593992359880576723488486772677767\n    ";
  static PyObject *__pyx_f_8_py_pari_euler(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    int __pyx_v_prec;
    struct __pyx_obj_8_py_pari_gen *__pyx_v_g;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    static char *__pyx_argnames[] = {"prec",0};
    __pyx_v_prec = __pyx_k51;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|i", __pyx_argnames, &__pyx_v_prec)) return 0;
    ((PyObject*)__pyx_v_g) = Py_None; Py_INCREF(((PyObject*)__pyx_v_g));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5528 */
    __pyx_1 = (__pyx_v_prec <= 3);
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5529 */
      consteuler(__pyx_v_8_py_pari_REAL_PREC);
      goto __pyx_L2;
    }
    /*else*/ {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5531 */
      consteuler(__pyx_v_prec);
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5533 */
    __pyx_2 = PyTuple_New(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5533; goto __pyx_L1;}
    __pyx_3 = PyObject_CallObject(((PyObject*)__pyx_ptype_8_py_pari_gen), __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5533; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5533; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v_g));
    ((PyObject *)__pyx_v_g) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5534 */
    __pyx_2 = ((struct __pyx_vtabstruct_8_py_pari_gen *)__pyx_v_g->__pyx_vtab)->init(__pyx_v_g,geuler,0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5534; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5535 */
    Py_INCREF(((PyObject *)__pyx_v_g));
    __pyx_r = ((PyObject *)__pyx_v_g);
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.euler");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_g);
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_pi(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_pi[] = "\n    EXAMPLES:\n        >> set_real_precision(5)\n        >> pi()\n        3.1415926535897932384626433833\n        >> pi(6)\n        3.14159265358979323846264338327950288419\n        >> get_real_precision()\n        5\n        >> set_real_precision(10)\n        >> pi()\n        3.1415926535897932384626433832795028841971693993751058209749445923078164062862\n        \n    We restore precision to the default.\n        >> set_real_precision(5)\n        \n    Note that pi is still saved to the largest precision to which it has been\n    computed so far:\n        >> pi()\n        3.1415926535897932384626433832795028841971693993751058209749445923078164062862\n    ";
  static PyObject *__pyx_f_8_py_pari_pi(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    int __pyx_v_prec;
    struct __pyx_obj_8_py_pari_gen *__pyx_v_g;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    static char *__pyx_argnames[] = {"prec",0};
    __pyx_v_prec = __pyx_k52;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|i", __pyx_argnames, &__pyx_v_prec)) return 0;
    ((PyObject*)__pyx_v_g) = Py_None; Py_INCREF(((PyObject*)__pyx_v_g));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5559 */
    __pyx_1 = (__pyx_v_prec <= 3);
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5560 */
      constpi(__pyx_v_8_py_pari_REAL_PREC);
      goto __pyx_L2;
    }
    /*else*/ {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5562 */
      constpi(__pyx_v_prec);
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5565 */
    __pyx_2 = PyTuple_New(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5565; goto __pyx_L1;}
    __pyx_3 = PyObject_CallObject(((PyObject*)__pyx_ptype_8_py_pari_gen), __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5565; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5565; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v_g));
    ((PyObject *)__pyx_v_g) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5566 */
    __pyx_2 = ((struct __pyx_vtabstruct_8_py_pari_gen *)__pyx_v_g->__pyx_vtab)->init(__pyx_v_g,gpi,0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5566; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5567 */
    Py_INCREF(((PyObject *)__pyx_v_g));
    __pyx_r = ((PyObject *)__pyx_v_g);
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.pi");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_g);
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_factorial(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_factorial(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    long __pyx_v_n;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    static char *__pyx_argnames[] = {"n",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l", __pyx_argnames, &__pyx_v_n)) return 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5570 */
    __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(mpfact(__pyx_v_n))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5570; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    __Pyx_AddTraceback("_py_pari.factorial");
    __pyx_r = 0;
    __pyx_L0:;
    return __pyx_r;
  }

  static PyObject *__pyx_k230p;

  static char (__pyx_k230[]) = "length of entries (=%s) must equal n (=%s)";

  static PyObject *__pyx_f_8_py_pari_vector(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_vector(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    long __pyx_v_n;
    PyObject *__pyx_v_entries = 0;
    int __pyx_v_e;
    struct __pyx_obj_8_py_pari_gen *__pyx_v_v;
    PyObject *__pyx_v_i;
    PyObject *__pyx_v_x;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    PyObject *__pyx_5 = 0;
    static char *__pyx_argnames[] = {"n","entries",0};
    __pyx_v_entries = __pyx_k53;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l|O", __pyx_argnames, &__pyx_v_n, &__pyx_v_entries)) return 0;
    Py_INCREF(__pyx_v_entries);
    ((PyObject*)__pyx_v_v) = Py_None; Py_INCREF(((PyObject*)__pyx_v_v));
    __pyx_v_i = Py_None; Py_INCREF(__pyx_v_i);
    __pyx_v_x = Py_None; Py_INCREF(__pyx_v_x);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5574 */
    __pyx_v_e = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5575 */
    __pyx_1 = __pyx_v_e;
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5575; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_e); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5575; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5575; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_n_vector);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_n_vector);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5575; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5577 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(zerovec(__pyx_v_n))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5577; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v_v));
    ((PyObject *)__pyx_v_v) = __pyx_2;
    __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5578 */
    if (PyObject_Cmp(__pyx_v_entries, Py_None, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5578; goto __pyx_L1;}
    __pyx_1 = __pyx_1 != 0;
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5579 */
      __pyx_4 = __Pyx_GetName(__pyx_b, __pyx_n_len); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5579; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5579; goto __pyx_L1;}
      Py_INCREF(__pyx_v_entries);
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_entries);
      __pyx_2 = PyObject_CallObject(__pyx_4, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5579; goto __pyx_L1;}
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __pyx_4 = PyInt_FromLong(__pyx_v_n); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5579; goto __pyx_L1;}
      if (PyObject_Cmp(__pyx_2, __pyx_4, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5579; goto __pyx_L1;}
      __pyx_1 = __pyx_1 != 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      if (__pyx_1) {

        /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5580 */
        __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_IndexError); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5580; goto __pyx_L1;}
        __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_len); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5581; goto __pyx_L1;}
        __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5581; goto __pyx_L1;}
        Py_INCREF(__pyx_v_entries);
        PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_entries);
        __pyx_5 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5581; goto __pyx_L1;}
        Py_DECREF(__pyx_2); __pyx_2 = 0;
        Py_DECREF(__pyx_4); __pyx_4 = 0;
        __pyx_2 = PyInt_FromLong(__pyx_v_n); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5581; goto __pyx_L1;}
        __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5581; goto __pyx_L1;}
        PyTuple_SET_ITEM(__pyx_4, 0, __pyx_5);
        PyTuple_SET_ITEM(__pyx_4, 1, __pyx_2);
        __pyx_5 = 0;
        __pyx_2 = 0;
        __pyx_5 = PyNumber_Remainder(__pyx_k230p, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5580; goto __pyx_L1;}
        Py_DECREF(__pyx_4); __pyx_4 = 0;
        __Pyx_Raise(__pyx_3, __pyx_5, 0);
        Py_DECREF(__pyx_3); __pyx_3 = 0;
        Py_DECREF(__pyx_5); __pyx_5 = 0;
        {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5580; goto __pyx_L1;}
        goto __pyx_L4;
      }
      __pyx_L4:;

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5582 */
      __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_enumerate); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5582; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5582; goto __pyx_L1;}
      Py_INCREF(__pyx_v_entries);
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_entries);
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5582; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      __pyx_5 = PyObject_GetIter(__pyx_3); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5582; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      for (;;) {
        __pyx_L5:;
        __pyx_2 = PyIter_Next(__pyx_5);
        if (!__pyx_2) {
          if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5582; goto __pyx_L1;}
          break;
        }
        __pyx_4 = __Pyx_UnpackItem(__pyx_2, 0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5582; goto __pyx_L1;}
        Py_DECREF(__pyx_v_i);
        __pyx_v_i = __pyx_4;
        __pyx_4 = 0;
        __pyx_3 = __Pyx_UnpackItem(__pyx_2, 1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5582; goto __pyx_L1;}
        Py_DECREF(__pyx_v_x);
        __pyx_v_x = __pyx_3;
        __pyx_3 = 0;
        if (__Pyx_EndUnpack(__pyx_2, 2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5582; goto __pyx_L1;}
        Py_DECREF(__pyx_2); __pyx_2 = 0;

        /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5583 */
        if (PyObject_SetItem(((PyObject *)__pyx_v_v), __pyx_v_i, __pyx_v_x) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5583; goto __pyx_L1;}
      }
      __pyx_L6:;
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      goto __pyx_L3;
    }
    __pyx_L3:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5584 */
    Py_INCREF(((PyObject *)__pyx_v_v));
    __pyx_r = ((PyObject *)__pyx_v_v);
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    Py_XDECREF(__pyx_5);
    __Pyx_AddTraceback("_py_pari.vector");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_v);
    Py_DECREF(__pyx_v_i);
    Py_DECREF(__pyx_v_x);
    Py_DECREF(__pyx_v_entries);
    return __pyx_r;
  }

  static PyObject *__pyx_k232p;

  static char (__pyx_k232[]) = "len of entries (=%s) must be %s*%s=%s";

  static PyObject *__pyx_f_8_py_pari_matrix(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_matrix(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    long __pyx_v_m;
    long __pyx_v_n;
    PyObject *__pyx_v_entries = 0;
    int __pyx_v_e;
    int __pyx_v_i;
    int __pyx_v_j;
    int __pyx_v_k;
    struct __pyx_obj_8_py_pari_gen *__pyx_v_A;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    PyObject *__pyx_5 = 0;
    PyObject *__pyx_6 = 0;
    PyObject *__pyx_7 = 0;
    static char *__pyx_argnames[] = {"m","n","entries",0};
    __pyx_v_entries = __pyx_k54;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "ll|O", __pyx_argnames, &__pyx_v_m, &__pyx_v_n, &__pyx_v_entries)) return 0;
    Py_INCREF(__pyx_v_entries);
    ((PyObject*)__pyx_v_A) = Py_None; Py_INCREF(((PyObject*)__pyx_v_A));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5588 */
    __pyx_v_e = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5589 */
    __pyx_1 = __pyx_v_e;
    if (__pyx_1) {
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5589; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_e); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5589; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5589; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_n_matrix);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_n_matrix);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5589; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5591 */
    __pyx_2 = ((PyObject *)__pyx_f_8_py_pari_new_gen(forcecopy(zeromat(__pyx_v_m,__pyx_v_n)))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5591; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v_A));
    ((PyObject *)__pyx_v_A) = __pyx_2;
    __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5592 */
    if (PyObject_Cmp(__pyx_v_entries, Py_None, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5592; goto __pyx_L1;}
    __pyx_1 = __pyx_1 != 0;
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5593 */
      __pyx_4 = __Pyx_GetName(__pyx_b, __pyx_n_len); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5593; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5593; goto __pyx_L1;}
      Py_INCREF(__pyx_v_entries);
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_entries);
      __pyx_2 = PyObject_CallObject(__pyx_4, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5593; goto __pyx_L1;}
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __pyx_4 = PyInt_FromLong((__pyx_v_m * __pyx_v_n)); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5593; goto __pyx_L1;}
      if (PyObject_Cmp(__pyx_2, __pyx_4, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5593; goto __pyx_L1;}
      __pyx_1 = __pyx_1 != 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      if (__pyx_1) {

        /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5594 */
        __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_IndexError); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5594; goto __pyx_L1;}
        __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_len); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5594; goto __pyx_L1;}
        __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5594; goto __pyx_L1;}
        Py_INCREF(__pyx_v_entries);
        PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_entries);
        __pyx_5 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5594; goto __pyx_L1;}
        Py_DECREF(__pyx_2); __pyx_2 = 0;
        Py_DECREF(__pyx_4); __pyx_4 = 0;
        __pyx_2 = PyInt_FromLong(__pyx_v_m); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5594; goto __pyx_L1;}
        __pyx_4 = PyInt_FromLong(__pyx_v_n); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5594; goto __pyx_L1;}
        __pyx_6 = PyInt_FromLong((__pyx_v_m * __pyx_v_n)); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5594; goto __pyx_L1;}
        __pyx_7 = PyTuple_New(4); if (!__pyx_7) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5594; goto __pyx_L1;}
        PyTuple_SET_ITEM(__pyx_7, 0, __pyx_5);
        PyTuple_SET_ITEM(__pyx_7, 1, __pyx_2);
        PyTuple_SET_ITEM(__pyx_7, 2, __pyx_4);
        PyTuple_SET_ITEM(__pyx_7, 3, __pyx_6);
        __pyx_5 = 0;
        __pyx_2 = 0;
        __pyx_4 = 0;
        __pyx_6 = 0;
        __pyx_5 = PyNumber_Remainder(__pyx_k232p, __pyx_7); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5594; goto __pyx_L1;}
        Py_DECREF(__pyx_7); __pyx_7 = 0;
        __Pyx_Raise(__pyx_3, __pyx_5, 0);
        Py_DECREF(__pyx_3); __pyx_3 = 0;
        Py_DECREF(__pyx_5); __pyx_5 = 0;
        {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5594; goto __pyx_L1;}
        goto __pyx_L4;
      }
      __pyx_L4:;

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5595 */
      __pyx_v_k = 0;

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5596 */
      for (__pyx_v_i = 0; __pyx_v_i < __pyx_v_m; ++__pyx_v_i) {

        /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5597 */
        for (__pyx_v_j = 0; __pyx_v_j < __pyx_v_n; ++__pyx_v_j) {

          /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5598 */
          __pyx_2 = PyInt_FromLong(__pyx_v_k); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5598; goto __pyx_L1;}
          __pyx_4 = PyObject_GetItem(__pyx_v_entries, __pyx_2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5598; goto __pyx_L1;}
          Py_DECREF(__pyx_2); __pyx_2 = 0;
          __pyx_6 = PyInt_FromLong(__pyx_v_i); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5598; goto __pyx_L1;}
          __pyx_7 = PyInt_FromLong(__pyx_v_j); if (!__pyx_7) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5598; goto __pyx_L1;}
          __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5598; goto __pyx_L1;}
          PyTuple_SET_ITEM(__pyx_3, 0, __pyx_6);
          PyTuple_SET_ITEM(__pyx_3, 1, __pyx_7);
          __pyx_6 = 0;
          __pyx_7 = 0;
          if (PyObject_SetItem(((PyObject *)__pyx_v_A), __pyx_3, __pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5598; goto __pyx_L1;}
          Py_DECREF(__pyx_3); __pyx_3 = 0;
          Py_DECREF(__pyx_4); __pyx_4 = 0;

          /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5599 */
          __pyx_v_k = (__pyx_v_k + 1);
          __pyx_L7:;
        }
        __pyx_L8:;
        __pyx_L5:;
      }
      __pyx_L6:;
      goto __pyx_L3;
    }
    __pyx_L3:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5600 */
    Py_INCREF(((PyObject *)__pyx_v_A));
    __pyx_r = ((PyObject *)__pyx_v_A);
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    Py_XDECREF(__pyx_5);
    Py_XDECREF(__pyx_6);
    Py_XDECREF(__pyx_7);
    __Pyx_AddTraceback("_py_pari.matrix");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_A);
    Py_DECREF(__pyx_v_entries);
    return __pyx_r;
  }

  static PyObject *__pyx_n_isprime;
  static PyObject *__pyx_n_znprimroot;
  static PyObject *__pyx_n_lift;
  static PyObject *__pyx_n_Mod;
  static PyObject *__pyx_n_charpoly;

  static PyObject *__pyx_k233p;
  static PyObject *__pyx_k234p;
  static PyObject *__pyx_k235p;

  static char (__pyx_k233[]) = "error in finitefield_init";
  static char (__pyx_k234[]) = "Degree n (=%s) must be at least 1.";
  static char (__pyx_k235[]) = "Prime p (=%s) must be prime.";

  static PyObject *__pyx_f_8_py_pari_finitefield_init(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_finitefield_init[] = "\n    \n    finitefield_init(p, long n, var=\"x\"): Return a polynomial f(x) so\n    that the extension of F_p of degree n is k = F_p[x]/(f).  Moreover,\n    the element x (mod f) of k is a generator for the multiplicative\n    group of k.\n    \n    INPUT:\n        p -- int, a prime number\n        n -- int, positive integer\n        var -- str, default to \"x\", but could be any pari variable. \n    OUTPUT:\n        pari polynomial mod p -- defines field\n    EXAMPLES:\n        >>> finitefield_init(97,1)\n        Mod(1, 97)*x + Mod(92, 97)\n\n    The last entry in each of the following two lines is\n    determined by a random algorithm.\n        >> finitefield_init(7,2)    \n        Mod(1, 7)*x^2 + Mod(6, 7)*x + Mod(3, 7)\n        >> finitefield_init(2,3)\n        Mod(1, 2)*x^3 + Mod(1, 2)*x^2 + Mod(1, 2)\n    ";
  static PyObject *__pyx_f_8_py_pari_finitefield_init(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_p = 0;
    long __pyx_v_n;
    PyObject *__pyx_v_var = 0;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__p;
    struct __pyx_obj_8_py_pari_gen *__pyx_v__f2;
    struct __pyx_obj_8_py_pari_gen *__pyx_v_s;
    int __pyx_v_err;
    long __pyx_v_x;
    GEN __pyx_v_v;
    GEN __pyx_v_g;
    PyObject *__pyx_v_f;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    int __pyx_5;
    int __pyx_6;
    static char *__pyx_argnames[] = {"p","n","var",0};
    __pyx_v_var = __pyx_k55;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "Ol|O", __pyx_argnames, &__pyx_v_p, &__pyx_v_n, &__pyx_v_var)) return 0;
    Py_INCREF(__pyx_v_p);
    Py_INCREF(__pyx_v_var);
    ((PyObject*)__pyx_v__p) = Py_None; Py_INCREF(((PyObject*)__pyx_v__p));
    ((PyObject*)__pyx_v__f2) = Py_None; Py_INCREF(((PyObject*)__pyx_v__f2));
    ((PyObject*)__pyx_v_s) = Py_None; Py_INCREF(((PyObject*)__pyx_v_s));
    __pyx_v_f = Py_None; Py_INCREF(__pyx_v_f);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5631 */
    __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5631; goto __pyx_L1;}
    __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_int); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5631; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5631; goto __pyx_L1;}
    Py_INCREF(__pyx_v_p);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_p);
    __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5631; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5631; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_4);
    __pyx_4 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5631; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5631; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__p));
    ((PyObject *)__pyx_v__p) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5632 */
    __pyx_v_err = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5633 */
    __pyx_5 = __pyx_v_err;
    if (__pyx_5) {
      __pyx_4 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5633; goto __pyx_L1;}
      __pyx_1 = PyInt_FromLong(__pyx_v_err); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5633; goto __pyx_L1;}
      __pyx_2 = PyTuple_New(2); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5633; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_2, 0, __pyx_1);
      Py_INCREF(__pyx_k233p);
      PyTuple_SET_ITEM(__pyx_2, 1, __pyx_k233p);
      __pyx_1 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_4, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5633; goto __pyx_L1;}
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5634 */
    __pyx_5 = (__pyx_v_n < 1);
    if (__pyx_5) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5635 */
      __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_ArithmeticError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5635; goto __pyx_L1;}
      __pyx_4 = PyInt_FromLong(__pyx_v_n); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5635; goto __pyx_L1;}
      __pyx_2 = PyNumber_Remainder(__pyx_k234p, __pyx_4); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5635; goto __pyx_L1;}
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      __Pyx_Raise(__pyx_1, __pyx_2, 0);
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5635; goto __pyx_L1;}
      goto __pyx_L3;
    }
    __pyx_L3:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5636 */
    __pyx_3 = PyInt_FromLong(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5636; goto __pyx_L1;}
    if (PyObject_Cmp(((PyObject *)__pyx_v__p), __pyx_3, &__pyx_5) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5636; goto __pyx_L1;}
    __pyx_5 = __pyx_5 < 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    if (!__pyx_5) {
      __pyx_4 = PyObject_GetAttr(((PyObject *)__pyx_v__p), __pyx_n_isprime); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5636; goto __pyx_L1;}
      __pyx_1 = PyTuple_New(0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5636; goto __pyx_L1;}
      __pyx_2 = PyObject_CallObject(__pyx_4, __pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5636; goto __pyx_L1;}
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      __pyx_6 = PyObject_IsTrue(__pyx_2); if (__pyx_6 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5636; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      __pyx_5 = (!__pyx_6);
    }
    if (__pyx_5) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5637 */
      __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_ArithmeticError); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5637; goto __pyx_L1;}
      __pyx_4 = PyNumber_Remainder(__pyx_k235p, ((PyObject *)__pyx_v__p)); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5637; goto __pyx_L1;}
      __Pyx_Raise(__pyx_3, __pyx_4, 0);
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5637; goto __pyx_L1;}
      goto __pyx_L4;
    }
    __pyx_L4:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5638 */
    __pyx_v_x = __pyx_f_8_py_pari_get_var(__pyx_v_var);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5639 */
    __pyx_6 = (__pyx_v_n == 1);
    if (__pyx_6) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5640 */
      __pyx_1 = ((PyObject *)__pyx_f_8_py_pari_new_gen(ffinit(__pyx_v__p->g,__pyx_v_n,__pyx_v_x))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5640; goto __pyx_L1;}
      __pyx_2 = PyObject_GetAttr(((PyObject *)__pyx_v__p), __pyx_n_znprimroot); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5640; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5640; goto __pyx_L1;}
      __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5640; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __pyx_2 = PyNumber_Subtract(__pyx_1, __pyx_4); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5640; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      __pyx_r = __pyx_2;
      __pyx_2 = 0;
      goto __pyx_L0;
      goto __pyx_L5;
    }
    __pyx_L5:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5642 */
    __pyx_3 = ((PyObject *)__pyx_f_8_py_pari_new_gen(ffinit(forcecopy(__pyx_v__p->g),__pyx_v_n,__pyx_v_x))); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5642; goto __pyx_L1;}
    Py_DECREF(__pyx_v_f);
    __pyx_v_f = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5643 */
    __pyx_1 = PyObject_GetAttr(__pyx_v_f, __pyx_n_lift); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5643; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5643; goto __pyx_L1;}
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_4); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5643; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    if (!__Pyx_TypeTest(__pyx_2, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5643; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v__f2));
    ((PyObject *)__pyx_v__f2) = __pyx_2;
    __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5644 */
    __pyx_v_g = FpXQ_gener(forcecopy(__pyx_v__f2->g),forcecopy(__pyx_v__p->g));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5645 */
    __pyx_3 = ((PyObject *)__pyx_f_8_py_pari_new_gen(__pyx_v_g)); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5645; goto __pyx_L1;}
    __pyx_1 = PyObject_GetAttr(((PyObject *)__pyx_v_8_py_pari_ONE), __pyx_n_Mod); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5645; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5645; goto __pyx_L1;}
    Py_INCREF(__pyx_v_p);
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_p);
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_4); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5645; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_1 = PyNumber_Multiply(__pyx_3, __pyx_2); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5645; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_1, __pyx_ptype_8_py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5645; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v_s));
    ((PyObject *)__pyx_v_s) = __pyx_1;
    __pyx_1 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5646 */
    __pyx_4 = PyObject_GetAttr(((PyObject *)__pyx_v_s), __pyx_n_Mod); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5646; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5646; goto __pyx_L1;}
    Py_INCREF(__pyx_v_f);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_f);
    __pyx_2 = PyObject_CallObject(__pyx_4, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5646; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_1 = PyObject_GetAttr(__pyx_2, __pyx_n_charpoly); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5646; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5646; goto __pyx_L1;}
    Py_INCREF(__pyx_v_var);
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_var);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5646; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.finitefield_init");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v__p);
    Py_DECREF(__pyx_v__f2);
    Py_DECREF(__pyx_v_s);
    Py_DECREF(__pyx_v_f);
    Py_DECREF(__pyx_v_p);
    Py_DECREF(__pyx_v_var);
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_set_real_precision(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_set_real_precision[] = "\n    Set the default precision to n words (word = 4 bytes on\n    a 32-bit machine). \n    \n    EXAMPLES:\n        >>> get_real_precision()\n        5\n        >>> set_real_precision(10)\n        >>> get_real_precision()\n        10\n        >>> set_real_precision(5)        \n    ";
  static PyObject *__pyx_f_8_py_pari_set_real_precision(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    long __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    static char *__pyx_argnames[] = {"n",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l", __pyx_argnames, &__pyx_v_n)) return 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5703 */
    __pyx_1 = (__pyx_v_n <= 2);
    if (__pyx_1) {
      __pyx_v_n = 3;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5704 */
    __pyx_v_8_py_pari_REAL_PREC = __pyx_v_n;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    __Pyx_AddTraceback("_py_pari.set_real_precision");
    __pyx_r = 0;
    __pyx_L0:;
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_get_real_precision(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_get_real_precision[] = "\n    EXAMPLES:\n        >>> get_real_precision()\n        5\n        >>> set_real_precision(10)\n        >>> get_real_precision()\n        10\n        >>> set_real_precision(5)\n    ";
  static PyObject *__pyx_f_8_py_pari_get_real_precision(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5717 */
    __pyx_1 = PyInt_FromLong(__pyx_v_8_py_pari_REAL_PREC); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5717; goto __pyx_L1;}
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    __Pyx_AddTraceback("_py_pari.get_real_precision");
    __pyx_r = 0;
    __pyx_L0:;
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_set_series_precision(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_set_series_precision[] = "\n    Set the default precision used when coercing objects into power series.\n    \n    EXAMPLES:\n        >>> default = get_series_precision()\n        >>> f = pari(\'1+x + x^2 + x^3\')\n        >>> set_series_precision(3)\n        >>> f.exp()\n        2.7182818284590452353602874714 + 2.7182818284590452353602874714*x + 4.0774227426885678530404312070*x^2 + 5.8896106283279313432806228546*x^3 + O(x^4)\n        >>> set_series_precision(10)\n        >>> f.exp()\n        2.7182818284590452353602874714 + 2.7182818284590452353602874714*x + 4.0774227426885678530404312070*x^2 + 5.8896106283279313432806228546*x^3 + 5.5498253997705506888605869206*x^4 + 5.9122629768984233869086252502*x^5 + 5.7801242769038864657452779426*x^6 + 4.8934466328589121865920413149*x^7 + 4.2738105146702444098510591188*x^8 + 3.4890085123444142422523306196*x^9 + O(x^10)\n        >>> set_series_precision(default)\n    ";
  static PyObject *__pyx_f_8_py_pari_set_series_precision(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    long __pyx_v_n;
    PyObject *__pyx_r;
    int __pyx_1;
    static char *__pyx_argnames[] = {"n",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l", __pyx_argnames, &__pyx_v_n)) return 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5735 */
    __pyx_1 = (__pyx_v_n <= 2);
    if (__pyx_1) {
      __pyx_v_n = 3;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5736 */
    precdl = __pyx_v_n;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    __Pyx_AddTraceback("_py_pari.set_series_precision");
    __pyx_r = 0;
    __pyx_L0:;
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_get_series_precision(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_get_series_precision[] = "\n    Get the default precision used when coercing objects into power series.\n    \n    EXAMPLES:\n        >>> get_series_precision()\n        16\n    ";
  static PyObject *__pyx_f_8_py_pari_get_series_precision(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    static char *__pyx_argnames[] = {0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5747 */
    __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_int); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5747; goto __pyx_L1;}
    __pyx_2 = PyLong_FromUnsignedLong(precdl); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5747; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5747; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
    __pyx_2 = 0;
    __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5747; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.get_series_precision");
    __pyx_r = 0;
    __pyx_L0:;
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_series_precision(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari_series_precision(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_new_val = 0;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {"new_val",0};
    __pyx_v_new_val = __pyx_k56;
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_new_val)) return 0;
    Py_INCREF(__pyx_v_new_val);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5750 */
    if (PyObject_Cmp(__pyx_v_new_val, Py_None, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5750; goto __pyx_L1;}
    __pyx_1 = __pyx_1 != 0;
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5751 */
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_set_series_precision); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5751; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5751; goto __pyx_L1;}
      Py_INCREF(__pyx_v_new_val);
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_new_val);
      __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5751; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5752 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_get_series_precision); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5752; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5752; goto __pyx_L1;}
    __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5752; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_r = __pyx_4;
    __pyx_4 = 0;
    goto __pyx_L0;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.series_precision");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_new_val);
    return __pyx_r;
  }

  static PyObject *__pyx_f_8_py_pari_init_primes(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_init_primes[] = "\n    Recompute the primes table including at least all primes up to M.\n    \n    EXAMPLES:\n        >>> init_primes(200000)\n    ";
  static PyObject *__pyx_f_8_py_pari_init_primes(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    unsigned long __pyx_v_M;
    PyObject *__pyx_r;
    static char *__pyx_argnames[] = {"M",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l", __pyx_argnames, &__pyx_v_M)) return 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5762 */
    free(((void (*))diffptr));

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5763 */
    __pyx_v_8_py_pari_num_primes = __pyx_v_M;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5764 */
    diffptr = initprimes(__pyx_v_M);

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    __Pyx_AddTraceback("_py_pari.init_primes");
    __pyx_r = 0;
    __pyx_L0:;
    return __pyx_r;
  }

  static PyObject *__pyx_k236p;

  static char (__pyx_k236[]) = "error in import_pari_script";

  static PyObject *__pyx_f_8_py_pari___read_script(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static PyObject *__pyx_f_8_py_pari___read_script(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    char (*__pyx_v_s);
    int __pyx_v_err;
    pari_sp __pyx_v_av;
    PyObject *__pyx_r;
    int __pyx_1;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    static char *__pyx_argnames[] = {"s",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "s", __pyx_argnames, &__pyx_v_s)) return 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5769 */
    __pyx_v_err = setjmp(GP_DATA->env);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5770 */
    __pyx_1 = __pyx_v_err;
    if (__pyx_1) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5771 */
      __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5771; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(__pyx_v_err); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5771; goto __pyx_L1;}
      __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5771; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
      Py_INCREF(__pyx_k236p);
      PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k236p);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5771; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_4); __pyx_4 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      goto __pyx_L2;
    }
    __pyx_L2:;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5772 */
    flisseq(__pyx_v_s);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5774 */
    top = avma;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    __Pyx_AddTraceback("_py_pari.__read_script");
    __pyx_r = 0;
    __pyx_L0:;
    return __pyx_r;
  }

  static PyObject *__pyx_n_open;

  static PyObject *__pyx_k237p;
  static PyObject *__pyx_k238p;

  static char (__pyx_k237[]) = "{";
    static char (__pyx_k238[]) = "}";

  static PyObject *__pyx_f_8_py_pari_read(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
  static char __pyx_doc_8_py_pari_read[] = "\n    Read a script from the named filename into the interpreter, where\n    s is a string.  The functions defined in the script are then\n    available for use from SAGE/PARI.\n\n    EXAMPLE:\n    \n        If foo.gp is a script that contains\n            {foo(n) =\n                n^2\n            }\n        and you type read(\"foo.gp\"), then the command\n        pari(\"foo(12)\") will create the Python/PARI gen which\n        is the integer 144.\n\n    CONSTRAINTS:    \n        The PARI script must *not* contain the following function calls:\n\n             print, default, ???    (please report any others that cause trouble)\n\n        Also multiline functions should be written in the following form:\n\n            {foo(x) =\n                code...\n            }\n\n        and *NOT* in the form\n\n            foo(x) =\n            {\n                    code...\n            }\n    ";
  static PyObject *__pyx_f_8_py_pari_read(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
    PyObject *__pyx_v_filename = 0;
    PyObject *__pyx_v_F;
    PyObject *__pyx_v_i;
    PyObject *__pyx_v_j;
    PyObject *__pyx_r;
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    int __pyx_4;
    int __pyx_5;
    static char *__pyx_argnames[] = {"filename",0};
    if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_filename)) return 0;
    Py_INCREF(__pyx_v_filename);
    __pyx_v_F = Py_None; Py_INCREF(__pyx_v_F);
    __pyx_v_i = Py_None; Py_INCREF(__pyx_v_i);
    __pyx_v_j = Py_None; Py_INCREF(__pyx_v_j);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5810 */
    __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_open); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5810; goto __pyx_L1;}
    __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5810; goto __pyx_L1;}
    Py_INCREF(__pyx_v_filename);
    PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_filename);
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5810; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_1 = PyObject_GetAttr(__pyx_3, __pyx_n_read); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5810; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_2 = PyTuple_New(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5810; goto __pyx_L1;}
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5810; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_v_F);
    __pyx_v_F = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5811 */
    while (1) {
      __pyx_L2:;
      __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_True); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5811; goto __pyx_L1;}
      __pyx_4 = PyObject_IsTrue(__pyx_1); if (__pyx_4 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5811; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      if (!__pyx_4) break;

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5812 */
      __pyx_2 = PyObject_GetAttr(__pyx_v_F, __pyx_n_find); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5812; goto __pyx_L1;}
      __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5812; goto __pyx_L1;}
      Py_INCREF(__pyx_k237p);
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_k237p);
      __pyx_1 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5812; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_v_i);
      __pyx_v_i = __pyx_1;
      __pyx_1 = 0;

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5813 */
      __pyx_2 = PyInt_FromLong((-1)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5813; goto __pyx_L1;}
      if (PyObject_Cmp(__pyx_v_i, __pyx_2, &__pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5813; goto __pyx_L1;}
      __pyx_4 = __pyx_4 == 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      if (__pyx_4) {

        /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5814 */
        __pyx_3 = __Pyx_GetName(__pyx_m, __pyx_n___read_script); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5814; goto __pyx_L1;}
        __pyx_1 = PyTuple_New(1); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5814; goto __pyx_L1;}
        Py_INCREF(__pyx_v_F);
        PyTuple_SET_ITEM(__pyx_1, 0, __pyx_v_F);
        __pyx_2 = PyObject_CallObject(__pyx_3, __pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5814; goto __pyx_L1;}
        Py_DECREF(__pyx_3); __pyx_3 = 0;
        Py_DECREF(__pyx_1); __pyx_1 = 0;
        Py_DECREF(__pyx_2); __pyx_2 = 0;

        /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5815 */
        goto __pyx_L3;
        goto __pyx_L4;
      }
      __pyx_L4:;

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5816 */
      __pyx_3 = __Pyx_GetName(__pyx_m, __pyx_n___read_script); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5816; goto __pyx_L1;}
      __pyx_4 = PyInt_AsLong(__pyx_v_i); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5816; goto __pyx_L1;}
      __pyx_1 = PySequence_GetSlice(__pyx_v_F, 0, __pyx_4); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5816; goto __pyx_L1;}
      __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5816; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_2, 0, __pyx_1);
      __pyx_1 = 0;
      __pyx_1 = PyObject_CallObject(__pyx_3, __pyx_2); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5816; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_1); __pyx_1 = 0;

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5817 */
      __pyx_4 = PyInt_AsLong(__pyx_v_i); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5817; goto __pyx_L1;}
      __pyx_3 = PySequence_GetSlice(__pyx_v_F, __pyx_4, 0x7fffffff); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5817; goto __pyx_L1;}
      __pyx_2 = PyObject_GetAttr(__pyx_3, __pyx_n_find); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5817; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __pyx_1 = PyTuple_New(1); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5817; goto __pyx_L1;}
      Py_INCREF(__pyx_k238p);
      PyTuple_SET_ITEM(__pyx_1, 0, __pyx_k238p);
      __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5817; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      __pyx_2 = PyNumber_Add(__pyx_3, __pyx_v_i); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5817; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      Py_DECREF(__pyx_v_j);
      __pyx_v_j = __pyx_2;
      __pyx_2 = 0;

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5818 */
      __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n___read_script); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5818; goto __pyx_L1;}
      __pyx_4 = PyInt_AsLong(__pyx_v_i); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5818; goto __pyx_L1;}
      __pyx_3 = PyInt_FromLong(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5818; goto __pyx_L1;}
      __pyx_2 = PyNumber_Add(__pyx_v_j, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5818; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __pyx_5 = PyInt_AsLong(__pyx_2); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5818; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      __pyx_3 = PySequence_GetSlice(__pyx_v_F, __pyx_4, __pyx_5); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5818; goto __pyx_L1;}
      __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5818; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_2, 0, __pyx_3);
      __pyx_3 = 0;
      __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5818; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5819 */
      __pyx_1 = PyInt_FromLong(1); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5819; goto __pyx_L1;}
      __pyx_2 = PyNumber_Add(__pyx_v_j, __pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5819; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      __pyx_4 = PyInt_AsLong(__pyx_2); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5819; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;
      __pyx_3 = PySequence_GetSlice(__pyx_v_F, __pyx_4, 0x7fffffff); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5819; goto __pyx_L1;}
      Py_DECREF(__pyx_v_F);
      __pyx_v_F = __pyx_3;
      __pyx_3 = 0;
    }
    __pyx_L3:;

    __pyx_r = Py_None; Py_INCREF(__pyx_r);
    goto __pyx_L0;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    __Pyx_AddTraceback("_py_pari.read");
    __pyx_r = 0;
    __pyx_L0:;
    Py_DECREF(__pyx_v_F);
    Py_DECREF(__pyx_v_i);
    Py_DECREF(__pyx_v_j);
    Py_DECREF(__pyx_v_filename);
    return __pyx_r;
  }

  static __Pyx_InternTabEntry __pyx_intern_tab[] = {
    {&__pyx_n_ArithmeticError, "ArithmeticError"},
    {&__pyx_n_AttributeError, "AttributeError"},
    {&__pyx_n_False, "False"},
    {&__pyx_n_IndexError, "IndexError"},
    {&__pyx_n_InputError, "InputError"},
    {&__pyx_n_KeyboardInterrupt, "KeyboardInterrupt"},
    {&__pyx_n_MemoryError, "MemoryError"},
    {&__pyx_n_Mod, "Mod"},
    {&__pyx_n_OverflowError, "OverflowError"},
    {&__pyx_n_RuntimeError, "RuntimeError"},
    {&__pyx_n_SIGINT, "SIGINT"},
    {&__pyx_n_True, "True"},
    {&__pyx_n_TypeError, "TypeError"},
    {&__pyx_n_ValueError, "ValueError"},
    {&__pyx_n___cmp__, "__cmp__"},
    {&__pyx_n___read_script, "__read_script"},
    {&__pyx_n___setitem__, "__setitem__"},
    {&__pyx_n__add, "_add"},
    {&__pyx_n__div, "_div"},
    {&__pyx_n__error, "_error"},
    {&__pyx_n__init, "_init"},
    {&__pyx_n__mod, "_mod"},
    {&__pyx_n__mul, "_mul"},
    {&__pyx_n__sub, "_sub"},
    {&__pyx_n_abs, "abs"},
    {&__pyx_n_append, "append"},
    {&__pyx_n_bezout, "bezout"},
    {&__pyx_n_bool, "bool"},
    {&__pyx_n_charpoly, "charpoly"},
    {&__pyx_n_ellan, "ellan"},
    {&__pyx_n_enumerate, "enumerate"},
    {&__pyx_n_euler, "euler"},
    {&__pyx_n_eval, "eval"},
    {&__pyx_n_execute, "execute"},
    {&__pyx_n_factorial, "factorial"},
    {&__pyx_n_find, "find"},
    {&__pyx_n_finitefield_init, "finitefield_init"},
    {&__pyx_n_float, "float"},
    {&__pyx_n_gc, "gc"},
    {&__pyx_n_get_real_precision, "get_real_precision"},
    {&__pyx_n_get_series_precision, "get_series_precision"},
    {&__pyx_n_init_fmt, "init_fmt"},
    {&__pyx_n_init_primes, "init_primes"},
    {&__pyx_n_initialized, "initialized"},
    {&__pyx_n_int, "int"},
    {&__pyx_n_isinstance, "isinstance"},
    {&__pyx_n_isprime, "isprime"},
    {&__pyx_n_len, "len"},
    {&__pyx_n_lift, "lift"},
    {&__pyx_n_list, "list"},
    {&__pyx_n_long, "long"},
    {&__pyx_n_matrix, "matrix"},
    {&__pyx_n_max, "max"},
    {&__pyx_n_min, "min"},
    {&__pyx_n_my_sigint, "my_sigint"},
    {&__pyx_n_ncols, "ncols"},
    {&__pyx_n_nrows, "nrows"},
    {&__pyx_n_nth_prime, "nth_prime"},
    {&__pyx_n_open, "open"},
    {&__pyx_n_pari, "pari"},
    {&__pyx_n_pi, "pi"},
    {&__pyx_n_polcoeff, "polcoeff"},
    {&__pyx_n_prime_list, "prime_list"},
    {&__pyx_n_py_pari_py, "py_pari_py"},
    {&__pyx_n_python, "python"},
    {&__pyx_n_read, "read"},
    {&__pyx_n_replace, "replace"},
    {&__pyx_n_series_precision, "series_precision"},
    {&__pyx_n_set_real_precision, "set_real_precision"},
    {&__pyx_n_set_series_precision, "set_series_precision"},
    {&__pyx_n_signal, "signal"},
    {&__pyx_n_stack_available, "stack_available"},
    {&__pyx_n_stack_bottom, "stack_bottom"},
    {&__pyx_n_stack_ptr, "stack_ptr"},
    {&__pyx_n_stack_size, "stack_size"},
    {&__pyx_n_stack_top, "stack_top"},
    {&__pyx_n_stack_usage, "stack_usage"},
    {&__pyx_n_str, "str"},
    {&__pyx_n_sys, "sys"},
    {&__pyx_n_t_VEC, "t_VEC"},
    {&__pyx_n_tuple, "tuple"},
    {&__pyx_n_type, "type"},
    {&__pyx_n_vector, "vector"},
    {&__pyx_n_xrange, "xrange"},
    {&__pyx_n_z, "z"},
    {&__pyx_n_znprimroot, "znprimroot"},
    {0, 0}
  };

  static __Pyx_StringTabEntry __pyx_string_tab[] = {
    {&__pyx_k49p, __pyx_k49, sizeof(__pyx_k49)},
    {&__pyx_k57p, __pyx_k57, sizeof(__pyx_k57)},
    {&__pyx_k59p, __pyx_k59, sizeof(__pyx_k59)},
    {&__pyx_k61p, __pyx_k61, sizeof(__pyx_k61)},
    {&__pyx_k63p, __pyx_k63, sizeof(__pyx_k63)},
    {&__pyx_k64p, __pyx_k64, sizeof(__pyx_k64)},
    {&__pyx_k65p, __pyx_k65, sizeof(__pyx_k65)},
    {&__pyx_k66p, __pyx_k66, sizeof(__pyx_k66)},
    {&__pyx_k67p, __pyx_k67, sizeof(__pyx_k67)},
    {&__pyx_k68p, __pyx_k68, sizeof(__pyx_k68)},
    {&__pyx_k69p, __pyx_k69, sizeof(__pyx_k69)},
    {&__pyx_k70p, __pyx_k70, sizeof(__pyx_k70)},
    {&__pyx_k71p, __pyx_k71, sizeof(__pyx_k71)},
    {&__pyx_k72p, __pyx_k72, sizeof(__pyx_k72)},
    {&__pyx_k73p, __pyx_k73, sizeof(__pyx_k73)},
    {&__pyx_k74p, __pyx_k74, sizeof(__pyx_k74)},
    {&__pyx_k75p, __pyx_k75, sizeof(__pyx_k75)},
    {&__pyx_k76p, __pyx_k76, sizeof(__pyx_k76)},
    {&__pyx_k77p, __pyx_k77, sizeof(__pyx_k77)},
    {&__pyx_k79p, __pyx_k79, sizeof(__pyx_k79)},
    {&__pyx_k80p, __pyx_k80, sizeof(__pyx_k80)},
    {&__pyx_k81p, __pyx_k81, sizeof(__pyx_k81)},
    {&__pyx_k84p, __pyx_k84, sizeof(__pyx_k84)},
    {&__pyx_k85p, __pyx_k85, sizeof(__pyx_k85)},
    {&__pyx_k86p, __pyx_k86, sizeof(__pyx_k86)},
    {&__pyx_k87p, __pyx_k87, sizeof(__pyx_k87)},
    {&__pyx_k88p, __pyx_k88, sizeof(__pyx_k88)},
    {&__pyx_k89p, __pyx_k89, sizeof(__pyx_k89)},
    {&__pyx_k90p, __pyx_k90, sizeof(__pyx_k90)},
    {&__pyx_k91p, __pyx_k91, sizeof(__pyx_k91)},
    {&__pyx_k92p, __pyx_k92, sizeof(__pyx_k92)},
    {&__pyx_k93p, __pyx_k93, sizeof(__pyx_k93)},
    {&__pyx_k94p, __pyx_k94, sizeof(__pyx_k94)},
    {&__pyx_k95p, __pyx_k95, sizeof(__pyx_k95)},
    {&__pyx_k96p, __pyx_k96, sizeof(__pyx_k96)},
    {&__pyx_k97p, __pyx_k97, sizeof(__pyx_k97)},
    {&__pyx_k98p, __pyx_k98, sizeof(__pyx_k98)},
    {&__pyx_k99p, __pyx_k99, sizeof(__pyx_k99)},
    {&__pyx_k100p, __pyx_k100, sizeof(__pyx_k100)},
    {&__pyx_k102p, __pyx_k102, sizeof(__pyx_k102)},
    {&__pyx_k103p, __pyx_k103, sizeof(__pyx_k103)},
    {&__pyx_k105p, __pyx_k105, sizeof(__pyx_k105)},
    {&__pyx_k107p, __pyx_k107, sizeof(__pyx_k107)},
    {&__pyx_k108p, __pyx_k108, sizeof(__pyx_k108)},
    {&__pyx_k109p, __pyx_k109, sizeof(__pyx_k109)},
    {&__pyx_k110p, __pyx_k110, sizeof(__pyx_k110)},
    {&__pyx_k111p, __pyx_k111, sizeof(__pyx_k111)},
    {&__pyx_k112p, __pyx_k112, sizeof(__pyx_k112)},
    {&__pyx_k113p, __pyx_k113, sizeof(__pyx_k113)},
    {&__pyx_k114p, __pyx_k114, sizeof(__pyx_k114)},
    {&__pyx_k115p, __pyx_k115, sizeof(__pyx_k115)},
    {&__pyx_k116p, __pyx_k116, sizeof(__pyx_k116)},
    {&__pyx_k117p, __pyx_k117, sizeof(__pyx_k117)},
    {&__pyx_k118p, __pyx_k118, sizeof(__pyx_k118)},
    {&__pyx_k119p, __pyx_k119, sizeof(__pyx_k119)},
    {&__pyx_k120p, __pyx_k120, sizeof(__pyx_k120)},
    {&__pyx_k121p, __pyx_k121, sizeof(__pyx_k121)},
    {&__pyx_k122p, __pyx_k122, sizeof(__pyx_k122)},
    {&__pyx_k123p, __pyx_k123, sizeof(__pyx_k123)},
    {&__pyx_k124p, __pyx_k124, sizeof(__pyx_k124)},
    {&__pyx_k125p, __pyx_k125, sizeof(__pyx_k125)},
    {&__pyx_k126p, __pyx_k126, sizeof(__pyx_k126)},
    {&__pyx_k127p, __pyx_k127, sizeof(__pyx_k127)},
    {&__pyx_k128p, __pyx_k128, sizeof(__pyx_k128)},
    {&__pyx_k129p, __pyx_k129, sizeof(__pyx_k129)},
    {&__pyx_k130p, __pyx_k130, sizeof(__pyx_k130)},
    {&__pyx_k131p, __pyx_k131, sizeof(__pyx_k131)},
    {&__pyx_k132p, __pyx_k132, sizeof(__pyx_k132)},
    {&__pyx_k133p, __pyx_k133, sizeof(__pyx_k133)},
    {&__pyx_k134p, __pyx_k134, sizeof(__pyx_k134)},
    {&__pyx_k135p, __pyx_k135, sizeof(__pyx_k135)},
    {&__pyx_k136p, __pyx_k136, sizeof(__pyx_k136)},
    {&__pyx_k137p, __pyx_k137, sizeof(__pyx_k137)},
    {&__pyx_k138p, __pyx_k138, sizeof(__pyx_k138)},
    {&__pyx_k139p, __pyx_k139, sizeof(__pyx_k139)},
    {&__pyx_k140p, __pyx_k140, sizeof(__pyx_k140)},
    {&__pyx_k141p, __pyx_k141, sizeof(__pyx_k141)},
    {&__pyx_k142p, __pyx_k142, sizeof(__pyx_k142)},
    {&__pyx_k143p, __pyx_k143, sizeof(__pyx_k143)},
    {&__pyx_k144p, __pyx_k144, sizeof(__pyx_k144)},
    {&__pyx_k145p, __pyx_k145, sizeof(__pyx_k145)},
    {&__pyx_k146p, __pyx_k146, sizeof(__pyx_k146)},
    {&__pyx_k147p, __pyx_k147, sizeof(__pyx_k147)},
    {&__pyx_k148p, __pyx_k148, sizeof(__pyx_k148)},
    {&__pyx_k149p, __pyx_k149, sizeof(__pyx_k149)},
    {&__pyx_k150p, __pyx_k150, sizeof(__pyx_k150)},
    {&__pyx_k151p, __pyx_k151, sizeof(__pyx_k151)},
    {&__pyx_k152p, __pyx_k152, sizeof(__pyx_k152)},
    {&__pyx_k153p, __pyx_k153, sizeof(__pyx_k153)},
    {&__pyx_k154p, __pyx_k154, sizeof(__pyx_k154)},
    {&__pyx_k155p, __pyx_k155, sizeof(__pyx_k155)},
    {&__pyx_k156p, __pyx_k156, sizeof(__pyx_k156)},
    {&__pyx_k157p, __pyx_k157, sizeof(__pyx_k157)},
    {&__pyx_k158p, __pyx_k158, sizeof(__pyx_k158)},
    {&__pyx_k159p, __pyx_k159, sizeof(__pyx_k159)},
    {&__pyx_k160p, __pyx_k160, sizeof(__pyx_k160)},
    {&__pyx_k161p, __pyx_k161, sizeof(__pyx_k161)},
    {&__pyx_k162p, __pyx_k162, sizeof(__pyx_k162)},
    {&__pyx_k163p, __pyx_k163, sizeof(__pyx_k163)},
    {&__pyx_k164p, __pyx_k164, sizeof(__pyx_k164)},
    {&__pyx_k165p, __pyx_k165, sizeof(__pyx_k165)},
    {&__pyx_k166p, __pyx_k166, sizeof(__pyx_k166)},
    {&__pyx_k167p, __pyx_k167, sizeof(__pyx_k167)},
    {&__pyx_k168p, __pyx_k168, sizeof(__pyx_k168)},
    {&__pyx_k169p, __pyx_k169, sizeof(__pyx_k169)},
    {&__pyx_k170p, __pyx_k170, sizeof(__pyx_k170)},
    {&__pyx_k171p, __pyx_k171, sizeof(__pyx_k171)},
    {&__pyx_k172p, __pyx_k172, sizeof(__pyx_k172)},
    {&__pyx_k173p, __pyx_k173, sizeof(__pyx_k173)},
    {&__pyx_k174p, __pyx_k174, sizeof(__pyx_k174)},
    {&__pyx_k175p, __pyx_k175, sizeof(__pyx_k175)},
    {&__pyx_k176p, __pyx_k176, sizeof(__pyx_k176)},
    {&__pyx_k177p, __pyx_k177, sizeof(__pyx_k177)},
    {&__pyx_k178p, __pyx_k178, sizeof(__pyx_k178)},
    {&__pyx_k179p, __pyx_k179, sizeof(__pyx_k179)},
    {&__pyx_k180p, __pyx_k180, sizeof(__pyx_k180)},
    {&__pyx_k181p, __pyx_k181, sizeof(__pyx_k181)},
    {&__pyx_k182p, __pyx_k182, sizeof(__pyx_k182)},
    {&__pyx_k183p, __pyx_k183, sizeof(__pyx_k183)},
    {&__pyx_k184p, __pyx_k184, sizeof(__pyx_k184)},
    {&__pyx_k185p, __pyx_k185, sizeof(__pyx_k185)},
    {&__pyx_k186p, __pyx_k186, sizeof(__pyx_k186)},
    {&__pyx_k187p, __pyx_k187, sizeof(__pyx_k187)},
    {&__pyx_k188p, __pyx_k188, sizeof(__pyx_k188)},
    {&__pyx_k189p, __pyx_k189, sizeof(__pyx_k189)},
    {&__pyx_k190p, __pyx_k190, sizeof(__pyx_k190)},
    {&__pyx_k191p, __pyx_k191, sizeof(__pyx_k191)},
    {&__pyx_k192p, __pyx_k192, sizeof(__pyx_k192)},
    {&__pyx_k193p, __pyx_k193, sizeof(__pyx_k193)},
    {&__pyx_k194p, __pyx_k194, sizeof(__pyx_k194)},
    {&__pyx_k195p, __pyx_k195, sizeof(__pyx_k195)},
    {&__pyx_k196p, __pyx_k196, sizeof(__pyx_k196)},
    {&__pyx_k197p, __pyx_k197, sizeof(__pyx_k197)},
    {&__pyx_k198p, __pyx_k198, sizeof(__pyx_k198)},
    {&__pyx_k199p, __pyx_k199, sizeof(__pyx_k199)},
    {&__pyx_k200p, __pyx_k200, sizeof(__pyx_k200)},
    {&__pyx_k201p, __pyx_k201, sizeof(__pyx_k201)},
    {&__pyx_k202p, __pyx_k202, sizeof(__pyx_k202)},
    {&__pyx_k203p, __pyx_k203, sizeof(__pyx_k203)},
    {&__pyx_k204p, __pyx_k204, sizeof(__pyx_k204)},
    {&__pyx_k205p, __pyx_k205, sizeof(__pyx_k205)},
    {&__pyx_k206p, __pyx_k206, sizeof(__pyx_k206)},
    {&__pyx_k207p, __pyx_k207, sizeof(__pyx_k207)},
    {&__pyx_k208p, __pyx_k208, sizeof(__pyx_k208)},
    {&__pyx_k209p, __pyx_k209, sizeof(__pyx_k209)},
    {&__pyx_k210p, __pyx_k210, sizeof(__pyx_k210)},
    {&__pyx_k211p, __pyx_k211, sizeof(__pyx_k211)},
    {&__pyx_k212p, __pyx_k212, sizeof(__pyx_k212)},
    {&__pyx_k216p, __pyx_k216, sizeof(__pyx_k216)},
    {&__pyx_k217p, __pyx_k217, sizeof(__pyx_k217)},
    {&__pyx_k219p, __pyx_k219, sizeof(__pyx_k219)},
    {&__pyx_k220p, __pyx_k220, sizeof(__pyx_k220)},
    {&__pyx_k221p, __pyx_k221, sizeof(__pyx_k221)},
    {&__pyx_k222p, __pyx_k222, sizeof(__pyx_k222)},
    {&__pyx_k223p, __pyx_k223, sizeof(__pyx_k223)},
    {&__pyx_k224p, __pyx_k224, sizeof(__pyx_k224)},
    {&__pyx_k225p, __pyx_k225, sizeof(__pyx_k225)},
    {&__pyx_k226p, __pyx_k226, sizeof(__pyx_k226)},
    {&__pyx_k228p, __pyx_k228, sizeof(__pyx_k228)},
    {&__pyx_k230p, __pyx_k230, sizeof(__pyx_k230)},
    {&__pyx_k232p, __pyx_k232, sizeof(__pyx_k232)},
    {&__pyx_k233p, __pyx_k233, sizeof(__pyx_k233)},
    {&__pyx_k234p, __pyx_k234, sizeof(__pyx_k234)},
    {&__pyx_k235p, __pyx_k235, sizeof(__pyx_k235)},
    {&__pyx_k236p, __pyx_k236, sizeof(__pyx_k236)},
    {&__pyx_k237p, __pyx_k237, sizeof(__pyx_k237)},
    {&__pyx_k238p, __pyx_k238, sizeof(__pyx_k238)},
    {0, 0, 0}
  };
  static struct __pyx_vtabstruct_8_py_pari_gen __pyx_vtable_8_py_pari_gen;

  static PyObject *__pyx_tp_new_8_py_pari_gen(PyTypeObject *t, PyObject *a, PyObject *k) {
    PyObject *o = (*t->tp_alloc)(t, 0);
    struct __pyx_obj_8_py_pari_gen *p = (struct __pyx_obj_8_py_pari_gen *)o;
    (struct __pyx_vtabstruct_8_py_pari_gen *)p->__pyx_vtab = __pyx_vtabptr_8_py_pari_gen;
    p->refers_to = Py_None; Py_INCREF(p->refers_to);
    return o;
  }

  static void __pyx_tp_dealloc_8_py_pari_gen(PyObject *o) {
    struct __pyx_obj_8_py_pari_gen *p = (struct __pyx_obj_8_py_pari_gen *)o;
    {
      PyObject *etype, *eval, *etb;
      PyErr_Fetch(&etype, &eval, &etb);
      ++o->ob_refcnt;
      __pyx_f_8_py_pari_3gen___dealloc__(o);
      if (PyErr_Occurred()) PyErr_WriteUnraisable(o);
      --o->ob_refcnt;
      PyErr_Restore(etype, eval, etb);
    }
    Py_XDECREF(p->refers_to);
    (*o->ob_type->tp_free)(o);
  }

  static int __pyx_tp_traverse_8_py_pari_gen(PyObject *o, visitproc v, void *a) {
    int e;
    struct __pyx_obj_8_py_pari_gen *p = (struct __pyx_obj_8_py_pari_gen *)o;
    if (p->refers_to) {
      e = (*v)(p->refers_to, a); if (e) return e;
    }
    return 0;
  }

  static int __pyx_tp_clear_8_py_pari_gen(PyObject *o) {
    struct __pyx_obj_8_py_pari_gen *p = (struct __pyx_obj_8_py_pari_gen *)o;
    Py_XDECREF(p->refers_to);
    p->refers_to = Py_None; Py_INCREF(p->refers_to);
    return 0;
  }
  static PyObject *__pyx_sq_item_8_py_pari_gen(PyObject *o, int i) {
    PyObject *r;
    PyObject *x = PyInt_FromLong(i); if(!x) return 0;
    r = o->ob_type->tp_as_mapping->mp_subscript(o, x);
    Py_DECREF(x);
    return r;
  }

  static int __pyx_mp_ass_subscript_8_py_pari_gen(PyObject *o, PyObject *i, PyObject *v) {
    if (v) {
      return __pyx_f_8_py_pari_3gen___setitem__(o, i, v);
    }
    else {
      PyErr_Format(PyExc_NotImplementedError,
        "Subscript deletion not supported by %s", o->ob_type->tp_name);
      return -1;
    }
  }

  static struct PyMethodDef __pyx_methods_8_py_pari_gen[] = {
    {"__reduce__", (PyCFunction)__pyx_f_8_py_pari_3gen___reduce__, METH_VARARGS|METH_KEYWORDS, 0},
    {"_add", (PyCFunction)__pyx_f_8_py_pari_3gen__add, METH_VARARGS|METH_KEYWORDS, 0},
    {"_sub", (PyCFunction)__pyx_f_8_py_pari_3gen__sub, METH_VARARGS|METH_KEYWORDS, 0},
    {"_mul", (PyCFunction)__pyx_f_8_py_pari_3gen__mul, METH_VARARGS|METH_KEYWORDS, 0},
    {"_div", (PyCFunction)__pyx_f_8_py_pari_3gen__div, METH_VARARGS|METH_KEYWORDS, 0},
    {"_mod", (PyCFunction)__pyx_f_8_py_pari_3gen__mod, METH_VARARGS|METH_KEYWORDS, 0},
    {"ncols", (PyCFunction)__pyx_f_8_py_pari_3gen_ncols, METH_VARARGS|METH_KEYWORDS, 0},
    {"nrows", (PyCFunction)__pyx_f_8_py_pari_3gen_nrows, METH_VARARGS|METH_KEYWORDS, 0},
    {"polcoeff", (PyCFunction)__pyx_f_8_py_pari_3gen_polcoeff, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_polcoeff},
    {"copy", (PyCFunction)__pyx_f_8_py_pari_3gen_copy, METH_VARARGS|METH_KEYWORDS, 0},
    {"list_str", (PyCFunction)__pyx_f_8_py_pari_3gen_list_str, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_list_str},
    {"python_list", (PyCFunction)__pyx_f_8_py_pari_3gen_python_list, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_python_list},
    {"python", (PyCFunction)__pyx_f_8_py_pari_3gen_python, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_python},
    {"__bool__", (PyCFunction)__pyx_f_8_py_pari_3gen___bool__, METH_VARARGS|METH_KEYWORDS, 0},
    {"isprime", (PyCFunction)__pyx_f_8_py_pari_3gen_isprime, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_isprime},
    {"divrem", (PyCFunction)__pyx_f_8_py_pari_3gen_divrem, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_divrem},
    {"lex", (PyCFunction)__pyx_f_8_py_pari_3gen_lex, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_lex},
    {"max", (PyCFunction)__pyx_f_8_py_pari_3gen_max, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_max},
    {"min", (PyCFunction)__pyx_f_8_py_pari_3gen_min, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_min},
    {"shift", (PyCFunction)__pyx_f_8_py_pari_3gen_shift, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_shift},
    {"shiftmul", (PyCFunction)__pyx_f_8_py_pari_3gen_shiftmul, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_shiftmul},
    {"sign", (PyCFunction)__pyx_f_8_py_pari_3gen_sign, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_sign},
    {"vecmax", (PyCFunction)__pyx_f_8_py_pari_3gen_vecmax, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_vecmax},
    {"vecmin", (PyCFunction)__pyx_f_8_py_pari_3gen_vecmin, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_vecmin},
    {"Col", (PyCFunction)__pyx_f_8_py_pari_3gen_Col, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_Col},
    {"List", (PyCFunction)__pyx_f_8_py_pari_3gen_List, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_List},
    {"Mat", (PyCFunction)__pyx_f_8_py_pari_3gen_Mat, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_Mat},
    {"Mod", (PyCFunction)__pyx_f_8_py_pari_3gen_Mod, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_Mod},
    {"Pol", (PyCFunction)__pyx_f_8_py_pari_3gen_Pol, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_Pol},
    {"Polrev", (PyCFunction)__pyx_f_8_py_pari_3gen_Polrev, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_Polrev},
    {"Qfb", (PyCFunction)__pyx_f_8_py_pari_3gen_Qfb, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_Qfb},
    {"Ser", (PyCFunction)__pyx_f_8_py_pari_3gen_Ser, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_Ser},
    {"Set", (PyCFunction)__pyx_f_8_py_pari_3gen_Set, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_Set},
    {"Str", (PyCFunction)__pyx_f_8_py_pari_3gen_Str, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_Str},
    {"Strchr", (PyCFunction)__pyx_f_8_py_pari_3gen_Strchr, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_Strchr},
    {"Strexpand", (PyCFunction)__pyx_f_8_py_pari_3gen_Strexpand, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_Strexpand},
    {"Strtex", (PyCFunction)__pyx_f_8_py_pari_3gen_Strtex, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_Strtex},
    {"Vec", (PyCFunction)__pyx_f_8_py_pari_3gen_Vec, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_Vec},
    {"Vecsmall", (PyCFunction)__pyx_f_8_py_pari_3gen_Vecsmall, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_Vecsmall},
    {"binary", (PyCFunction)__pyx_f_8_py_pari_3gen_binary, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_binary},
    {"bitand", (PyCFunction)__pyx_f_8_py_pari_3gen_bitand, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_bitand},
    {"bitneg", (PyCFunction)__pyx_f_8_py_pari_3gen_bitneg, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_bitneg},
    {"bitnegimply", (PyCFunction)__pyx_f_8_py_pari_3gen_bitnegimply, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_bitnegimply},
    {"bitor", (PyCFunction)__pyx_f_8_py_pari_3gen_bitor, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_bitor},
    {"bittest", (PyCFunction)__pyx_f_8_py_pari_3gen_bittest, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_bittest},
    {"bitxor", (PyCFunction)__pyx_f_8_py_pari_3gen_bitxor, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_bitxor},
    {"ceil", (PyCFunction)__pyx_f_8_py_pari_3gen_ceil, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_ceil},
    {"centerlift", (PyCFunction)__pyx_f_8_py_pari_3gen_centerlift, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_centerlift},
    {"changevar", (PyCFunction)__pyx_f_8_py_pari_3gen_changevar, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_changevar},
    {"component", (PyCFunction)__pyx_f_8_py_pari_3gen_component, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_component},
    {"conj", (PyCFunction)__pyx_f_8_py_pari_3gen_conj, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_conj},
    {"conjvec", (PyCFunction)__pyx_f_8_py_pari_3gen_conjvec, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_conjvec},
    {"denominator", (PyCFunction)__pyx_f_8_py_pari_3gen_denominator, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_denominator},
    {"floor", (PyCFunction)__pyx_f_8_py_pari_3gen_floor, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_floor},
    {"frac", (PyCFunction)__pyx_f_8_py_pari_3gen_frac, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_frac},
    {"imag", (PyCFunction)__pyx_f_8_py_pari_3gen_imag, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_imag},
    {"length", (PyCFunction)__pyx_f_8_py_pari_3gen_length, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_length},
    {"lift", (PyCFunction)__pyx_f_8_py_pari_3gen_lift, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_lift},
    {"numerator", (PyCFunction)__pyx_f_8_py_pari_3gen_numerator, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_numerator},
    {"numtoperm", (PyCFunction)__pyx_f_8_py_pari_3gen_numtoperm, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_numtoperm},
    {"padicprec", (PyCFunction)__pyx_f_8_py_pari_3gen_padicprec, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_padicprec},
    {"permtonum", (PyCFunction)__pyx_f_8_py_pari_3gen_permtonum, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_permtonum},
    {"precision", (PyCFunction)__pyx_f_8_py_pari_3gen_precision, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_precision},
    {"random", (PyCFunction)__pyx_f_8_py_pari_3gen_random, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_random},
    {"real", (PyCFunction)__pyx_f_8_py_pari_3gen_real, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_real},
    {"round", (PyCFunction)__pyx_f_8_py_pari_3gen_round, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_round},
    {"simplify", (PyCFunction)__pyx_f_8_py_pari_3gen_simplify, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_simplify},
    {"sizebyte", (PyCFunction)__pyx_f_8_py_pari_3gen_sizebyte, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_sizebyte},
    {"sizedigit", (PyCFunction)__pyx_f_8_py_pari_3gen_sizedigit, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_sizedigit},
    {"truncate", (PyCFunction)__pyx_f_8_py_pari_3gen_truncate, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_truncate},
    {"valuation", (PyCFunction)__pyx_f_8_py_pari_3gen_valuation, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_valuation},
    {"variable", (PyCFunction)__pyx_f_8_py_pari_3gen_variable, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_variable},
    {"sqrt", (PyCFunction)__pyx_f_8_py_pari_3gen_sqrt, METH_VARARGS|METH_KEYWORDS, 0},
    {"gamma", (PyCFunction)__pyx_f_8_py_pari_3gen_gamma, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_gamma},
    {"zeta", (PyCFunction)__pyx_f_8_py_pari_3gen_zeta, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_zeta},
    {"issquare", (PyCFunction)__pyx_f_8_py_pari_3gen_issquare, METH_VARARGS|METH_KEYWORDS, 0},
    {"issquarefree", (PyCFunction)__pyx_f_8_py_pari_3gen_issquarefree, METH_VARARGS|METH_KEYWORDS, 0},
    {"lcm", (PyCFunction)__pyx_f_8_py_pari_3gen_lcm, METH_VARARGS|METH_KEYWORDS, 0},
    {"gcd", (PyCFunction)__pyx_f_8_py_pari_3gen_gcd, METH_VARARGS|METH_KEYWORDS, 0},
    {"bezout", (PyCFunction)__pyx_f_8_py_pari_3gen_bezout, METH_VARARGS|METH_KEYWORDS, 0},
    {"xgcd", (PyCFunction)__pyx_f_8_py_pari_3gen_xgcd, METH_VARARGS|METH_KEYWORDS, 0},
    {"elladd", (PyCFunction)__pyx_f_8_py_pari_3gen_elladd, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_elladd},
    {"ellak", (PyCFunction)__pyx_f_8_py_pari_3gen_ellak, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_ellak},
    {"ellan", (PyCFunction)__pyx_f_8_py_pari_3gen_ellan, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_ellan},
    {"ellap", (PyCFunction)__pyx_f_8_py_pari_3gen_ellap, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_ellap},
    {"ellbil", (PyCFunction)__pyx_f_8_py_pari_3gen_ellbil, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_ellbil},
    {"ellchangecurve", (PyCFunction)__pyx_f_8_py_pari_3gen_ellchangecurve, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_ellchangecurve},
    {"ellchangepoint", (PyCFunction)__pyx_f_8_py_pari_3gen_ellchangepoint, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_ellchangepoint},
    {"elleisnum", (PyCFunction)__pyx_f_8_py_pari_3gen_elleisnum, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_elleisnum},
    {"elleta", (PyCFunction)__pyx_f_8_py_pari_3gen_elleta, METH_VARARGS|METH_KEYWORDS, 0},
    {"ellglobalred", (PyCFunction)__pyx_f_8_py_pari_3gen_ellglobalred, METH_VARARGS|METH_KEYWORDS, 0},
    {"ellheight", (PyCFunction)__pyx_f_8_py_pari_3gen_ellheight, METH_VARARGS|METH_KEYWORDS, 0},
    {"ellheightmatrix", (PyCFunction)__pyx_f_8_py_pari_3gen_ellheightmatrix, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_ellheightmatrix},
    {"ellinit", (PyCFunction)__pyx_f_8_py_pari_3gen_ellinit, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_ellinit},
    {"ellisoncurve", (PyCFunction)__pyx_f_8_py_pari_3gen_ellisoncurve, METH_VARARGS|METH_KEYWORDS, 0},
    {"ellj", (PyCFunction)__pyx_f_8_py_pari_3gen_ellj, METH_VARARGS|METH_KEYWORDS, 0},
    {"elllocalred", (PyCFunction)__pyx_f_8_py_pari_3gen_elllocalred, METH_VARARGS|METH_KEYWORDS, 0},
    {"elllseries", (PyCFunction)__pyx_f_8_py_pari_3gen_elllseries, METH_VARARGS|METH_KEYWORDS, 0},
    {"ellminimalmodel", (PyCFunction)__pyx_f_8_py_pari_3gen_ellminimalmodel, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_ellminimalmodel},
    {"ellorder", (PyCFunction)__pyx_f_8_py_pari_3gen_ellorder, METH_VARARGS|METH_KEYWORDS, 0},
    {"ellordinate", (PyCFunction)__pyx_f_8_py_pari_3gen_ellordinate, METH_VARARGS|METH_KEYWORDS, 0},
    {"ellpointtoz", (PyCFunction)__pyx_f_8_py_pari_3gen_ellpointtoz, METH_VARARGS|METH_KEYWORDS, 0},
    {"ellpow", (PyCFunction)__pyx_f_8_py_pari_3gen_ellpow, METH_VARARGS|METH_KEYWORDS, 0},
    {"ellrootno", (PyCFunction)__pyx_f_8_py_pari_3gen_ellrootno, METH_VARARGS|METH_KEYWORDS, 0},
    {"ellsigma", (PyCFunction)__pyx_f_8_py_pari_3gen_ellsigma, METH_VARARGS|METH_KEYWORDS, 0},
    {"ellsub", (PyCFunction)__pyx_f_8_py_pari_3gen_ellsub, METH_VARARGS|METH_KEYWORDS, 0},
    {"elltaniyama", (PyCFunction)__pyx_f_8_py_pari_3gen_elltaniyama, METH_VARARGS|METH_KEYWORDS, 0},
    {"elltors", (PyCFunction)__pyx_f_8_py_pari_3gen_elltors, METH_VARARGS|METH_KEYWORDS, 0},
    {"ellwp", (PyCFunction)__pyx_f_8_py_pari_3gen_ellwp, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_ellwp},
    {"ellzeta", (PyCFunction)__pyx_f_8_py_pari_3gen_ellzeta, METH_VARARGS|METH_KEYWORDS, 0},
    {"ellztopoint", (PyCFunction)__pyx_f_8_py_pari_3gen_ellztopoint, METH_VARARGS|METH_KEYWORDS, 0},
    {"omega", (PyCFunction)__pyx_f_8_py_pari_3gen_omega, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_omega},
    {"disc", (PyCFunction)__pyx_f_8_py_pari_3gen_disc, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_disc},
    {"j", (PyCFunction)__pyx_f_8_py_pari_3gen_j, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_j},
    {"bnfunit", (PyCFunction)__pyx_f_8_py_pari_3gen_bnfunit, METH_VARARGS|METH_KEYWORDS, 0},
    {"bnfinit", (PyCFunction)__pyx_f_8_py_pari_3gen_bnfinit, METH_VARARGS|METH_KEYWORDS, 0},
    {"idealfactor", (PyCFunction)__pyx_f_8_py_pari_3gen_idealfactor, METH_VARARGS|METH_KEYWORDS, 0},
    {"nfbasis", (PyCFunction)__pyx_f_8_py_pari_3gen_nfbasis, METH_VARARGS|METH_KEYWORDS, 0},
    {"nfinit", (PyCFunction)__pyx_f_8_py_pari_3gen_nfinit, METH_VARARGS|METH_KEYWORDS, 0},
    {"polcompositum", (PyCFunction)__pyx_f_8_py_pari_3gen_polcompositum, METH_VARARGS|METH_KEYWORDS, 0},
    {"poldisc", (PyCFunction)__pyx_f_8_py_pari_3gen_poldisc, METH_VARARGS|METH_KEYWORDS, 0},
    {"polgalois", (PyCFunction)__pyx_f_8_py_pari_3gen_polgalois, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_polgalois},
    {"polisirreducible", (PyCFunction)__pyx_f_8_py_pari_3gen_polisirreducible, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_polisirreducible},
    {"polresultant", (PyCFunction)__pyx_f_8_py_pari_3gen_polresultant, METH_VARARGS|METH_KEYWORDS, 0},
    {"polroots", (PyCFunction)__pyx_f_8_py_pari_3gen_polroots, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_polroots},
    {"factor", (PyCFunction)__pyx_f_8_py_pari_3gen_factor, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_factor},
    {"eint1", (PyCFunction)__pyx_f_8_py_pari_3gen_eint1, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_eint1},
    {"order", (PyCFunction)__pyx_f_8_py_pari_3gen_order, METH_VARARGS|METH_KEYWORDS, 0},
    {"znprimroot", (PyCFunction)__pyx_f_8_py_pari_3gen_znprimroot, METH_VARARGS|METH_KEYWORDS, 0},
    {"abs", (PyCFunction)__pyx_f_8_py_pari_3gen_abs, METH_VARARGS|METH_KEYWORDS, 0},
    {"mattranspose", (PyCFunction)__pyx_f_8_py_pari_3gen_mattranspose, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_mattranspose},
    {"matker", (PyCFunction)__pyx_f_8_py_pari_3gen_matker, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_matker},
    {"matkerint", (PyCFunction)__pyx_f_8_py_pari_3gen_matkerint, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_matkerint},
    {"trace", (PyCFunction)__pyx_f_8_py_pari_3gen_trace, METH_VARARGS|METH_KEYWORDS, 0},
    {"norm", (PyCFunction)__pyx_f_8_py_pari_3gen_norm, METH_VARARGS|METH_KEYWORDS, 0},
    {"charpoly", (PyCFunction)__pyx_f_8_py_pari_3gen_charpoly, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_charpoly},
    {"nextprime", (PyCFunction)__pyx_f_8_py_pari_3gen_nextprime, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_nextprime},
    {"subst", (PyCFunction)__pyx_f_8_py_pari_3gen_subst, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_3gen_subst},
    {"kronecker", (PyCFunction)__pyx_f_8_py_pari_3gen_kronecker, METH_VARARGS|METH_KEYWORDS, 0},
    {"exp", (PyCFunction)__pyx_f_8_py_pari_3gen_exp, METH_VARARGS|METH_KEYWORDS, 0},
    {"log", (PyCFunction)__pyx_f_8_py_pari_3gen_log, METH_VARARGS|METH_KEYWORDS, 0},
    {"type", (PyCFunction)__pyx_f_8_py_pari_3gen_type, METH_VARARGS|METH_KEYWORDS, 0},
    {0, 0, 0, 0}
  };

  static PyNumberMethods __pyx_tp_as_number_gen = {
    __pyx_f_8_py_pari_3gen___add__, /*nb_add*/
    __pyx_f_8_py_pari_3gen___sub__, /*nb_subtract*/
    __pyx_f_8_py_pari_3gen___mul__, /*nb_multiply*/
    __pyx_f_8_py_pari_3gen___div__, /*nb_divide*/
    __pyx_f_8_py_pari_3gen___mod__, /*nb_remainder*/
    0, /*nb_divmod*/
    __pyx_f_8_py_pari_3gen___pow__, /*nb_power*/
    __pyx_f_8_py_pari_3gen___neg__, /*nb_negative*/
    0, /*nb_positive*/
    __pyx_f_8_py_pari_3gen___abs__, /*nb_absolute*/
    0, /*nb_nonzero*/
    __pyx_f_8_py_pari_3gen___invert__, /*nb_invert*/
    __pyx_f_8_py_pari_3gen___lshift__, /*nb_lshift*/
    __pyx_f_8_py_pari_3gen___rshift__, /*nb_rshift*/
    0, /*nb_and*/
    __pyx_f_8_py_pari_3gen___xor__, /*nb_xor*/
    0, /*nb_or*/
    0, /*nb_coerce*/
    __pyx_f_8_py_pari_3gen___int__, /*nb_int*/
    __pyx_f_8_py_pari_3gen___long__, /*nb_long*/
    __pyx_f_8_py_pari_3gen___float__, /*nb_float*/
    0, /*nb_oct*/
    0, /*nb_hex*/
    0, /*nb_inplace_add*/
    0, /*nb_inplace_subtract*/
    0, /*nb_inplace_multiply*/
    0, /*nb_inplace_divide*/
    0, /*nb_inplace_remainder*/
    0, /*nb_inplace_power*/
    0, /*nb_inplace_lshift*/
    0, /*nb_inplace_rshift*/
    0, /*nb_inplace_and*/
    0, /*nb_inplace_xor*/
    0, /*nb_inplace_or*/
    0, /*nb_floor_divide*/
    0, /*nb_true_divide*/
    0, /*nb_inplace_floor_divide*/
    0, /*nb_inplace_true_divide*/
  };

  static PySequenceMethods __pyx_tp_as_sequence_gen = {
    __pyx_f_8_py_pari_3gen___len__, /*sq_length*/
    0, /*sq_concat*/
    0, /*sq_repeat*/
    __pyx_sq_item_8_py_pari_gen, /*sq_item*/
    __pyx_f_8_py_pari_3gen___getslice__, /*sq_slice*/
    0, /*sq_ass_item*/
    0, /*sq_ass_slice*/
    0, /*sq_contains*/
    0, /*sq_inplace_concat*/
    0, /*sq_inplace_repeat*/
  };

  static PyMappingMethods __pyx_tp_as_mapping_gen = {
    __pyx_f_8_py_pari_3gen___len__, /*mp_length*/
    __pyx_f_8_py_pari_3gen___getitem__, /*mp_subscript*/
    __pyx_mp_ass_subscript_8_py_pari_gen, /*mp_ass_subscript*/
  };

  static PyBufferProcs __pyx_tp_as_buffer_gen = {
    0, /*bf_getreadbuffer*/
    0, /*bf_getwritebuffer*/
    0, /*bf_getsegcount*/
    0, /*bf_getcharbuffer*/
  };

  statichere PyTypeObject __pyx_type_8_py_pari_gen = {
    PyObject_HEAD_INIT(0)
    0, /*ob_size*/
    "_py_pari.gen", /*tp_name*/
    sizeof(struct __pyx_obj_8_py_pari_gen), /*tp_basicsize*/
    0, /*tp_itemsize*/
    __pyx_tp_dealloc_8_py_pari_gen, /*tp_dealloc*/
    0, /*tp_print*/
    0, /*tp_getattr*/
    0, /*tp_setattr*/
    __pyx_f_8_py_pari_3gen___cmp__, /*tp_compare*/
    __pyx_f_8_py_pari_3gen___repr__, /*tp_repr*/
    &__pyx_tp_as_number_gen, /*tp_as_number*/
    &__pyx_tp_as_sequence_gen, /*tp_as_sequence*/
    &__pyx_tp_as_mapping_gen, /*tp_as_mapping*/
    0, /*tp_hash*/
    __pyx_f_8_py_pari_3gen___call__, /*tp_call*/
    0, /*tp_str*/
    0, /*tp_getattro*/
    0, /*tp_setattro*/
    &__pyx_tp_as_buffer_gen, /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC, /*tp_flags*/
    "\n    Python extension class that models the PARI GEN type.\n    ", /*tp_doc*/
    __pyx_tp_traverse_8_py_pari_gen, /*tp_traverse*/
    __pyx_tp_clear_8_py_pari_gen, /*tp_clear*/
    __pyx_f_8_py_pari_3gen___richcmp__, /*tp_richcompare*/
    0, /*tp_weaklistoffset*/
    0, /*tp_iter*/
    0, /*tp_iternext*/
    __pyx_methods_8_py_pari_gen, /*tp_methods*/
    0, /*tp_members*/
    0, /*tp_getset*/
    0, /*tp_base*/
    0, /*tp_dict*/
    0, /*tp_descr_get*/
    0, /*tp_descr_set*/
    0, /*tp_dictoffset*/
    0, /*tp_init*/
    0, /*tp_alloc*/
    __pyx_tp_new_8_py_pari_gen, /*tp_new*/
    0, /*tp_free*/
    0, /*tp_is_gc*/
    0, /*tp_bases*/
    0, /*tp_mro*/
    0, /*tp_cache*/
    0, /*tp_subclasses*/
    0, /*tp_weaklist*/
  };

  static struct PyMethodDef __pyx_methods[] = {
    {"my_sigint", (PyCFunction)__pyx_f_8_py_pari_my_sigint, METH_VARARGS|METH_KEYWORDS, 0},
    {"init_fmt", (PyCFunction)__pyx_f_8_py_pari_init_fmt, METH_VARARGS|METH_KEYWORDS, 0},
    {"_init", (PyCFunction)__pyx_f_8_py_pari__init, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari__init},
    {"pari", (PyCFunction)__pyx_f_8_py_pari_pari, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_pari},
    {"stack_ptr", (PyCFunction)__pyx_f_8_py_pari_stack_ptr, METH_VARARGS|METH_KEYWORDS, 0},
    {"stack_top", (PyCFunction)__pyx_f_8_py_pari_stack_top, METH_VARARGS|METH_KEYWORDS, 0},
    {"stack_bottom", (PyCFunction)__pyx_f_8_py_pari_stack_bottom, METH_VARARGS|METH_KEYWORDS, 0},
    {"stack_size", (PyCFunction)__pyx_f_8_py_pari_stack_size, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_stack_size},
    {"stack_usage", (PyCFunction)__pyx_f_8_py_pari_stack_usage, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_stack_usage},
    {"stack_available", (PyCFunction)__pyx_f_8_py_pari_stack_available, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_stack_available},
    {"execute", (PyCFunction)__pyx_f_8_py_pari_execute, METH_VARARGS|METH_KEYWORDS, 0},
    {"eval", (PyCFunction)__pyx_f_8_py_pari_eval, METH_VARARGS|METH_KEYWORDS, 0},
    {"_error", (PyCFunction)__pyx_f_8_py_pari__error, METH_VARARGS|METH_KEYWORDS, 0},
    {"min", (PyCFunction)__pyx_f_8_py_pari_min, METH_VARARGS|METH_KEYWORDS, 0},
    {"max", (PyCFunction)__pyx_f_8_py_pari_max, METH_VARARGS|METH_KEYWORDS, 0},
    {"prime_list", (PyCFunction)__pyx_f_8_py_pari_prime_list, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_prime_list},
    {"nth_prime", (PyCFunction)__pyx_f_8_py_pari_nth_prime, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_nth_prime},
    {"euler", (PyCFunction)__pyx_f_8_py_pari_euler, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_euler},
    {"pi", (PyCFunction)__pyx_f_8_py_pari_pi, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_pi},
    {"factorial", (PyCFunction)__pyx_f_8_py_pari_factorial, METH_VARARGS|METH_KEYWORDS, 0},
    {"vector", (PyCFunction)__pyx_f_8_py_pari_vector, METH_VARARGS|METH_KEYWORDS, 0},
    {"matrix", (PyCFunction)__pyx_f_8_py_pari_matrix, METH_VARARGS|METH_KEYWORDS, 0},
    {"finitefield_init", (PyCFunction)__pyx_f_8_py_pari_finitefield_init, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_finitefield_init},
    {"set_real_precision", (PyCFunction)__pyx_f_8_py_pari_set_real_precision, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_set_real_precision},
    {"get_real_precision", (PyCFunction)__pyx_f_8_py_pari_get_real_precision, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_get_real_precision},
    {"set_series_precision", (PyCFunction)__pyx_f_8_py_pari_set_series_precision, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_set_series_precision},
    {"get_series_precision", (PyCFunction)__pyx_f_8_py_pari_get_series_precision, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_get_series_precision},
    {"series_precision", (PyCFunction)__pyx_f_8_py_pari_series_precision, METH_VARARGS|METH_KEYWORDS, 0},
    {"init_primes", (PyCFunction)__pyx_f_8_py_pari_init_primes, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_init_primes},
    {"__read_script", (PyCFunction)__pyx_f_8_py_pari___read_script, METH_VARARGS|METH_KEYWORDS, 0},
    {"read", (PyCFunction)__pyx_f_8_py_pari_read, METH_VARARGS|METH_KEYWORDS, __pyx_doc_8_py_pari_read},
    {0, 0, 0, 0}
  };

  DL_EXPORT(void) init_py_pari(void); /*proto*/
  DL_EXPORT(void) init_py_pari(void) {
    PyObject *__pyx_1 = 0;
    PyObject *__pyx_2 = 0;
    PyObject *__pyx_3 = 0;
    PyObject *__pyx_4 = 0;
    PyObject *__pyx_5 = 0;
    PyObject *__pyx_6 = 0;
    PyObject *__pyx_7 = 0;
    PyObject *__pyx_8 = 0;
    PyObject *__pyx_9 = 0;
    PyObject *__pyx_10 = 0;
    PyObject *__pyx_11 = 0;
    PyObject *__pyx_12 = 0;
    PyObject *__pyx_13 = 0;
    PyObject *__pyx_14 = 0;
    PyObject *__pyx_15 = 0;
    PyObject *__pyx_16 = 0;
    PyObject *__pyx_17 = 0;
    PyObject *__pyx_18 = 0;
    PyObject *__pyx_19 = 0;
    PyObject *__pyx_20 = 0;
    PyObject *__pyx_21 = 0;
    PyObject *__pyx_22 = 0;
    PyObject *__pyx_23 = 0;
    PyObject *__pyx_24 = 0;
    PyObject *__pyx_25 = 0;
    PyObject *__pyx_26 = 0;
    int __pyx_27;
    PyObject *__pyx_28 = 0;
    PyObject *__pyx_29 = 0;
    PyObject *__pyx_30 = 0;
    __pyx_m = Py_InitModule4("_py_pari", __pyx_methods, __pyx_mdoc, 0, PYTHON_API_VERSION);
    if (!__pyx_m) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1; goto __pyx_L1;};
    __pyx_b = PyImport_AddModule("__builtin__");
    if (!__pyx_b) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1; goto __pyx_L1;};
    if (PyObject_SetAttrString(__pyx_m, "__builtins__", __pyx_b) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1; goto __pyx_L1;};
    if (__Pyx_InternStrings(__pyx_intern_tab) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1; goto __pyx_L1;};
    if (__Pyx_InitStrings(__pyx_string_tab) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1; goto __pyx_L1;};
    ((PyObject*)__pyx_v_8_py_pari_ZERO) = Py_None; Py_INCREF(((PyObject*)__pyx_v_8_py_pari_ZERO));
    ((PyObject*)__pyx_v_8_py_pari_ONE) = Py_None; Py_INCREF(((PyObject*)__pyx_v_8_py_pari_ONE));
    ((PyObject*)__pyx_v_8_py_pari_TWO) = Py_None; Py_INCREF(((PyObject*)__pyx_v_8_py_pari_TWO));
    __pyx_vtabptr_8_py_pari_gen = &__pyx_vtable_8_py_pari_gen;
    __pyx_vtable_8_py_pari_gen.init = (void *)__pyx_f_8_py_pari_3gen_init;
    __pyx_vtable_8_py_pari_gen._gen = (void *)__pyx_f_8_py_pari_3gen__gen;
    __pyx_type_8_py_pari_gen.tp_free = _PyObject_GC_Del;
    if (PyType_Ready(&__pyx_type_8_py_pari_gen) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2171; goto __pyx_L1;}
    if (__Pyx_SetVtable(__pyx_type_8_py_pari_gen.tp_dict, __pyx_vtabptr_8_py_pari_gen) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2171; goto __pyx_L1;}
    if (PyObject_SetAttrString(__pyx_m, "gen", (PyObject *)&__pyx_type_8_py_pari_gen) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2171; goto __pyx_L1;}
    __pyx_ptype_8_py_pari_gen = &__pyx_type_8_py_pari_gen;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":70 */
    __pyx_k1;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":131 */
    __pyx_1 = __Pyx_Import(__pyx_n_gc, 0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 131; goto __pyx_L1;}
    if (PyObject_SetAttr(__pyx_m, __pyx_n_gc, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 131; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2027 */
    GP_DATA = (&__pyx_v_8_py_pari___GP_DATA);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2030 */
    __pyx_v_8_py_pari_REAL_PREC = 5;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2088 */
    __pyx_k3 = 200000000;
    __pyx_k4 = 500000;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2447 */
    __pyx_1 = PyInt_FromLong((-1)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2447; goto __pyx_L1;}
    __pyx_k5 = __pyx_1;
    __pyx_1 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2640 */
    __pyx_2 = PyInt_FromLong(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2640; goto __pyx_L1;}
    __pyx_k6 = __pyx_2;
    __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2671 */
    __pyx_3 = PyInt_FromLong((-1)); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2671; goto __pyx_L1;}
    __pyx_k7 = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2914 */
    __pyx_4 = PyInt_FromLong((-1)); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2914; goto __pyx_L1;}
    __pyx_k8 = __pyx_4;
    __pyx_4 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2959 */
    __pyx_5 = PyInt_FromLong((-1)); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2959; goto __pyx_L1;}
    __pyx_k9 = __pyx_5;
    __pyx_5 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":2996 */
    __pyx_6 = PyInt_FromLong(0); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2996; goto __pyx_L1;}
    __pyx_k10 = __pyx_6;
    __pyx_6 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3026 */
    __pyx_7 = PyInt_FromLong((-1)); if (!__pyx_7) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3026; goto __pyx_L1;}
    __pyx_k11 = __pyx_7;
    __pyx_7 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3299 */
    __pyx_k12 = (-1);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3476 */
    __pyx_8 = PyInt_FromLong((-1)); if (!__pyx_8) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3476; goto __pyx_L1;}
    __pyx_k13 = __pyx_8;
    __pyx_8 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3758 */
    __pyx_9 = PyInt_FromLong((-1)); if (!__pyx_9) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3758; goto __pyx_L1;}
    __pyx_k14 = __pyx_9;
    __pyx_9 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3850 */
    __pyx_k15 = (-1);

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":3898 */
    __pyx_10 = __Pyx_GetName(__pyx_b, __pyx_n_False); if (!__pyx_10) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3898; goto __pyx_L1;}
    __pyx_k16 = __pyx_10;
    __pyx_10 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4049 */
    __pyx_11 = __Pyx_GetName(__pyx_b, __pyx_n_False); if (!__pyx_11) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4049; goto __pyx_L1;}
    __pyx_k17 = __pyx_11;
    __pyx_11 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4202 */
    __pyx_k18 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4210 */
    __pyx_k19 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4227 */
    __pyx_k20 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4502 */
    __pyx_k21 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4561 */
    __pyx_12 = PyInt_FromLong(0); if (!__pyx_12) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4561; goto __pyx_L1;}
    __pyx_k22 = __pyx_12;
    __pyx_12 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4583 */
    __pyx_k23 = 0;
    __pyx_13 = PyInt_FromLong(0); if (!__pyx_13) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4583; goto __pyx_L1;}
    __pyx_k24 = __pyx_13;
    __pyx_13 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4629 */
    __pyx_14 = PyInt_FromLong(1); if (!__pyx_14) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4629; goto __pyx_L1;}
    __pyx_k25 = __pyx_14;
    __pyx_14 = 0;
    __pyx_k26 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4713 */
    __pyx_15 = PyInt_FromLong(1); if (!__pyx_15) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4713; goto __pyx_L1;}
    __pyx_k27 = __pyx_15;
    __pyx_15 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4721 */
    __pyx_16 = PyInt_FromLong(0); if (!__pyx_16) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4721; goto __pyx_L1;}
    __pyx_k28 = __pyx_16;
    __pyx_16 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4743 */
    __pyx_17 = PyInt_FromLong(0); if (!__pyx_17) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4743; goto __pyx_L1;}
    __pyx_k29 = __pyx_17;
    __pyx_17 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4753 */
    Py_INCREF(__pyx_n_z);
    __pyx_k31 = __pyx_n_z;
    __pyx_k32 = 20;
    __pyx_k33 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4888 */
    __pyx_k34 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4904 */
    __pyx_k35 = 0;
    __pyx_18 = PyInt_FromLong(0); if (!__pyx_18) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4904; goto __pyx_L1;}
    __pyx_k36 = __pyx_18;
    __pyx_18 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4920 */
    __pyx_k37 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4927 */
    __pyx_k38 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4941 */
    __pyx_19 = PyInt_FromLong((-1)); if (!__pyx_19) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4941; goto __pyx_L1;}
    __pyx_k39 = __pyx_19;
    __pyx_19 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4973 */
    __pyx_20 = PyInt_FromLong((-1)); if (!__pyx_20) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4973; goto __pyx_L1;}
    __pyx_k40 = __pyx_20;
    __pyx_20 = 0;
    __pyx_21 = PyInt_FromLong(0); if (!__pyx_21) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4973; goto __pyx_L1;}
    __pyx_k41 = __pyx_21;
    __pyx_21 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":4983 */
    __pyx_22 = PyInt_FromLong(0); if (!__pyx_22) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 4983; goto __pyx_L1;}
    __pyx_k42 = __pyx_22;
    __pyx_22 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5011 */
    __pyx_23 = PyInt_FromLong((-1)); if (!__pyx_23) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5011; goto __pyx_L1;}
    __pyx_k43 = __pyx_23;
    __pyx_23 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5030 */
    __pyx_k44 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5087 */
    __pyx_k45 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5095 */
    __pyx_k46 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5115 */
    __pyx_24 = PyInt_FromLong((-1)); if (!__pyx_24) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5115; goto __pyx_L1;}
    __pyx_k47 = __pyx_24;
    __pyx_24 = 0;
    __pyx_25 = PyInt_FromLong(0); if (!__pyx_25) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5115; goto __pyx_L1;}
    __pyx_k48 = __pyx_25;
    __pyx_25 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5427 */
    Py_INCREF(__pyx_k49p);
    __pyx_k50 = __pyx_k49p;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5507 */
    __pyx_k51 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5537 */
    __pyx_k52 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5572 */
    Py_INCREF(Py_None);
    __pyx_k53 = Py_None;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5586 */
    Py_INCREF(Py_None);
    __pyx_k54 = Py_None;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5602 */
    __pyx_26 = PyInt_FromLong((-1)); if (!__pyx_26) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5602; goto __pyx_L1;}
    __pyx_k55 = __pyx_26;
    __pyx_26 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5749 */
    Py_INCREF(Py_None);
    __pyx_k56 = Py_None;

    /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5833 */
    __pyx_27 = (precdl == 0);
    if (__pyx_27) {

      /* "/home/was/sage/src/scripts/build-tmp/_py_pari.pyx":5834 */
      __pyx_28 = __Pyx_GetName(__pyx_m, __pyx_n__init); if (!__pyx_28) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5834; goto __pyx_L1;}
      __pyx_29 = PyTuple_New(0); if (!__pyx_29) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5834; goto __pyx_L1;}
      __pyx_30 = PyObject_CallObject(__pyx_28, __pyx_29); if (!__pyx_30) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 5834; goto __pyx_L1;}
      Py_DECREF(__pyx_28); __pyx_28 = 0;
      Py_DECREF(__pyx_29); __pyx_29 = 0;
      Py_DECREF(__pyx_30); __pyx_30 = 0;
      goto __pyx_L5;
    }
    __pyx_L5:;
    return;
    __pyx_L1:;
    Py_XDECREF(__pyx_1);
    Py_XDECREF(__pyx_2);
    Py_XDECREF(__pyx_3);
    Py_XDECREF(__pyx_4);
    Py_XDECREF(__pyx_5);
    Py_XDECREF(__pyx_6);
    Py_XDECREF(__pyx_7);
    Py_XDECREF(__pyx_8);
    Py_XDECREF(__pyx_9);
    Py_XDECREF(__pyx_10);
    Py_XDECREF(__pyx_11);
    Py_XDECREF(__pyx_12);
    Py_XDECREF(__pyx_13);
    Py_XDECREF(__pyx_14);
    Py_XDECREF(__pyx_15);
    Py_XDECREF(__pyx_16);
    Py_XDECREF(__pyx_17);
    Py_XDECREF(__pyx_18);
    Py_XDECREF(__pyx_19);
    Py_XDECREF(__pyx_20);
    Py_XDECREF(__pyx_21);
    Py_XDECREF(__pyx_22);
    Py_XDECREF(__pyx_23);
    Py_XDECREF(__pyx_24);
    Py_XDECREF(__pyx_25);
    Py_XDECREF(__pyx_26);
    Py_XDECREF(__pyx_28);
    Py_XDECREF(__pyx_29);
    Py_XDECREF(__pyx_30);
    __Pyx_AddTraceback("_py_pari");
  }

  static char *__pyx_filenames[] = {
    "_py_pari.pyx",
  };
  statichere char **__pyx_f = __pyx_filenames;

  /* Runtime support code */
  
static int __Pyx_ArgTypeTest(PyObject *obj, PyTypeObject *type, int none_allowed, char *name) {
    if (!type) {
        PyErr_Format(PyExc_SystemError, "Missing type object");
        return 0;
    }
    if ((none_allowed && obj == Py_None) || PyObject_TypeCheck(obj, type))
        return 1;
    PyErr_Format(PyExc_TypeError,
        "Argument '%s' has incorrect type (expected %s, got %s)",
        name, type->tp_name, obj->ob_type->tp_name);
    return 0;
}

static PyObject *__Pyx_Import(PyObject *name, PyObject *from_list) {
    PyObject *__import__ = 0;
    PyObject *empty_list = 0;
    PyObject *module = 0;
    PyObject *global_dict = 0;
    PyObject *empty_dict = 0;
    PyObject *list;
    __import__ = PyObject_GetAttrString(__pyx_b, "__import__");
    if (!__import__)
        goto bad;
    if (from_list)
        list = from_list;
    else {
        empty_list = PyList_New(0);
        if (!empty_list)
            goto bad;
        list = empty_list;
    }
    global_dict = PyModule_GetDict(__pyx_m);
    if (!global_dict)
        goto bad;
    empty_dict = PyDict_New();
    if (!empty_dict)
        goto bad;
    module = PyObject_CallFunction(__import__, "OOOO",
        name, global_dict, empty_dict, list);
bad:
    Py_XDECREF(empty_list);
    Py_XDECREF(__import__);
    Py_XDECREF(empty_dict);
    return module;
}

static PyObject *__Pyx_GetName(PyObject *dict, PyObject *name) {
    PyObject *result;
    result = PyObject_GetAttr(dict, name);
    if (!result)
        PyErr_SetObject(PyExc_NameError, name);
    return result;
}

static void __Pyx_WriteUnraisable(char *name) {
    PyObject *old_exc, *old_val, *old_tb;
    PyObject *ctx;
    PyErr_Fetch(&old_exc, &old_val, &old_tb);
    ctx = PyString_FromString(name);
    PyErr_Restore(old_exc, old_val, old_tb);
    if (!ctx)
        ctx = Py_None;
    PyErr_WriteUnraisable(ctx);
}

static void __Pyx_Raise(PyObject *type, PyObject *value, PyObject *tb) {
    Py_XINCREF(type);
    Py_XINCREF(value);
    Py_XINCREF(tb);
    /* First, check the traceback argument, replacing None with NULL. */
    if (tb == Py_None) {
        Py_DECREF(tb);
        tb = 0;
    }
    else if (tb != NULL && !PyTraceBack_Check(tb)) {
        PyErr_SetString(PyExc_TypeError,
            "raise: arg 3 must be a traceback or None");
        goto raise_error;
    }
    /* Next, replace a missing value with None */
    if (value == NULL) {
        value = Py_None;
        Py_INCREF(value);
    }
    /* Next, repeatedly, replace a tuple exception with its first item */
    while (PyTuple_Check(type) && PyTuple_Size(type) > 0) {
        PyObject *tmp = type;
        type = PyTuple_GET_ITEM(type, 0);
        Py_INCREF(type);
        Py_DECREF(tmp);
    }
    if (PyString_Check(type))
        ;
    else if (PyClass_Check(type))
        ; /*PyErr_NormalizeException(&type, &value, &tb);*/
    else if (PyInstance_Check(type)) {
        /* Raising an instance.  The value should be a dummy. */
        if (value != Py_None) {
            PyErr_SetString(PyExc_TypeError,
              "instance exception may not have a separate value");
            goto raise_error;
        }
        else {
            /* Normalize to raise <class>, <instance> */
            Py_DECREF(value);
            value = type;
            type = (PyObject*) ((PyInstanceObject*)type)->in_class;
            Py_INCREF(type);
        }
    }
    else {
        /* Not something you can raise.  You get an exception
           anyway, just not what you specified :-) */
        PyErr_Format(PyExc_TypeError,
                 "exceptions must be strings, classes, or "
                 "instances, not %s", type->ob_type->tp_name);
        goto raise_error;
    }
    PyErr_Restore(type, value, tb);
    return;
raise_error:
    Py_XDECREF(value);
    Py_XDECREF(type);
    Py_XDECREF(tb);
    return;
}

static int __Pyx_TypeTest(PyObject *obj, PyTypeObject *type) {
    if (!type) {
        PyErr_Format(PyExc_SystemError, "Missing type object");
        return 0;
    }
    if (obj == Py_None || PyObject_TypeCheck(obj, type))
        return 1;
    PyErr_Format(PyExc_TypeError, "Cannot convert %s to %s",
        obj->ob_type->tp_name, type->tp_name);
    return 0;
}

static void __Pyx_UnpackError(void) {
    PyErr_SetString(PyExc_ValueError, "unpack sequence of wrong size");
}

static PyObject *__Pyx_UnpackItem(PyObject *seq, int i) {
  PyObject *item;
  if (!(item = PySequence_GetItem(seq, i))) {
    if (PyErr_ExceptionMatches(PyExc_IndexError))
    	__Pyx_UnpackError();
  }
  return item;
}

static int __Pyx_EndUnpack(PyObject *seq, int i) {
  PyObject *item;
  if (item = PySequence_GetItem(seq, i)) {
    Py_DECREF(item);
    __Pyx_UnpackError();
    return -1;
  }
  PyErr_Clear();
    return 0;
}

static PyObject *__Pyx_GetExcValue(void) {
    PyObject *type = 0, *value = 0, *tb = 0;
    PyObject *result = 0;
    PyThreadState *tstate = PyThreadState_Get();
    PyErr_Fetch(&type, &value, &tb);
    PyErr_NormalizeException(&type, &value, &tb);
    if (PyErr_Occurred())
        goto bad;
    if (!value) {
        value = Py_None;
        Py_INCREF(value);
    }
    Py_XDECREF(tstate->exc_type);
    Py_XDECREF(tstate->exc_value);
    Py_XDECREF(tstate->exc_traceback);
    tstate->exc_type = type;
    tstate->exc_value = value;
    tstate->exc_traceback = tb;
    result = value;
    Py_XINCREF(result);
    type = 0;
    value = 0;
    tb = 0;
bad:
    Py_XDECREF(type);
    Py_XDECREF(value);
    Py_XDECREF(tb);
    return result;
}

static PyObject *__Pyx_GetStdout(void) {
    PyObject *f = PySys_GetObject("stdout");
    if (!f) {
        PyErr_SetString(PyExc_RuntimeError, "lost sys.stdout");
    }
    return f;
}

static int __Pyx_PrintItem(PyObject *v) {
    PyObject *f;
    
    if (!(f = __Pyx_GetStdout()))
        return -1;
    if (PyFile_SoftSpace(f, 1)) {
        if (PyFile_WriteString(" ", f) < 0)
            return -1;
    }
    if (PyFile_WriteObject(v, f, Py_PRINT_RAW) < 0)
        return -1;
    if (PyString_Check(v)) {
        char *s = PyString_AsString(v);
        int len = PyString_Size(v);
        if (len > 0 &&
            isspace(Py_CHARMASK(s[len-1])) &&
            s[len-1] != ' ')
                PyFile_SoftSpace(f, 0);
    }
    return 0;
}

static int __Pyx_PrintNewline(void) {
    PyObject *f;
    
    if (!(f = __Pyx_GetStdout()))
        return -1;
    if (PyFile_WriteString("\n", f) < 0)
        return -1;
    PyFile_SoftSpace(f, 0);
    return 0;
}

static int __Pyx_InternStrings(__Pyx_InternTabEntry *t) {
    while (t->p) {
        *t->p = PyString_InternFromString(t->s);
        if (!*t->p)
            return -1;
        ++t;
    }
    return 0;
}

static int __Pyx_InitStrings(__Pyx_StringTabEntry *t) {
    while (t->p) {
        *t->p = PyString_FromStringAndSize(t->s, t->n - 1);
        if (!*t->p)
            return -1;
        ++t;
    }
    return 0;
}

static int __Pyx_SetVtable(PyObject *dict, void *vtable) {
    PyObject *pycobj = 0;
    int result;
    
    pycobj = PyCObject_FromVoidPtr(vtable, 0);
    if (!pycobj)
        goto bad;
    if (PyDict_SetItemString(dict, "__pyx_vtable__", pycobj) < 0)
        goto bad;
    result = 0;
    goto done;

bad:
    result = -1;
done:
    Py_XDECREF(pycobj);
    return result;
}

#include "compile.h"
#include "frameobject.h"
#include "traceback.h"

static void __Pyx_AddTraceback(char *funcname) {
    PyObject *py_srcfile = 0;
    PyObject *py_funcname = 0;
    PyObject *py_globals = 0;
    PyObject *empty_tuple = 0;
    PyObject *empty_string = 0;
    PyCodeObject *py_code = 0;
    PyFrameObject *py_frame = 0;
    
    py_srcfile = PyString_FromString(__pyx_filename);
    if (!py_srcfile) goto bad;
    py_funcname = PyString_FromString(funcname);
    if (!py_funcname) goto bad;
    py_globals = PyModule_GetDict(__pyx_m);
    if (!py_globals) goto bad;
    empty_tuple = PyTuple_New(0);
    if (!empty_tuple) goto bad;
    empty_string = PyString_FromString("");
    if (!empty_string) goto bad;
    py_code = PyCode_New(
        0,            /*int argcount,*/
        0,            /*int nlocals,*/
        0,            /*int stacksize,*/
        0,            /*int flags,*/
        empty_string, /*PyObject *code,*/
        empty_tuple,  /*PyObject *consts,*/
        empty_tuple,  /*PyObject *names,*/
        empty_tuple,  /*PyObject *varnames,*/
        empty_tuple,  /*PyObject *freevars,*/
        empty_tuple,  /*PyObject *cellvars,*/
        py_srcfile,   /*PyObject *filename,*/
        py_funcname,  /*PyObject *name,*/
        __pyx_lineno,   /*int firstlineno,*/
        empty_string  /*PyObject *lnotab*/
    );
    if (!py_code) goto bad;
    py_frame = PyFrame_New(
        PyThreadState_Get(), /*PyThreadState *tstate,*/
        py_code,             /*PyCodeObject *code,*/
        py_globals,          /*PyObject *globals,*/
        0                    /*PyObject *locals*/
    );
    if (!py_frame) goto bad;
    py_frame->f_lineno = __pyx_lineno;
    PyTraceBack_Here(py_frame);
bad:
    Py_XDECREF(py_srcfile);
    Py_XDECREF(py_funcname);
    Py_XDECREF(empty_tuple);
    Py_XDECREF(empty_string);
    Py_XDECREF(py_code);
    Py_XDECREF(py_frame);
}
